//组装拆分
Ext.require([
    'Ext.grid.*',
    'Ext.data.*',
    'Ext.selection.CheckboxModel'
]);

Ext.define('Seller.view.stock.AssembleRuleGrid', function() {

    var myData= Ext.create('Ext.data.Store', {
        fields:['id', 'aCommodityId', 'bCommodityId', 'bCommodityNum','cCommodityId','cCommodityNum','dCommodityId','dCommodityNum',
            'aCommodityName','aBarcode','bCommodityName','bBarcode','cCommodityName','cBarcode','dCommodityName','dBarcode',]

    });

    return {
        extend: 'Ext.grid.Panel',
        xtype: 'assembleRuleGrid',
        store:myData,
        title: '组装拆分资料',
        columns: [
            {
                text : '组装',
                dataIndex : 'id',
                align:'center',
                width : 70,
                sortable: false,
                menuDisabled : true,
                renderer : function() {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">组装</a>';
                },
                listeners : {
                    'click' : function(grid, rowIndex, colIndex) {
                        // // 获取数据
                        var data = grid.store.data.items[colIndex].data;
                        //var rec = grid.getStore().getAt(rowIndex);
                        Ext.create('Ext.window.Window', {
                            id:'assembleRuleOptViewWin',
                            title: '组装商品',
                            // height: 350,
                            width: 650,
                            modal:true,
                            items: {
                                xtype: 'assembleRuleOptView',
                                id:'assembleRuleOptView',
                            }
                        }).show();
                        Ext.getCmp('assembleRuleOptView').loadData(data.id,'1');
                    }
                }
            },
            {
                text : '拆分',
                dataIndex : 'id',
                align:'center',
                width : 70,
                sortable: false,
                menuDisabled : true,
                renderer : function() {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">拆分</a>';
                },
                listeners : {
                    'click' : function(grid, rowIndex, colIndex) {
                        // // 获取数据
                        var data = grid.store.data.items[colIndex].data;
                        //var rec = grid.getStore().getAt(rowIndex);
                        Ext.create('Ext.window.Window', {
                            id:'assembleRuleOptViewWin',
                            title: '拆分商品',
                            // height: 350,
                            width: 650,
                            modal:true,
                            items: {
                                xtype: 'assembleRuleOptView',
                                id:'assembleRuleOptView',
                            }
                        }).show();
                        Ext.getCmp('assembleRuleOptView').loadData(data.id,'2');
                    }
                }
            },
            {
                text : '修改',
                dataIndex : 'id',
                sortable: false,
                menuDisabled : true,
                align:'center',
                width : 70,
                renderer : function() {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">修改</a>';
                },
                listeners : {
                    'click' : function(grid, rowIndex, colIndex) {
                        // // 获取数据
                        var data = grid.store.data.items[colIndex].data;
                        //var rec = grid.getStore().getAt(rowIndex);
                        Ext.create('Ext.window.Window', {
                            id:'assembleRuleAddViewWin',
                            title: '组装拆分规则',
                            // height: 350,
                            width: 650,
                            modal:true,
                            // layout: 'fit',
                            items: {  // Let's put an empty grid in just to illustrate fit layout
                                xtype: 'assembleRuleAddView',
                                id:'assembleRuleAddView',
                            }
                        }).show();

                        Ext.getCmp('assembleRuleAddView').loadData(data.id);
                    }
                }
            },
            {
                text : '删除',
                dataIndex : 'id',
                align:'center',
                width : 70,
                sortable: false,
                menuDisabled : true,
                renderer : function() {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">删除</a>';
                },
                listeners : {
                    'click' : function(grid, cmp, rowIndex,colIndex) {
                        // // 获取数据
                        // console.log(grid, cmp, rowIndex,colIndex)
                        var data = grid.store.data.items[rowIndex].data;
                        var id =data.id;
                        Ext.Msg.confirm('提示','您确认需要删除当前记录吗?',function(btn)
                        {
                            if(btn=='yes')
                            {
                                AssembleRuleDao.delete(id,function(success)
                                {
                                    if(success)
                                    {
                                        Ext.Msg.alert('提示','删除成功.',function () {
                                            grid.getStore().removeAt(rowIndex);
                                            Ext.getCmp('assembleRuleListView').loadData();
                                        });

                                    }
                                    else
                                    {
                                        Ext.Msg.alert('提示','删除失败.');
                                    }
                                });
                            }

                        });
                    }
                }
            },

            // {
            //   text:'操作',width:100,sortable:false,xtype:'templatecolumn', tpl: '<input type="number" id="{id}" value={sequence} style="width: 80px;" />',
            // },
            { text: 'A商品(大)', flex:1,minWidth:130, sortable: false,menuDisabled : true, dataIndex: 'aCommodityName' },
            { text: 'B商品', flex:1,minWidth:130, sortable: false,menuDisabled : true,  dataIndex: 'bCommodityName' },
            { text: 'B数量', flex:1,minWidth:90,sortable: false,menuDisabled : true,  dataIndex: 'bCommodityNum',align:'right' },
            { text: 'C商品', flex:1,minWidth:130, sortable: false,menuDisabled : true,  dataIndex: 'cCommodityName' },
            { text: 'C数量', flex:1,minWidth:90, sortable: false,menuDisabled : true,  dataIndex: 'cCommodityNum',align:'right' },
            { text: 'D商品', flex:1,minWidth:130, sortable: false,menuDisabled : true,  dataIndex: 'dCommodityName'  },
            { text: 'D数量',flex:1,minWidth:90,sortable: false,menuDisabled : true,  dataIndex: 'dCommodityNum',align:'right'},
            { text: 'id', dataIndex: 'id',hidden:true },
        ]
    };
});

Ext.define('Seller.view.stock.AssembleRuleListView',{
    extend: 'Ext.container.Container',
    xtype: 'assembleRuleListView',
    id: 'assembleRuleListView',
    width:'100%',
    pageSize:gPageSize, //每页多少记录
    pageIndex:1, //当前页码
    ttlNum:0,    //总数量
    layout: {
        type: 'vbox',
        align: 'stretch',
    },

    items: [
        {
           xtype: 'panel',
            height:60,
            margin:'0 0 15 0',
            layout:'hbox',
            baseCls:'titleBar',

            items:[ {
                xtype: 'fieldset',
                width:'100%',
                height: '100%',
                margin: 2,
                padding:'10 5 10 5',
                style:{
                    backgroundColor:'#ccc',
                    borderRadius:'3px'
                },
                layout:'hbox',
                cls:'headerBar',

                items: [
                    { xtype: 'textfield',id:'txtRuleCommKey',emptyText:'A商品名称/条码',/*fieldLabel:'A商品名称/条码',*/labelWidth:130,height:'90%',
                        cls:'inputBorderStyle',
                        margin:2,
                        labelStyle:'margin-top:6px;',
                        enableKeyEvents:true,
                        listeners:{
                            keyup:function (field,e,eopts) {
                                // console.log(field,e,eopts);
                                if(event && event.keyCode == 13){
                                    var btn=Ext.getCmp('btnSearchRule');
                                    btn.fireEvent('click',btn,e,eopts);
                                }
                            }
                        }
                    },
                    { xtype:'button',text:'查询',id:'btnSearchRule', scale:'medium',margin:'2 2 2 10',width:90},
                    { xtype:'button',text:'新增规则',id:'btnAddRule',scale:'medium',margin:'2 2 2 5',width:90},
                ]
            }]
        },
        {
            xtype: 'assembleRuleGrid',
            id:'assembleRuleGrid',
            flex:1,
            style:{
                backgroundColor:'#ccc',
                borderRadius:'3px'
            },
            dockedItems: [{
                xtype: 'toolbar',
                dock: 'bottom',
                //ui: 'footer',
                id:'pageToolRule',
                layout: {
                    type: 'hbox',
                    align: 'middle',
                    pack:'end',
                },
                defaults: {minHeight:30},
                items:[
                    {
                        xtype:'panel',
                       //html:'<div id=pageInfoDiv  style="align-items: center; margin-top: 5px; width: 280px;">当前0 / 0页，共查询到 0 条记录，每页20条</div>',
                        html: '<div style="align-items: center; margin-top: 2px;">当前 <span id="currentPageIndexRule">1</span> / <span id="totalPageIndexRule">1</span>页，共查询到 <span id="totalPageSizeRule">0</span> 条记录，每页显示<input id="showPageSizeRule" type="number" style="width: 50px; align-items::right;" value="20">条</div>',
                    },
                    {
                        id:'btnFirstRule',
                        width:45,
                        xtype:'button',
                        text:'<<',
                        tooltip:'第一页',
                        handler:function()
                        {
                            var vw=Ext.getCmp('assembleRuleListView');
                            vw.setPageIndex(1);
                            loadAssembleRuleList(vw);
                        }
                    },
                    {
                        id:'btnPreviousRule',
                        width:45,
                        xtype:'button',
                        tooltip:'上一页',
                        text:'<',
                        handler:function(button)
                        {
                            var vw=Ext.getCmp('assembleRuleListView');
                            vw.setPageIndex(vw.getPageIndex()-1);
                            loadAssembleRuleList(vw);
                        }
                    },
                    {
                        id: 'btnNextRule',
                        width: 45,
                        xtype: 'button',
                        text: '>',
                        tooltip:'下一页',
                        handler:function()
                        {
                            var vw=Ext.getCmp('assembleRuleListView');
                            //console.log(vw);
                            vw.setPageIndex(vw.getPageIndex()+1);
                            loadAssembleRuleList(vw);
                        }
                    },
                    {
                         id: 'btnLastRule',
                        width: 45,
                        xtype: 'button',
                        text: '>>',
                        tooltip:'末页',
                        handler:function()
                        {
                            var vw=Ext.getCmp('assembleRuleListView');
                            var nTTLNum=vw.getTTLNum();
                            var nPageSize=vw.getPageSize();

                            var nPageIndex= Math.ceil(nTTLNum /nPageSize)
                            vw.setPageIndex(nPageIndex);
                            loadAssembleRuleList(vw);
                        }
                    },
                    {
                        id: 'btnRefreshRule',
                        width: 45,
                        xtype: 'button',
                        text: '刷新',
                        tooltip: '刷新',
                        handler: function () {
                            var vw=Ext.getCmp('assembleRuleListView');
                            vw.setPageIndex(1);
                            vw.setPageSize();
                            loadAssembleRuleList(vw);
                        }
                    },
                ]
            }],
        }],

    loadData : function() {

        if (Ext.getDom('showPageSizeRule') != null) {
            Ext.getDom('showPageSizeRule').value = this.pageSize;
        }

        var vw=Ext.getCmp('assembleRuleListView');
        loadAssembleRuleList(vw);
    },
    setPageSize:function(nPageSize)
    {
        //this.pageSize=nPageSize;
        var pageSize = 1;
        if (Ext.getDom('showPageSizeRule') != null) {
            var tempPageSize = Ext.getDom('showPageSizeRule').value;
            if (!checkNumber(tempPageSize)) {
                pageSize = 1;
            }
            else if (Number(tempPageSize) < 0) {
                pageSize = 1;
            }
            else {
                pageSize = Number(tempPageSize);
            }
        }
        this.pageSize = pageSize;
    },

    getPageSize:function()
    {
        return this.pageSize;
    },

    setPageIndex:function(nPageIndex)
    {
        //console.log('nindex:'+nPageIndex);
        if(nPageIndex>0)
            this.pageIndex=nPageIndex;
        else
            this.pageIndex=1;


    },
    getPageIndex:function()
    {
        return this.pageIndex;
    },

    setTTLNum:function(nTTlNum)
    {
        if(nTTlNum>0)
            this.ttlNum=nTTlNum;
        else
            this.ttlNum=0;
    },

    getTTLNum:function()
    {
        return this.ttlNum;
    },

    setPageMsg:function()
    {
        Ext.getCmp('btnFirstRule').setDisabled(false);
        Ext.getCmp('btnPreviousRule').setDisabled(false);
        Ext.getCmp('btnNextRule').setDisabled(false);
        Ext.getCmp('btnLastRule').setDisabled(false);

        var nTTLPage=Math.ceil(this.ttlNum /this.pageSize);
        //console.log('ttL:'+nTTLPage);
        //console.log('index:'+this.pageIndex);
        if(nTTLPage==0)
        {
            //console.log('a');
            Ext.getCmp('btnFirstRule').setDisabled(true);
            Ext.getCmp('btnPreviousRule').setDisabled(true);
            Ext.getCmp('btnNextRule').setDisabled(true);
            Ext.getCmp('btnLastRule').setDisabled(true);
        }
        else if(this.pageIndex==1 && nTTLPage==1)
        {
            //console.log('c');
            Ext.getCmp('btnFirstRule').setDisabled(false);
            Ext.getCmp('btnPreviousRule').setDisabled(true);
            Ext.getCmp('btnNextRule').setDisabled(true);
            Ext.getCmp('btnLastRule').setDisabled(true);
        }
        else if(this.pageIndex==nTTLPage)
        {
            //console.log('b');
            Ext.getCmp('btnFirstRule').setDisabled(false);
            Ext.getCmp('btnPreviousRule').setDisabled(false);
            Ext.getCmp('btnNextRule').setDisabled(true);
            Ext.getCmp('btnLastRule').setDisabled(false);
        }
        else if(this.pageIndex==1)
        {
            //console.log('d');
            Ext.getCmp('btnFirstRule').setDisabled(false);
            Ext.getCmp('btnPreviousRule').setDisabled(true);
            Ext.getCmp('btnNextRule').setDisabled(false);
            Ext.getCmp('btnLastRule').setDisabled(false);
        }

        //Ext.getDom('pageInfoDiv').innerText="当前 "+(nTTLPage==0?0:this.pageIndex)+" / "+nTTLPage+"页，共查询到 "+this.ttlNum+" 条记录，每页"+this.pageSize+"条";
        if (Ext.getDom('currentPageIndexRule') != null) {
            Ext.getDom('currentPageIndexRule').innerText = this.pageIndex;
        }
        var totalPage = Math.ceil(this.ttlNum / this.pageSize);
        if (Ext.getDom('totalPageIndexRule') != null) {
            Ext.getDom('totalPageIndexRule').innerText = (totalPage == 0 ? 1 : totalPage);
        }
        if (Ext.getDom('totalPageSizeRule') != null) {
            Ext.getDom('totalPageSizeRule').innerText = this.ttlNum;
        }
    }
});