

var ArrivalDao={
    /**
     * 根据id查询
     * @param {Object} callback(success,err)
     */
    getById : function(id, callback) {
        var sql = "SELECT * FROM arrivalInfo where id=? ";
        getBySql(sql,[id],callback);
    },

    /**
     * 根据进货申请名称查询
     * @param {Object} callback(success,err)
     */
    //getByName : function(name, callback) {
    //    var sql = "SELECT * FROM arrivalInfo where name=? ";
    //    loadBySqlParam(sql,[name],callback);
    //},


    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadSearchInfo : function(param,callBack) {
        //console.log(keyword);
        var sql = "SELECT * from arrivalInfo where sellerId = ? " ;
        var keyArr=[loginInfo.storeId];
        if (param)
        {
            sql=sql+' and  purchaseId like ? ';
            keyArr.push('%'+param+'%');
        }
        sql=sql+'Order by purchaseId';

        loadBySqlParam(sql,keyArr, callBack);
    },

    /**
     * 根据条件查询
     * @param {Object} callBack(success,res|err)
     */
    loadSearchByArrivalDate : function(payStatus,purchaseType,supplierId,keyword,startDate,endDate,callBack) {
        //console.log(keyword);
        var sql = "SELECT id,purchaseId,supplierName,payAmount,arrivalWorkName,sellerId,workId,workName,purchaseDate," +
            "supplierId,arrivalWorkId,payWorkId,parentSellerId,createId,createTime,lastUpdateId,lastUpdateTime," +
            "CASE purchaseType WHEN '0' THEN '进货单' WHEN '1' THEN '退货单' END AS purchaseType," +
            "CASE payStatus WHEN '0' THEN '未付款' WHEN '1' THEN '部分付款' WHEN '2' THEN '已付' END AS payStatus," +
            "commodifyNum,totalAmount,arrivalDate,payDate,payWorkName " +
            "FROM arrivalInfo WHERE sellerId = ? " ;
        var keyArr=[loginInfo.storeId];
        if (payStatus)
        {
            sql=sql+' AND  payStatus!= ?  ';
            keyArr.push(payStatus);
        }
        if (purchaseType)
        {
            sql=sql+' AND  purchaseType = ? ';
            keyArr.push(purchaseType);
        }
        if (supplierId)
        {
            sql=sql+' AND  supplierId = ? ';
            keyArr.push(supplierId);
        }
        if (keyword)
        {
            sql=sql+' AND  (purchaseId  like ? or id like ?) ';
            keyArr.push('%'+keyword+'%');
            keyArr.push('%'+keyword+'%');
        }

        if (startDate && endDate)
        {
            sql=sql+' AND  date(arrivalDate) BETWEEN ? AND ? ';
            keyArr.push(startDate);
            keyArr.push(endDate);
        }else if(startDate){
            sql=sql+' AND  date(arrivalDate) >= ? ';
            keyArr.push(startDate);
        }else if(endDate){
            sql=sql+' AND  date(arrivalDate) <= ? ';
            keyArr.push(endDate);
        }

        sql=sql+'Order by arrivalDate desc';
        loadBySqlParam(sql,keyArr, callBack);
    },


    /**
     *增加类型
     */
    add : function(sqlData, callBack) {
        insert("arrivalInfo", sqlData, callBack);
    },

    /**
     *删除类型
     */
    delete : function(id, callBack) {
        del("arrivalInfo", id, callBack);
    },

    /**
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update : function(sqlData,id, callback) {
        update('arrivalInfo',sqlData,id,callback)
    },



    /**
     * 查询所有数据
     * @param {Object} callBack(success,res|err)
     */
    loadAllData : function(callBack) {
        //console.log(keyword);
        var sql = "SELECT * FROM arrivalInfo where sellerId =  '"+loginInfo.storeId+"'";
        loadBySql(sql, callBack);
    },


    /**
     * 根据arrivalId查询ArrivalDetail
     * @param {Object} callBack(success,res|err)
     */
    loadByArrivalId : function(arrivalId,callBack) {
        if(!arrivalId){
            return;
        }
        var sql = "SELECT * from arrivalDetail where arrivalId = ? and sellerId = ? and ifnull(status,'')<>'9' " ;

        loadBySqlParam(sql,[arrivalId,loginInfo.storeId], callBack);
    },


    /**
     * 分页查询
     * @param {Object} callback(success,res|err)
     */
    loadGFRByPage : function(payStatus,purchaseType,supplierId,keyword,startDate,endDate,limitCount,pageIndex, callback) {

        var sql = "SELECT id,purchaseId,supplierName,round(payAmount,2) payAmount,arrivalWorkName,sellerId,workId,workName,purchaseDate," +
            "supplierId,arrivalWorkId,payWorkId,parentSellerId,createId,createTime,lastUpdateId,lastUpdateTime," +
            "CASE purchaseType WHEN '0' THEN '进货单' WHEN '1' THEN '退货单' END AS purchaseType," +
            "CASE payStatus WHEN '0' THEN '未付款' WHEN '1' THEN '部分付款' WHEN '2' THEN '已付' END AS payStatus," +
            "round(commodifyNum,2) commodifyNum,round(totalAmount,2) totalAmount,arrivalDate,payDate,payWorkName " +
            "FROM arrivalInfo WHERE 1=1 and ifnull(status,'')<>'9' " ;
        var keyArr=[];
        if (payStatus)
        {
            sql=sql+' AND  payStatus!= ?  ';
            keyArr.push(payStatus);
        }
        if (purchaseType)
        {
            sql=sql+' AND  purchaseType = ?  ';
            keyArr.push(purchaseType);
        }
        if (supplierId)
        {
            sql=sql+' AND  supplierId = ?  ';
            keyArr.push(supplierId);
        }
        if (Ext.isEmpty(keyword))
        {
            sql=sql+" AND  (purchaseId like ? ESCAPE '^' or id like ? ESCAPE '^')  ";
            keyArr.push('%'+replaceSQLiteCharacters(keyword)+'%');
            keyArr.push('%'+replaceSQLiteCharacters(keyword)+'%');
        }

        if (startDate && endDate)
        {
            sql=sql+' AND  date(arrivalDate) BETWEEN ? AND ? '
            keyArr.push(startDate);
            keyArr.push(endDate);
        }else if(startDate){
            sql=sql+' AND  date(arrivalDate) >= ?  '
            keyArr.push(startDate);
        }else if(endDate){
            sql=sql+' AND  date(arrivalDate) <= ?  '
            keyArr.push(endDate);
        }
        sql = sql+ ' AND sellerId = ? ',
            keyArr.push(loginInfo.storeId);
        sql=sql+" Order by arrivalDate desc limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;

        loadBySqlParam(sql,keyArr, callback);
    },


    /**
     * 分页查询
     * @param {Object} callback(success,res|err)
     */
    loadGFRByPageTotal : function(payStatus,purchaseType,supplierId,keyword,startDate,endDate, callback) {

        var sql = "SELECT count(id) as ttlNum FROM arrivalInfo WHERE 1=1 " ;
        var keyArr=[];
        if (payStatus)
        {
            sql=sql+' AND  payStatus!= ?  ';
            keyArr.push(payStatus);
        }
        if (purchaseType)
        {
            sql=sql+' AND  purchaseType = ?  ';
            keyArr.push(purchaseType);
        }
        if (supplierId)
        {
            sql=sql+' AND  supplierId = ?  ';
            keyArr.push(supplierId);
        }
        if (keyword)
        {
            sql=sql+' AND  (purchaseId like ? or id like ?)  '
            keyArr.push('%'+keyword+'%');
            keyArr.push('%'+keyword+'%');
        }

        if (startDate && endDate)
        {
            sql=sql+' AND  date(arrivalDate) BETWEEN ? AND ? '
            keyArr.push(startDate);
            keyArr.push(endDate);
        }else if(startDate){
            sql=sql+' AND  date(arrivalDate) >= ?  '
            keyArr.push(startDate);
        }else if(endDate){
            sql=sql+' AND  date(arrivalDate) <= ?  '
            keyArr.push(endDate);
        }

        getBySql(sql,keyArr, callback);
    },





}