
var CommodityTypeDao={
    /**
     *增加类型
     */
    add : function(sqlData, callBack) {
        insert("commodityType", sqlData, callBack);
    },

    /**
     *删除类型
     */
    delete : function(id, callBack) {
        del("commodityType", id, callBack);
    },
    /**
     *
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update : function(sqlData,id, callback) {
        update('commodityType',sqlData,id,callback)
    },




    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadCommodityType : function(keyword,callBack) {
        //console.log(keyword);
        var sql = "SELECT CASE WHEN A.isInventory='1' THEN '是' ELSE '否' END AS invName, "+
                "CASE WHEN A.isDiscount='1' THEN '是' ELSE '否' END AS discountName,"+
                "CASE WHEN A.isKitchenPrint='1' THEN '是' ELSE '否' END AS kitchenPrintName,"+
                " A.* FROM commodityType A  " +
            " where A.name like ? and ifnull(A.status,'0')<>'9' and A.sellerId=?  Order by A.sequence ";
        loadBySqlParam(sql,['%'+keyword+'%',loginInfo.storeId], callBack);
    },

    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadCommodityTypeByPage : function(keyword,limitCount,pageIndex,callBack) {

        var keyArr=[];
        var sql = "SELECT CASE WHEN A.isInventory='1' THEN '是' ELSE '否' END AS invName, "+
            "CASE WHEN A.isDiscount='1' THEN '是' ELSE '否' END AS discountName,"+
            "CASE WHEN A.isKitchenPrint='1' THEN '是' ELSE '否' END AS kitchenPrintName,"+
            " A.*  FROM commodityType A " +
            " where  ifnull(A.status,'0')<>'9'  and A.sellerId=?   ";

        keyArr.push(loginInfo.storeId);
        if(!Ext.isEmpty(keyword))
        {
            sql=sql+" and A.name like ?  ESCAPE '^'  ";
            keyArr.push("%"+replaceSQLiteCharacters(keyword)+"%");

            //console.log(replaceSQLiteCharacters(keyword));
        }

        sql=sql+" Order by A.sequence limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;
        //console.log(sql,keyArr);
        loadBySqlParam(sql,keyArr, callBack);

    },

    /**
     * 总数
     * @param {Object} callBack(success,res|err)
     */
    loadCommodityTypeByPageTotal : function(keyword,callBack) {
        var keyArr=[];
        var sql = "SELECT Count(A.ID) as ttlNum FROM commodityType A " +
            " where  A.sellerId=?  and ifnull(A.status,'0')<>'9' ";
        keyArr.push(loginInfo.storeId);
        if(!Ext.isEmpty(keyword))
        {
            sql=sql+" and A.name like ?  ESCAPE '^'  ";
            keyArr.push("%"+replaceSQLiteCharacters(keyword)+"%");
            //console.log(replaceSQLiteCharacters(keyword));

        }



        getBySql(sql,keyArr, callBack);
    },


    /**
     * 获取所有分类信息
     * @param  callBack(success,res|err)
     */
    loadCommodityTypeData:function (callBack) {
        var sql = "SELECT id,sequence,name,selected FROM commoditytype where ifnull(status, '0') != ? AND sellerId = ? ORDER BY sequence  ";
        loadBySqlParam(sql,['9',loginInfo.storeId],callBack);

    },

    /**
     * 更新分类的信息
     * @param  callBack(success,res|err)
     */
    updateCommodityType:function (dataArr,vw,callBack) {
        var sqlArr=[];
        var sql ;
        var lastUpdateTime=createDateStr();
        Ext.Array.forEach(dataArr,function (item) {
            sql = "UPDATE commoditytype SET syned='0', sequence= '"+item.sequence+"' ,selected = '"+item.beSelected+"',lastUpdateTime='"+lastUpdateTime+"' WHERE id = '"+item.id+"'";
            sqlArr.push([sql]);
            if( item.beSelected == '1' ){
                sql = "UPDATE commodityinfo SET syned='0',selected = '1',lastUpdateTime='"+lastUpdateTime+"' WHERE typeId = '"+item.id+"'";
                sqlArr.push([sql]);
            }
            else if( item.beSelected == '0' ){
                sql = "UPDATE commodityinfo SET syned='0',selected = '0',lastUpdateTime='"+lastUpdateTime+"' WHERE typeId = '"+item.id+"'";
                sqlArr.push([sql]);
            }
        })


        mposService.execTransactionData(sqlArr, function (success, item) {
            if (success) {
                if(vw!=null &&  vw.el!=null) {
                    Ext.get(vw.el).unmask();
                }
                Ext.Msg.alert('提示', '保存成功.');

            } else {
                if(vw!=null &&  vw.el!=null) {
                    Ext.get(vw.el).unmask();
                }
                Ext.Msg.alert('提示', '保存失败.');
                loadComTypeList(vw);
                // LogDao.SaveLog('权限修改失败:'+error);
            }
        });
        // loadBySql(sql,callBack);
    },




    /**
     * 查询是否还存在该分类的数据
     * @param string callBack(success,res|err)
     */
    checkDelete : function(id,callBack) {
        // var sql = "SELECT b.id FROM commodityType AS a LEFT JOIN commodityStock AS b ON a.id = b.commodityTypeId WHERE a.id = '"+id+"'";
        var sql = "SELECT count(id) as ttlNum from commodityInfo  WHERE typeId = ? and ifnull(status,'0')<>'9'  and sellerId=?  ";
        // console.log(sql);
        getBySql(sql,[id,loginInfo.storeId], callBack);
    },

    /**
     * 查询所有数据
     * @param {Object} callBack(success,res|err)
     */
    loadCommodityTypeAllData : function(callBack) {
        var sql = "SELECT * FROM commodityType  where ifnull(status,'0')<>'9' and sellerId=? Order by sequence ";
        loadBySqlParam(sql,[loginInfo.storeId], callBack);
    },

    /**
     * 查询所有包含库存分类
     * @param {Object} callBack(success,res|err)
     */
    loadCommodityTypeIncludeInv : function(callBack) {
        var sql = "SELECT * FROM commodityType  where ifnull(status,'0')<>'9' and sellerId=? AND ifnull(isInventory,'')='1' Order by sequence ";
        loadBySqlParam(sql,[loginInfo.storeId], callBack);
    },

    /**
     * 查询数据
     * @param {Object} callback(success,err)
     */
    getById : function(id, callback) {
        var sql = "SELECT * FROM commodityType where id=? and ifnull(status,'0')<>'9' and sellerId=? ";
        getBySql(sql,[id,loginInfo.storeId],callback);
    },

    /**
     * 检查商品分类名称是否存在
     * @param {Object} callBack(success,res|err)
     */
    checkCommodityTypeExist : function(name,id, callBack) {

        var keyArr=[];
        var sql = "SELECT * FROM commodityType WHERE 1=1 AND ifnull(status,'0')<>'9' and sellerId=?  ";
        keyArr.push(loginInfo.storeId);
        if(id)
        {
            sql=sql+' and id <> ? ';
            keyArr.push(id);
        }
        if(name)
        {
            sql=sql+' and name = ? ';
            keyArr.push(name);
        }

        loadBySqlParam(sql,keyArr, callBack);
    },

    /**
     * 检查商品分类
     * @param {Object} callBack(success,res|err)
     */
    loadCommodityTypeByNameId : function(callBack) {
        var sql = "SELECT id,name FROM commodityType WHERE 1=1 AND ifnull(status,'0')<>'9' and sellerId=? ";

        loadBySqlParam(sql,[loginInfo.storeId], callBack);
    },

    /**
     * 总数
     * @param {Object} callBack(success,res|err)
     */
    GetMaxSeq : function(callBack) {
        var sql = "SELECT MAX(A.sequence)+1 as sequence FROM commodityType A  where A.sellerId=? and ifnull(status,'0')<>'9' and  A.sequence is not null ";
        getBySql(sql,[loginInfo.storeId], callBack);
    },
}