var LossCauseDao = {


    addLossCause: function (sqlData, callBack) {
        insert("lossCause", sqlData, callBack);
    },


    loadLossCauseByPageTotal: function (name, callback) {
        var sql = "SELECT count(id) as ttlNum FROM lossCause where 1 = 1 and ifnull(status,'')<>'9' ";
        var keyArr = [];
        if (!Ext.isEmpty(name)) {
            sql += " and lossCause like ?  ESCAPE '^' ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }

        sql = sql + ' and sellerId=? ';
        keyArr.push(loginInfo.storeId);

        getBySql(sql, keyArr, callback);
    },
    loadLossCauseByPage: function (name, limitCount, pageIndex, callback) {
        var sql = "SELECT * FROM lossCause where 1 = 1 and ifnull(status,'')<>'9' and sellerId=?  ";
        var keyArr = [];
        keyArr.push(loginInfo.storeId);
        if (!Ext.isEmpty(name)) {
            sql += " and lossCause like ? ESCAPE '^' ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql += "order by createTime desc limit " + limitCount + " offset (" + pageIndex + "-1)*" + limitCount;
        loadBySqlParam(sql, keyArr, callback);
    },

    /**
     * 查询所有口味
     * @param callBack(success,res|err)
     */
    loadAllData: function (callBack) {
        var sql = "SELECT * FROM lossCause  where  ifnull(status,'')<>'9' and sellerId=? ";
        loadBySqlParam(sql, [loginInfo.storeId], callBack);
    },

    loadLossCauseByCashier: function (callBack) {
        var sql = "SELECT id,lossCause FROM lossCause where  ifnull(status,'')<>'9' and sellerId=? ";
        loadBySqlParam(sql, [loginInfo.storeId], callBack);
    },

    /**
     * 根据id查询口味
     * @param {Object} callBack(success,res|err)
     */
    getById: function (id, callBack) {
        var sql = "SELECT * FROM lossCause where id =? and sellerId=? ";
        getBySql(sql, [id, loginInfo.storeId], callBack);
    },

    /**
     * 根据id更新报损设置
     * @param {Object} callBack(success,res|err)
     */
    updateById: function (sqldata, id, callBack) {
        update('lossCause', sqldata, id, callBack);
    },


    /**
     * 根据名称查询口味
     * @param {Object} callBack(success,res|err)
     */
    checkDuplicateRemark: function (lossCause, id, callBack) {
        var sql = "SELECT * FROM lossCause where lossCause = ? and ifnull(status,'')<>'9' and sellerId=? ";
        var keyArr=[];
        keyArr.push(lossCause);
        keyArr.push(loginInfo.storeId);
        if (!Ext.isEmpty(id)) {
            sql=sql+" AND id<>? ";
            keyArr.push(id);
        }
        getBySql(sql, keyArr, callBack);
    },


    delete: function (id, callBack) {
        del('lossCause', id, callBack)
    }
}

