/**
 * 开台设置
 * @type {{landOrig: OriginalSettingsDao.landOrig}}
 */
var OriginalSettingsDao={
    //增加开台设置查询
    landOrig :function (keyword,callBack) {
        var sql=" select c.id,c.name,c.price,case c.isSupportNorms when '0' then  '否' when '1' then '是' else '' end as isSupportNorms,w.name as typeName from commodityInfo c,commodityType w where  c.typeId=w.id ";
        loadBySqlParam(sql,[],callBack);
    },
    /**
     * 根据name查询
     * @param id
     * @param callBack
     */
    landOrigAndNamePage :function (name,limitCount,pageIndex,callBack) {
        var sql="select c.id,c.name,c.price,case c.isSupportNorms when '0' then  '否' when '1' then '是' else '' end as isSupportNorms,w.name as typeName " +
            " from commodityInfo c left join commodityType w on c.typeId=w.id where 1=1 and  c.status<>'9'";
        var keyArr=[];
        if (!Ext.isEmpty(name))
        {
            sql=sql+" and  c.name like ? ESCAPE '^' ";
            keyArr.push('%'+replaceSQLiteCharacters(name)+'%');
        }
        sql=sql+" order by c.id desc limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;
        loadBySqlParam(sql,keyArr,callBack);
    },
    /**
     * 总数
     * @param {Object} callBack(success,res|err)
     */
    landOpenAndNameByPageTotal : function(name,callBack) {
        var sql = "SELECT count(c.id) as ttlNum from commodityInfo c left join commodityType w on c.typeId=w.id where 1=1 and c.status<>'9'";
        var keyArr=[];
        if (!Ext.isEmpty(name))
        {
            sql=sql+" and  c.name like ? ESCAPE '^' ";
            keyArr.push('%'+replaceSQLiteCharacters(name)+'%');
        }
        getBySql(sql,keyArr, callBack);
    },
    /**
     *增加
     */
    add : function(sqlData, callBack) {
        insert("openPlaceSet", sqlData, callBack);
    },

    //查询开台
    OrigSelect :function(callBack){
        var sql="select A.id,A.commodityId,CASE A.labelPrint WHEN '1' THEN '打印' WHEN '0' THEN '不打印' END AS labelPrint,C.name AS commodityTypeName, B.name AS commodityName," +
            " round(ifnull(B.price,0),2) AS commodityPrice ,A.commodityNum,A.normName," +
            " round(ifnull(B.price,0)*ifnull(A.commodityNum,0),2) sumAmount " +
            " from openPlaceSet A LEFT JOIN commodityinfo B ON A.commodityId=B.id  AND A.sellerId=B.sellerId  LEFT JOIN commoditytype C ON A.commodityTypeId = c.id where B.sellerId=? and ifnull(A.status,'0')<>'9' ";
        loadBySqlParam(sql,[loginInfo.storeId],callBack);
    },

    /**
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update : function(sqlData,id, callback) {
        update('openPlaceSet',sqlData,id,callback)
    },

    /**
     *删除类型
     */
    delete : function(id, callBack) {
        del("openPlaceSet", id, callBack);
    },
    /**
     * 根据id查询
     * @param id
     * @param callBack
     */
    getById : function(id,callBack){
        var sql="select * from openPlaceSet where id=? ";
        getBySql(sql,[id],callBack);
    }
};
