var PayListSettingDao={
    /**
     * 根据name查询
     * @param id
     * @param callBack
     */
    PayListAndNamePage :function (name,limitCount,pageIndex,callBack) {
        var sql="select p.id,p.sellerId,p.payType,p.syned,p.openStatus,p.payTypeName,CASE p.openStatus when '1' then '启用' when '0' then '禁用' else '' end  as openStatusName,p.status  " +
            " from payconfig  p where 1=1 and p.payType <> 7 AND p.payType <> 6 ";
        var keyArr=[];
        if (name)
        {
            sql=sql+' and  p.payTypeName like ? ';
            keyArr.push('%'+name+'%');
        }

        sql=sql+" and p.sellerId=?  and ifnull(p.status,'0')<>'9' ";
        keyArr.push(loginInfo.storeId);

        sql=sql+" order by length(p.payType) asc,p.payType asc,p.payType asc limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;
        loadBySqlParam(sql,keyArr,callBack);
    },
    /**
     * 查询默认支付方式
     */
    getDefaultPayType : function (callback) {
        var sql = 'select payType from payconfig where ifnull(defaultPayType, "0") = "1" and sellerId = "' + loginInfo.storeId + '"';
        getBySql(sql, null, callback)
    },
    /**
     * 默认支付方式入库
     */
    updateDefaultPayType : function (payType, callback) {
        // var sql = 'update setting set defaultPayType = "'+payType+'" where id = "'+settingId+'";'
        /*var sql = 'SELECT * FROM "setting" DESC LIMIT 1;';
        getBySql(sql, null, function (success, data) {
            if (success)
                update('setting', {defaultPayType:payType}, data.id, callback)
        })*/
        var time = new Date().format('yyyy-MM-dd hh:mm:ss');
        var delSql = 'UPDATE payconfig SET defaultPayType = null, syned = "0",lastUpdateTime = "' + time + '" WHERE defaultPayType = "1" and sellerId = "' + loginInfo.storeId + '"';
        executeSql(delSql, function (success, info) {
            if(!success) return callback && callback(false, info);
            if(!payType || payType == '') return callback && callback(true);
            var addSql = 'UPDATE payconfig SET defaultPayType = "1", syned = "0",lastUpdateTime = "' + time + '" WHERE payType = "' + payType + '" and sellerId = "' + loginInfo.storeId + '"';
            executeSql(addSql, function (success, info) {
                if(!success) return callback && callback(false, info);
                return callback && callback(true);
            });
        });
    },
    /**
     * 获取setting表
     */
    getSettingData : function (callback) {
        var sql = 'SELECT * FROM setting';
        getBySql(sql, null, callback)
    },
    /**
     * 总数
     * @param {Object} callBack(success,res|err)
     */
    landPayAndNameByPageTotal : function(name,callBack) {
        var sql = "SELECT count(p.id) as ttlNum  FROM payconfig p where 1=1  and p.payType <> 7 AND p.payType <> 6 ";
        var keyArr=[];
        if (name)
        {
            sql=sql+' and  p.payTypeName like ?  '
            keyArr.push('%'+name+'%');
        }
        sql=sql+" and p.sellerId=? and ifnull(p.status,'0')<>'9'  ";
        keyArr.push(loginInfo.storeId);

        getBySql(sql,keyArr, callBack);
    },
    /**
     *删除类型
     */
    delete : function(id, callBack) {
        delByWhere('payconfig',"payType=? and payType not in ('1','2','3','4','5','6','7','8')",[id],callBack);
    },
    /*
    * 根据id查询
    * @param id
    * @param callBack
    */
    getById : function(id,callBack){
        var sql="select * from payconfig where id=? and sellerId=? and ifnull(status,'0')<>'9' ";
        getBySql(sql,[id,loginInfo.storeId],callBack);
    },
    /**
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update : function(sqlData,id, callback) {
        update('payconfig',sqlData,id,callback)
    },
    /**
     *增加
     */
    add : function(sqlData, callBack) {
        insert("payconfig", sqlData, callBack);
    },
    /**
     * 插入表数据,指定表名
     */
    insertTable : function(tableName, sqlData, callBack) {
    	insert(tableName, sqlData, callBack);
    },
    /*
    * 查询
    * @param {Object} callBack(success,res|err)
    */
    checkTypeName: function (id, typeName, callBack) {
        var sql = "SELECT * FROM payconfig  where 1=1 ";
        var keyArr = [];
        if (id) {
            keyArr.push(id);
            sql += '  and id <> ? ';
        }

        if (typeName) {
            keyArr.push(typeName);
            sql += '  and payTypeName = ? ';
        }

        sql=sql+" and sellerId=? and ifnull(status,'0')<>'9'  ";
        keyArr.push(loginInfo.storeId);

        loadBySqlParam(sql, keyArr, callBack);
    },


    /*
   * 查询所有自定义支付方式
   * @param {Object} callBack(success,res|err)
   */
    getDefinePayAll: function (callBack) {
        var sql = "SELECT * FROM payconfig  where 1=1 ";
        var keyArr = [];
        sql += '  and payType not in ("1","2","3","4","5","6","7","8","9","11") ';
        sql=sql+" and sellerId=? ";
        keyArr.push(loginInfo.storeId);

        loadBySqlParam(sql, keyArr, callBack);
    },

    getPayRegisterStatus : function (type, callBack) {
        if(type == 8) {
            PayListSettingDao.getWxPayRegisterStatus(callBack);
        } else if(type == 9) {
            PayListSettingDao.getAliPayRegisterStatus(callBack);
        }
    },
    //微信
    getWxPayRegisterStatus : function (callBack) {
        callBack = callBack || emFunc;
        mposService.getAPIData('/loaddata/checkSellerIsRegisterPay', {
                sellerId: loginInfo.storeId,
                type : 1,
            },
            function (success, data) {
                if (success && data.success) {
                    return callBack && callBack(data.success, data);
                }
                else {
                    return callBack(false, data ? data : '提交失败！');
                }
            }, '2' ), function (msg) {
            return callBack(false, '提交失败！');
        };
    },
    //支付宝
    getAliPayRegisterStatus : function (callBack) {
        callBack = callBack || emFunc;
        mposService.getAPIData('/loaddata/checkSellerIsRegisterPay', {
                sellerId: loginInfo.storeId,
                type : 2
            },
            function (success, data) {
                if (success && data.success) {
                    return callBack && callBack(data.success, data);
                }
                else {
                    return callBack(false, data ? data : '提交失败！');
                }
            }, '2'/*开通微信点餐接口*/ ), function (msg) {
            return callBack(false, '提交失败！');
        };
    },
}