

var PurchaseDetailDao={
    /**
     * 根据id查询
     * @param {Object} callback(success,err)
     */
    getById : function(id, callback) {
        var sql = "SELECT * FROM purchaseDetail where id= ? ";
        getBySql(sql,[id],callback);
    },




    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadSearchInfo : function(param,callBack) {
        //console.log(keyword);
        var sql = "SELECT * from purchaseDetail where sellerId = ? " ;
        var keyArr=[loginInfo.storeId];
        if (!Ext.isEmpty(param))
        {
            sql=sql+" and  name like ?  ESCAPE '^' ";
            keyArr.push('%'+replaceSQLiteCharacters(param)+'%');
        }
        sql=sql+'Order by name';

        loadBySqlParam(sql,keyArr, callBack);
    },

    /**
     *增加类型
     */
    add : function(sqlData, callBack) {
        insert("purchaseDetail", sqlData, callBack);
    },

    /**
     *删除类型
     */
    delete : function(id, callBack) {
        del("purchaseDetail", id, callBack);
    },

    /**
     *根据purchaseId删除
     */
    deleteByPurchaseId : function(purchaseId, callBack) {
        delByWhere("purchaseDetail","purchaseId=?",purchaseId,callBack);
    },
    /**
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update : function(sqlData,id, callback) {
        update('purchaseDetail',sqlData,id,callback)
    },



    /**
     * 查询所有数据
     * @param {Object} callBack(success,res|err)
     */
    loadAllData : function(callBack) {
        //console.log(keyword);
        var sql = "SELECT * FROM purchaseDetail where sellerId = ? ";
        loadBySql(sql, callBack);
    },

    /**
     * 根据purchaseId查询所有数据
     * @param {Object} callBack(success,res|err)
     */
    loadByPurchaseId : function(puchaseId,callBack) {
        //console.log(keyword);
        var sql = "SELECT * FROM purchaseDetail where purchaseId=? and sellerId = ? ";
        loadBySqlParam(sql,[puchaseId,loginInfo.storeId], callBack);
    },

    /**
     * 根据purchaseId查询到货明细
     * @param {Object} callBack(success,res|err)
     */
    loadArrivalDetailByPurchaseId : function(puchaseId,callBack) {
        //console.log(keyword);
        var sql = "SELECT * FROM purchaseDetail where purchaseId=? and purchaseNum!= arrivalNum and sellerId = ? ";
        loadBySqlParam(sql,[puchaseId,loginInfo.storeId], callBack);
    },

}