var SellerInfoDao=
    {
        /**
         * 查询主副机数据
         * @param sellerId
         * @param callBack
         */
        loadSellerDevice : function(sellerId, callBack) {
            var sql = "SELECT * FROM devicetype WHERE sellerId=?";
            loadBySqlParam(sql, [sellerId], callBack);
        },
        /**
         * 查询所有数据
         * @param {Object} callBack(success,res|err)
         */
        loadAllData : function(callBack) {
            //console.log(keyword);
            var sql = "SELECT * FROM seller";
            loadBySql(sql, callBack);
        },


        /**
         * 查询数据
         * @param {Object} callback(success,err)
         */
        getById : function(id, callback) {
            var sql = "SELECT * FROM seller where id=? ";
            getBySql(sql,[id],callback);
        },

        /**
         * 更新数据
         * @param {Object} callback(success,err)
         */
        updateSellerInfoById : function(sqlData,id, callback) {
            update('seller',sqlData,id,callback)
        },

        /**
         *删除数据
         */
        delete : function(id, callBack) {
            del("seller", id, callBack);
        },

        /**
         * 查询商家数据
         * @param {Object} callback(success,err)
         */
        getSellerByName : function(userName, callback) {
            var sql = "SELECT * FROM seller where userName=? or id=? ";
            getBySql(sql,[userName,userName],callback);
        },


        loadPasswordBySellerId : function (sellerId,callback) {
            var sql = "select * from seller where id=?";
            loadBySqlParam(sql, [loginInfo.storeId], callback);
        },

        updateSellerPasswordBySellerId : function (sqlData, id, callback) {
            update('seller', sqlData, id, callback);
        },
        /**
         *  微信(在线支付)
         * @param isWxpayStatus
         * @param callBack
         */
        synSellerisWxpayStatusToServer : function (isWxpayStatus,callBack) {
            callBack = callBack || emFunc;//=> callBack = callBack ? callBack : emFunc
            mposService.getAPIData('/syndata/modifySellerInfo', {
                    sellerId: loginInfo.storeId,
                    isWxpay: isWxpayStatus ? '1' : '0',
                },
                function (result) {
                    if (result) {
                        return callBack && callBack(true);
                    }
                    else {
                        return callBack(false, result.msg ? result.msg : '提交失败！');
                    }
                }, '1'/*开通微信点餐接口*/ ), function (msg) {
                return callBack(false, '提交失败！');
            };
        }
    }
