var SpecialSettringDao = {
    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadSelectTypeInfo: function (name, callBack) {
        var sql = "SELECT * from commodityInfo where 1=1 and ifnull(status,'0')<>'9' ";
        var keyArr = [];
        if (!Ext.isEmpty(name)) {
            sql = sql + " and  name like ? ESCAPE '^'   ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql = sql + 'Order by sequence';

        loadBySqlParam(sql, keyArr, callBack);
    },
    /**
     *增加
     */
    add: function (sqlData, callBack) {
        insert("specialprice", sqlData, callBack);
    },
    /**
     *删除类型
     */
    delete: function (id, callBack) {
        del("specialprice", id, callBack);
    },
    //查询特价
    CouupSelect: function (callBack) {
        var sql = "select s.id,s.specialName,s.specialPriceCycle,s.specialPriceWeek,s.specialPrice,case s.specialPriceRange when '1,2,0' then '收银台,点菜宝,微信点餐' else '' end as specialPriceRange,s.specialPriceStartTime,s.specialPriceEndTime,s.specialPriceStartDate,s.specialPriceEndDate, case s.status when '1' then '可用' when '0' then '禁用' else '' END as status from specialprice s where 1=1 and ifnull(status,'0')<>'9'";
        loadBySql(sql, callBack);
    },
    /**
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update: function (sqlData, id, callback) {
        update('specialprice', sqlData, id, callback)
    },
    /**
     * 根据id查询
     * @param id
     * @param callBack
     */
    getById: function (id, callBack) {
        var sql = "select s.*,b.name from specialprice s  join commodityinfo b on s.commodityId=b.id where 1=1 and ifnull(s.status,'')<>'9' and ifnull(b.status,'')<>'9' and s.id=? ";
        getBySql(sql, [id], callBack);
    },
    /**
     * 根据name查询
     * @param name
     * @param callBack
     */
    landSpeciAndNameByPage: function (name, limitCount, pageIndex, callBack) {
        var sql = "select s.id,b.name specialName,s.specialPriceCycle,s.specialPriceWeek,s.specialPrice,specialNormsName," +
            " s.specialPriceRange ," +
            " s.specialPriceStartTime,s.specialPriceEndTime,s.specialPriceStartDate,s.specialPriceEndDate," +
            " s.status " +
            " from specialprice  s  join commodityinfo b on s.commodityId=b.id where 1=1 and ifnull(b.status,'')<>'9'   ";
        var keyArr = [];
        // if (name) {
        //     sql = sql + ' and  s.specialName like ?  '
        //     keyArr.push('%' + name + '%');
        // }
        if (!Ext.isEmpty(name)) {
            sql = sql + " and  s.specialName like ? ESCAPE '^'   ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql = sql + " and s.sellerId=? and ifnull(s.status,'')<>'9' "
        keyArr.push(loginInfo.storeId);
        sql = sql + " order by s.id desc limit " + limitCount + " offset (" + pageIndex + "-1)*" + limitCount;
        loadBySqlParam(sql, keyArr, callBack);
    },
    getSpecialPriceNotDel : function(callback) {
        var sql = "select * from specialprice where ifnull(isDeleted, '0')!='1' and ifnull(status, '0')!='9'";
        loadBySql(sql, callback);
    },
    /**
     * 总数
     * @param {Object} callBack(success,res|err)
     */
    landSpeciAndNameByPageTotal: function (name, callBack) {
        var sql = "SELECT count(s.id) as ttlNum  FROM specialprice s join commodityinfo b on s.commodityId=b.id where 1=1 and ifnull(b.status,'')<>'9'  ";
        var keyArr = [];
        // if (name) {
        //     sql = sql + ' and  s.specialName like ?  '
        //     keyArr.push('%' + name + '%');
        // }
        if (!Ext.isEmpty(name)) {
            sql = sql + " and  s.specialName like ? ESCAPE '^'   ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql = sql + " and s.sellerId=? and ifnull(s.status,'')<>'9' "
        keyArr.push(loginInfo.storeId);

        getBySql(sql, keyArr, callBack);
    },


    /*
     * 检查重复特价
     * */
    checkDulicateSpecial: function (parmaArray, callback) {

        var specialId = parmaArray[0];
        var commodityId = parmaArray[1];
        var newPriceWeek = parmaArray[2];
        var newStartDate = parmaArray[3];
        var newEndDate = parmaArray[4];
        var newStartTime = parmaArray[5];
        var newEndTime = parmaArray[6];
        var specialNormsName = parmaArray[7];
        var enableCheckVal = parmaArray[8];

        if(enableCheckVal=="0")
        {
             callback && callback(true, false);
             return;
        }

        //查询状态是激活特价
        var sql = "select * from specialprice s where ifnull(s.status,'')='1' and s.sellerId=? and s.commodityId=? "
        var keyArray = [];
        keyArray.push(loginInfo.storeId);
        keyArray.push(commodityId);
        if (!Ext.isEmpty(specialId)) {
            sql = sql + " and id<> ? ";
            keyArray.push(specialId);
        }
        if (!Ext.isEmpty(specialNormsName)) {
            sql = sql + " and specialNormsName=? ";
            keyArray.push(specialNormsName);
        }

        loadBySqlParam(sql, keyArray, function (success, items) {
            if (success && items) {
                var dateTimeOverlap = false;
                if (items.length <= 0) {
                    callback && callback(true, dateTimeOverlap);
                }
                else {
                    for (var i = 0; i < items.length; i++) {
                        var item = items[i];
                        if (!Ext.isEmpty(newPriceWeek)) {
                            //周期验证
                            if (!Ext.isEmpty(item.specialPriceWeek)) {
                                if (!SettingUtil.isWeekDayOverlap(newPriceWeek, item.specialPriceWeek))
                                    continue;
                            }
                            else {
                                if (!SettingUtil.isDateAndWeekOverlap(item.specialPriceStartDate, item.specialPriceEndDate, newPriceWeek))
                                    continue;
                            }
                        }
                        else {
                            //日期验证
                            if (!Ext.isEmpty(item.specialPriceWeek)) {
                                if (!SettingUtil.isDateAndWeekOverlap(newStartDate, newEndDate, item.specialPriceWeek))
                                    continue;
                            }
                            else {
                                if (!SettingUtil.isDateOverlap(newStartDate, newEndDate, item.specialPriceStartDate, item.specialPriceEndDate))
                                    continue;
                            }
                        }

                        //存在相同时间点
                        if (SettingUtil.isDateTimeOverlap(newStartTime, newEndTime, item.specialPriceStartTime, item.specialPriceEndTime)) {
                            dateTimeOverlap = true;
                            break;
                        }

                    }

                    callback && callback(true, dateTimeOverlap);
                }
            }
            else {
                callback && callback(false);
            }
        });
    }
}