var UnitInfoDao=
    {
        /**
         * 查询所有数据
         * @param {Object} callBack(success,res|err)
         */
        loadAllData : function(callBack) {
            //console.log(keyword);
            var sql = "SELECT * FROM sellerunit  ";
            loadBySql(sql, callBack);
        },


        /**
         * 查询所有已有单位名称
         * @param {Object} callBack(success,res|err)
         */
        loadUnitName : function(callBack) {
            var sql = "SELECT unitName  FROM sellerunit";
            loadBySql(sql, callBack);
        },


        /**
         * 分页查询
         * @param {Object} callback(success,res|err)
         */
        loadUnitByPage: function (unitName, pageSize, pageIndex, callback) {
            var sql = "SELECT * from sellerunit where 1=1 ";
            var keyArr=[];
            if (!Ext.isEmpty(unitName)) {
                sql = sql + " and  unitName like ? ESCAPE '^'   ";
                keyArr.push('%' + replaceSQLiteCharacters(unitName) + '%');
            }
            sql = sql + " Order by unitName limit ? offset ? ";
            keyArr.push(pageSize);
            keyArr.push( (pageIndex-1)*pageSize );
            loadBySqlParam(sql, keyArr, callback);
        },

        /**
         * 分页查询
         * @param {Object} callback(success,res|err)
         */
        loadUnitByPageTotal: function (unitName, callback) {

            var sql = "SELECT count(id) as ttlNum from sellerunit where 1=1  ";
            var keyArr = [];
            if (!Ext.isEmpty(unitName)) {
                sql = sql + ' and  unitName like ? ESCAPE '^'  '
                keyArr.push('%' + replaceSQLiteCharacters(unitName) + '%');
            }
            getBySql(sql, keyArr, callback);
        },

        /**
         * 检查单位名称是否存在
         * @param {Object} callBack(success,res|err)
         */
        checkUnitExist : function(unit,id, callBack) {

            var keyArr=[];
            var sql = "SELECT * FROM sellerunit WHERE  1=1  ";
            if(!Ext.isEmpty(id)) {
                sql=sql+' and id<>? '
                keyArr.push(id);
            }
            if(!Ext.isEmpty(unit))
            {
                sql=sql+' and unitName = ? ';
                keyArr.push(unit);
            }

            loadBySqlParam(sql,keyArr, callBack);
        },

        /**
         * 查询数据
         * @param {Object} callback(success,err)
         */
        getById : function(id, callback) {
            var sql = "SELECT * FROM sellerunit where id=? ";
            getBySql(sql,[id],callback);
        },

        /**
         * 更新数据
         * @param {Object} callback(success,err)
         */
        updateUnitNameById : function(sqlData,id, callback) {
            update('sellerunit',sqlData,id,callback)
        },

        /**
         *增加单位类别
         * @param {Object} callback(success,err)
         */
        addUnitNameInfo : function(sqlData, callBack) {
            insert("sellerunit", sqlData, callBack);
        },
        /**
         *删除数据
         */
        delete : function(id, callBack) {
            del("sellerunit", id, callBack);
        }
    }
