/*******************************************************************************
 * 获取随机数
 *
 * @param {}
 *            min
 * @param {}
 *            max
 * @return {}
 */
function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function roudTheNum(num) {
    return Math.round(num * Math.pow(10, 2)) / Math.pow(10, 2);
}

String.prototype.startWith = function (str) {
    var reg = new RegExp("^" + str);
    return reg.test(this);
};

String.prototype.endWith = function (str) {
    var reg = new RegExp(str + "$");
    return reg.test(this);
};

Date.prototype.format = function (format) {
    var o = {
        "M+": this.getMonth() + 1, // month
        "d+": this.getDate(), // day
        "h+": this.getHours(), // hour
        "m+": this.getMinutes(), // minute
        "s+": this.getSeconds(), // second
        "q+": Math.floor((this.getMonth() + 3) / 3), // quarter
        "S": this.getMilliseconds()
        // millisecond
    };

    if (/(y+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }

    for (var k in o) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
        }
    }
    return format;
};

/**
 * 去数组重复数据
 * @param arr
 * @returns {*}
 */

function removeByValue(arr, val) {
    for(var i=0; i<arr.length; i++) {
        if(arr[i] == val) {
            arr.splice(i, 1);
            i--;
        }
    }
}
/**
 * 替换SQLite特殊字符
 * @param string
 * @return string
 */
function replaceSQLiteCharacters(str) {

    if (Ext.isEmpty(str))
        return "";

    var regPercent = new RegExp('%', 'g');
    var str = str.replace(regPercent, '^%');
    var regUnderline = new RegExp('_', 'g');
    var str = str.replace(regUnderline, '^_');
    return str;
}

/**
 * 验证字符是否合法，是否含有标签符号
 * @param string
 * @return boolean
 */
function isEmojiCharacter(substring) {//验证字符是否合法，是否含有标签符号
    for (var i = 0; i < substring.length; i++) {
        var hs = substring.charCodeAt(i);
        if (0xd800 <= hs && hs <= 0xdbff) {
            if (substring.length > 1) {
                var ls = substring.charCodeAt(i + 1);
                var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
                if (0x1d000 <= uc && uc <= 0x1f77f) {
                    return true;
                }
            }
        } else if (substring.length > 1) {
            var ls = substring.charCodeAt(i + 1);
            if (ls == 0x20e3) {
                return true;
            }
        } else {
            if (0x2100 <= hs && hs <= 0x27ff) {
                return true;
            } else if (0x2B05 <= hs && hs <= 0x2b07) {
                return true;
            } else if (0x2934 <= hs && hs <= 0x2935) {
                return true;
            } else if (0x3297 <= hs && hs <= 0x3299) {
                return true;
            } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030
                || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b
                || hs == 0x2b50) {
                return true;
            }
        }
    }
}

/**
 * 时间戳转日期
 * @param timestamp
 * @param format
 * @returns
 */
function timestampToDate(timestamp, format) {
    format = format ? format : 'yyyy-MM-dd hh:mm:ss';
    return new Date(parseInt(timestamp)).format(format);
}
/*验证正数(前面8位整数最多两位小数)*/
function checkPositiveNumber(obj) {

    if (Ext.isEmpty(obj))
        return false;

    //var re = /(^[0-9]{1,8})+(.[0-9]{1,2})?$/;
    var re = /^(?:(?:(?:[1-9]\d{0,2}(?:,\d{3})*)|[1-9]\d*|0))(?:\.\d{1,2})?$/;

    if (typeof obj == "object") {
        if (!re.test(obj.value)) {
            return false;
        } else {
            if(Number(obj.value)>=100000000)
            {
                return false;
            }
            else {
                return true;
            }
        }
    } else {
        if (!re.test(obj)) {
            return false;
        } else {
            if(Number(obj)>=100000000)
            {
                return false;
            }
            else {
                return true;
            }
        }
    }
}
/*验证金额正数(前面7位整数最多两位小数)*/
function checkPositiveNumber2(obj) {
    if (Ext.isEmpty(obj))
        return false;
    var re = /^(?:(?:(?:[1-9]\d{0,2}(?:,\d{3})*)|[1-9]\d*|0))(?:\.\d{1,2})?$/;
    if (typeof obj == "object") {
        if (!re.test(obj.value)) {
            return false;
        } else {
            if (Number(obj.value) >= 10000000) {
                return false;
            } else {
                return true;
            }
        }
    } else {
        if (!re.test(obj)) {
            return false;
        } else {
            if (Number(obj) >= 10000000) {
                return false;
            } else {
                return true;
            }
        }
    }
}
/*验证数量正数(前面6位整数最多两位小数)*/
function checkPositiveAmount2(obj) {
    if (Ext.isEmpty(obj))
        return false;
    var flag = checkPositiveNumber(obj);
    if (!flag) {
        return flag;
    } else if (Number(obj) >= 0 && Number(obj) < 1000000) {
        return true;
    } else {
        return false;
    }
}
/*验证正数(前面4位整数最多两位小数)*/
function checkPositiveAmount(obj) {
    if (Ext.isEmpty(obj))
        return false;

    //var re=/(^[0-9]{1,4})+(.[0-9]{1,2})?$/;
    var flag = checkPositiveNumber(obj);
    if (!flag) {
        return flag;
    }
    else if (Number(obj) >= 0 && Number(obj) < 10000) {
        return true;
    }
    else {
        return false;
    }

    // if (typeof obj == "object") {
    //     if (!re.test(obj.value)) {
    //         return false;
    //     } else {
    //         return true;
    //     }
    // } else {
    //     if (!re.test(obj)) {
    //         return false;
    //     } else {
    //         return true;
    //     }
    // }

}
/**
 * 是否是整数
 * */
function isIntegerDigital(value) {
    var regu = /^[-]?[0-9]+(.[0]+|)$/;
    return regu.test(value);
}
/**
 * 是否是数字
 * @param value
 * @returns
 */
function isDigital(value) {
    var regu = /^[-]?[0-9]+(.[0-9]+|)$/;
    return regu.test(value);
}
/**
 * @param number 数字型
 * @param decimal  小数位数
 * @returns 原值或整型或浮点型
 */
function roundNumber(number, decimal) {
    if (!number && number != 0) return number;
    if (!isDigital(number)) return number;
    if (!decimal) return parseInt(number);  // 转整型
    // 转指定小数位数的浮点数!
    return parseFloat(parseFloat(number).toFixed(decimal));
}

/* 验证正数 */
function checkNumber(value) {
    var re = /^[0-9]\d*$/;
    if (!re.test(value)) {
        return false;
    } else {
        return true;
    }
}

/* 验证整数 */
function isInteger(str) {
    var regu = /^[-]{0,1}[0-9]{1,}$/;
    return regu.test(str);
}

/* 正整数 */
function isPositiveInteger(str) {
    var regu = /^[1-9]{1}[0-9]{0,}$/;
    return regu.test(str);
}

//是否是手机号码
function checkPhoneNumber(str) {
    //var reg = /^1[3|4|5|8][0-9]\d{4,8}$/;
    var reg = /^1[3|4|5|6|7|8|9][0-9]\d{4,8}$/;
    return reg.test(str);
}
// 是否是邮箱
function checkemail(str) {
    var reg = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/;
    return reg.test(str)
}
//验证固定电话
function checkPhone(str) {
    // var reg = /^(\(\d{3,4}\)|\d{3,4}-|\s)?\d{7,14}$/;//([0-9]{3,4}-)?[0-9]{7,8}
    var reg = new RegExp("([0-9]{3,4}-)?[0-9]{7,8}");
    return reg.test(str)
}

function isBankCard(str) {
    var reg = /^(\d{16}|\d{19})$/;
    return reg.test(str);
}
//验证是否是数字
function isAllNumber(str) {
    var reg = new RegExp("^[0-9]*$");
    return reg.test(str);
}
//验证身份证号码
function checkIDNumber(str) {
    var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
    return reg.test(str)
}

function isIPAddress(ip) {
    var reg = /^((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))))$/;
    if (ip) {
        if (!reg.test(ip))
            return false;
    } else
        return false;
    return true;
}
/**
 * 验证邮箱
 * @param mail
 * @returns {boolean}
 * @constructor
 */
function CheckMail(mail) {
    var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
    if (filter.test(mail))
        return true;
    else {
        return false;
    }
}
/**
 * 验证是否手机号码
 */
function isMobile(mobile) {
    //定义手机号码正规表达式
    //var reg = /^(130|131|132|133|134|135|136|137|138|139|140|141|142|143|144|145|146|147|148|149|150|151|152|153|155|156|157|158|159|180|181|182|183|184|185|186|187|188|189)\d{8}$/;
    //var reg = /^(13[0-9]|14[579]|15[012356789]|17[0135678]|18[0-9]|19[0-9])\d{8}$/;
    var reg = /^(13[0-9]|14[0-9]|15[0-9]|16[0-9]|17[0-9]|18[0-9]|19[0-9])\d{8}$/;
    if (mobile) {
        if (!reg.test(mobile)) {
            return false;
        }
    } else {
        return false;
    }
    return true;
}

/**
 * 验证用户名
 */
function isUserName(value) {
    var re = /^[a-zA-Z]+[a-zA-Z0-9_]*$/;
    if (!re.test(value)) {
        return false;
    } else {
        return true;
    }
}

/**
 * 创建商品的条形码
 */
function createBarCode(date) {
    var random = "";
    for (var i = 0; i < 1; i++) {
        random += getRandomInt(0, 9);
    }

    return date.format('yyMMddhhmmss') + random;
}


/**
 * 创建主键ID
 */
function createId(prefix) {
    var random = "";
    for (var i = 0; i < 8; i++) {
        random += getRandomInt(0, 9);
    }
    var dt = new Date();
    var ms = dt.getMilliseconds() + "";
    if (ms.length < 3) {
        for (var i = 0; i < 3; i++) {
            ms = '0' + ms;
        }
    }

    return prefix + dt.format("yyyyMMddhhmmss") + ms + random;
}

/**
 * 创建销售单ID
 */
function creatId(date, prefix) {
    var random = "";
    for (var i = 0; i < 8; i++) {
        random += getRandomInt(0, 9);
    }
    var ms = date.getMilliseconds() + "";
    if (ms.length < 3) {
        for (var i = 0; i < 3; i++) {
            ms = '0' + ms;
        }
    }

    return prefix + date.format("yyyyMMddhhmmss") + ms + random;
}

/**
 * 生成销售音ID
 */
function createSellId(date, prefix) {
    if (!date) {
        date = new Date();
    }
    var random = "";
    for (var i = 0; i < 8; i++) {
        random += getRandomInt(0, 9);
    }
    return seller.userName + prefix + date.format("yyyyMMddhhmmss") + random;
}

/**
 * 销售明细类型
 * @param {Object} type0下单，1追加
 */
function getSellDetailType(type) {
    if (type == '1') {
        return "追加";
    } else {
        return "下单";
    }
}

/**
 * 校验数据，如果为空则设置成默认值
 * @param {Object} value
 * @param {Object} defaultValue
 */
function nvlValue(value, defaultValue) {
    if (!value || value == 'null' || value == 'undefined') {
        value = defaultValue;
    }
    return value;
}

/**
 * 校验数据，如果为空则设置成默认值
 * @param {Object} value
 * @param {Object} defaultValue
 */
function nvlValues(value, defaultValue) {
    if(value === 0||value == '0'){
        return defaultValue;
    }
    if (!value || value == 'null' || value == 'undefined'|| value == 'NaN' || value ==null) {
        if(defaultValue==0||defaultValue=='0'){
            value=defaultValue;
        }else{
            value = defaultValue||"";
        }
    }
    return value;
}
/**
 * 是否是可用的数字(用于判断纯数字包括零)
 * @returns
 */
function isValidDigital(value) {
    if(/^(|-)\d+(|\.[0-9]+)$/g.test(value+"")) return true;
    return false;
}
var zindex = 1000;

function showConfirmPay(title, message, fn) {
    var id = creatId(new Date(), 'SCFPAY_SPECIAL');
    //var id = "SCF-DATE-CONFIRM-PAY-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        modal: true,
        id: id,
        hideOnMaskTap: false,
        width: 200,
        height: 150,
        zIndex: zindex++,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 35,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                text: '取消',
                cls: 'white-button',
                id: 'show-cancel-view-pay-btn',
                handler: function () {
                    if (fn) {
                        fn('no');
                    }
                    Ext.getCmp(id).destroy();
                }
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                margin: '0 0 0 5',
                cls: 'red-button',
                text: '确定',
                id: 'show-confirm-view-pay-btn',
                handler: function () {
                    if (fn) {
                        fn('yes');
                    }
                    Ext.getCmp(id).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    msgView.show();
    msgView.setAutoDestroy(true);

    return id;
}
/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showConfirm(title, message, fn, width, height) {
    var id = creatId(new Date(), 'SCF_SPECIAL');
    //var id = "SCF-DATE-CONFIRM-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        modal: true,
        id: id,
        hideOnMaskTap: false,
        width: width ? width : 200,
        height: height ? height : 150,
        zIndex: zindex++,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 35,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                text: '取消',
                cls: 'white-button',
                id: 'show-cancel-view-btn',
                handler: function () {
                    if (fn) {
                        fn('no');
                    }
                    Ext.getCmp(id).destroy();
                }
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                margin: '0 0 0 5',
                cls: 'red-button',
                text: '确定',
                id: 'show-confirm-view-btn',
                handler: function () {
                    if (fn) {
                        fn('yes');
                    }
                    Ext.getCmp(id).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    msgView.show();
    msgView.setAutoDestroy(true);

    return id;
}

function showCloseConfirmWithWx(title, message, fn) {
    var idCmp = creatId(new Date(), 'SCCF_WX_SPECIAL');
    //var idCmp = "SCCF-DATE-DIALOG-WX-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        modal: true,
        zIndex: zindex++,
        hideOnMaskTap: false,
        width: 200,
        height: 150,
        id: idCmp,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 35,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                text: '取消',
                cls: 'white-button',
                handler: function () {
                    if (fn) {
                        fn('no');
                    }
                    Ext.getCmp(idCmp).destroy();
                }
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                margin: '0 0 0 5',
                cls: 'red-button',
                text: '确定',
                //id : idCmp + 'btn',
                id: 'show-close-confirm-wx-btn',
                handler: function () {
                    if (fn) {
                        fn('yes');
                    }
                    Ext.getCmp(idCmp).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    msgView.show();
    //closeAlertInterval(idCmp, 10);
    closeConfirmWxInterval(idCmp, 10);
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showCloseConfirm(title, message, fn) {
    var idCmp = creatId(new Date(), 'SCCF_SPECIAL');
    //var idCmp = "SCCF-DATE-DIALOG-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        modal: true,
        zIndex: zindex++,
        hideOnMaskTap: false,
        width: 200,
        height: 150,
        id: idCmp,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 35,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                text: '取消',
                cls: 'white-button',
                handler: function () {
                    if (fn) {
                        fn('no');
                    }
                    Ext.getCmp(idCmp).destroy();
                }
            }, {
                xtype: 'button',
                height: 30,
                width: 80,
                margin: '0 0 0 5',
                cls: 'red-button',
                text: '确定',
                //id : idCmp + 'btn',
                id: 'show-close-confirm-btn',
                handler: function () {
                    if (fn) {
                        fn('yes');
                    }
                    Ext.getCmp(idCmp).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    msgView.show();
    //closeAlertInterval(idCmp, 10);
    closeConfirmInterval(idCmp, 10);
}

function showAlertWidthCallback(title, message, fn) {
    showAlert(title, message, 0, 0, 0, fn);
}
function showAlertWithWH(title, message, width, height, fn) {
    showAlertWH(title, message, 0, 0, width, height, fn);
}
function showAlertWH(title, message, left, top, width, heigth, fn, parent) {
    var idCmp = creatId(new Date(), 'SAWH_SPECIAL');
    //var idCmp = "SCCF-DATE-ALERT-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        modal: true,
        hideOnMaskTap: false,
        id: idCmp,
        width: width ? width : 200,
        zIndex: zindex++,
        height: heigth ? heigth : 150,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 40,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                iconMask: true,
                margin: '0 0 0 1',
                height: 30,
                width: 100,
                cls: 'red-button',
                text: '确定',
                id: 'show-alert-view-btn',
                handler: function () {
                    if (fn) {
                        fn();
                    }
                    Ext.getCmp(idCmp).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    if (parent) {
        msgView.showBy(parent);
    } else {
        msgView.show();
    }
    if (left) {
        msgView.setLeft(left);
    }
    if (top) {
        msgView.setTop(top);
    }
}
/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showAlertWithHeight(title, message, heigth, fn) {
    showAlert(title, message, 0, 0, heigth, fn);
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showAlertWithParent(parent, title, message, heigth, fn) {
    showAlert(title, message, 0, 0, heigth, fn, parent);
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showAlert(title, message, left, top, heigth, fn, parent) {
    var idCmp = creatId(new Date(), 'SA_SPECIAL');
    //var idCmp = "SCCF-DATE-ALERT-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        modal: true,
        hideOnMaskTap: false,
        id: idCmp,
        width: 200,
        zIndex: zindex++,
        height: heigth ? heigth : 150,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 40,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                iconMask: true,
                margin: '0 0 0 1',
                height: 30,
                width: 100,
                cls: 'red-button',
                text: '确定',
                id: 'show-alert-view-btn',
                handler: function () {
                    if (fn) {
                        fn();
                    }
                    Ext.getCmp(idCmp).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    if (parent) {
        msgView.showBy(parent);
    } else {
        msgView.show();
    }
    if (left) {
        msgView.setLeft(left);
    }
    if (top) {
        msgView.setTop(top);
    }
}

function showCloseAlert(title, message, ti, fn) {
    var id = creatId(new Date(), 'SCA_SPECIAL');
    //var id = "SCA-DATE-ALERT-VIEW";
    var msgView = Ext.Viewport.add({
        xtype: 'panel',
        centered: true,
        id: id,
        modal: true,
        hideOnMaskTap: false,
        width: 200,
        height: 150,
        zIndex: zindex++,
        scrollable: false,
        layout: 'vbox',
        items: [{
            xtype: 'toolbar',
            title: title,
            docked: 'top'
        }, {
            xtype: "label",
            margin: '10 0 0 0',
            flex: 1,
            html: "<center>" + message + "</center>"
        }, {
            xtype: 'panel',
            height: 40,
            layout: 'hbox',
            items: [{
                xtype: 'spacer'
            }, {
                xtype: 'button',
                iconMask: true,
                margin: '0 0 0 1',
                height: 30,
                width: 100,
                text: '确定',
                cls: 'red-button',
                //id : id + 'btn',
                id: 'show-close-alert-confirm-btn',
                handler: function () {
                    if (fn) {
                        fn();
                    }
                    Ext.getCmp(id).destroy();
                }
            }, {
                xtype: 'spacer'
            }]
        }]
    });
    msgView.show();
    closeAlertInterval(id, ti);
}

var wxInterval = null;
function closeConfirmWxInterval(id, ti) {
    var k = ti - 1;
    if (wxInterval) {
        clearInterval(wxInterval);
        wxInterval = null;
    }
    wxInterval = setInterval(function () {
        if (k < 1) {
            window.clearInterval(wxInterval);
            wxInterval = null;
            if (Ext.getCmp(id)) {
                Ext.getCmp(id).destroy();
            }
            return;
        }
        //if (Ext.getCmp(id + 'btn')) {
        //	Ext.getCmp(id + 'btn').setText("确定" + "(" + k + "秒)");
        //} else {
        if (Ext.getCmp('show-close-confirm-btn')) {
            Ext.getCmp('show-close-confirm-btn').setText('确定' + "(" + k + "秒)");
        } else {
            window.clearInterval(wxInterval);
            wxInterval = null;
            if (Ext.getCmp(id)) {
                Ext.getCmp(id).destroy();
            }
            return;
        }
        k--;
    }, 1000);
}

function closeConfirmInterval(id, ti) {
    var k = ti - 1;
    var st = setInterval(function () {
        if (k < 1) {
            window.clearInterval(st);
            if (Ext.getCmp(id)) {
                Ext.getCmp(id).destroy();
            }
            return;
        }
        //if (Ext.getCmp(id + 'btn')) {
        //	Ext.getCmp(id + 'btn').setText("确定" + "(" + k + "秒)");
        //} else {
        if (Ext.getCmp('show-close-confirm-btn')) {
            Ext.getCmp('show-close-confirm-btn').setText('确定' + "(" + k + "秒)");
        } else {
            window.clearInterval(st);
            if (Ext.getCmp(id)) {
                Ext.getCmp(id).destroy();
            }
            return;
        }
        k--;
    }, 1000);
}

function closeAlertInterval(id, ti) {
    var k = ti - 1;
    var st = setInterval(function () {
        if (k < 1) {
            window.clearInterval(st);
            if (Ext.getCmp(id)) {
                Ext.getCmp(id).destroy();
            }
            return;
        }
        //if (Ext.getCmp(id + 'btn')) {
        //	Ext.getCmp(id + 'btn').setText("确定" + "(" + k + "秒)");
        //} else {
        if (Ext.getCmp('show-close-alert-confirm-btn')) {
            Ext.getCmp('show-close-alert-confirm-btn').setText('确定' + "(" + k + "秒)");
        } else {
            window.clearInterval(st);
            if (Ext.getCmp(id)) {
                Ext.getCmp(id).destroy();
            }
            return;
        }
        k--;
    }, 1000);
}

/**
 * 组装查询条件
 */
function mkWhere(data) {
    var arr = [];
    if (typeof data === 'object') {
        for (var i in data) {
            if (isNaN(data[i])) {
                arr.push(i + "='" + data[i] + "'");
            } else {
                arr.push(i + "=" + data[i] + "");
            }
        }
    }
    return arr.join(' , ');
}

function toUtf8(str) {
    var out, i, len, c;
    out = "";
    len = str.length;
    for (i = 0; i < len; i++) {
        c = str.charCodeAt(i);
        if ((c >= 0x0001) && (c <= 0x007F)) {
            out += str.charAt(i);
        } else if (c > 0x07FF) {
            out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
            out += String.fromCharCode(0x80 | ((c >> 6) & 0x3F));
            out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
        } else {
            out += String.fromCharCode(0xC0 | ((c >> 6) & 0x1F));
            out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
        }
    }
    return out;
}

/**
 * 限制输入长度
 * @param {Object} content
 * @param {Object} len
 * @param {Object} type1左2右对齐
 */
function limitLen(content, len, type) {
    if (!content) {
        if (typeof (content) == 'number') {
            content = '0';
        } else {
            content = "";
        }
    }
    content = content + '';
    var blen = getBLen(content);
    if (blen > len) {
        return content.substring(0, len) + "... ";
    } else {
        for (var i = blen; i < (len + 1); i++) {
            if (type == 2) {
                content = " " + content;
            } else {
                content += " ";
            }
        }
        return content;
    }
}

function limitLen2(content, len, type) {
    if (!content) {
        if (typeof (content) == 'number') {
            content = '0';
        } else {
            content = "";
        }
    }
    content = content + '';
    var blen = getBLen(content);
    if (blen > len) {
        return content.substring(0, len);
    } else {
        var dif = len - blen;

        for (var i = 0; i < dif; i++) {
            if (type == 2) {
                content = ' ' + content;
            } else {
                content += ' ';
            }
        }
        return content;
    }
}

function limitLenDoubleWidth(content, len, type) {
    if (!content) {
        if (typeof (content) == 'number') {
            content = '0';
        } else {
            content = "";
        }
    }
    content = content + '';
    var blen = getBLen(content);

    if (blen > len) {
        return content.substring(0, len);
    } else {
        var dif = len - blen;

        for (var i = 0; i < dif; i++) {
            if (type == 2) {
                content = ' ' + content;
            } else {
                content += ' ';
            }
        }
        return content;
    }
}
/**
 * 判断版本是否更新
 * @param {Object} callBack
 */
function isVersionUpdate(callBack) {
    Ext.Ajax.request({
        url: webHostVersionInterface + '/version/checkVersionNew?time=' + new Date().getTime(),
        useDefaultXhrHeader: false,
        params: {
            isWindows: Ext.os.is.Windows,
            brand: brand
        },
        success: function (response) {
            var result = Ext.JSON.decode(response.responseText);
            if (result.state) {
                var versionCode = parseFloat(result.versionCode);
                if (versionCode > parseFloat(version)) {
                    if (callBack) {
                        callBack(true, null, result.versionCode, result.packgeName, result.content);
                    }
                } else {
                    if (callBack) {
                        callBack(false, "当前已是最新版本!");
                    }
                }
            } else {
                if (callBack) {
                    callBack(false, result.msg);
                }
            }
        },
        failure: function (response, opts) {
            if (callBack) {
                callBack(false, "检查新版本出错，<br/>未连接到服务器，请检查网络状态！");
            }
        }
    });
}

/**
 * 打开升级提示
 */
function showUpgrade(versionCode, packgeName, content) {
    var upgradeView = Ext.Viewport.add({
        xtype: 'panel',
        id: 'upgradeView',
        centered: true,
        modal: true,
        hideOnMaskTap: false,
        hidden: true,
        width: 350,
        height: 255,
        scrollable: false,
        items: [{
            xtype: 'toolbar',
            title: '版本更新',
            docked: 'top'
        }, {
            xtype: 'formpanel',
            scrollable: false,
            width: '100%',
            height: 210,
            items: [{
                xtype: "panel",
                height: 30,
                html: '检测到新版本【' + versionCode + '】，立即更新吗?'
            }, {
                xtype: "fieldset",
                padding: 0,
                margin: 0,
                defaults: {
                    labelWidth: 70
                },
                items: [{
                    xtype: 'textareafield',
                    name: 'content',
                    height: 135,
                    readOnly: true,
                    value: content ? content : '未填写更新内容',
                    label: '详情'
                }]
            }, {
                xtype: 'spacer'
            }, {
                xtype: 'panel',
                layout: 'hbox',
                padding: '3 0 0 0',
                margin: 0,
                defaults: {
                    height: 40,
                    flex: 1
                },
                items: [{
                    xtype: 'button',
                    cls: 'white-button',
                    iconMask: true,
                    text: '取消',
                    handler: function () {
                        Ext.getCmp('upgradeView').destroy();
                    }
                }, {
                    xtype: 'button',
                    cls: 'red-button',
                    iconMask: true,
                    margin: '0 0 0 1',
                    text: '更新',
                    handler: function () {
                        var apkUrl = webHostVersionInterface + "/version/downPadPackge?brand=" + brand + "&fileName=" + packgeName;
                        window.CommonPlugin.upgradeVersion(apkUrl, packgeName, function (successData) {
                        }, function (msg) {
                            showAlert('升级出错', msg);
                        });
                        Ext.getCmp('upgradeView').destroy();
                    }
                }]
            }]
        }]
    });
    upgradeView.show();
}

/**
 * 判断激活码是否过期
 */
function isActivationOverdue() {
    //alert(new Date(parseInt(activationinfo.expirationDate)).format("yyyy-MM-dd hh:mm:ss"));
    return (parseInt(activationinfo.expirationDate) < new Date().getTime());
}

function showActivationInfo() {
    var activationView = Ext.Viewport.add({
        xtype: 'panel',
        id: 'activationView',
        centered: true,
        modal: true,
        hideOnMaskTap: false,
        hidden: true,
        width: 350,
        height: 200,
        top: 0,
        left: (clientWidth - 400) / 2,
        scrollable: false,
        items: [{
            xtype: 'toolbar',
            title: '收银系统激活',
            docked: 'top'
        }, {
            xtype: 'formpanel',
            scrollable: false,
            cls: 'bggreen',
            width: '100%',
            height: 150,
            items: [{
                xtype: "fieldset",
                margin: '5 0 5 0',
                defaults: {
                    labelWidth: 70
                },
                items: [{
                    xtype: 'textfield',
                    id: 'activationCode',
                    name: 'activationCode',
                    label: '激活码'
                }]
            }, {
                xtype: 'fieldset',
                layout: 'hbox',
                padding: '0 0 0 0',
                margin: '0 0 0 0',
                defaults: {
                    height: 40,
                    width: '100%'
                },
                items: [{
                    xtype: 'button',
                    cls: 'red-button',
                    iconMask: true,
                    margin: '0 0 0 1',
                    text: '激活',
                    handler: function () {
                        var activationCode = Ext.getCmp('activationCode').getValue();
                        nativePostRequest('/syndata/validateActivation?time=' + new Date().getTime(), {
                            activationCode: activationCode
                        }, function (response) {
                            var result = Ext.JSON.decode(response.responseText);
                            if (result.state) {
                                var newactivationinfo = {
                                    ecode: result.activationInfo.ecode,
                                    activationCode: activationCode + "",
                                    activationDate: new Date().format("yyyy-MM-dd hh:mm:ss"),
                                    isRegister: '0',
                                    activationStatus: result.activationInfo.activationStatus + "",
                                    expirationDate: result.activationInfo.expirationDate + ""
                                };
                                if (activationinfo && activationinfo.id) {
                                    SellerDao.updateActivationInfo(newactivationinfo, activationinfo.id);
                                } else {
                                    SellerDao.addActivationInfo(newactivationinfo);
                                }
                                seller.activationCode = activationCode + "";
                                showAlert('提示', "激活成功！");
                                Ext.getCmp('activationView').destroy();
                                isLogin();
                            } else {
                                showAlert('提示', result.msg ? result.msg : "激活失败，<br/>该激活码无效！");
                            }
                        }, function (msg) {
                            showAlert('提示', "激活失败，<br/>未连接到服务器，请检查网络状态！");
                        });
                    }
                }]
            }]
        }]
    });
    activationView.show();
}

/**
 * 判断版本是否更新
 * @param {Object} callBack
 */
function isActivation(callBack) {
    SellerDao.getActivationInfo(function (success, res) {
        if (!res) {
            showActivationInfo();
        } else {
            seller.activationCode = res.activationCode;
            activationinfo = {
                id: res.id,
                ecode: res.ecode,
                activationCode: res.activationCode,
                activationDate: res.activationDate,
                isRegister: res.isRegister,
                expirationDate: res.expirationDate
            };
            if (isActivationOverdue()) {
                showActivationInfo();
                showAlert("登录失败", "激活码【" + activationinfo.activationCode + "】已过期，请购买正式版或者续费！");
            } else {
                isLogin();
            }

        }
    });
}

function isLogin() {
    SellerDao.getLocalUser(function (success, sellerItem) {
        if (!success || !sellerItem) {
            showLogin();
        }
    });
}

function addViewport(xtype, id, width, height, left, top, modal) {
    return Ext.Viewport.add({
        xtype: 'panel',
        id: id,
        modal: modal ? modal : true,
        width: width,
        centered: true,
        top: top,
        left: left,
        height: height,
        style: 'padding:0',
        layout: {
            type: 'vbox',
            align: 'center'
        },
        items: [{
            xtype: xtype
        }]
    });
}

/**
 * 读取地址参数
 * @param {Object} strName
 */
function getRequestParam(paramName) {
    var strHref = location.href;
    var intPos = strHref.indexOf("?");
    if (!intPos == -1) {
        return "";
    }
    var strRight = strHref.substr(intPos + 1);
    var arrTmp = strRight.split("&");
    for (var i = 0, len = arrTmp.length; i < len; i++) {
        var arrTemp = arrTmp[i].split("=");
        if (arrTemp[0].toUpperCase() == paramName.toUpperCase()) {
            return arrTemp[1];
        }
    }
    return "";
}

function getBLen(str) {
    if (str == null)
        return 0;
    if (typeof str != "string") {
        str += "";
    }
    return str.replace(/[^x00-xff]/g, "01").length;
}

function showLoading(title, context) {
    task = Ext.create('Ext.util.DelayedTask', function () {
        Ext.Viewport.mask({
            xtype: 'loadmask',
            centered: true,
            fullscreen: true,
            showAnimation: 'slideIn',
            transparent: false,
            message: title ? title : "正在处理，请稍后.."
        });
    }, context);
    task.delay(100);
}

function closeLoading() {
    if (task) {
        task.cancel();
        task = null;
    }
    Ext.Viewport.unmask();
}

function beep(path) {
    //console.log(path);
    if (typeof path == 'undefined' || !path) {
        path = 'apple.mp3';
    }

    if (!audio) {
        audio = new Ext.Audio();
        audio.setUrl(path);
    }
    audio.play();
}

/**
 * 更茶位费单价
 * @param {Object} teaPrice
 */
function updateTeaPrice(teaPrice) {
    SellerDao.updateSeller({
        teaPrice: teaPrice
    }, seller.id, function (success) {
        seller.teaPrice = teaPrice;
    });
}

function createRedMask(message, color) {
    Ext.Viewport.mask({
        xtype: 'loadmask',
        centered: true,
        showAnimation: 'slideIn',
        fullscreen: true,
        message: "<font color='" + color + "'>" + message + "</font>"
    });
}

var util = {
    getAfterOneHourTimeByTime: function (date) {
        var dt = new Date(date);
        var ms = new Date(dt).getTime();
        return new Date(ms + 3600000);
    },

    addZero: function (num) {
        return num < 10 ? "0" + num : num;
    },

    isLeapYear: function (pYear) {
        if (!isNaN(parseInt(pYear))) {
            if ((pYear % 4 == 0 && pYear % 100 != 0) || (pYear % 100 == 0 && pYear % 400 == 0)) {
                return true;
            }
        }
        return false;
    },
    getDateStr: function (addDayCount) {
        var dd = new Date();
        dd.setDate(dd.getDate() + addDayCount);
        //获取AddDayCount天后的日期
        var y = dd.getFullYear();
        var m = dd.getMonth() + 1;
        //获取当前月份的日期
        var d = dd.getDate();
        return y + "-" + (m < 10 ? ("0" + m) : m) + "-" + (d < 10 ? ("0" + d) : d);
    },
    toDate: function (timestamp) {
        if (!timestamp) {
            return "";
        }
        timestamp = parseInt(timestamp);
        // 将当前时间换成时间格式字符串
        var newDate = new Date();
        newDate.setTime(timestamp);
        return newDate.format("yyyy-MM-dd hh:mm:ss");
    }
};


function urlInterceptor(url) {
    if (!url) return false;
    if (url.indexOf('updateData') > -1
        || url.indexOf('updateOtherData') > -1
        || url.indexOf('validateActivation') > -1
        || url.indexOf('loadPushOrder') > -1
        || url.indexOf('dealOrder') > -1
        || url.indexOf('updateCommodityType') > -1
        || url.indexOf('updateCommodity') > -1
        || url.indexOf('updateCustomer') > -1
        || url.indexOf('updateDataNew') > -1) return true;

    return false;
}
/**
 * 原生post request请求
 * @param {Object} url
 * @param {Object} params
 * @param {Object} callBack
 */
function nativePostRequest(url, params, success, failure, timeout) {
    /* if (isPreviewVersion) {
     if (!urlInterceptor(url)) {
     //console.log('interceptor url');
     success && success({
     state : true,
     msg : '测试账号访问被拒绝,请注册商家账号!'
     });
     return;
     }
     }*/
    nativeRequest(url, params, 'post', success, failure, timeout);
}

/**
 * 原生get request请求
 * @param {Object} url
 * @param {Object} params
 * @param {Object} callBack
 */
function nativeGetRequest(url, params, success, failure, timeout) {
    nativeRequest(url, params, 'get', success, failure);
}

/**
 * 检查是否有权限
 * @param {Object} permissions
 */
function checkPermissions(permissions, isShow) {
    var p = cashierPermissions + ",";
    if (cashierPermissions && p.indexOf(permissions + ",") != -1) {
        return true;
    }
    if (isShow) {
        showAlert('提示', '对不起，您没有该项权限！');
    }
    return false;
}

/**
 * 保存设置
 * @param {Object} data
 * @param {Object} callBack
 */
function updateSetting(data, callBack) {
    callBack = callBack || emFunc;
    SettingDao.updateSetting(data, setting.id, function (success, msg) {
        if (success) {
            SettingDao.getSetting(function (success, res) {
                if (success && res) {
                    setting = res;
                    callBack(true);
                } else {
                    callBack(false);
                }
            });
        } else {
            callBack(false);
        }
    });
}

//暂时停用一会
function timeoutDisable(id, sec) {
    var codeType;
    if (Ext.getCmp(id)) {
        Ext.getCmp(id).setDisabled(true);
    } else if ($('#' + id)) {
        $('#' + id).attr("disabled", true);
    }
    timeOutSet(id, sec);
}

function timeOutSet(id, sec) {
    sec = sec ? sec : 2000;
    setTimeout(function () {
        if (Ext.getCmp(id)) {
            Ext.getCmp(id).setDisabled(false);
        } else if ($('#' + id)) {
            $('#' + id).removeAttr("disabled");
        }
    }, sec);
}

function setDisable(id, boolean) {
    if (boolean) {
        if (Ext.getCmp(id)) {
            Ext.getCmp(id).setDisabled(true);
        }else if ($('#'+id)) {
            $('#'+id).attr("disabled", true);
        }
    } else if (!boolean) {
        if (Ext.getCmp(id)) {
            Ext.getCmp(id).setDisabled(false);
        } else if ($('#' + id)) {
            $('#' + id).removeAttr("disabled");
        }
    }
}
// /*验证正数(最多两位小数)*/
// function checkPositiveNumber(obj) {
// 	var re = /^(?:(?:(?:[1-9]\d{0,2}(?:,\d{3})*)|[1-9]\d*|0))(?:\.\d{1,2})?$/;
// 	if ( typeof obj == "object") {
// 		if (!re.test(obj.value)) {
// 			return false;
// 		} else {
// 			return true;
// 		}
// 	} else {
// 		if (!re.test(obj)) {
// 			return false;
// 		} else {
// 			return true;
// 		}
// 	}
// }

//空函数
var emFunc = function () {

};

//创建分类工具
function createPage() {
    return {};
}

(function ($) {
    $.PageUtil = function (arg) {
        this.page = {
            currPage: 1, //当前分页
            totalPage: 1, //总页数
            limitCount: (arg.limitCount ? arg.limitCount : 12)
        };
        //这个是私有变量，外部无法访问
        this.up = function () {//this.testFun方法，加上了this，就是公有方法了，外部可以访问。
            if (this.page.currPage < this.page.totalPage) {
                this.page.currPage += 1;
            }
        };
        this.down = function () {
            if (this.page.currPage < 2) {
                this.page.currPage = 1;
            } else {
                this.page.currPage -= 1;
            }
        };
        this.getTotalPage = function () {
            return this.page.totalPage;
        };
        this.getCurrPage = function () {
            return this.page.currPage;
        };
        this.setCurrPage = function (currPage) {
            this.page.currPage = currPage;
        };
        this.setTotalPage = function (totalPage) {
            this.page.totalPage = totalPage;
        };
        this.setLimitCount = function (limitCount) {
            this.page.limitCount = limitCount;
        };
        this.getLimitCount = function () {
            return this.page.limitCount;
        };
        this.getOffset = function () {
            var offset = this.page.currPage - 1;
            if (offset < 0) {
                offset = 0;
            }
            return offset;
        };
        this.reset = function () {
            this.page.currPage = 1;
        };
        this.countPage = function (totalCount) {
            this.page.totalPage = parseInt(totalCount / this.page.limitCount);
            if (totalCount > 0 && totalCount % this.page.limitCount > 0) {
                this.page.totalPage += 1;
            }
            if (this.page.totalPage < 2) {
                this.page.totalPage = 1;
            }
        };
    };
})(jQuery);

Array.prototype.remove = function (val) {
    var index = this.indexOf(val);
    if (index > -1) {
        this.splice(index, 1);
    }
};

String.prototype.repeat = function (n) {
    return new Array(n + 1).join(this);
};

function isArray(o) {
    return Object.prototype.toString.call(o) === '[object Array]';
}

function encodeJSON(value) {
    try {
        return JSON.stringify(value);
    } catch (err) {
        console.dir(err);
    }
    return '';
}
function decodeJSON(value) {
    try {
        return JSON.parse(value);
    } catch (err) {
        console.dir(err);
    }

    return '';
}
function upThingPage(thingPage, operator) {
    if (!thingPage) return;
    var totalPage = thingPage.getTotalPage();
    var curPage = thingPage.getCurrPage();
    if (curPage >= totalPage) return;
    thingPage.up();
    var limitCount = thingPage.getLimitCount();
    var startPage = thingPage.getOffset() * limitCount;
    var endPage = startPage + limitCount;
    operator(startPage, endPage);
}
function downThingPage(thingPage, operator) {
    if (!thingPage) return;
    var totalPage = thingPage.getTotalPage();
    var curPage = thingPage.getCurrPage();
    if (curPage <= 1) return;
    thingPage.down();
    var limitCount = thingPage.getLimitCount();
    var startPage = thingPage.getOffset() * limitCount;
    var endPage = startPage + limitCount;
    operator(startPage, endPage);
}

//判断一个对象是否为数组
function isArray(o) {
    return Object.prototype.toString.call(o) == '[object Array]';
}
/**
 * 创建时间
 */
function createDateStr(){
	return new Date().format('yyyy-MM-dd hh:mm:ss');
}

/**
 * 生成系统ID
 */
function createSysId() {
	var date = new Date();
	var random = "";
	for (var i = 0; i < 4; i++) {
		random += getRandomInt(0, 9)+"";
	}
	var prefix=loginInfo.storeId;
	if(prefix.length>14){
		prefix=loginInfo.sellerName;
	}
	if(prefix.length>14){
		prefix=prefix.substring(0,14);
	}
	return prefix + date.format("yyyyMMddhhmmss") + random;
}

/**
 * 用于比对两个字符串/数组间的存在关系
 * @param array 传入的数组或字符串
 * @param element 比对的元素和连续字符串（可为字符串）
 * @param searchType 'all' element比对字符串中所有都要存在，'one'比对字符串中只存在一个即可，default = 'all'
 * @returns {boolean} true 存在关系 false 不存在关系
 * 例子如下:
 */
/*
string = 'asdfghjkl'    ==      array = ['a','s','d','f','g','h','j','k','l'];
isInArray(string, 'asdf') => true;
isInArray(string, ['a','gh','s']) => ture;
isInArray(string, ['a','o'], 'all') => false;
isInArray(string, ['a', 'o'], 'one') => true;
*/
function isInArray(array, element, searchType) {
    searchType = searchType || 'all';
    if (typeof element == 'object') {
        if (searchType == 'all') {
            var isInArray = true;
            for (var ei = 0; ei < element.length; ei++) {
                if (array.indexOf(element[ei]) == -1) {
                    isInArray = false;
                }
            }
            return isInArray;
        } else if (searchType == 'one') {
            var isInArray = false;
            for (var ei = 0; ei < element.length; ei++) {
                if (array.indexOf(element[ei]) != -1) {
                    isInArray = true;
                }
            }
            return isInArray;
        }
    } else {
        return array.indexOf(element) != -1 ? true : false;
    }
}

/**
 * 获取datas中相应id的值
 * @param datas
 * @param id
 * @returns
 */
function getDataById(datas,id){
	if(!datas){
		return null;
	}
	for(var j=0;j<datas.length;j++){
		if(datas[j]&&datas[j].id==id){
			return datas[j];
		}
	}
	return null;
}

function createIdFromUUID() {
    try {
        var uuid = new Ext.data.UuidGenerator().generate();
        return uuid.replace(/-/g, '');
    } catch(err) {
        return "";
    }
}

/**
 * 保留数字小数点位数或取整
 * @param value
 * @param fixCounts(可以不传值)
 * @returns {*}
 */
function parseDigitalDecimal(value, fixCounts) {
    var fixCounts = fixCounts || 2;
    // if(isIntegerDigital(value)) return parseInt(value);
    if (isDigital(value)) {
        return parseFloat(value).toFixed(fixCounts);
    }
    return value; // 非数字返回原值
}