 Ext.define('Seller.controller.SellController', {
	extend : 'Ext.app.Controller',
	// requires : ['Ext.util.Geolocation', 'Ext.dataview.List'],
	config : {
		// refs : {},
		control : {
            'textfield[id=sell-query]' : {
                clearicontap : function () {querySellInfoFieldCleariconTap()},
                change : function (filed, e, eOpts) {querySellInfoFieldChange(filed, e, eOpts)},
                keyup : function (field, e, eOpts) {querySellInfoFieldChange(field, e, eOpts)},
                focus : function () {querySellInfoFieldKeyFocus()}
            },
            'list[id=sell-categoryList]' : {
                initialize : function () {},
                select : function(view, record, eOpts) {sellListFunc(view, record, eOpts)},
            },
            'button[id=sell-main-view-close]' : {tap : function(currView, e, eOpts){preventEventBubble(e);sellInfoCloseViewFunc()}},
            'button[id=sellInfo-down-btn]' : {tap : function(currView, e, eOpts){preventEventBubble(e);downSell()}},
            'button[id=sellInfo-up-btn]' : {tap : function(currView, e, eOpts){preventEventBubble(e);upSell()}},
            'button[id=sell-printorder-btn]' : {tap : function(currView, e, eOpts){preventEventBubble(e);printOrderInfo()}},
            'button[id=sell-returnorder-btn]' : {tap : function(currView, e, eOpts){preventEventBubble(e);returnOrderFunc()}},
		}
	},
});

function sellInfoCloseViewFunc(){
    if (Ext.getCmp('self-input-sellInfo-num'))
        Ext.getCmp('self-input-sellInfo-num').destroy();
    Ext.getCmp('sell-main-view').destroy();
    // Ext.getCmp('shouyinMainView').show();
}

function querySellInfoFieldCleariconTap(){
    SellDao.getSellTotalCount(filed.getValue(), queryDeviceId, function(success, totalCount) {
        if (success) {
        	var me = Ext.getCmp('sell-main-view');
        	var limitSellCount = me.sellMainPage.getLimitCount();
            totalSellPage = parseInt(totalCount / limitSellCount);
            if (totalCount % limitSellCount > 0) {
                totalSellPage += 1;
            }
            currSellPage = 1;
            Ext.getCmp('sell-total-label').setHtml("1/" + totalSellPage);
            loadSellInfoPage(limitSellCount, 0);
        }
    });
}

function querySellInfoFieldChange(filed, e, eOpts) {
    SellDao.getSellTotalCount(filed.getValue(), Ext.getCmp('sell-main-view').queryDeviceId, function(success, totalCount) {
        if (success) {
        	var me = Ext.getCmp('sell-main-view');
        	var limitSellCount = me.sellMainPage.getLimitCount();
            totalSellPage = parseInt(totalCount / limitSellCount);
            if (totalCount % limitSellCount > 0) {
                totalSellPage += 1;
            }
            currSellPage = 1;
            Ext.getCmp('sell-total-label').setHtml("1/" + totalSellPage);
            loadSellInfoPage(limitSellCount, 0);
        }
    });
}

function sellListFunc(view, record, eOpts){
    Ext.getCmp('sell-main-view').loadDetail(record);
    if ("2" == record.get('sellType') || "2" == record.get('status') || "3" == record.get('status') || "5" ==record.get('status')) {
        Ext.getCmp('sell-returnorder-btn').setHidden(true);
        //Ext.getCmp('sell-printorder-btn').setHidden(true);
    } else {
        Ext.getCmp('sell-returnorder-btn').setHidden(false);
        //Ext.getCmp('sell-printorder-btn').setHidden(false);
    }
    // 只有在撤销状态下不显示打印单据
    if (record.get('sellType') === '0' && record.get('status') === '3') {
        Ext.getCmp('sell-printorder-btn').setHidden(true);
    } else if (record.get('sellType') === '1' && record.get('status') === '3') {
        Ext.getCmp('sell-printorder-btn').setHidden(true);
    } else {
        Ext.getCmp('sell-printorder-btn').setHidden(false);
    }
    if(record.get('sourceType') == '6') // 美团不支持反结账
        Ext.getCmp('sell-returnorder-btn').setHidden(true);
    if(record.get('payType') == '11') { // 免单
        Ext.getCmp('sell-returnorder-btn').setHidden(true);
    }
}

function printOrderInfo() {
    var categoryList = Ext.getCmp("sell-categoryList");
    //var store = categoryList.getStore();
    if (categoryList.getSelection().length < 1) {
        return;
    }
    var record = categoryList.getSelection()[0];
    if (record == null) {
        return;
    }
    var sellId = record.get('id');
    var status = record.get('status');//反结账 退货 销售
    var sellType = record.get('sellType');// 外卖
    PrintDao.printSellTicketLogic(sellId, status, sellType, null, true);
}

function returnOrderFunc(){
    timeoutDisable('sell-returnorder-btn');
    var categoryList = Ext.getCmp("sell-categoryList");
    if (categoryList.getSelection().length < 1) {
        return;
    }
    var record = categoryList.getSelection()[0];
    if (record == null) {
        return;
    }
    checkPermissions("3", true).then(function() {
    	var deviceId = record.get("deviceId");
        if(deviceId != seller.deviceId) {
        	showAlert("提示", "非本机的结算单,不能反结账!");
        	return;
        }
        SellDao.getSellInfoById(record.get('id'),function (success, data) {
            if (!success) showAlert('提示', data);
            if (success) {
                if(data.sellType=='1'){
                    showAlert('提示', '外卖单据不能进行反结账！');
                    return;
                }
                if (data.placeId != '' || data.placeId) {
                    var _placeId = data.placeId.split('-')[0];
                    ServicePlaceDao.getServicePlaceById(_placeId, function (success, placeData) {
                        if (success) {
                            if (placeData.status == '1' || placeData.status == '2') {
                                showAlert('提示', '该桌位已被占用，不能进行反结账！');
                                return;
                            } else if (placeData.status == '9') {
                                showAlert('提示', '该桌位已被删除，不能进行反结账！');
                                return;
                            }
                            else {
                                returnOrderMission();
                            }
                        }
                    })
                } else {
                    returnOrderMission();
                }
            }
        })
    }).catch(function() {});
    /*if (!checkPermissions("3", true)) {
        return;
    }
    var deviceId = record.get("deviceId");
    if(deviceId != seller.deviceId) {
    	showAlert("提示", "非本机的结算单,不能反结账!");
    	return;
    }
    SellDao.getSellInfoById(record.get('id'),function (success, data) {
        if (!success) showAlert('提示', data);
        if (success) {
            if(data.sellType=='1'){
                showAlert('提示', '外卖单据不能进行反结账！');
                return;
            }
            if (data.placeId != '' || data.placeId) {
                var _placeId = data.placeId.split('-')[0];
                ServicePlaceDao.getServicePlaceById(_placeId, function (success, placeData) {
                    if (success) {
                        if (placeData.status == '1' || placeData.status == '2') {
                            showAlert('提示', '该桌位已被占用，不能进行反结账！');
                            return;
                        } else if (placeData.status == '9') {
                            showAlert('提示', '该桌位已被删除，不能进行反结账！');
                            return;
                        }
                        else {
                            returnOrderMission();
                        }
                    }
                })
            } else {
                returnOrderMission();
            }
        }
    })*/
}
function returnOrderMission() {
    timeoutDisable('sell-returnorder-btn',1000);
    var sellTakeViewCmp = Ext.getCmp('sell-main-view');
    var reverseDialogIds = showConfirm('提示', '确定要对当前销售数据进行反结账吗？', function(buttonId) {
        if (buttonId == "yes") {
            openCashboxByPrint(function(){

            }, function(fail){
                showAlert('提示', fail);
            });
            if(sellTakeViewCmp) sellTakeViewCmp.SelltakeViewPayOff();
            return;

            var dialogData = {
                commodityNum : parseFloat(commodityNum).toFixed(2),
                sellAmount : sellAmount,
            };
            returnOrderFunCheckout(dialogData);
        }
        if(sellTakeViewCmp.reverseDialogId) sellTakeViewCmp.reverseDialogId=null;
    });
    if(reverseDialogIds && reverseDialogIds.length > 0) {
    	 if(sellTakeViewCmp)sellTakeViewCmp.reverseDialogId = reverseDialogIds[reverseDialogIds.length-1];
    }
}
function returnOrderClick() {
    setting.isReturnOrderCustomerPrint = Ext.getCmp('sell-returnOrder-customer-print').isChecked() ? true :false;
    setting.isReturnOrderPrivatePrint = Ext.getCmp('sell-returnOrder-private-print').isChecked() ? true : false;
    SettingDao.updateIsReturnOrderCheck({
            isReturnOrderCustomerPrint: setting.isReturnOrderCustomerPrint,
            isReturnOrderPrivatePrint: setting.isReturnOrderPrivatePrint
        }, setting.id, function (success, info) {
        if (!success) showAlert('提示', info);

    });
}
function returnOrderFunCheckout(data) {
    var commodityNum = data.commodityNum + '';
    var temp = commodityNum.split('.');
    if (temp[1] == '00') {
        commodityNum = parseInt(data.commodityNum);
    } else {
        commodityNum = parseFloat(data.commodityNum).toFixed(2);
    }
    var sellAccountView =Ext.Viewport.add(Ext.create('Seller.view.sell.ReturnOrder'));
    sellAccountView.showBy(Ext.getCmp('sell-main-view'), 'cc-cc?');
    sellAccountView.setData({commodityNum:commodityNum,sellAmount:data.sellAmount})
}
function printReturnOrderTips(record) {
    var sellId = record.get('id');
    var sellType = record.get('sellType');// 外卖
    PrintDao.printSellTicketLogic(sellId, null, sellType, '1');
    Ext.getCmp('SellAccountView').destroy();
}

function returnOrderDBFunc(record, oldSellInfo, oldSellDetails) {
    createNewSellInfoAndDetails(record, oldSellInfo, oldSellDetails, function (success, msg, codeUrl, sellId) {
        if (!success) {
            showAlert('提示', '反结账失败！');
            return;
        }

        var oldSellId = record.get('id');
        var optReason = record.get('optReason');
        var updateSellInfoData = {
        	id : oldSellId,
            status: '2',
            isHandover: '0',
            syned: '0',
            isReverse: '1',
            reverseEmployeeId: shouYinEmployee.id,
            reverseEmployeeName: shouYinEmployee.workName,
            optReason: optReason
        };
        var serviceId = record.data.placeId.split('-')[0];
        var updateServicePlaceData = {
            status: '1',
        };
        record.set('status', '2');

        /* 不同的交接班 */
        if(record.get('handoverId') && record.get('handoverId') != shouYinEmployee.handoverId) {
            updateSellInfoData.isNewHandover = '1';
            updateSellInfoData.handoverId = shouYinEmployee.handoverId;
        } else {
        	updateSellInfoData.handoverId = shouYinEmployee.handoverId;
        }

        //操作来源，主机、副机、点菜宝
        if(Application.Ftype == Application.MASTER){
            updateSellInfoData.optSource = 'M';
        }else if(Application.Ftype == Application.SLAVE){
            updateSellInfoData.optSource = 'S';
        }else {
            updateSellInfoData.optSource = 'D';
        }

        ServicePlaceDao.updatePlace(updateServicePlaceData, serviceId, function (success) {
            if (!success) {
                showAlert('提示', '更新桌位状态失败！终止反结账流程');
                return;
            }
            var commodityInfos = {};
            var sdLen = oldSellDetails.length;
            for(var sdi=0;sdi<sdLen;sdi++) {
            	getSellNumFromSellDetail(oldSellDetails[sdi], commodityInfos);
            }
            SellDao.updateSellInfoAndStock(updateSellInfoData, commodityInfos, function(success) {
            	if(success) {
                    console.log('操作单据：订单' + oldSellId + '完成反结账--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
            		setTimeout(HandoverDao.countHandover(), 100);
            		//SellDao.submitById(oldSellId);
            		if (Ext.getCmp('sell-main-view') && Ext.getCmp('sell-main-view').sellMainPage && Ext.getCmp('sell-main-view').sellMainPage.getCurrPage())
            		loadSellInfoPage(limitSellCount, Ext.getCmp('sell-main-view').sellMainPage.getCurrPage()-1);
                    pushMasterSocket({viewIds:["sell-main-view"],operatorData:updateSellInfoData.id}, null, M_EVENT_TYPE.REFRESHVIEW);
            	}
            });
            /*SellDao.updateSellInfo(updateSellInfoData, oldSellId, function (success) {
                if (success) {
                    setTimeout(HandoverDao.countHandover(), 100);
                }
                SellDao.submitById(oldSellId);
                loadSellInfoPage(limitSellCount, 0);
            });*/
            ServicePlaceDao.submitPlaceById(serviceId);
        });
    });
}

function createNewSellInfoAndDetails(record, oldSellInfo, oldSellDetails, callback) {
    var date = new Date();
    var sellId = record.get('id');
    var sellAmount = parseFloat(record.get('sellAmount'));
    var totalAmount = parseFloat(record.get('totalAmount'));
    var teaAmount = parseFloat(nvlValue(record.get('teaAmount'), 0));
    var discount = parseFloat(nvlValue(record.get('discount'), 100));
    var couponMoney = parseFloat(nvlValue(record.get('couponMoney'), 0));
    var eraseZeroAmount = parseFloat(nvlValue(record.get('eraseZeroAmount'), 0));
    if (discount < 100) {
        // 打折
        sellAmount = parseFloat((sellAmount - teaAmount + eraseZeroAmount + couponMoney)/* * 100 / discount*/).toFixed(2);
        totalAmount = parseFloat(totalAmount - teaAmount).toFixed(2);
    } else {
        sellAmount = parseFloat(sellAmount + couponMoney - teaAmount + eraseZeroAmount).toFixed(2);
        totalAmount = parseFloat(totalAmount - teaAmount).toFixed(2);
    }
    var newSellInfo = oldSellInfo;
    var newSellDetails = oldSellDetails;
    if (isInArray(newSellInfo.id, '-')) {
        var sellInfoIndex = parseInt(newSellInfo.id.split('-')[1]) + 1;
        newSellInfo.id = newSellInfo.id.split('-')[0] + '-' + sellInfoIndex;
    } else {
        newSellInfo.id += '-1';
    }
    for (var sdi = 0; sdi < newSellDetails.length; sdi++) {
        var newSellDetail = newSellDetails[sdi];
        newSellDetail.id = createSellId(date, "SD");
        newSellDetail.sellId = newSellInfo.id;
        newSellDetail.createTime = date.format("yyyy-MM-dd hh:mm:ss");
        newSellDetail.orderByTime = date.getTime();
    }

    newSellInfo.status = '0';
    newSellInfo.isHandover = '0';
    newSellInfo.syned = '0';
    newSellInfo.endTime = null;
    newSellInfo.factAmount = '0';
    newSellInfo.cashAmount = '0';
    newSellInfo.wxpayAmount = '0';
    newSellInfo.unionpayAmount = '0';
    newSellInfo.payType = null;
    newSellInfo.couponId = null;
    newSellInfo.prepayAmount = '0';
    newSellInfo.alipayAmount = '0';
    newSellInfo.timepayAmount = '0';
    newSellInfo.pointspayAmount = '0';
    newSellInfo.surplusAmount = '0';
    newSellInfo.eraseZeroAmount = '0';
    newSellInfo.wxpayOnlineAmount = '0';
    newSellInfo.alipayOnlineAmount = '0';
    newSellInfo.sellAmount = sellAmount;
    newSellInfo.totalAmount = totalAmount;
    newSellInfo.couponMoney = '0';
    newSellInfo.discount = discount;
    newSellInfo.combinationAmount = null;
    newSellInfo.couponName = null;
    newSellInfo.cashierId = null;
    newSellInfo.cashierName = null;
    newSellInfo.isCoupon = '0';
    newSellInfo.orderId = null;
    newSellInfo.isComboPay = null;
    newSellInfo.sellTime = date.format("yyyy-MM-dd hh:mm:ss");
    newSellInfo.employeeScale = null;
    newSellInfo.saleScale = null;
    newSellInfo.waiterScale = null;
    delete newSellInfo.gainAmount;

    SellDao.createSellInfoByData(newSellInfo, newSellDetails, callback)
}

function querySellInfoFieldKeyFocus() {
    if (!Ext.getCmp('self-input-sellInfo-num'))
        sellInfoKeyboard();
    else showBy(Ext.getCmp('self-input-sellInfo-num'), Ext.getCmp('sell-main-view'));
     //Ext.getCmp('sell-query').blur();
}
function sellInfoKeyboard() {
    var inputID = 'sell-query';
    var me = this;
    var oldNum = Ext.getCmp(inputID).getValue();
    var titleText,labelText,placeHolderText;

    function resetInputfieldNumber() {
        Ext.getCmp('input-customer-num-identity').setValue(oldNum);
    }
    function getInputField() {
        return Ext.getCmp(inputID);
    }


    var inputSellInfoNumView = Ext.Viewport.add({
        xtype : 'panel',
        layout : 'vbox',
        bottom : 70,
        width : '88%',
        left : '6%',
        // left : 280,
        // cls : 'tm-bg',
        style : 'background: rgba(245,245,220,0.8);',
        margin : '0 auto',
        modal : false,
        // hideOnMaskTap : true,
        height : 240,
        id : 'self-input-sellInfo-num',
        showAnimation : {
            type: 'slideIn',
            direction : 'up',
            // easing : 'ease-in',
            duration: 500
        },
        hideAnimation : {
            type: 'slideOut',
            direction : 'down',
            easing : 'ease-out',
            duration: 500
        },
        items : {
            xtype : 'panel',
            layout : 'hbox',
            // width : '88%',
            // height : 260,
            width : '100%',
            height : '100%',
            cls : 'tm-bg',
            // margin : '0 auto',
            id : 'sell-wholeKeyboard',

            items : [{
                width : '100%',
                layout : 'vbox',
                margin : '10 10 10 10',
                flex : 5,
                defaults : {
                    flex : 1,
                    defaults : {
                        width : '8%',
                        margin : '8 4',
                    }
                },
                items : [{
                    xtype : 'panel',
                    layout : 'hbox',
                    defaults : {
                        width : '8%',
                        margin : '8 4',
                    },
                    items : [{
                        xtype : 'button',
                        // id : 'QButton',
                        text : 'Q',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'W',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'E',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'R',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'T',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'Y',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'U',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'I',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'O',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'P',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '@',
                        cls : 'keyword',
                        //disabled : true,
                        handler : sellInfoInputKeyValue
                    }]
                }, {
                    xtype : 'panel',
                    layout : 'hbox',
                    items : [{
                        xtype : 'button',
                        text : 'A',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'S',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'D',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'F',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'G',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'H',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'J',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'K',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'L',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '_',
                        cls : 'keyword',
                       // disabled : true,
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '*',
                        cls : 'keyword',
                        //disabled : true,
                        handler : sellInfoInputKeyValue
                    }]
                }, {
                    xtype : 'panel',
                    layout : 'hbox',
                    defaults : {
                        width : '8%',
                        margin : '8 4',
                    },
                    items : [{
                        xtype : 'button',
                        text : '∧',
                        cls : 'unkeyword',
                        disabled : true,
                        handler : shiftConfrimSmall
                    }, {
                        xtype : 'button',
                        text : 'Z',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'X',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'C',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'V',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'B',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'N',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : 'M',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '-',
                        cls : 'keyword',
                        //disabled : true,
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '/',
                        cls : 'keyword',
                        //disabled : true,
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '￥',
                        cls : 'keyword',
                        //disabled : true,
                        handler : sellInfoInputKeyValue
                    }]
                }]
            }, {
                layout : 'vbox',
                margin : 10,
                flex : 2.3,
                defaults : {
                    flex : 1,
                    defaults : {
                        width : '17.5%',
                        margin : '8 4',
                    }
                },
                items : [{
                    xtype : 'panel',
                    layout : 'hbox',
                    items : [{
                        xtype : 'button',
                        text : '1',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '2',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '3',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '0',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        cls : 'dl-delete',
                        id : 'sellInfo-input-delete',
                        handler : sellInfoInputKeyValue
                    }]
                }, {
                    xtype : 'panel',
                    layout : 'hbox',
                    items : [{
                        xtype : 'button',
                        text : '4',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '5',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '6',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '.',
                        cls : 'keyword',
                        //disabled : true,
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '清空',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }]
                }, {
                    xtype : 'panel',
                    layout : 'hbox',
                    items : [{
                        xtype : 'button',
                        text : '7',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '8',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        text : '9',
                        cls : 'keyword',
                        handler : sellInfoInputKeyValue
                    }, {
                        xtype : 'button',
                        width : '37%',
                        cls : 'redkeyword',
                        text : '确认',
                        handler : function() {
                            if (Ext.getCmp('self-input-sellInfo-num'))
                                Ext.getCmp('self-input-sellInfo-num').hide();
                        }
                    }]
                }]
            }]
        },
        listeners : {
            show : function (currView, eOpts) {
                hideOnTapOutside(currView, Ext.getCmp('sell-query'), 'hide');
            }
        }
        // wholeKeyboard()
    });
    // if(type == 0)
    // 	resetInputfieldNumber();
    Ext.getCmp('sell-wholeKeyboard').setCls('tm5-bg');
    showBy(inputSellInfoNumView ,Ext.getCmp('sell-main-view'));
}

function sellInfoInputKeyValue() {
    var comfirmId  = this.getId();
    var value = this.getText();
    var oldValue = Ext.getCmp('sell-query').getValue();

    if(value == '清空') Ext.getCmp('sell-query').setValue('');
    else if(value){
        // alert(value);
        Ext.getCmp('sell-query').setValue(oldValue + value);
    } else if(comfirmId == 'sellInfo-input-delete'){
        if (oldValue && oldValue.length > 1) {
            Ext.getCmp('sell-query').setValue(oldValue.substring(0, oldValue.length - 1));
        } else {
            Ext.getCmp('sell-query').setValue("");
        }
    }
    Ext.getCmp('sell-query').focus();
}
