Ext.define('Seller.view.commodity.AddCommoditySub', {
	extend : 'Seller.view.commodity.Commodity',
	alias : 'widget.addcommoditysub',
	constructor : function() {
		this.callParent(arguments);
	},
	initialize : function(panel, eOpts) {
		Ext.getCmp('commodity-toolbar').setTitle('添加商品');
		setTimeout(function() {
			Ext.getCmp('commodity-view-delete').setHidden(true);
		},100);
	},
	checkPermission : function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("16", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
		/*if (!checkPermissions("7", true)) {
			return false;
		}
		return true;*/
	},
	saveViewData : function(viewData) {
		var me = this;
		viewData.isDelete = '0';
		viewData.syned = '0';
		viewData.status = '1';
		viewData.lastUpdateTime=new Date().format('yyyy-MM-dd hh:mm:ss');
		CommodityDao.checkCommodityByType(viewData.typeId, viewData.name, function(success, datas) {
			if(success && datas) {
                if (datas.length && datas.length > 0) {
                    if (!datas[0].isDelete || (datas[0].isDelete && datas[0].isDelete !== '1')) {
                        showAlert('提示', '已经存在相同名称的商品');
                        me.closeOperator();
                        return;
                    }

                    viewData.isDelete = null;
                    viewData.id = datas[0].id;
                    CommodityDao.updateCommodity(viewData, datas[0].id, function (success) {
                        if (success) {
                            me.afterViewData(viewData);
                        } else {
                            showAlert('提示', '保存出错！');
                            me.closeOperator();
                        }
                    });
                    return;
                }
                viewData.isSupportNorms = '0';
                CommodityDao.addCommodity(viewData, function (success) {
                    if (success) {
                        me.afterViewData(viewData);
                    } else {
                        showAlert('提示', '保存出错！');
                        me.closeOperator();
                    }
                });
            }
		});
	},
	afterViewData : function(viewDatas) {
		this.callParent(arguments);
	}
});