Ext.define('Seller.view.commodity.AddCommodityTypeSub', {
	extend : 'Seller.view.commodity.CommodityType',
	alias : 'widget.addcommoditytypesub',
	constructor : function() {
		this.callParent(arguments);
	},
	initialize : function(panel, eOpts) {
		Ext.getCmp('commodity-type-toolbar').setTitle('添加商品分类');
		CommodityDao.getMaxSequence(function(success, res) {
			if (success) {
				var commodityTypeForm = Ext.getCmp('commodityTypeForm');
				commodityTypeForm.getFields("sequence").setValue(res ? parseInt(res) +1 : 0);
			}
		});
		setTimeout(function() {
			Ext.getCmp('commodityType-view-delete').setHidden(true);
		}, 100);
	},
	getKtPrinterJson : function() {
		return {};
	},
	checkPermission : function() {
		//return true;
		return new Promise(function(resolve, reject) {
			checkPermissions("16", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
	},
	dealKtPrinter : function(optionsArray, optionSelected, optionSel) {
		Ext.getCmp('cdTypePrintSelField').setValue(optionsArray[0].value);
		if(!Ext.getCmp('type-ktcb-field').isChecked())
			Ext.getCmp('type-ktcb-field').check();
	},
	saveViewData : function(viewDatas) {
		var me = this;
		viewDatas.isDelete = '0';
		viewDatas.syned = '0';
		viewDatas.status = '1';
		viewDatas.lastUpdateTime=new Date().format('yyyy-MM-dd hh:mm:ss');
		// 检测是否同名
		CommodityDao.checkCommodityTypeName(viewDatas.name, function(success, datas) {	
			if(success && datas) {
				if(datas.length && datas.length > 0) {
					if(datas[0].isDelete != '1') {
						showAlert('提示', '该分类名称已经存在！');
						return;
					}

					viewDatas.isDelete = null;
					viewDatas.id = datas[0].id;
					CommodityDao.updateCommodityType(viewDatas, datas[0].id, function(success) {
						if (success) {
							me.afterViewData(viewDatas);
							showAlert('提示', '保存成功！');
						} else {
							showAlert('提示', '保存出错！');
						}
					});
					return;
				}
			}
			viewDatas.id = createSysId();
			CommodityDao.addCommodityType(viewDatas, function(success) {
				if (success) {
					me.afterViewData(viewDatas);
					showAlert('提示', '保存成功！');
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	afterViewData : function(viewDatas) {
		this.callParent(arguments);
	}
});