Ext.define('Seller.view.commodity.Commodity', {
	//extend : 'Ext.Container',
	extend : 'Seller.view.Base.Base',
	alias : 'widget.commodity',
	parentContainer : null,
	typeId : null,
    optCommViewType : null,
	ADDVIEW : "ADDVIEW",
	EDITVIEW : "EDITVIEW",
	config : {
		id : 'commodity-view',
		centered : true,
		height : '100%',
		width : '100%',
		listeners : {
			painted : function(element, eOpts) {
				var isMaster = isConfigMaster();
				var addComboView = Ext.getCmp("add-commodity-combo-panel");
				if(addComboView) addComboView.setHidden(isMaster ? false : true);
				if(isMaster) {
					return;
				}
				var commodityViewCmp = Ext.getCmp("commodity-view");
				var commodityNameCmp = commodityViewCmp.down("textfield[id=id-comm-name]");
				if(commodityNameCmp) commodityNameCmp.setDisabled(true);
				var commodityPriceCmp = commodityViewCmp.down("textfield[id=id-comm-price]");
				if(commodityPriceCmp) commodityPriceCmp.setDisabled(true);
				var commodityUnitCmp = commodityViewCmp.down("textfield[id=id-comm-unit]");
				if(commodityUnitCmp) commodityUnitCmp.setDisabled(true);
				var commoditySequenceCmp = commodityViewCmp.down("textfield[id=id-comm-sequence]");
				if(commoditySequenceCmp) commoditySequenceCmp.setDisabled(true);
				var commodityTimePriceCmp = commodityViewCmp.down("checkboxfield[id=commodityTimePrice]");
				if(commodityTimePriceCmp) commodityTimePriceCmp.setDisabled(true);
				var commodityKtPrintCmp = commodityViewCmp.down("checkboxfield[id=commodityKtPrint]");
				if(commodityKtPrintCmp) commodityKtPrintCmp.setDisabled(true);
				var commodityCategoryCmp = commodityViewCmp.down("selectfield[id=commodityCategory]");
				if(commodityCategoryCmp) commodityCategoryCmp.setDisabled(true);
				var commoditySaveCmp = commodityViewCmp.down("button[id=commodity-toolbaradd]");
				if(commoditySaveCmp) commoditySaveCmp.setHidden(true);
			}
		},
		items : [{
			xtype : 'formpanel',
			id : 'commodityForm',
			scrollable : false,
			//height : 180,
			//height : 220,
			height : 220,
	 		items : [{
				xtype : 'fieldset',
				title : '',
				instructions : '',
				margin : 1,
				defaults : {
                    disabled: Application.Ftype == Application.SLAVE ? true : false,
                    disabledCls : 'disableFontCls',
					labelWidth : 130,
				},
				items : [{
					xtype : 'hiddenfield',
					name : 'id'
				}, {
					xtype : 'textfield',
					name : 'name',
					id : 'id-comm-name',
					placeHolder : '请输入商品名称',
					label : '商品名称',
					required : true
				}, {
					xtype : 'textfield',
					name : 'price',
					maxLength : 11,
					id : 'id-comm-price',
					placeHolder : '请输入销售价',
					value : 0,
					label : '销售价',
					required : true
				}, {
					xtype : 'textfield',
					name : 'unit',
					id : 'id-comm-unit',
					placeHolder : '请输入单位',
					value : '例',
					clearIcon : false,
					label : '商品单位',
					listeners : {
						/*
						focus : function(textView, e, eOpts) {
							dealCommodityUnit('id-comm-unit');
						}*/
					}
				}, {
					xtype : 'textfield',
					name : 'sequence',
					id : 'id-comm-sequence',
					placeHolder : '请输入排序号',
					value : 0,
					label : '排序号',
					//required : true
				}, {
					xtype : 'checkboxfield',
					label : '设为称重商品',
					name : 'isWeight',
					id: 'isWeightCommodity',
					checked : false,
					listeners : {
						check: function(field, e, eOpts) {
							if (e) {
								if (e.stopPropagation) e.stopPropagation();
								if (e.stopEvent) e.stopEvent();
							}
							if (Ext.getCmp('commodityTimePrice').getChecked()) {
								field.uncheck();
							};
							if (Ext.getCmp('commodityCategory').getValue() == '2') {
								var store = Ext.getCmp('commodityGridPanel').getStore();
								if (store.getAllCount() > 0) {
									showAlert('提示', '套餐商品不能设为称重商品!');
									field.uncheck();
									return;
								};
							}
							// 规格商品不能设置为称重商品
							var commodityRecord = Ext.getCmp('commodity-view').record;
							if (commodityRecord && commodityRecord.get('isSupportNorms') == '1') {
								showAlert('提示', '规格商品不能设为称重商品!');
								field.uncheck();
								Ext.getCmp('commodityCategory').setDisabled(true);
								return;
							}
							Ext.getCmp('commodityCategory').setValue('1');
							Ext.getCmp('commodityCategory').setDisabled(true);
						},
						uncheck: function(field, e, eOpts) {
							if (e) {
								if (e.stopPropagation) e.stopPropagation();
								if (e.stopEvent) e.stopEvent();
							}
							Ext.getCmp('commodityCategory').setDisabled(false);
						}
					}
				},{
					xtype : 'checkboxfield',
					label : '设为时价菜',
					name : 'isTimePrice',
					id : 'commodityTimePrice',
					checked : false,
					listeners : {
						check: function(field, e, eOpts) {
							if (e) {
								if (e.stopPropagation) e.stopPropagation();
								if (e.stopEvent) e.stopEvent();
							}
							if (Ext.getCmp('isWeightCommodity').getChecked()) {
								field.uncheck();
							};
						}
					}
				}, {
					xtype : 'checkboxfield',
					label : '入厨',
					name : 'kitchenPrint',
					id: 'commodityKtPrint',
					checked : false,
					hidden: false,
				}, {
					xtype : 'selectfield',
					name : 'category',
					id : 'commodityCategory',
                    disabled: Application.Ftype == Application.SLAVE ? true : false,
                    disabledCls : 'disableFontCls',
					label : '类型',
					options : [{
						text : '零售商品',
						value : '1'
					}, {
						text : '套餐',
						value : '2'
					}],
					listeners : {
						/*change : function(filed, newValue, oldValue, eOpts) {
							Ext.getCmp('commodity-view').comboOperator(newValue);
							Ext.getCmp('commodity-view').commonOperator({category:newValue});
						}*/
					}
				}]
			}]
		}, {
			xtype : 'panel',
			layout : 'vbox',
			//height : 300,
			height : 280,
			hidden : true,
			id : 'commodityGridPanelPanel',
			items : [{
				xtype : 'panel',
				height : 36,
				cls:'whitebg solid-border-top solid-border-bottom',
				html : '<div class="sy-commodity-Pack" style="width:500px;"><div class="name">品名</div><div class="num">数量</div><div class="price">价格</div><div class="sellAmount">小计</div></div>'
			}, {
				xtype : 'list',
				id : 'commodityGridPanel',
				margin : '0 0 0 0',
				//height : isConfigMaster() ? 198 : 238,
				flex : 1,
				store : Ext.create("Ext.data.Store", {
					fields : ['id', 'comboId', 'commodityId', 'commodityName', 'commodityNum', 'commodityPrice', 'sumAmount', 'normName'],
					autoLoad : true,
					data : []
				}),
				selectedCls : 'checkedbg',
				itemTpl : new Ext.XTemplate('<div class="sy-commodity-list" style="width:500px !important;"><div class="name jz-center">{commodityName}<tpl if="normName">({normName})</tpl></div><div class="num jz-center">{commodityNum}</div><div class="price jz-center">{commodityPrice}</div><div class="sellAmount jz-center">{sumAmount}</div><div class="type{type} delete{isDelete}"></div></div>'),
				isAfterrendered : false, //添加一个变量，用于检测afterrender是否已经发生
				listeners : {
					itemtap : function(list, index, target, record, e, eOpts) {
					},
					itemtouchmove : function(list, index, target, record, e, eOpts) {
					}
				}
			}, {
				xtype : 'panel',
				layout : 'hbox',
				height : 40,
				cls:'solid-border-top',
				padding:10,
				id : "add-commodity-combo-panel",
                hidden : isConfigMaster() ? false : true,
				items : [{
					xtype : 'spacer'
				}, {
					xtype : 'button',
					cls:'white-button',
					width : 135,
					height : 40,
					id : 'commodity-viewDelete',
					iconMask : true,
					text : '删除',
					handler : function() {

					}
				}, {
					xtype : 'spacer'
				},{
					xtype : 'button',
					cls:'red-button',
					width : 135,
					height : 40,
					id : 'Commodityred',
					iconMask : true,
					text : '增加套餐商品',
					handler : function() {

					}
				}, {
					xtype : 'spacer'
				}]
			}]
		}, {
			xtype : 'toolbar',
			title : '添加商品',
			docked : 'top',
			id : 'commodity-toolbar',
			items : [{
				xtype : 'button',
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : 'add-commodity-close',
				handler : function() {
					/*var parentContainer = Ext.getCmp('commodity-view').parentContainer;
					parentContainer.destroy();*/
				}
			}, {
				xtype : 'spacer'
			}, {
				xtype : 'button',
				id : 'commodity-toolbaradd',
				text : '保存',
				hidden : Application.Ftype == Application.SLAVE ? true : false,
				handler : function() {
					// Ext.getCmp('commodity-view').dealCommodity();
				}
			}, {
				xtype : 'button',
				text : '删除',
				hidden : true,
				id : 'commodity-view-delete',
				handler : function() {
					/*Ext.getCmp('commodity-view').deleteCommodity();*/
				}
			}]
		}]
	},
	initialize : function(panel, eOpts) {
	},
	addCommodity : function(commodityId, commodityName, commodityNum, commodityPrice, extra) {
		var categoryList = Ext.getCmp('commodityGridPanel');
		var store = categoryList.getStore();
		var lAllCount = store.getAllCount();
		for(var lsi=0; lsi<lAllCount; lsi++) {
			var lrecord = store.getAt(lsi);
			if(lrecord.get('commodityId') == commodityId && lrecord.get('commodityName') == commodityName) {
				showAlert('提示', '已经存在相同的商品', 0, 0, 0, function() {
					var parentContainer = Ext.getCmp('selectcommodity-edit-view').parentContainer;
					parentContainer.destroy();
				});
				return;
			}
		}
		Ext.getCmp('commodityGridPanel').getStore().add({
			id : createSysId("C"),
			commodityId : commodityId,
			//commodityName : commodityName,
			commodityName : extra.commodityName,
			commodityNum : commodityNum,
			commodityPrice : commodityPrice,
			sumAmount : parseFloat(parseFloat(commodityNum) * parseFloat(commodityPrice)).toFixed(2),
			normName : extra.normName
		});
		var parentContainer = Ext.getCmp('selectcommodity-edit-view').parentContainer;
		parentContainer.destroy();

	},
	checkPermission : function() {
		//return true;
		return new Promise(function(resolve, reject) {resolve(true);});
	},
	checkNormsCondition : function(viewDatas) {
		return true;
	},
	checkWeighCommodity : function(viewDatas){
        if(viewDatas.isWeight == '1' && viewDatas.comboMealsJson){
			if(JSON.parse(viewDatas.comboMealsJson).length == 0){
				showAlert('提示', '设为称重的商品请取消选择套餐类型！');
				return false;
			}else if(JSON.parse(viewDatas.comboMealsJson).length > 0){
				showAlert('提示', '添加套餐的商品不能设为称重商品！');
				return false;
			}

		}
		return true;
	},
	checkComboCondition : function(viewDatas) {
		var categoryList = Ext.getCmp("commodityGridPanel");
		var store = categoryList.getStore();
		if (viewDatas.category == "2") {
			if (store.getAllCount() < 1) {
				showAlert('提示', '请添加套餐商品！');
				return false;
			}
		}

		return true;
	},
	checkCondition : function(viewDatas) {
		/*if (!viewDatas.name) {
			showAlert('提示', '请输入商品名称！');
			return false;
		}
		if (!viewDatas.price && viewDatas.price != '0') {
			showAlert('提示', '请输入销售价！');
			return false;
		}
		if (!viewDatas.sequence && viewDatas.sequence != 0) {
			showAlert('提示', '请输入排序号！');
			return false;
		} else if(!isInteger(viewDatas.sequence)){
			showAlert('提示', '请输入排序号(只支持正整数)!');
			return false;
		}
		return true;*/
		if(!this.checkNameCondition(viewDatas)) return false;
		if(!this.checkPriceCondition(viewDatas)) return false;
		if(!this.checkSequenceCondition(viewDatas)) return false;
		return true;
	},
	getViewDatas : function() {
		var commodityForm = Ext.getCmp('commodityForm');
		var dataValues = commodityForm.getValues();
		/**'addcommoditysub' 为添加商品页面
		* 'editcommoditysub' 为修改商品页面*/
        // if (this.config.xtype == 'addcommoditysub') {
        if (this.optCommViewType == this.ADDVIEW) {
            dataValues.id = createSysId("C");
            dataValues.status = '1';
            dataValues.selected = '0';
            dataValues.barCode = createBarCode(new Date());
        }
        if (dataValues.kitchenPrint) {
			dataValues.kitchenPrint = '1';
		} else {
			dataValues.kitchenPrint = '0';
		}
		if (dataValues.isWeight) {
			dataValues.isWeight = '1';
		} else {
			dataValues.isWeight = '0';
		}
		if(dataValues.isTimePrice) dataValues.isTimePrice = '1';
		else dataValues.isTimePrice = '0';
		//this.getSelfViewData && this.getSelfViewData(dataValues);
		dataValues.typeId = Ext.getCmp('commodity-view').typeId;

		var categoryList = Ext.getCmp("commodityGridPanel");
		var store = categoryList.getStore();
		// dataValues.id = createSysId();
		if(dataValues.category == '2') { // 套餐
			var comboMeals = [];
            // dataValues.id = createSysId();
            for (var i = 0; i < store.getAllCount(); i++) {
				var record = store.getAt(i);
				comboMeals[i] = {};
				comboMeals[i] = record.getData();
				comboMeals[i].comboId = dataValues.id;
			}
			dataValues.comboMealsJson = Ext.JSON.encode(comboMeals);
			dataValues.isTimePrice = '0';
		} else {
			dataValues.comboMealsJson = null;
		}
		dataValues.labelPrint = '0';
		dataValues.sellerId = seller.id;
		//生成商品名称的拼音码
		dataValues.pinyinCode = makePy(dataValues.name);
		dataValues.syned = "0";
		this.getSelfViewData && this.getSelfViewData(dataValues);

		return dataValues;
	},
	dealCommodity : function() {
		var me = this;
		me.checkPermission("7", true).then(function() {
			showLoading("正在保存商品信息");
			var viewData = me.getViewDatas();
			if(!me.checkCondition(viewData)) {closeLoading();return;}
			if(!me.checkComboCondition(viewData)) {closeLoading();return;}
			if(!me.checkNormsCondition(viewData)) {closeLoading();return;}
			me.saveViewData && me.saveViewData(viewData);
		}).catch(function() {closeLoading();});
		/*if(!me.checkPermission("7", true)) {closeLoading();return;}
		var viewData = me.getViewDatas();
		if(!me.checkCondition(viewData)) {closeLoading();return;}
		if(!me.checkWeighCommodity(viewData)){closeLoading();return;}
		if(!me.checkComboCondition(viewData)) {closeLoading();return;}
		if(!me.checkNormsCondition(viewData)) {closeLoading();return;}
		me.saveViewData && me.saveViewData(viewData);*/
	},
	closeOperator : function() {
		closeLoading();
	},
	deleteCommodity : function() {

	},
	afterViewDataParent : function(viewData) {
		var me = this;
		var parentContainer = Ext.getCmp('commodity-view').parentContainer;
		// parentContainer.destroy();
		parentContainer.hide();
		//CommodityDao.submitCommodityToServer(viewData);
		CommodityDao.submitCommodityById(viewData.id);
		//保存成功后，返回到指定的页面
		var tempId = viewData.id;
		var tempDate=createDateStr();
		if (viewData.category == '2') {
            var jsonPar = JSON.parse(viewData.comboMealsJson);
            var ids="";
            ComboMealssDao.loadAllComboMeals(function(success,datas){
    			if(success){
    				for (var i = 0; i < jsonPar.length; i++) {
    	            	var temp = jsonPar[i];
    	            	if(ids){
    	        			ids+=",'"+temp.id+"'";
    	        		}else{
    	        			ids+="'"+temp.id+"'";
    	        		}
    	            	var tempComboId=getDataById(datas,temp.id);
    	            	if(!tempComboId){
    	            		var comboMeals = {
	                            id: temp.id,
	                            comboId: temp.comboId,
	                            commodityId: temp.commodityId,
	                            commodityName: temp.commodityName,
	                            commodityPrice: temp.commodityPrice,
	                            commodityNum: temp.commodityNum,
	                            sumAmount: temp.sumAmount,
	                            normName: temp.normName,
	                            sellerId: seller.id,
	                            createId: shouYinEmployee.workId,
	                            createTime: tempDate,
	        					lastUpdateTime : tempDate,
	        					syned : '0',
	                            status: temp.status?temp.status:'1'
	                        };
	                        ComboMealssDao.ComboMealsAdd(comboMeals, function (success, result) {
	                            if (!success) showAlert('提示', result);
	                        });
    	            	}
    	            }
    				executeSql("update comboMeals set syned='0',status='9',lastUpdateTime='"+ tempDate +"' where ifnull(status,'1')<>'9' and id not in("+ids+") and comboId='"+tempId+"'  and sellerId='"+seller.id+"'");
    			}else{
    				callBackFunction(false);
    			}
    		});
        } else {
			/*ComboMealssDao.DeleteByComboId(tempId , function (success, result) {
				if (!success) showAlert('提示', result);
            })*/
            executeSql("update comboMeals set syned='0',status='9',lastUpdateTime='"+ tempDate +"' where comboId='"+tempId+"' and sellerId='"+seller.id+"'");
		}
		if (viewData.operateType == 'delete') {
            showAlert('提示', '删除成功！');
		} else {
			showAlert('提示', '保存成功！');
        }
        me.closeOperator();
		Ext.getCmp('select-commodity-view').doSelectCommodiyType(viewData.typeId);
		sendCommodityUpdate();
	},
	commonOperator : function(recordData) {
		if(recordData.isSupportNorms == '1' || recordData.category == '2') {
			Ext.getCmp('commodityTimePrice').setDisabled(true);
			Ext.getCmp('commodityTimePrice').setChecked(false);
		} else {
			Ext.getCmp('commodityTimePrice').setDisabled(false);
		}
	},
	comboOperator : function(category) {
		var parentContainer = Ext.getCmp('commodity-view').parentContainer;
		if(category == '2') { // 套餐
			//parentContainer.setHeight(620);
			parentContainer.setHeight(650);
			if (clientHeight <= 600) parentContainer.setHeight(590);
			//Ext.getCmp('commodityTimePrice').setDisabled(true);
			//Ext.getCmp('commodityTimePrice').setChecked(false);
			Ext.getCmp('commodityGridPanelPanel').show();
		} else {
			if(Ext.getCmp('commodityGridPanelPanel'))
				Ext.getCmp('commodityGridPanelPanel').hide();
			//Ext.getCmp('commodityTimePrice').setDisabled(false);
			parentContainer.setHeight(355);
		}
	},
	normsOperator : function(isSupportNorms) {
		//Ext.getCmp('commodityTimePrice').setDisabled(true);
		//Ext.getCmp('commodityTimePrice').setChecked(false);
		if(isSupportNorms == '1')
			Ext.getCmp('commodityCategory') && Ext.getCmp('commodityCategory').setDisabled(true);
		else
			Ext.getCmp('commodityCategory') && Ext.getCmp('commodityCategory').setDisabled(false);
	},
	addCommodity : function(commodityId, commodityName, commodityNum, commodityPrice, extra) {
		var categoryList = Ext.getCmp('commodityGridPanel');
		var store = categoryList.getStore();
		var lAllCount = store.getAllCount();
		for(var lsi=0; lsi<lAllCount; lsi++) {
			var lrecord = store.getAt(lsi);
			if(lrecord.get('commodityId') == commodityId && lrecord.get('commodityName') == commodityName) {
				showAlert('提示', '已经存在相同的商品', 0, 0, 0, function() {
					var parentContainer = Ext.getCmp('selectcommodity-edit-view').parentContainer;
					parentContainer.destroy();
				});
				return;
			}
		}
		Ext.getCmp('commodityGridPanel').getStore().add({
			id : createSysId("C"),
			commodityId : commodityId,
			//commodityName : commodityName,
			commodityName : extra.commodityName,
			commodityNum : commodityNum,
			commodityPrice : commodityPrice,
			sumAmount : parseFloat(parseFloat(commodityNum) * parseFloat(commodityPrice)).toFixed(2),
			normName : extra.normName
		});
		var parentContainer = Ext.getCmp('selectcommodity-edit-view').parentContainer;
		parentContainer.destroy();

	},
	dealCommodityUnit : function() {
		CommodityDao.loadUnit(function(success, units) {
			if(success && units && units.length > 0) {
				Ext.getCmp('commodity-view').showCommodityUnitView(units);
			}
		});
	},
	showCommodityUnitView : function(units) {
		var unitTextView = null;
		if(Ext.getCmp('unit-text-view'))
			unitTextView = Ext.getCmp('unit-text-view');
		else {
			unitTextView = Ext.Viewport.add({
				xtype : 'panel',
				centered : true,
				hideOnTapMask : false,
				modal : true,
				id : 'unit-text-view',
				width : 300,
				height : 500,
				items : [{
					xtype : 'toolbar',
					docked : 'top',
					title : '请选择商品单位',
					items : [
                    getDefaultToolbarLeftViewForHandler(function() {
                    	if(Ext.getCmp('unit-text-view'))
							Ext.getCmp('unit-text-view').destroy();
     				}), {
						xtype : 'button',
						cls : 'close-button',
						hidden : true,
						handler : function() {
							if(Ext.getCmp('unit-text-view'))
								Ext.getCmp('unit-text-view').destroy();
						}
					}]
				}, {
					xtype : 'list',
					id : 'unit-text-list-view',
					width : 300,
					height : 450,
					itemCls : 'text-center solid-border-bottom',
					store : Ext.create('Ext.data.Store', {
						model : 'Seller.model.Option',
						id : 'unit-text-view-store',
						data : []
					}),
					listeners : {
						itemtap : function(listView, index, target, record, e, eOpts) {
							Ext.getCmp('id-comm-unit').setValue(record.get('value'));
							if(Ext.getCmp('unit-text-view'))
								Ext.getCmp('unit-text-view').destroy();
						}
					}
				}]
			});
		}
		showBy(unitTextView,Ext.getCmp('addCommodityView'));
		var unitTxtViewList = Ext.getCmp('unit-text-list-view');
		var unitTxtViewStore = unitTxtViewList.getStore();
		for(var ui=0,ulen=units.length;ui<ulen;ui++) {
			unitTxtViewStore.add({
				text : units[ui].unitName,
				value : units[ui].unitName
			});
		}
		Ext.getCmp('id-comm-unit').blur();
	},
	setParentContainer : function(parentContainer) {
		this.parentContainer = parentContainer;
		var categoryList = Ext.getCmp("commodityGridPanel");
		var store = categoryList.getStore();
		store.removeAll();
		var cmpKtField = Ext.getCmp('commodityKtPrint');
		Ext.getCmp('commodityForm').setHeight(312);
		if (clientHeight <= 600) Ext.getCmp('commodityForm').setHeight(250);
		if(isKtTransToCommodityType) {
			cmpKtField.setHidden(true);
			Ext.getCmp('commodity-view').getParent().setHeight(355);
		} else {
			cmpKtField.setHidden(false);
			Ext.getCmp('commodity-view').getParent().setHeight(355);
		}
	}
});

function dealCommodityUnit(viewType) {
	CommodityDao.loadUnit(function(success, units) {
		if(success && units && units.length > 0) {
			//showCommodityUnitView(viewType, units);
			showCommodityUnitView(units, function(value) {
				Ext.getCmp(viewType).setValue(value);
			});
			Ext.getCmp(viewType).blur();
		}
	});
	Ext.getCmp(viewType).blur();
}
function showCommodityUnitView(units, callback) {
	var unitTextView = null;
	if(Ext.getCmp('unit-text-view'))
		unitTextView = Ext.getCmp('unit-text-view');
	else {
		unitTextView = Ext.Viewport.add({
			xtype : 'panel',
			centered : true,
			hideOnTapMask : false,
			modal : true,
			id : 'unit-text-view',
			//width : 300,
			//height : 500,
			width : 1000,
			height : "auto",
			items : [{
				xtype : 'toolbar',
				docked : 'top',
				title : '请选择商品单位',
				items : [
                getDefaultToolbarLeftViewForHandler(function() {
                	if(Ext.getCmp('unit-text-view'))
						Ext.getCmp('unit-text-view').destroy();
 				}), {xtype:"spacer"}, getDefaultToolbarRightViewForHandler(function() {
 					var unitElement = $(".commodity-unit div.unit-cell.selected");
 					var unitName = null;
 					if(unitElement) unitName=unitElement.html();
 					callback && callback(unitName);
 					if(Ext.getCmp('unit-text-view'))
 						Ext.getCmp("unit-text-view").destroy();
 				}), {
					xtype : 'button',
					cls : 'close-button',
					hidden : true,
					handler : function() {
						if(Ext.getCmp('unit-text-view'))
							Ext.getCmp('unit-text-view').destroy();
					}
				}]
			}, {
				xtype : 'list',
				id : 'unit-text-list-view2',
				hidden : true,
				width : 300,
				height : 450,
				itemCls : 'text-center solid-border-bottom',
				store : Ext.create('Ext.data.Store', {
					model : 'Seller.model.Option',
					id : 'unit-text-view-store',
					data : []
				}),
				listeners : {
					itemtap : function(listView, index, target, record, e, eOpts) {
						preventEventBubble(e);
						callback && callback(record.get('value'));
						if(Ext.getCmp('unit-text-view'))
							Ext.getCmp('unit-text-view').destroy();
					}
				}
			}, {
				xtype: "dataview",
				id: "unit-text-list-view",
				flex: 1,
				// height : 600,
				minHeight: 200,
				maxHeight: 650,
				style: "padding : 10px;height: 600px;",
				width: '100%',
				cls: "white-bg"
			}]
		});
	}
	var templateS1 = "<div class='commodity-unit' style='float:left;'>"
		+	"<tpl for='units'>"
		+		"<tpl if='endName'>"
		+			"</div>"
		+		"<tpl elseif='stickName'>"
		+ 			"<div style='float:left;' class='commodity-container'><div name='{stickName}' id='{id}' class='unit-space'>{stickName}</div>"
		+		"<tpl else>"
		//+			"<div name='{unitName}' id='{id}' class='unit-cell'>{unitName}<icon></icon></div>"
		+			"<div name='{unitName}' id='{id}' class='unit-cell'>{unitName}</div>"
		+		"</tpl>"
		+	"</tpl>"
		+ "</div>";
	var templateS = "<div class='commodity-unit' style='float:left;'>"
		+	"<tpl for='units'>"
		+		"<tpl if='endName'>"
		+			""
		+		"<tpl elseif='stickName'>"
		+ 			"<div name='{stickName}' id='{id}' class='unit-space'>{stickName}</div>"
		+		"<tpl else>"
		//+			"<div name='{unitName}' id='{id}' class='unit-cell'>{unitName}<icon></icon></div>"
		+			"<div name='{unitName}' id='{id}' class='unit-cell'>{unitName}</div>"
		+		"</tpl>"
		+	"</tpl>"
		+ "</div>";
	var unitTemplate = new Ext.XTemplate(templateS);
	var unitListCmp = Ext.getCmp("unit-text-list-view");
	unitListCmp.setHtml(unitTemplate.apply({
		units : filterUnitStick(units)
	}));
	showBy(unitTextView,Ext.getCmp('addCommodityView'));
	$(".commodity-unit").each(function(index, element) {
		var divElement = $(this).find("div.unit-cell");
		divElement.click(function() {
			$(".commodity-unit div.unit-cell").each(function(index, element) {
				$(this).removeClass("selected");
			});
			$(this).addClass("selected");
		});
	});
	/*var unitTxtViewList = Ext.getCmp('unit-text-list-view');
	var unitTxtViewStore = unitTxtViewList.getStore();
	for(var ui=0,ulen=units.length;ui<ulen;ui++) {
		unitTxtViewStore.add({
			text : units[ui].unitName,
			value : units[ui].unitName
		});
	}*/
}

function filterUnitStick(units) {
	if(!units) return units;
	var stickUnits = {};
	var currStickName = null;
	for(var ui=0,ulen=units.length;ui<ulen;ui++) {
		var pyName = makePy(units[ui].unitName);
		if(pyName && pyName.length > 0 && /[a-zA-Z]+/gi.test(pyName[0])) {
			currStickName = pyName[0].substring(0,1).toUpperCase();
			if(!(currStickName in stickUnits)) {
				stickUnits[currStickName] = [];
				stickUnits[currStickName].push({stickName:currStickName,id:creatId(new Date(),"stick"+currStickName)});
			}
			//units[ui].stickName = currStickName;
			stickUnits[currStickName].push(units[ui]);
		} else {
			if(!("Other" in stickUnits)) {
				stickUnits["Other"] = [];
				stickUnits["Other"].push({stickName:"其他",id:creatId(new Date(),"stickOther")});
			}
			//units[ui].stickName = "其他";
			stickUnits["Other"].push(units[ui]);
		}
	}
	var stickUnitArray = [];
	var currStick = null;
	var unitKeys = Object.keys(stickUnits);
	unitKeys.sort();
	for(var ui=0,ulen=unitKeys.length;ui<ulen;ui++) {
		var sKey = unitKeys[ui];
		if(stickUnits.hasOwnProperty(sKey) && sKey !== "Other") {
			stickUnitArray = stickUnitArray.concat(stickUnits[sKey]);
			// resolve 2
			stickUnitArray = stickUnitArray.concat([{endName:"end"}]);
		}
	}
	/*for(var sKey in stickUnits) {
		if(stickUnits.hasOwnProperty(sKey) && sKey !=="Other") {
			if(!currStick) currStick = sKey;
			stickUnitArray = stickUnitArray.concat(stickUnits[sKey]);
		}
	}*/
	if("Other" in stickUnits) {
		stickUnitArray = stickUnitArray.concat(stickUnits["Other"]);
		stickUnitArray = stickUnitArray.concat([{endName:"end"}]);
	}
	console.log(stickUnitArray);
	return stickUnitArray;
}

function updateOpenSettingForDel(commodityId) { // 删除操作
	if(!setting.openPlaceSettingJson) return;
	var openPlaceSetting = Ext.JSON.decode(setting.openPlaceSettingJson);
	if(!openPlaceSetting) return;
	var openPlaceLen = openPlaceSetting.length;
	var isOpenPlaceHas = false;
	var tmpDealOpenPlace = null;
	for(var oi=0; oi<openPlaceLen; oi++) {
		if(openPlaceSetting[oi].commodityId == commodityId) {
			tmpDealOpenPlace = openPlaceSetting[oi];
			tmpDealOpenPlace.isDelete = '1';
			openPlaceSetting.splice(oi, 1);
			isOpenPlaceHas = true;
			break;
		}
	}
	if(tmpDealOpenPlace) {
		setting.openPlaceSettingJson = Ext.JSON.encode(openPlaceSetting);
		SettingDao.submitOpenSettingSingle(tmpDealOpenPlace, function(success) {});
		if(setting.id) {
			SettingDao.updateSetting({
				openPlaceSettingJson : Ext.JSON.encode(openPlaceSetting)
			}, setting.id, function(success) {
				if(success)
					sendPushOpenPlaceSetting();
			});
		} else {
			SettingDao.addSetting({
				openPlaceSettingJson : Ext.JSON.encode(openPlaceSetting)
			}, function(success) {
				if(success)
					sendPushOpenPlaceSetting();
			});
		}
	}
}
function updateOpenSettingForCommodity(commodityInfo) {
	if (setting.openPlaceSettingJson) {
		var store = Ext.getCmp('buyCarGridPanel').getStore();
		var commodityStore = Ext.getStore('showyin-commodity-store');
		var datas = Ext.JSON.decode(setting.openPlaceSettingJson);
		var isHasCommodityInOpen = false;
		for (var i = 0; i < datas.length; i++) {
			if(datas[i].commodityId == commodityInfo.id) {
				datas[i].commodityPrice = commodityInfo.price;
				datas[i].sumAmount = parseFloat(parseFloat(datas[i].commodityPrice) * parseFloat(datas[i].commodityNum));
				isHasCommodityInOpen = true;
			}
		}
		if(isHasCommodityInOpen) {
			setting.openPlaceSettingJson = Ext.JSON.encode(datas);
			if(setting.id) {
				SettingDao.updateSetting({openPlaceSettingJson:setting.openPlaceSettingJson}, setting.id, function(success) {});
			} else {
				SettingDao.getSetting(function(success, settingD) {
					if(settingD && settingD.id)
						SettingDao.updateSetting({openPlaceSettingJson:setting.openPlaceSettingJson}, settingD.id, function(success) {});
					else
						SettingDao.addSetting({openPlaceSettingJson:setting.openPlaceSettingJson}, function(success) {});
				});
			}
		}
	}
}
function updateSpecialPriceForDel(commodityInfo) {
	SpecialPriceDao.getSpecialPriceNotDel(function(success, specials) {
		if(!success) return;
		for(var si=0,slen=specials.length;si<slen;si++) {
			if(specials[si].commodityId == commodityInfo.commodityId) {
				var specialData = specials[si];
				SpecialPriceDao.updateSpecialPrice({
					isDeleted : '1',
					syned : '0'
				}, specials[si].id, function(success) {
					specialData.isDeleted = '1';
					specialData.syned = '0';
					if(success) SpecialPriceDao.submitToServer(specialData);
				});
				break;
			}
		}
	});
}
function updateSpecialPriceForCommodity(commodityInfo) { // 更新特价商品的
	SpecialPriceDao.updateSpecialPriceByEdit(commodityInfo.id, function(success) {
	//SpecialPriceDao.updateSpecialPriceIRep(commodityInfo.id, function(success) {
		//console.log(arguments);
		var specialPriceView = Ext.getCmp('specialPriceSettingContent');
		if(!specialPriceView) return;
		var specialPriceStore = specialPriceView.getStore();
		var commodityRecord = specialPriceStore.findRecord('commodityId', commodityInfo.id);
		if(!commodityRecord) return;
		commodityRecord.set('specialName', commodityInfo.name);
		commodityRecord.commit();
	});
}

/**
 * 更新套餐的内容
 * @param commodityInfo
 */
function updateComboJsonForCommodity(commodityInfo) {
	return new Promise(function(resolve, reject) {
		if(commodityInfo.category === '2') {resolve(true);return;}
		CommodityDao.loadCommodityComMealsForCommodityId(commodityInfo.id, function(success, commodityComboMeals) {
			if(!success) {resolve(true);return;}
			var comboMealsInfo = {};
			for(var ci=0,clen=commodityComboMeals.length;ci<clen;ci++) {
				var commodityComboMealsInfo = commodityComboMeals[ci];
				try {
					var comboMealDatas = Ext.JSON.decode(commodityComboMealsInfo.comboMealsJson);
					for(var cmi=0,cmlen=comboMealDatas.length;cmi<cmlen;cmi++) {
						if(comboMealDatas[cmi].commodityId === commodityInfo.id) {
							comboMealDatas[cmi].commodityName = commodityInfo.name;
							comboMealDatas[cmi].commodityPrice = commodityInfo.price;
							comboMealDatas[cmi].sumAmount = parseFloat(new Number(commodityInfo.price)*new Number(comboMealDatas[cmi].commodityNum)).toFixed(2);
							comboMealDatas[cmi].sellerId = seller.id;
							comboMealDatas[cmi].lastUpdateTime = new Date().getTime();
                            comboMealDatas[cmi].syned = "0";
						}
					}
					comboMealsInfo[commodityComboMealsInfo.id] = Ext.JSON.encode(comboMealDatas);
				} catch(err) {}
			}
			resolve(true);
			CommodityDao.updateCommodityComboMealsInfo(comboMealsInfo, function(success) {
				console.log(success);
			});

            ComboMealssDao.updateComboMealsByCommodityInfo(commodityInfo, function(success) {
                console.log(success);
            });
		});
    });
}