Ext.define('Seller.view.commodity.CommodityType', {
	//extend : 'Ext.Container',
	extend : 'Seller.view.Base.Base',
	alias : 'widget.commoditytype',
	parentContainer : null,
	optCommTypeViewType: null,
	ADDTYPEVIEW: "ADDTYPEVIEW",
	EDITTYPEVIEW: "EDITTYPEVIEW",
	config : {
		id : 'commodityType-view',
		centered : true,
		height : '100%',
		width : '100%',
		listeners : {
			painted : function(element, eOpts) {
				var isMaster = isConfigMaster();
				if(isMaster) return;
				var commodityTypeViewCmp = Ext.getCmp("commodityType-view");
				var commodityTypeNameCmp = commodityTypeViewCmp.down("textfield[id=id-type-name]");
				if(commodityTypeNameCmp) commodityTypeNameCmp.setDisabled(true);
				var commodityTypeSequenceCmp = commodityTypeViewCmp.down("textfield[id=id-cb-type-sequence]");
				if(commodityTypeSequenceCmp) commodityTypeSequenceCmp.setDisabled(true);
				var commodityTypeDiscountCmp = commodityTypeViewCmp.down("checkboxfield[id=id-cb-type-discount]");
				if(commodityTypeDiscountCmp) commodityTypeDiscountCmp.setDisabled(true);
				var commodityTypeInventoryCmp = commodityTypeViewCmp.down("checkboxfield[id=id-cb-type-inventory]");
				if(commodityTypeInventoryCmp) commodityTypeInventoryCmp.setDisabled(true);
				var commodityTypeIsPrintCmp = commodityTypeViewCmp.down("checkboxfield[id=type-ktcb-field]");
				if(commodityTypeIsPrintCmp) commodityTypeIsPrintCmp.setDisabled(true);
				var commodityTypePrintCmp = commodityTypeViewCmp.down("selectfield[id=cdTypePrintSelField]");
				if(commodityTypePrintCmp) commodityTypePrintCmp.setDisabled(true);
				var commodityTypeSaveCmp = commodityTypeViewCmp.down("button[id=commodityType-view-save]");
				if(commodityTypeSaveCmp) commodityTypeSaveCmp.setHidden(true);
			}
		},
		items : [{
			xtype : 'formpanel',
			id : 'commodityTypeForm',
			scrollable : false,
			height : '100%',
			items : [{
				xtype : 'fieldset',
				title : '',
				instructions : '',
				margin : 1,
				defaults : {
					labelWidth : 130,
                    disabled: Application.Ftype == Application.SLAVE ? true : false,
                    disabledCls : 'disableFontCls',
				},
				items : [{
					xtype : 'textfield',
					name : 'name',
					id : 'id-type-name',
					placeHolder : '请输入名称',
					label : '名称',
					required : true
				}, {
					xtype : 'textfield',
					name : 'sequence',
					id : 'id-cb-type-sequence',
					placeHolder : '请输入排序号(只支持整数)',
					value : 0,
					label : '排序号',
				}, {
					xtype : 'checkboxfield',
					label : '是否可以打折',
					name : 'isTypeDiscount',
					id : 'id-cb-type-discount',
					checked : true,
					listeners : {}
				}, {
					xtype : 'checkboxfield',
					label : '是否记录库存',
					name : 'isTypeInventory',
					id : 'id-cb-type-inventory',
					checked : false,
					listeners : {}
				}, {
					xtype : 'checkboxfield',
					label : '入厨',
					name : 'iskitchenprint',
					id: 'type-ktcb-field',
					checked : false,
					hidden: true,
				}, {
					xtype : 'selectfield',
					id : 'cdTypePrintSelField',
					name : 'category',
					label : '厨打机',
					hidden: true,
					options : [],
				}, {
					xtype : 'textfield',
					id : 'cdTypePrintTxtFieldComType',
					name : 'category_t',
					label : '厨打机',
					hidden : true,
					// hidden : false,
					readOnly : true,
					listeners : {
						focus : function(currView, e, eOpts) {
							Ext.Viewport.add(Ext.create("Seller.view.commodity.CommodityKtPrinter"));
							if(Ext.getCmp("commodity-kt-printer")) {
								var parentContainer = Ext.getCmp("commodityType-view");
								Ext.getCmp("commodity-kt-printer").loadData(parentContainer.settingPrinter, parentContainer.ktPrintJson);
								Ext.getCmp("commodity-kt-printer").setParentContainer(parentContainer);
							}
							currView.blur();
						},
						blur : function() {}
					}
				}]
			}]
		}, {
			xtype : 'formpanel',
			id : 'commodityTypePrintForm',
			scrollable : true,
			height: '62%',
			hidden: true,
			items: [{
				xtype : 'fieldset',
				id: 'commodityTypePrintFieldSet',
				title : '',
				instructions : '',
				margin : 1,
				defaults : {
					labelWidth : 130
				},
				items: []
			}]
		}, {
			xtype : 'toolbar',
			title : '添加商品分类',
			docked : 'top',
			id : 'commodity-type-toolbar',
			items : [{
				xtype:'button',		
				//cls:'close-button',
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : 'commodity-type-close',
				// handler : function() {
				// 	var parentContainer = Ext.getCmp('commodityType-view').parentContainer;
				// 	parentContainer.destroy();
				// }
			}, {
				xtype : 'spacer'
			}, {
				xtype:'button',	
				text : '保存',
				id : 'commodityType-view-save',
				hidden : Application.Ftype==Application.SLAVE?true:false,
				// handler : function() {
				// 	var componentType = Ext.getCmp('commodityType-view');
				// 	componentType.dealComponentType();
				// }
			}, {
				xtype : 'button',
				text : '删除',
				hidden : true,
				id : 'commodityType-view-delete',
				// handler : function() {
				// 	Ext.getCmp('commodityType-view').deleteCommodityType();
				// }
			}]
		}]
	},
	initialize : function(panel, eOpts) {
	},
	getViewDatas : function() {
		var commodityTypeForm = Ext.getCmp('commodityTypeForm');
		var dataValues = commodityTypeForm.getValues();
		dataValues.sellerId = seller.id;
		
		return dataValues;
	},
	checkPermission : function() {
		//return true;
		return new Promise(function(resolve, reject) {resolve(true);});
	},
	checkCondition : function(viewDatas) {
		/*if (!viewDatas.name) {
			showAlert('提示', '请输入名称！');
			return false;
		}
		if (!viewDatas.sequence && viewDatas.sequence != 0) {
			showAlert('提示', '请输入正确的排序号！');
			return false;
		} else if(!isInteger(viewDatas.sequence)){
			showAlert('提示', '请输入排序号(只支持正整数)!');
			return false;
		}*/
		if(!this.checkNameCondition(viewDatas)) return false;
		if(!this.checkSequenceCondition(viewDatas)) return false;
		return true;
	},
	checkPrinterCondition2 : function(viewDatas) {
		if(!viewDatas.category) {
			showAlert('提示', '请选择厨打机!');
			return false;
		}
		if(viewDatas.category == -1 && viewDatas.iskitchenprint) {
			showAlert('提示', '请选择厨打机!');
			return false;
		}
		return true;
	},
	/* 修改过后的厨房打印机 */
	modifyKtPrinters : function(selKtPrintInfo) {
		var me = this;
		var ktPrinters = me.settingPrinter;
		var ktPrintJson = {};
		for(var si=0,slen=selKtPrintInfo.length;si<slen;si++) {
			for(var ki=0,klen=ktPrinters.length;ki<klen;ki++) {
				if(ktPrinters[ki].id == selKtPrintInfo[si].id) 
					ktPrintJson[ktPrinters[ki].id] = ktPrinters[ki];
			}
		}
		me.ktPrintJson = ktPrintJson;
		initKtPrinter(ktPrinters, ktPrintJson, me);  /* 刷新厨打显示 */
	},
	fillKtPrinters : function(selKtPrinters, tmpOptionSelected, tmpOptionSel) {
		/* 填充打印机 */
		Ext.getCmp("cdTypePrintTxtFieldComType").setValue(selKtPrinters.join(","));
		//this.
		//Ext.getCmp('cdTypePrintSelField').setOptions(tmpOptionsArray);
		//this.dealKtPrinter && this.dealKtPrinter(tmpOptionsArray, tmpOptionSelected, tmpOptionSel);
	},
	/* Deprecated */
	initKtPrinter : function(printers, ktPrintJson) {
		var me = this;
		//var ktPrintJson = {};  // 之前具有的设置
		var tmpOptionSelected = false;
		var tmpOptionsArray = [];
		var tmpOptionSel = 0;
		tmpOptionsArray.push({
			text: '',
			value: -1
		});
		for(var pi=0,plen=printers.length;pi<plen;pi++) {
			var pName = "厨打" + pi;
			if(printers[pi].ktPrintName)
				pName = printers[pi].ktPrintName;
			tmpOptionsArray.push({
				text: pName,
				value: printers[pi].id
			});
			if(ktPrintJson) {
				if(ktPrintJson.hasOwnProperty(printers[pi].id)) {
					tmpOptionSel = ktPrintJson[printers[pi].id]?(tmpOptionsArray.length-1):tmpOptionSel;
					tmpOptionSelected = true;
				}
			}
		}
		if(tmpOptionsArray.length > 0) {
			Ext.getCmp('cdTypePrintSelField').setOptions(tmpOptionsArray);
			me.dealKtPrinter && me.dealKtPrinter(tmpOptionsArray, tmpOptionSelected, tmpOptionSel);
		}
	},
	loadDataForSel : function(printers) {
		var me = this;
		Ext.getCmp('commodityTypeForm').setHeight(180);
		// Ext.getCmp('type-ktcb-field').setHidden(false);
		var commodityPrintSelField = Ext.getCmp('cdTypePrintSelField');
		//commodityPrintSelField.setHidden(false);
		//commodityPrintSelField.setOptions([]);
		// Ext.getCmp('commodityType-view').getParent().setHeight(310);
		Ext.getCmp('commodityType-view').getParent().setHeight(225);
		me.isSingleSel = true;
		me.settingPrinter = printers;

		var ktPrintJson = me.getKtPrinterJson ? me.getKtPrinterJson() : {};  // 之前具有的设置
		var showPrintNum = 0;
		var isHasChecked = false;
		//me.initKtPrinter(printers, ktPrintJson);
		me.ktPrintJson = ktPrintJson;  /* 保存原数据值 */
		initKtPrinter(printers, ktPrintJson, me);
        if (Application.Ftype == Application.SLAVE) {
            commodityPrintSelField.setDisabled(true);
        }
	},
	loadData: function() {
		if(!isKtTransToCommodityType) {
			return;
		}
		
		var me = this;
		KTPrinterDao.loadPrinterNoDel(function(success, printers) {
			if(success) {
				me.loadDataForSel && me.loadDataForSel(printers);
			}
		});
	},
	setParentContainer : function(parentContainer) {
		this.parentContainer = parentContainer;
	},
	dealComponentType : function() {
		var me = this;
		me.checkPermission().then(function() {
			me.dealComponentTypeContent();
		}).catch(function() {});
	},
	dealComponentTypeContent : function() {
		var me = this;
		var ctDatas = me.getViewDatas();
		var componentType = Ext.getCmp('commodityType-view');
		var isSingleSel = componentType.isSingleSel;
		var tmpKtPrinter = componentType.settingPrinter;
		var commodityTypePrintForm = Ext.getCmp("commodityTypePrintForm");
		var printValues = commodityTypePrintForm.getValues();
		
		if(!me.checkCondition(ctDatas)) return;
		// if(!me.checkPrinterCondition(ctDatas)) return; // 2.4后不检查厨打 
		
		// 更新商品类型
		var kitchenPrintJson = {};
		var tmpIsSelectField = true;
		// init printer
		var tlen = tmpKtPrinter.length;
		var tmpKtPrintJson = me.ktPrintJson;
		var tmpKtPrintKeys = Ext.Object.getKeys(tmpKtPrintJson);
		for(var kpi=0,kplen=tmpKtPrintKeys.length;kpi<kplen;kpi++) {
			kitchenPrintJson[tmpKtPrintKeys[kpi]] = tmpKtPrintJson[tmpKtPrintKeys[kpi]];
			kitchenPrintJson[tmpKtPrintKeys[kpi]].name = tmpKtPrintJson[tmpKtPrintKeys[kpi]].ktPrintName;
			kitchenPrintJson[tmpKtPrintKeys[kpi]].ip = tmpKtPrintJson[tmpKtPrintKeys[kpi]].ktPrintIp;
		}
		delete ctDatas.category;
		delete ctDatas.category_t;
		try {
            kitchenPrintJson = JSON.stringify(kitchenPrintJson);
		} catch(err) {kitchenPrintJson=""};
		// 2.4后不更新此前厨打设置
		// ctDatas.kitchenPrintJson = kitchenPrintJson;
		// ctDatas.iskitchenprint = ctDatas.iskitchenprint?'1':'0';
		delete ctDatas.iskitchenprint;

		ctDatas.isDiscount = ctDatas.isTypeDiscount ? '1' : '0';
		ctDatas.isInventory = ctDatas.isTypeInventory ? '1' : '0';
		delete ctDatas.isTypeDiscount;
		delete ctDatas.isTypeInventory;

		ctDatas.syned = "0";
		me.saveViewData && me.saveViewData(ctDatas);
	},
	deleteCommodityType : function() {
	},
	afterViewDataParent :  function(viewDatas) { // 保存view数据之后统一的操作
		//CommodityDao.submitCommodityTypeToServer(viewDatas);
		CommodityDao.submitCommodityTypeById(viewDatas.id);
		/*Ext.getCmp('select-commodity-view').loadData(function(){
			setTimeout(function() {
				Ext.getCmp('select-commodity-view').currCommodityTypeId = viewDatas.id;
				Ext.getCmp('select-commodity-view').commodityTypeClick($("#commoditytype"+viewDatas.id)[0], viewDatas.id, viewDatas.name);				
			}, 200);
		});*/
		Ext.getCmp('select-commodity-view').refreshTypeData(viewDatas.id);
		var parentContainer = Ext.getCmp('commodityType-view').parentContainer;
		parentContainer.hide();
		// parentContainer.destroy();
		sendCommodityType();
	}
});

function initKtPrinter(printers, ktPrintJson, content) {
	var me = this;
	//var ktPrintJson = {};  // 之前具有的设置
	var selKtPrinters = [];
	for(var pi=0,plen=printers.length;pi<plen;pi++) {
		var pName = "厨打" + pi;
		if(printers[pi].ktPrintName)
			pName = printers[pi].ktPrintName;
		if(ktPrintJson) {
			if(ktPrintJson.hasOwnProperty(printers[pi].id)) {
				pName = printers[pi].ktPrintName;
				selKtPrinters.push(pName);
			}
		}
	}
	//if(selKtPrinters.length > 0) {
		content.fillKtPrinters && content.fillKtPrinters(selKtPrinters);
	//}
}

function setCmTypePrinterRadio(newValue) {
	var commodityTypePrintForm = Ext.getCmp('commodityTypePrintForm');
	if(commodityTypePrintForm.isHidden()) {
		//showAlert('提示', '还未设置打印机!');
		return;
	}
	var typePrinterFields = commodityTypePrintForm.getFields();
	// the first printer checked 
	var isPrinterChecked = false;
	var firstPrinterShowField = null; 
	for(var keyPrinterField in typePrinterFields) {
		if(!typePrinterFields[keyPrinterField].isHidden()) {
			if(newValue)
				firstPrinterShowField = firstPrinterShowField || typePrinterFields[keyPrinterField];
			if(typePrinterFields[keyPrinterField].isChecked()) {
				if(newValue) {
					isPrinterChecked = true;
				} else
					typePrinterFields[keyPrinterField].uncheck();
			}
		}
	}
	if(firstPrinterShowField) {
		if(!isPrinterChecked) { // has no checked of all printer
			firstPrinterShowField.check();
		}
	}
}

function setCmTypePrinterSelect(newValue) {
	var printerSelect = Ext.getCmp('cdTypePrintSelField');
	var printerSelData = printerSelect.getOptions();
	if(newValue == true) {
		if(printerSelect) printerSelect.setDisabled(false);
	} else {
		if(printerSelect) printerSelect.setDisabled(true);		
	}
	if(printerSelData.length <= 0) return;
	if(!newValue) {
		printerSelect.setValue(printerSelData[0].value);
		return;
	}
	var commodityTypeForm = Ext.getCmp('commodityTypeForm');
	var tmpCmTypeValues = commodityTypeForm.getValues();
	if(tmpCmTypeValues.category === -1) {
		if(printerSelData.length > 1){			
			printerSelect.setValue(printerSelData[1].value);
		}
	}
}