Ext.define('Seller.view.commodity.EditCommoditySub', {
	extend : 'Seller.view.commodity.Commodity',
	alias : 'widget.editcommoditysub',
	constructor : function() {
		this.callParent(arguments);
	},
	initialize : function(panel, eOpts) {
		Ext.getCmp('commodity-toolbar').setTitle(Application.Ftype==Application.SLAVE?"查看商品":'修改商品');
			Ext.getCmp('commodity-view-delete').setHidden(Application.Ftype==Application.SLAVE?true:false);
        setTimePCommAndTypeDisable();
	},
	checkPermission : function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
		/*if (!checkPermissions("7", true)) {
			return false;
		}
		return true;*/
	},
	setRecord : function(record) {
		var commodityForm = Ext.getCmp('commodityForm');
		if (!commodityForm) {
			return;
		}
		var copyRecord = record.copy(record.get('id'));
		copyRecord.set('isTimePrice', copyRecord.get('isTimePrice')=='1'?true:false);
		if(!copyRecord.get('unit') || copyRecord.get('unit') == '')
			copyRecord.set('unit', '例');
		
		this.commonOperator(copyRecord.getData());
		this.normsOperator(copyRecord.get('isSupportNorms'));
		commodityForm.setRecord(copyRecord);
		this.record = record;
		var parentContainer = Ext.getCmp('commodity-view').parentContainer;
		
		if (record.get('category') == "2") {
			var categoryList = Ext.getCmp("commodityGridPanel");
			var store = categoryList.getStore();
			store.removeAll();
			if (record.get('comboMealsJson')) {
				var comboMealsJson = record.get('comboMealsJson');
				var comboMeals = Ext.JSON.decode(comboMealsJson)
				for (var ci = 0, clen = comboMeals.length; ci < clen; ci++) {
					comboMeals[ci].commodityPrice = parseDigitalDecimal(comboMeals[ci].commodityPrice);
				}
				store.add(comboMeals);
				// store.setData(record.get('comboMealsJson'));
			}
		} else {
			if(Ext.getCmp('commodityGridPanel'))
				Ext.getCmp('commodityGridPanel').getStore().removeAll();
		}
		
		this.comboOperator(record.get('category'));
	},
	getSelfViewData : function(viewDatas) {
		if(this.record) {
			viewDatas.labelPrint = this.record.get('labelPrint')==='1' ? '1' : '0';
			//viewDatas.typeId = this.record.get('typeId');
		}
	},
	checkNormsCondition : function(viewDatas) { // 检测规格
		var record = Ext.getCmp('commodity-view').record;
		var isSupportNorms = record.get('isSupportNorms');
		if(isSupportNorms == '1') { // 是否支持规格
			for(var normi=1;normi<9;normi++) {
				if(record.get('normsName'+normi) && record.get('normsPrice'+normi)>=0 
						&& record.get('normsPrice'+normi) == viewDatas.price) {
					break;
				}
			}
			if(normi==9) {
				showAlert('提示', '请输入的价格与规格价格之一保持一致!');
				return false;
			}
		}
		return true;
	},
	saveViewData : function(viewData) {
		var me = this;
        var record = Ext.getCmp('commodity-view').record;
		viewData.lastUpdateTime=new Date().format('yyyy-MM-dd hh:mm:ss');
		CommodityDao.isSameCommodityName(viewData.typeId, viewData.id, viewData.name, function(success, total) {
			if(success && total > 0) {
				showAlert('提示', '已经存在相同名称的商品!');
				me.closeOperator();
				return;
			}
			// 设置为称重商品后判断当前商品是否存在于套餐内
			if(viewData.isWeight == '1' || viewData.category == '2' || record.get('category') == '2'){
				CommodityDao.isExistCombineCommodity(viewData.id, function(success, datas){
					if(success && datas.length > 0){
						if(viewData.isWeight == '1'){
							showAlert('提示', '此商品已经存在于套餐商品内，不能设为称重商品!');
						}else if(viewData.category == '2'){
							showAlert('提示', '此商品已经存在于套餐商品内，不能再设置组合套餐!');
						}
						me.closeOperator();
						return;
					}
					SellDao.loadSelldetailForComboMeals(function (success, result) {
						if (success && result.length > 0) {
							if (viewData.category == '2' || record.get('category') == '2') {
                                var comboDetails = result;
                                var flag = comboDetails.some(function(item){
                                    return item.commodityId === viewData.id;
                                });
                                if (flag) {
                                    showAlert('提示', '此商品已经下单，订单未完成，不能更改套餐信息！');
                                    me.closeOperator();
                                    return;
                                }
							}
						}
                        CommodityDao.updateCommodity(viewData, viewData.id, function(success) {
                            if (success) {
                                //showAlert("提示", "修改商品成功");
                                updateComboJsonForCommodity(viewData).then(function() {
                                    me.afterViewData(viewData);
                                });
                                updateOpenSettingForCommodity(viewData);
                                updateSpecialPriceForCommodity(viewData);
                            } else {
                                showAlert('提示', '保存出错！');
                                me.closeOperator();
                            }
                        });
                    });
				});
			}else {
				CommodityDao.updateCommodity(viewData, viewData.id, function(success) {
                    if (success) {
                        //showAlert("提示", "修改商品成功");
                        updateComboJsonForCommodity(viewData).then(function() {
                            me.afterViewData(viewData);
                        });
                        updateOpenSettingForCommodity(viewData);
                        updateSpecialPriceForCommodity(viewData);
                    } else {
                        showAlert('提示', '保存出错！');
                        me.closeOperator();
                    }
                });
			}
		});
	},
	afterViewData : function(viewDatas) {
		this.callParent(arguments);
	},
	deleteCommodity : function() {
		var me = this;
		var commodityId1 = me.record.get("id");
		checkPermissions("5", true).then(function() {
			CommodityDao.isExistCombineCommodity(commodityId1, function(success, res) {
				var comboName = [];// 套餐名字*
				var comboId = ''; // 套餐id
				for (var ri = 0, len = res.length; ri < len; ri++) {
					var combo = res[ri];
					comboId = combo.id;
					comboName[ri] = combo.name;
				}
				if (comboId != commodityId1 && res && res.length > 0) {
					showAlert("提示", "该商品存在于" + comboName + "套餐内,不能删除！");
					// showConfirm('提示', '该商品存在于' + comboName + '套餐内,是否删除？', function(buttonId) { // buttonId yes/no*
					// 	deleteCommodityStatus(buttonId, me);
					// });
				} else {
					showConfirm('提示', '确定删除该商品？', function(buttonId) {
						deleteCommodityStatus(buttonId, me);
					});
				}
			})
		}).then(function() {});
		/*checkPermissions("5", true).then(function() {
			showConfirm('提示', '确定删除该商品？', function(buttonId) {
				if (buttonId == "yes") {
					showLoading("正在删除商品...");
					var commodityForm = Ext.getCmp('commodityForm');
					var commodityId = Ext.getCmp('commodity-view').record.get("id");
					var record = Ext.getCmp('commodity-view').record;
					var tempDate=createDateStr();
					CommodityDao.updateCommodity({
						syned : '0',
	                    isDelete :'1',
						status : '9',
						lastUpdateTime:tempDate
					}, commodityId, function(success) {
						if (success) {
	                        executeSql("update comboMeals set syned='0',status='9',lastUpdateTime='"+ tempDate +"' where comboId='"+commodityId+"' and sellerId='"+seller.id+"'");
							Ext.getCmp('select-commodity-view').deleteCommodity(record);
							me.afterViewData({id:commodityId, typeId : record.get('typeId'), operateType : 'delete'});
							updateOpenSettingForDel(commodityId);
							updateSpecialPriceForDel(record.getData());
						} else {
							showAlert('提示', '删除出错！');
							me.closeOperator();
						}
					});
				}
			});
		}).then(function() {});*/
		/*if (!checkPermissions("5", true)) {
			return;
		}
		showConfirm('提示', '确定删除该商品？', function(buttonId) {
			if (buttonId == "yes") {
				showLoading("正在删除商品...");
				var commodityForm = Ext.getCmp('commodityForm');
				var commodityId = Ext.getCmp('commodity-view').record.get("id");
				var record = Ext.getCmp('commodity-view').record;
				var tempDate=createDateStr();
				CommodityDao.updateCommodity({
					syned : '0',
                    isDelete :'1',
					status : '9',
					lastUpdateTime:tempDate
				}, commodityId, function(success) {
					if (success) {
                        executeSql("update comboMeals set syned='0',status='9',lastUpdateTime='"+ tempDate +"' where comboId='"+commodityId+"' and sellerId='"+seller.id+"'");
						Ext.getCmp('select-commodity-view').deleteCommodity(record);
						me.afterViewData({id:commodityId, typeId : record.get('typeId'), operateType : 'delete'});
						updateOpenSettingForDel(commodityId);
						updateSpecialPriceForDel(record.getData());
					} else {
						showAlert('提示', '删除出错！');
						me.closeOperator();
					}
				});
			}
		});*/
	}, 
	commodityFilterFn : function() {
		var me = this;
		return function(commInfo) {
			if(!me.record) return commInfo;
			if(!me.record.get('id')) return commInfo;
			if(commInfo.id == me.record.get('id')) return null;
			return commInfo;
		}
	}
});

function setTimePCommAndTypeDisable() {
    if (Application.Ftype == Application.SLAVE) {
        TPandTypeDisableTask = setInterval(function () {
            Ext.getCmp('commodityTimePrice').setDisabled(true);
            Ext.getCmp('commodityCategory').setDisabled(true);
            if (Ext.getCmp('commodityTimePrice').getDisabled() && Ext.getCmp('commodityCategory').getDisabled() && typeof TPandTypeDisableTask != 'undefined') {
            	window.clearInterval(TPandTypeDisableTask);
            	delete TPandTypeDisableTask;
			}
        }, 100);
        setTimeout(function () {
            if (typeof TPandTypeDisableTask != 'undefined') {
                window.clearInterval(TPandTypeDisableTask);
                delete TPandTypeDisableTask;
            }
        }, 5000)
    }
}

// 点击确定-删除商品*
function deleteCommodityStatus(buttonId,me) {
	if (buttonId == "yes") {
		showLoading("正在删除商品...");
		var commodityForm = Ext.getCmp('commodityForm');
		var commodityId = Ext.getCmp('commodity-view').record.get("id");
		var record = Ext.getCmp('commodity-view').record;
		var tempDate = createDateStr();
		CommodityDao.updateCommodity({
			syned: '0',
			isDelete: '1',
			status: '9',
			lastUpdateTime: tempDate
		}, commodityId, function(success) {
			if (success) {
				executeSql("update comboMeals set syned='0',status='9',lastUpdateTime='" + tempDate + "' where comboId='" + commodityId + "' and sellerId='" + seller.id + "'");
				Ext.getCmp('select-commodity-view').deleteCommodity(record);
				me.afterViewData({
					id: commodityId,
					typeId: record.get('typeId'),
					operateType: 'delete'
				});
				updateOpenSettingForDel(commodityId);
				updateSpecialPriceForDel(record.getData());
			} else {
				showAlert('提示', '删除出错！');
				me.closeOperator();
			}
		});
	}
}