Ext.define('Seller.view.commodity.EditCommodityTypeSub', {
	extend : 'Seller.view.commodity.CommodityType',
	alias : 'widget.editcommoditytypesub',
	parentContainer : null,
	constructor : function() {
		this.callParent(arguments);
	},
	initialize : function(panel, eOpts) {
		Ext.getCmp('commodity-type-toolbar').setTitle(Application.Ftype==Application.SLAVE?"查看商品分类":'修改商品分类');
		setTimeout(function() {
			Ext.getCmp('commodityType-view-delete').setHidden(Application.Ftype==Application.SLAVE?true:false);
		}, 0);
	},
	checkPermission : function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
		/*if (!checkPermissions("7", true)) {
			return false;
		}
		return true;*/
	},
	setCommodityTypeDefaultValue : function(record) {
		if(!record.get('isTypeDiscount')) {
			record.set('isTypeDiscount', record.get('isDiscount')=='1'?true:false);
		}
		if(!record.get('isTypeInventory')) {
			record.set('isTypeInventory', record.get('isInventory')=='1'?true:false);
		}
	},
	setRecord : function(record) {
		if(!record) return;
		var copyRecord = record.copy(record.get('id'));
		this.record = record;
		var commodityTypeForm = Ext.getCmp('commodityTypeForm');
		this.setCommodityTypeDefaultValue(copyRecord);
		commodityTypeForm.setRecord(copyRecord);
		this.loadData();
	},
	getKtPrinterJson : function() {
		var me = this;
		var ktPrintJson = me.record.get("kitchenPrintJson");   // 已经具有的设置
		if(ktPrintJson) ktPrintJson = Ext.JSON.decode(ktPrintJson);
		else ktPrintJson = {};
		
		return ktPrintJson;
	},
	saveViewData : function(viewDatas) {
		var me = this;
		var commodityTypeId = Ext.getCmp('commodityType-view').record.get('id');
		viewDatas.id = commodityTypeId;
		viewDatas.lastUpdateTime=createDateStr();
		// 检测是否同名
		CommodityDao.isSameCommodityTypeName(commodityTypeId, viewDatas.name, function(success, total) {
			if(success && total > 0) {
				showAlert('提示', '已经存在相同的商品类型!');
				return;
			}
			CommodityDao.updateCommodityType(viewDatas, Ext.getCmp('commodityType-view').record.get('id'), function(success) {
				if (success) {
					showAlert("提示", "保存成功!");
					Ext.getCmp('commodityType-view').record.set('isDiscount', viewDatas.isDiscount);
					me.afterViewData(viewDatas);
					//Ext.getCmp('editCommodityTypeView').hide();
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	afterViewData : function(viewDatas) {
		this.callParent(arguments);
	},
	dealKtPrinter : function(optionsArray, optionSelected, optionSel) {
		if(optionSelected) {
			Ext.getCmp('cdTypePrintSelField').setValue(optionsArray[optionSel].value);
			if(!Ext.getCmp('type-ktcb-field').isChecked())
				Ext.getCmp('type-ktcb-field').check();
		}
	},
	deleteCommodityType : function() {
		var me = this;
		checkPermissions("5", true).then(function() {
			var record = Ext.getCmp('commodityType-view').record;
			showConfirm('提示', '是否确定删除该商品分类', function(btnId) {
				if(btnId == 'yes') {							
					var typeId = record.get('id');
					CommodityDao.getComInfoNotDelTotalCountByTypeId(typeId, function(success, count) {
						if(success && count > 0) {
							showAlert('提示', '该商品分类下面还有商品!');
							return;
						}
						CommodityDao.updateCommodityType({
							syned : '0',
							isDelete : '1',
	                        status : '9',
	    					lastUpdateTime:createDateStr()
						}, Ext.getCmp('commodityType-view').record.get('id'), function(success) {
							if (success) {
								Ext.getCmp('select-commodity-view').deleteCommodityType(Ext.getCmp('commodityType-view').record);
								me.afterViewData({id : record.get('id'), status : '9' });
							} else {
								showAlert('提示', '删除出错！');
							}
						});
					});
				}
			});
		}).catch(function() {});
		/*if (!checkPermissions("5", true)) {
			return;
		}
		var record = Ext.getCmp('commodityType-view').record;
		showConfirm('提示', '是否确定删除该商品分类', function(btnId) {
			if(btnId == 'yes') {							
				var typeId = record.get('id');
				CommodityDao.getComInfoNotDelTotalCountByTypeId(typeId, function(success, count) {
					if(success && count > 0) {
						showAlert('提示', '该商品分类下面还有商品!');
						return;
					}
					CommodityDao.updateCommodityType({
						syned : '0',
						isDelete : '1',
                        status : '9',
    					lastUpdateTime:createDateStr()
					}, Ext.getCmp('commodityType-view').record.get('id'), function(success) {
						if (success) {
							Ext.getCmp('select-commodity-view').deleteCommodityType(Ext.getCmp('commodityType-view').record);
							me.afterViewData({id : record.get('id'), status : '9' });
						} else {
							showAlert('提示', '删除出错！');
						}
					});
				});
			}
		});*/
	}
});