/**
 * 根据关键字查询会员信息
 */
var isQuerySellerCustomering=false;
function querySellerCustomer(keywork, callBack) {
	if(isQuerySellerCustomering){
		return;
	}
	isQuerySellerCustomering=true;
    callBack = callBack || emFunc;
    if (!keywork) {
    	isQuerySellerCustomering=false;
        callBack(false, '请输入关键字！');
        return;
    }

    /*SellerCustomerInfoDao.getSellerCustomerByMobileOrCard(keywork, function(success, returnData) {
        if(success && returnData) {
            callBack(true, returnData);
        } else callBack(false, returnData ? returnData : '查询不到会员信息!');
    });*/
    nativePostRequest(webHostDownInterface + '/loaddata/getSellerCustomerByMobileOrCard?time=' + new Date().getTime(), {
        mobile : keywork
    }, function(result) {
    	isQuerySellerCustomering=false;
        if (result.success && result.customer) {
            //result.customer.timecardInfos = result.timecardInfos;
            callBack(true, result.customer);
        } else {
            callBack(false, result.msg ? result.msg : '查询不到会员信息！');
        }
    }, function(msg) {
    	isQuerySellerCustomering=false;
        callBack(false, msg ? msg : '查询失败,请检查网络状态！', true);
    });

}

function querySellerCustomerById(sellerCustomerId, callBack) {
    callBack = callBack || emFunc;
    /*SellerCustomerInfoDao.getSellerCustomerInfo(sellerCustomerId, function(success, returnData) {
        if(success && returnData) {
            callBack(true, returnData);
        } else callBack(false, returnData ? returnData : '查询不到会员信息!');
    });*/
    nativePostRequest(webHostDownInterface + '/loaddata/getSellerCustomerInfo?time=' + new Date().getTime(), {
        sellerCustomerId : sellerCustomerId
    }, function(result) {
        if (result.success && result.customer) {
            result.customer.timecardInfos = result.timecardInfos;
            callBack(true, result.customer);
        } else {
            callBack(false, result.msg ? result.msg : '查询不到会员信息！');
        }
    }, function(msg) {
        callBack(false, msg ? msg : '查询失败,请检查网络状态！');
    });
}

/**
 * 根据关键字查询会员信息
 */

function querySellerCustomerList(keywork, callBack) {
    callBack = callBack || emFunc;
    if (!keywork) {
        callBack(false, '请输入关键字！');
        return;
    }
    /*SellerCustomerInfoDao.getSellerCustomerList(keywork, function(success, returnData) {
        if(success && returnData && returnData.length > 0) {
            callBack(true, returnData);
        } else callBack(false, returnData ? returnData : "查询不到会员信息!");
    });*/
    var url = webHostDownInterface + '/loaddata/getSellerCustomerList?time=' + new Date().getTime();
    nativePostRequest(url, {
        mobile : keywork
    }, function(result) {
        if (result.success && result.list && result.list.length > 0) {
            callBack(true, result.list);
        } else {
            callBack(false, result.msg ? result.msg : '查询不到会员信息！');
        }
    }, function(msg) {
        callBack(false, msg ? msg : '查询失败,请检查网络状态！');
    });
}

function queryCustomerByMobileOrCard(value) {
    showLoading("正在查询，请稍后..", Ext.getCmp("customer-query-view"));
    querySellerCustomer(value, function(success, customer) {
        closeLoading();
        if (success && customer && customer.cardNum) {
            fillCustomer(customer);
        } else {
            fillCustomer(null);
            showAlert('提示', "查询不到会员信息!");
        }
    });
}

function queryCustomerByValue(value) {
    showLoading("正在查询，请稍后..", Ext.getCmp("customer-query-view"));
    querySellerCustomerList(value, function(success, list) {
        closeLoading();
        if (success && list.length > 0) {
            if (list.length == 1) {
                var customerId = list[0].id;
                showLoading("正在处理，请稍后..", Ext.getCmp("customer-query-view"));
                querySellerCustomerById(customerId, function(success, res) {
                    closeLoading();
                    if (success) {
                        fillCustomer(res);
                        if (Ext.getCmp('customerListView')) {
                            Ext.getCmp('customerListView').destroy();
                        }
                    } else {
                        showAlert('提示', res ? res : "查询不到会员信息!");
                    }
                });
                return;
            }
            var searchView = Ext.Viewport.add({
                xtype : 'panel',
                id : 'customerListView',
                modal : true,
                hideOnMaskTap : false,
                centered : true,
                //width : 560,
                width : 750,
                height : 490,
                scrollable : false,
                items : [{
                    xtype : 'toolbar',
                    title : '请选择会员',
                    height : 50,
                    items : [{
                        xtype : 'button',
                        //cls : 'close-button',
                        cls : 'close-button-complete',
                        width : 80,
                        iconCls : 'close-icon',
                        icon : 'resources/icon/public/back.png',
                        text : '返回',
                        id : 'query-search-customer-view-close',
                        handler : function() {
                            if (Ext.getCmp('customerListView')) {
                                Ext.getCmp('customerListView').destroy();
                            }
                        }
                    }, {
                        xtype : 'spacer'
                    }, {
                        xtype : 'button',
                        text : '确定',
                        handler : function() {
                            if (Ext.getCmp("search-customer-list").getSelection().length > 0) {
                                //fillCustomer(Ext.getCmp("search-customer-list").getSelection()[0].getData());
                                var customerId = Ext.getCmp("search-customer-list").getSelection()[0].get("id");
                                showLoading("正在处理，请稍后..", Ext.getCmp("customer-query-view"));
                                querySellerCustomerById(customerId, function(success, res) {
                                    closeLoading();
                                    if (success) {
                                        fillCustomer(res);
                                        if (Ext.getCmp('customerListView')) {
                                            Ext.getCmp('customerListView').destroy();
                                        }
                                    } else {
                                        showAlert('提示', res ? res : "查询不到会员信息!");
                                    }
                                });
                            }
                        }
                    }]
                }, {
                    xtype : 'container',
                    width : '100%',
                    height : 40,
                    layout : 'vbox',
                    html : '<div class="customer-header"><div class="cardnum">会员卡号</div><div class="mobile">手机号码</div><div class="name">客户名称</div><div class="discount">折扣(%)</div><div class="address">地址</div></div>'
                }, {
                    xtype : 'list',
                    id : 'search-customer-list',
                    store : Ext.create('Ext.data.Store', {
                        id : 'search-customer-store',
                        model : 'Seller.model.SellerCustomerInfo',
                        data : []
                    }),
                    emptyText : '没有搜索到会员',
                    height : 400,
                    selectedCls : 'checkedbg',
                    itemTpl : '<div class="customer-query-list" style="750px;"><div class="cardnum">{cardNum}</div><div class="mobile">{mobile}</div><div class="name">{name}</div><div class="discount">{discount}</div><div class="address text-overflow" title="{address}">{address}</div></div>',
                    listeners : {
                        itemdoubletap : function(obj, index, target, record, e, eOpts) {
                            if (Ext.getCmp("search-customer-list").getSelection().length > 0) {
                                //fillCustomer(Ext.getCmp("search-customer-list").getSelection()[0].getData());
                                var customerId = Ext.getCmp("search-customer-list").getSelection()[0].get("id");
                                showLoading("正在处理，请稍后..", Ext.getCmp("customer-query-view"));
                                querySellerCustomerById(customerId, function(success, res) {
                                    closeLoading();
                                    if (success) {
                                        if (!res.cardNum || res.cardNum == "") {
                                            showAlert('提示', '会员卡号为空!');
                                            return;
                                        }
                                        fillCustomer(res);
                                        if (Ext.getCmp('customerListView')) {
                                            Ext.getCmp('customerListView').destroy();
                                        }
                                    } else {
                                        showAlert('提示', res ? res : "查询不到会员信息!");
                                    }
                                });
                            }
                        }
                    }
                }]
            });
            showBy(searchView,Ext.getCmp('customer-query-view'));
            if (Ext.getCmp('customerListView') && Ext.getCmp('customer-query-view').getParent()) {
                Ext.getCmp('customerListView').setZIndex(Ext.getCmp('customer-query-view').getParent().getZIndex() + 1);
            }
            var store = Ext.getStore('search-customer-store');
            for (var i = 0, len = list.length; i < len; i++) {
                store.add(list[i]);
            }
            Ext.getCmp("search-customer-list").select(store.getAt(0), true, false);
        } else {
            showAlert('提示', "查询不到会员信息!");
        }
    });
}

/**
 * 设置扫码支付状态
 * @author v_cjc
 * @createTime 2017年12月26日 上午10:28:23
 * @param isEnabled  启用或不启用
 * @returns
 */
function setScanBarPayType(isEnabled) {
	var customerQueryCmp = Ext.getCmp("customer-query-view");
	if(customerQueryCmp)
    	customerQueryCmp.isScanCodeWaitPaying = isEnabled;
}
/**
 * 扫描条形码充值
 * 1. 没有密码时，扫码支付多次
 */
function scanBarCodeRecharge(barCode) {
    var payType = Ext.getCmp('customer-query-view').payType;
    var transId = Ext.getCmp('customer-query-view').transId;
    var customerRechargeForm = Ext.getCmp('customerRechargeForm');
    var amount = customerRechargeForm.getFields('amount').getValue();
    var presentAmount = customerRechargeForm.getFields('presentAmount').getValue();
    if (payType == '8'){
        if(!isWxQRCode(barCode)){
            showToast('请扫描微信二维码!');
            return;
        }
    } else if(payType =='9') {
        if (!isAliQRCode(barCode)){
            showToast('请扫描支付宝二维码!');
            return;
        }
    }
    var payMainUtil = Ext.getCmp('customer-query-view').payMainUtil;
    if(payMainUtil && payMainUtil.isScanCodePaying()) {
    	if(!payMainUtil.isReScanCode()) {
    		showToast('正在充值中, 请等待...');
    		return;
    	}
    } else if(Ext.getCmp("customer-query-view").isScanCodeWaitPaying) {
    	/* 扫码等待支付中 */
    	showToast("正在充值中, 请等待...");
    	return;
    }
    setScanBarPayType(true);
    /*if(Ext.getCmp('customer-query-view').MemberpayScanCalc) {
        showToast('正在充值中, 请等待...');
        return;
    }
    Ext.getCmp('customer-query-view').MemberpayScanCalc = true;*/
    nativePostRequest(webHostPayInterface + '/pay/customerRecharge?time=' + new Date().getTime(), {
        sellerCustomerId : Ext.getCmp('customer-query-view').selectCustomer.id,
        transId : transId,
        type : payType == "9" ? "2" : "1",
        sourceType : "0",
        amount : amount,
        presentAmount : presentAmount,
        optEmployeeId : shouYinEmployee.id,
        desc : '收银台充值',
        authCode : barCode
    }, function(result) {
        if (result.state) {
            addSellerCustomerAmount(payType, result.rechargeId, result.amount, result.presentAmount, result.customer);
            Ext.getCmp('customer-query-view').MemberpayScanCalc = false;
            setScanBarPayType(false);
        } else {
            if (result.errCode == "1" || result.errCode == "2") {
                //createRedMask("<font color='red'>等待用户输入密码，请稍后..</font>", "red");
                //showCloseAlert('提示', result.msg ? result.msg : '等待用户操作!', 3);
                Ext.getCmp('customer-query-view').payMainUtil.checkRechargeIsPay(transId, function(success, transId, msg) {
                    if (success) {
                        addSellerCustomerAmount(payType, transId, msg.amount, msg.presentAmount, msg.customer);
                        //showCloseAlert("提示", result.msg ? result.msg : '支付成功！', 3);
                        interruptCancelPay();
                        setScanBarPayType(false);
                        clearQueryPayTask();
                    } else {
                        //showAlert('出错提示', msg ? msg : '支付失败!');
                        //showAlertWithHeight('出错提示', msg ? msg : '支付失败', 250);
                    	//showCloseAlert('出错提示', msg ? msg : '超时未支付!', 5000);
                    	if(payMainUtil) {
                    		var payInfo = payMainUtil.getPayInfo();
                    		payInfo = payInfo || {transId : '',payTimeCount:0};
                    		cancelPreAmountPaying(payInfo.transId, function(success) {
                    		}, 0, "超时未支付, 正在取消支付中...");
                    	}
                        /*showAlertWithWH('出错提示', msg ? msg : '超时未支付!', null, null, function() {                        	
                        	if(payMainUtil) {
                        		var payInfo = payMainUtil.getPayInfo();
                        		payInfo = payInfo || {transId : '',payTimeCount:0};
                        		cancelPreAmountPaying(payInfo.transId, function(success) {}, 0);
                        	}
                        });*/
                    }
                    Ext.getCmp('customer-query-view').MemberpayScanCalc = false;
                }, true);
            } else {
            	clearQueryPayTask()
                //showAlert("提示", result.msg ? result.msg : '支付失败！');
                showAlertWithWH("提示", result.msg ? result.msg : '支付失败！', 300, 240);
            	setScanBarPayType(false);
            }
        }
    }, function(msg) {
        showAlert("支付出错", msg ? msg : '支付出错，请检查网络状态！');
    });
}

/**
 * 设置信息
 */
function fillCustomer(customer) {
    var customerQueryForm = Ext.getCmp('customerQueryForm');
    customerQueryForm.reset();
    if (customer) {
        Ext.getCmp('customer-query-view').selectCustomer = customer;
        customerQueryForm.getFields('cardNum').setValue(customer.cardNum);
        //Ext.getCmp('queryMobile').setValue(customer.mobile);
        customerQueryForm.getFields('mobile').setValue(customer.mobile);
        customerQueryForm.getFields('balanceAmount').setValue(nvlValue(customer.balanceAmount, 0).toFixed(2));
        customerQueryForm.getFields('discount').setValue(customer.discount==0?customer.discount:nvlValue(customer.discount, 100));
        customerQueryForm.getFields('name').setValue(customer.name);
        customerQueryForm.getFields('address').setValue(customer.address);
        if (customer.birthday) {
            var birthdayDate = new Date(Date.parse(customer.birthday.replace("/-/g", "/"))).format("yyyy-MM-dd");
            //console.log(birthdayDate);
            customerQueryForm.getFields('birthday').setValue(birthdayDate);
        }

        //customerQueryForm.setValues(customer);
    }
    if(customer) {
        Ext.getCmp('password-opt-panel').setHidden(false);
        if(!customer.password || customer.password=="") {
            Ext.getCmp('password-operator-add').setHidden(false);
            Ext.getCmp('password-operator-edit').setHidden(true);
        } else {
            Ext.getCmp('password-operator-add').setHidden(true);
            Ext.getCmp('password-operator-edit').setHidden(false);
        }
    } else {
        Ext.getCmp('password-opt-panel').setHidden(true);
    }
    if (isConfigSlaveSelfService()) {
        Ext.getCmp('password-operator-edit').setHidden(true);
        Ext.getCmp('password-operator-add').setHidden(true);
    }
}

function clearQueryPayTask() {
	if(!Ext.getCmp('customer-query-view')) return;
    if (Ext.getCmp('customer-query-view').payMainUtil)
        Ext.getCmp('customer-query-view').payMainUtil.destroy();
    Ext.getCmp('customer-query-view').payMainUtil = null;
}

function closeQueryPayTask(callback) {
    if (Ext.getCmp('customer-query-view').payMainUtil) {
        Ext.getCmp('customer-query-view').payMainUtil.closePayOperator(function(success) {
            if (success) {
                callback && callback(true);
            }
        });
    } else
        callback && callback(false);
}

function setPreAmountDisable(isDisabled) {
    var preAmountIds = ["pay-cash-recharge", "pay-unionpay-recharge", "pay-wxpay-recharge",
        "pay-alipay-recharge", "pay-wxpay-online-recharge", "pay-alipay-online-recharge"];
    for(var preAmountKey in preAmountIds) {
        if(preAmountIds.hasOwnProperty(preAmountKey)) {
            var preAmountCmp = preAmountIds[preAmountKey];
            if(Ext.getCmp(preAmountCmp)) {
                Ext.getCmp(preAmountCmp).setDisabled(isDisabled);
            }
        }
    }
}

function timeForPreAmount(payType, amount, presentAmount, transId) {
    var preAmountInterval = null;
    var intervalCallback = null;
    var preAmountCallback = function(result) {
        closeLoading();
        setPreAmountDisable(false);
        if(result.state) {
            addSellerCustomerAmount(payType, result.transId, result.amount, result.presentAmount, result.customer);
        } else {
            showAlert('提示', result.msg ? result.msg : '充值失败!');
        }
        if(preAmountInterval)
            clearInterval(preAmountInterval);
        preAmountCallback = null;
        intervalCallback = null;
    }
    var requestUrlPath = "/loaddata/sureAddSellerCustomerAmount";
    var timeoutInterval = 0;
    var errMsg = null;
    intervalCallback = function() {
        nativePostRequest(webHostDownInterface + requestUrlPath, {
            transId : transId
        }, function(result) {
            errMsg = null;
            preAmountCallback && preAmountCallback(result);
        }, function(errMsg) {
            errMsg = errMsg;
            intervalCallback && intervalCallback();
        });
    };
    intervalCallback();
    preAmountInterval = setInterval(function() {
        timeoutInterval += 1000;
        if(timeoutInterval > 60 * 1000) { // 超时返回
            preAmountCallback && preAmountCallback({state : false, msg : errMsg});
        }
    }, 1000);
    /*preAmountInterval = setInterval(function() {
        timeoutInterval += 1500;
        if(timeoutInterval > 60 * 1000) { // 超时返回
            preAmountCallback && preAmountCallback({state : false, msg : errMsg});
            return;
        }
        nativePostRequest(webHostDownInterface + requestUrlPath, {
            transId : transId
        }, function(result) {
            errMsg = null;
            preAmountCallback && preAmountCallback(result);
        }, function(errMsg) {
            errMsg = errMsg;
            //showAlert('提示', errMsg ? errMsg : '充值失败!');
        });
    }, 1500);*/
}
/**
 * 中断取消支付操作
 * @author v_cjc
 * @createTime 2017年12月26日 下午2:35:07
 * @returns
 */
function interruptCancelPay() {
	var dialogId = Ext.getCmp("customer-query-view").dialogId;
	if(dialogId) {
		if(Ext.getCmp(dialogId)) {
			var cancelBtnCmp = Ext.getCmp(dialogId).down("button[text=取消]");
			if(cancelBtnCmp) {
				var cancelBtnHandler = cancelBtnCmp.getHandler();
				cancelBtnHandler && cancelBtnHandler();
			}
		}
	}
	if(Ext.getCmp("customer-query-view").timeoutCancelHandle) {
		clearTimeout(Ext.getCmp("customer-query-view").timeoutCancelHandle);
		setPreAmountDisable(false);
		closeLoading();
	}
}
/**
 * 保持当前支付并显示
 * @param payMainUtil
 * @param prePayData  预支付的数据
 * @returns
 */
function persistPayAndShow(payMainUtil, prePayData) {
	if(!payMainUtil) return false;
	var payInfo = payMainUtil.getPayInfo();
	if(payInfo && payInfo.payType == prePayData.payType && payInfo.amount === prePayData.amount) {
		setPreAmountDisable(false);
		payMainUtil.show(Ext.getCmp('customer-query-view'));
		return true;
	}
	return false;
}
/**
 * 是否扫码支付中
 * @returns
 */
function isScanCodeInPaying(payMainUtil) {
	if(payMainUtil && payMainUtil.getPayStatus())
		return true;
	return false;
}
/**
 * 1. 还未扫码，同一个支付方式和相同的充值金额, 保持(再打开对话框)
 * 2. 还未扫码，不同的支付方式和充值金额，关闭再起任务(本地任务,重新生成支付流水)
 * 3. 还未扫码，同一个支付方式和不同的充值金额，关闭再起任务(同上)
 * 4. 已扫码, 同一个支付方式和相同的充值金额，保持(再打开对话框)
 * 5. 已扫码, 同一个支付方式和不同的充值金额，撤销->再发起
 * 6. 已扫码, 不同的支付方式和相同的充值金额，撤销->再发起
 * 7. 已扫码, 不同的支付方式和不同的充值金额，撤销->再发起
 * @param payType
 * @param amount
 * @param presentAmount
 * @returns
 */
function confirmPreAmountOnline(payType, amount, presentAmount) {
	var payMainUtil = Ext.getCmp('customer-query-view').payMainUtil;
	var prePayData = {
		payType:payType,
		amount:amount,
		presentAmount:presentAmount
	};
	if(isScanCodeInPaying(payMainUtil)) {
		if(persistPayAndShow(payMainUtil, prePayData)) return;
		cancelPreAmount(payType, amount, presentAmount);
		return;
	}
	if(persistPayAndShow(payMainUtil, prePayData)) return;
	clearQueryPayTask();
	confirmPreAmountOnlineAgain(payType,amount,presentAmount);
}
/**
 * 1. 相同支付方式和相同的充值金额
 * 2. 不同支付方式和相同的充值金额
 * 3. 相同支付方式和不同的充值金额
 * @param payType
 * @param amount
 * @param presentAmount
 * @returns
 */
function confirmPreAmountOnlineAgain(payType, amount, presentAmount) {
    showLoading('正在生成二维码，请稍后...', Ext.getCmp('customer-query-view'));
    var rechargeData = {
        sellerCustomerId : Ext.getCmp('customer-query-view').selectCustomer.id,
        amount : amount,
        presentAmount : presentAmount,
        optEmployeeId : shouYinEmployee.id,
        sourceType : "0",
        desc : '收银台充值',
        type : payType == "9" ? "2" : "1"
    };
    nativePostRequest(webHostPayInterface + '/pay/customerRecharge?time=' + new Date().getTime(), rechargeData, function(result) {
        closeLoading();
        setPreAmountDisable(false);
        if (result.state) {
            var ctx = Ext.getCmp('customer-query-view');
            ctx.transId = result.transId;
            clearQueryPayTask();
            var zindex = ctx.getZIndex() + 5;
            ctx.payMainUtil = new ScanPayUtil('scan-pay-wait', payType, zindex, null, {
            	transId:result.transId,
            	amount:amount,
            	presentAmount:presentAmount,
            	payType : payType,
            	context : ctx,
            	onlinePayType : ONLINE_PAY_TYPE.RECHARGE_PAY
            });
            ctx.payMainUtil.show(Ext.getCmp('customer-query-view'));
        } else {
            // showAlert('出错提示', result.msg ? result.msg : '请求支付出错');
            showAlert('提示', result.msg ? result.msg : '访问服务失败！');
        }
    }, function(error) {
        closeLoading();
        setPreAmountDisable(false);
        showAlert('提示', error ? error : '生成二维码失败,请检查网络!');
    });
}
function confirmPreAmount(payType, amount, presentAmount) {
    /*Ext.getCmp('customer-query-view').setMasked({
        xtype : 'loadmask',
        centered : true,
        fullscreen : true,
        showAnimation : 'slideIn',
        transparent : false,
        message : "正在充值，请稍后.."
    });
    setTimeout(function() {
        Ext.getCmp('customer-query-view').getMasked().setMessage("请稍后后后后后后...");
    }, 2000);
    setTimeout(function() {
        Ext.getCmp('customer-query-view').unmask();
    }, 5000);
    return;*/
    if (!navigator.onLine) {
        showAlert('提示', '访问服务失败！');
    } else {
        setPreAmountDisable(true);
        showConfirm('提示', '确定充值吗?', function (buttonId) {
            if (buttonId == "yes") {
                if (!navigator.onLine) {
                    showAlert('提示', '访问服务失败！');
                    setPreAmountDisable(false);
                    return;
                }
                var customerInfo = getCustomerInfo();
                if(!validatorPreAmount(customerInfo)) {
                	setPreAmountDisable(false);
                	return;
                }
                if (payType == '8' || payType == '9') {
                    if (amount <= 0) {
                        setPreAmountDisable(false);
                        showAlert('提示', '在线充值不支持零元或负数充值!');
                        return;
                    }
                    if(isConfigSlave()) {
	                    showLoading("检测设备状态中, 请稍候...");
	                    isMasterSlaveDeviceNormal(function(success, msg) {
	                    	closeLoading();
	                    	if(!success) {
	                    		setPreAmountDisable(false);showAlert("提示",msg ? msg : "设备状态异常!");
	                    		return;
	                    	}
	                    	confirmPreAmountOnline(payType, amount, presentAmount);
	                    });
                    } else confirmPreAmountOnline(payType, amount, presentAmount);
                    return;
                }
                
                if(isConfigSlave()) {
	                showLoading("检测设备状态中, 请稍候...");
	                isMasterSlaveDeviceNormal(function(success, msg) {
	                	closeLoading();
	                	if(!success) {setPreAmountDisable(false);showAlert("提示",msg ? msg : "设备状态异常!");return;}
		                //nativePostRequest(webHostSynDataInterface + '/syndata/addSellerCustomerAmount?time=' + new Date().getTime(), {
	                	confirmPreAmounting(payType, amount, presentAmount);
	                });
                } else confirmPreAmounting(payType, amount, presentAmount);
            } else {
                setPreAmountDisable(false);
            }
        });
    }
}
function confirmPreAmounting(payType, amount, presentAmount) {
    showLoading("正在充值中...", Ext.getCmp('customer-query-view'));
    nativePostRequest(webHostDownInterface + '/loaddata/addSellerCustomerAmount?time=' + new Date().getTime(), {
        sellerCustomerId: Ext.getCmp('customer-query-view').selectCustomer.id,
        amount: amount ? amount : 0,
        presentAmount: presentAmount ? presentAmount : 0,
        payType: payType,
        employeeId: shouYinEmployee.id
    }, function (result) {
        //closeLoading();
        if (result.state) {
            timeForPreAmount(payType, result.amount, result.presentAmount, result.transId);
            //addSellerCustomerAmount(payType, result.transId, result.amount, result.presentAmount);
        } else {
            closeLoading();
            setPreAmountDisable(false);
            showAlert('提示', result.msg ? result.msg : "充值失败!");
        }
    }, function (msg) {
        closeLoading();
        setPreAmountDisable(false);
        showAlert('提示', msg ? msg : "充值失败!");
    });
}
/**
 * 取消支付中...
 * @author v_cjc
 * @createTime 2017年12月27日 上午11:12:40
 * @param payType
 * @param amount
 * @param presentAmount
 * @returns
 */
function cancelPreAmount(payType, amount, presentAmount) {
	var payMainUtil = Ext.getCmp('customer-query-view').payMainUtil;
	var payInfo = payMainUtil.getPayInfo();
	var confirmIds = showConfirm("提示", "正在充值中,是否强制关闭支付...", function(btnId) {
		Ext.getCmp("customer-query-view").dialogId = null;
		//if(!payMainUtil) return; /* 中断取消支付的操作 */
		if(btnId === 'yes') {
			//showLoading("正在关闭支付中");
			//nativePostRequest(webHostPayInterface + '/payHandle/closePayTrans?time=' + new Date().getTime(), {
			cancelPreAmountPaying(payInfo.transId, function(success, msg) {
				if(success) {
					confirmPreAmountOnlineAgain(payType,amount,presentAmount);
				}
			});
		} else {
			setPreAmountDisable(false);
		}
	});
	Ext.getCmp("customer-query-view").dialogId = confirmIds[confirmIds.length-1];
}
function cancelPreAmountPaying(transId, callback, timeout, loadingTxt) {
	showLoading(loadingTxt ? loadingTxt : "正在取消支付中...");
	Ext.getCmp("customer-query-view").timeoutCancelHandle = setTimeout(function() {
		nativePostRequest(webHostPayInterface + '/payHandle/cancelPayTrans?time=' + new Date().getTime(), {
			sellerId : seller.id,
			payTransId : transId
		}, function(result) {
			closeLoading();
			if(result.state) {
				clearQueryPayTask();
				callback && callback(true);
				showAlert("提示", "当前交易已被取消!");
			} else {
				setPreAmountDisable(false);
				showAlert("提示", result.msg ? result.msg : "关闭支付处理失败!");
			}
		}, function(error) {
			closeLoading();
			setPreAmountDisable(false);
			showAlert('提示', error ? error : '关闭支付失败!');
		});
		Ext.getCmp("customer-query-view").timeoutCancelHandle = null;
	}, timeout ? timeout : 15000);
}
/**
 * 取消充值支付
 * @author v_cjc
 * @createTime 2017年12月27日 下午1:43:04
 * @param callback
 * @returns
 */
function cancelPreAmountPay(callback) {
	var me = Ext.getCmp("customer-query-view");
	var payMainUtil = me.payMainUtil;
	var hintTxt = "是否取消当前交易!";
	var isRecharging = false;
	if(isScanCodeInPaying(payMainUtil)) {
		hintTxt = "正在充值中, 是否取消当前交易!";
		isRecharging = true;
	}
	var payInfo = payMainUtil && payMainUtil.getPayInfo();
	payInfo = payInfo || {transId : '',payTimeCount:5000};
	var timeout = 15000;
	if(isRecharging) {
		if(payInfo.payTimeCount) timeout = 15000 - payInfo.payTimeCount;
		if(timeout < 1000) timeout = 1000;
	} else timeout = 1000;
	showConfirm("提示", hintTxt, function(btnId) {
		if(btnId === 'yes') {
		    payMainUtil.setIsClose(true);
		    if(isRecharging) {  // 正在充值中
				cancelPreAmountPaying(payInfo.transId, function(success) {
					//if(success) showAlert("提示", "充值已关闭!");
					callback && callback(success);
				}, timeout);
		    } else callback && callback(true);
		} else
			callback && callback(false);
	});
}
function rechargeOnlineCheck(payType, callback) {
    if (payType == '8' || payType == '9') {
        PayDao.getPayRegisterStatus(payType == '8' ? 3 : 2, function(success, msg) {
            if (success) {
                callback && callback(true);
            } else {
                if (msg == '提交失败' || '提交失败！') {
                    showAlert('提示', '访问服务失败！');
                }else
                    showAlertWithHeight('提示', msg ? msg : '暂不支持此支付方式,请联系客户...', 250);
                callback && callback(false);
            }
        });
    } else {
        callback && callback(true);
    }
}

/**
 * 检查充值金额是否合法
 * @author v_cjc
 * @createTime 2017年12月26日 上午11:34:32
 * @returns
 */
function validatorPreAmount(customerInfo) {
	if (!checkValidCondition(Ext.getCmp('customer-query-view').selectCustomer, ConditionValue.NOTEMPTY, '请输入会员信息')) return false;
    if (!checkValidCondition(customerInfo.amount, ConditionValue.NOTEMPTY, '请输入充值金额!')) return false;
    if(customerInfo.presentAmount)
        if (!checkValidCondition(customerInfo.presentAmount, ConditionValue.CKPOSITIVE, '请输入赠送金额(正整数)')) return false;
    return true;
}
function doPreAmount(payType) {
    var customerInfo = getCustomerInfo();
    if(!validatorPreAmount(customerInfo)) return;
    function doPreAmountReal() {
    	Ext.getCmp('customer-query-view').payType = payType;
        if (!Ext.getCmp('customer-query-view').isRecharging) {
            Ext.getCmp('customer-query-view').isRecharging = true;
            rechargeOnlineCheck(payType, function(success) {
                Ext.getCmp('customer-query-view').isRecharging = false;
                if (success)
                    confirmPreAmount(payType, customerInfo.amount, customerInfo.presentAmount);
            });
        }
    }
    if(isValidDigital(customerInfo.presentAmount) && customerInfo.presentAmount>0) {
    		//validatePermission(PERMISSIONS.CUSTOMERPRESENT)
    		checkPermissions(PERMISSIONS.CUSTOMERPRESENT, true, "对不起，您没有赠送权限!")
    		.then(function() {doPreAmountReal();})
    		.catch(function() {});
    } else doPreAmountReal();
}
/**
 * 充值
 */
function doPreAmount2(payType) {
    if (!Ext.getCmp('customer-query-view').selectCustomer) {
        showAlert('提示', '请先查询会员信息！');
        return;
    }
    var customerInfo = getCustomerInfo();
    if (!customerInfo.amount && customerInfo.amount != 0) {
        showAlert('提示', "请输入充值金额!");
        return;
    }
    if(customerInfo.presentAmount) {
        if(!checkPositiveNumber(customerInfo.presentAmount)) {
            showAlert('提示', '请输入赠送金额(正整数)');
            return;
        }
    }
    Ext.getCmp('customer-query-view').payType = payType;
    if (!Ext.getCmp('customer-query-view').isRecharging) {
        Ext.getCmp('customer-query-view').isRecharging = true;
        rechargeOnlineCheck(payType, function() {
            Ext.getCmp('customer-query-view').isRecharging = false;
            confirmPreAmount(payType, customerInfo.amount, customerInfo.presentAmount);
        });
    }
}

function getCustomerInfo() {
    var customerInfo = {};
    var customerRechargeForm = Ext.getCmp('customerRechargeForm');
    customerInfo.amount = customerRechargeForm.getFields('amount').getValue();
    customerInfo.presentAmount = customerRechargeForm.getFields('presentAmount').getValue();
    var customerQueryForm = Ext.getCmp('customerQueryForm');
    customerInfo.mobile = customerQueryForm.getFields('mobile').getValue();
    customerInfo.name = customerQueryForm.getFields('name').getValue();
    customerInfo.address = customerQueryForm.getFields('address').getValue();

    return customerInfo;
}
/**
 *
 */
function addSellerCustomerAmount(payType, transId, amount, presentAmount, customer) {
    var customerRechargeForm = Ext.getCmp('customerRechargeForm');
    var customerQueryForm = Ext.getCmp('customerQueryForm');
    var mobile = customerQueryForm.getFields('mobile').getValue();
    var name = customerQueryForm.getFields('name').getValue();
    var address = customerQueryForm.getFields('address').getValue();
    HandoverDao.addPreamount(amount, payType, presentAmount, shouYinEmployee.handoverId, function(success, msg) {
        if (success) {
            setTimeout(HandoverDao.countHandover(), 200);
            Ext.getCmp('customer-query-view').print(getChargePayTypeName(payType), amount, presentAmount, mobile, name, address, transId, customer);
        } else {
            showAlert('提示', "错误信息", "充值成功，但交班数据处理出错：" + msg);
        }
    });
    customerRechargeForm.reset();
    showAlert('提示', "充值成功!");
    if (Ext.getCmp('customer-query-view').payMainUtil) {
        Ext.getCmp('customer-query-view').payMainUtil.destroy();
        Ext.getCmp('customer-query-view').payMainUtil = null;
    }
    if (Ext.getCmp('preamoun-qrcode-view')) {
        Ext.getCmp('preamoun-qrcode-view').destroy();
    }
    var keywork = Ext.getCmp('queryMobile').getValue();
    querySellerCustomer(mobile, function(success, res) {
        if (success) {
            fillCustomer(res);
            if (payType == '1') openCashboxByPrint(function(success){

            }, function(fail){
                showAlert('提示', fail);
            });
            var parentContainer = Ext.getCmp('customer-query-view').parentContainer;
            if (parentContainer.selectCustomerInfo && parentContainer.selectCustomerInfo.id == res.id) {
                if ( typeof parentContainer.setSelectCustomer === 'function')
                    parentContainer.setSelectCustomer(res);
            }
            // 父窗口是 shouyinMainView
            if(Ext.getCmp('shouyinMainView').selectCustomerInfo) {
                Ext.getCmp('shouyinMainView').addCustomer(Ext.getCmp('customer-query-view').selectCustomer);
            }
        } else {
            showAlert('提示', res ? res : "查询不到会员信息!");
        }
    });
}
function addSellerCustomerAmount2(payType, transId) {
    var customerRechargeForm = Ext.getCmp('customerRechargeForm');
    var amount = customerRechargeForm.getFields('amount').getValue();
    var presentAmount = customerRechargeForm.getFields('presentAmount').getValue();
    var customerQueryForm = Ext.getCmp('customerQueryForm');
    var mobile = customerQueryForm.getFields('mobile').getValue();
    var name = customerQueryForm.getFields('name').getValue();
    var address = customerQueryForm.getFields('address').getValue();
    HandoverDao.addPreamount(amount, payType, presentAmount, shouYinEmployee.handoverId, function(success, msg) {
        if (success) {
            setTimeout(HandoverDao.countHandover(), 200);
            Ext.getCmp('customer-query-view').print(getChargePayTypeName(payType), amount, presentAmount, mobile, name, address, transId);
        } else {
            showAlert('提示', "错误信息", "充值成功，但交班数据处理出错：" + msg);
        }
    });
    customerRechargeForm.reset();
    showAlert('提示', "充值成功!");
    if (Ext.getCmp('customer-query-view').payMainUtil) {
        Ext.getCmp('customer-query-view').payMainUtil.destroy();
        Ext.getCmp('customer-query-view').payMainUtil = null;
    }
    if (Ext.getCmp('preamoun-qrcode-view')) {
        Ext.getCmp('preamoun-qrcode-view').destroy();
    }
    var keywork = Ext.getCmp('queryMobile').getValue();
    querySellerCustomer(mobile, function(success, res) {
        if (success) {
            fillCustomer(res);
            openCashboxByPrint(function(succ){}, function(fail){
                showAlert('提示', fail);
            });
            var parentContainer = Ext.getCmp('customer-query-view').parentContainer;
            if (parentContainer.selectCustomerInfo && parentContainer.selectCustomerInfo.id == res.id) {
                if ( typeof parentContainer.setSelectCustomer === 'function')
                    parentContainer.setSelectCustomer(res);
            }
            // 父窗口是 shouyinMainView
            if(Ext.getCmp('shouyinMainView').selectCustomerInfo) {
                Ext.getCmp('shouyinMainView').addCustomer(Ext.getCmp('customer-query-view').selectCustomer);
            }
        } else {
            showAlert('提示', res ? res : "查询不到会员信息!");
        }
    });
}
function finishPayTypePreAmount(preAmountTxt, amount, presentAmount, mobile, name, address) {
    showAlert('提示', preAmountTxt + "成功!");
    Ext.getCmp('customer-query-view').print(preAmountTxt, amount, presentAmount, mobile, name, address);
}
/**
 * 支付成功
 */
function finishPayPreamount(type, preAmount, presentAmount, mobile, name, address) {
    if ("3" == type) {
        finishPayTypePreAmount('支付宝充值', amount, presentAmount, mobile, name, address);
    } else {
        finishPayTypePreAmount('微信充值', amount, presentAmount, mobile, name, address);
    }
    Ext.getCmp('preamoun-qrcode-view').destroy();
    var customerRechargeForm = Ext.getCmp('customerRechargeForm');
    customerRechargeForm.reset();
    var keywork = Ext.getCmp('queryMobile').getValue();
    querySellerCustomer(keywork, function(success, res) {
        if (success) {
            fillCustomer(res);
        } else {
            showAlert('提示', res ? res : "查询不到会员信息!");
        }
    });
}

function getChargePayTypeName(type) {
    if (type == '1') {
        return '现金充值';
    } else if (type == '3') {
        return '银联卡充值';
    } else if (type == '4' ) {
        return '微信离线充值';
    } else if (type == '5' ) {
        return '支付宝离线充值';
    } else if (type == '8'){
        return '微信在线充值';
    } else if (type == '9') {
        return '支付宝在线充值';
    } else {
        return '';
    }

}


function customerQueryPayOperator(data, callback) {
    for(var di=0,dilen=data.length;di<dilen;di++) {
        if(data[di].payType === '1') {
            continue;
        } else if(data[di].payType === '2') {
        } else if(data[di].payType === '3') {
            if(Ext.getCmp('pay-unionpay-recharge'))
                Ext.getCmp('pay-unionpay-recharge').setHidden(false);
        } else if(data[di].payType === '4') {
            if(Ext.getCmp('pay-wxpay-recharge'))
                Ext.getCmp('pay-wxpay-recharge').setHidden(false);
        } else if(data[di].payType === '5') {
            if(Ext.getCmp('pay-alipay-recharge'))
                Ext.getCmp('pay-alipay-recharge').setHidden(false);
        } else if(data[di].payType === '6') {

        } else if(data[di].payType === '7') {

        } else if(data[di].payType === '8') {
            if(Ext.getCmp('pay-wxpay-online-recharge'))
                Ext.getCmp('pay-wxpay-online-recharge').setHidden(false);
        } else if(data[di].payType === '9') {
            if(Ext.getCmp('pay-alipay-online-recharge'))
                Ext.getCmp('pay-alipay-online-recharge').setHidden(false);
        }
    }
}
function customerQueryPay(callback) {
    if(Ext.getCmp('pay-unionpay-recharge'))
        Ext.getCmp('pay-unionpay-recharge').setHidden(true);
    if(Ext.getCmp('pay-wxpay-recharge'))
        Ext.getCmp('pay-wxpay-recharge').setHidden(true);
    if(Ext.getCmp('pay-alipay-recharge'))
        Ext.getCmp('pay-alipay-recharge').setHidden(true);
    if(Ext.getCmp('pay-wxpay-online-recharge'))
        Ext.getCmp('pay-wxpay-online-recharge').setHidden(true);
    if(Ext.getCmp('pay-alipay-online-recharge'))
        Ext.getCmp('pay-alipay-online-recharge').setHidden(true);
    SellerDao.loadSellerPay(function(success, payData) {
        if (payData && payData.length > 0 && (!payData[0].isAllowPay || payData[0].isAllowPay == '0')) {
            PayDao.loadPayDataByAllowPay(function(success, data) {
                if(success && data && data.length >= 0) {
                    customerQueryPayOperator(data);
                }
                callback&&callback(success);
            });
        } else {
            PayDao.loadPayDataNotDelAndOpen(function(success, data) {
                if(success && data && data.length >= 0) {
                    customerQueryPayOperator(data);
                }
                callback&&callback(success);
            });
        }
    });
}
function showPasswordOperatorView(type) {
	var queryPasswordId = "customer-sub-modify-password";
	var modifyPassword = Ext.getCmp(queryPasswordId);
	var passwordTxt = type=='1' ? '新增会员密码' : '修改会员密码';
	if(!modifyPassword) {
		modifyPassword = Ext.Viewport.add({
			xtype : 'panel',
			width : 400,
			height : 250,
			modal : true,
			centered : true,
			hideOnMaskTap : false,
			id : queryPasswordId,
			items : [{
				xtype : 'toolbar',
				docked : 'top',
				title : passwordTxt, //'修改会员密码',
				items : [{
					xtype : 'button',
					cls : 'close-button',
					handler : function() {
						if(Ext.getCmp(queryPasswordId)) {
							Ext.getCmp(queryPasswordId).destroy();
						}
					}
				}, {
					xtype : 'spacer'
				}, {
					xtype : 'button',
					id : 'save-customer-pwd',
					cls : 'sy-tm-button',
					text : '保存',
					handler : function() {
						var oldPwdCmp = Ext.getCmp('input-old-password');
						var newPwdCmp = Ext.getCmp('input-new-password');
						var cmNewPwdCmp = Ext.getCmp('input-cm-new-password');
						var oldPwd = oldPwdCmp.getValue();
						var newPwd = newPwdCmp.getValue();
						var cmNewPwd = cmNewPwdCmp.getValue();
						var customerQueryView = Ext.getCmp('customer-query-view');
						var selectCustomer = customerQueryView.selectCustomer;
						if(selectCustomer) { // 选中会员
							if(!oldPwdCmp.getHidden() && selectCustomer.password != hex_md5(oldPwd)) {
								showAlert('提示', '输入的原密码不匹配!');
								return;
							}
							if(!newPwd) {
								showAlert('提示', '请输入正确的新密码!');
								return;
							}
							if(newPwd.length != 6 || !checkNumber(newPwd)) {
								showAlert('提示', '输入的新密码不合格(6位数字)!');
								return;
							}
							if(cmNewPwd != newPwd) {
								showAlert('提示', '两次输入的密码不匹配!');
								return;
							}
							selectCustomer.password = hex_md5(newPwd);
							
							showLoading(passwordTxt+"中,请稍侯...");
							// ajax request
							//nativePostRequest(webHostSynDataInterface + '/syndata/updateSellercustomerPassword', {
							nativePostRequest(webHostDownInterface + '/loaddata/updateSellercustomerPassword', {
								sellerCustomerId : selectCustomer.id,
								password : selectCustomer.password,
								sellerId : seller.id
							}, function(result) {
								closeLoading();
								if(result && result.state) {
									showAlert('提示', '密码修改成功!');
									Ext.getCmp('queryCustomer-btn').fireEvent('tap', Ext.getCmp('queryCustomer-btn'));
								} else {
									showAlert('提示', '密码修改失败!');
								}
							}, function(errMsg) {
								closeLoading();
								console.log(errMsg);
								showAlert('提示', errMsg ? errMsg : '请求服务失败!');
							});
						}
						if(Ext.getCmp(queryPasswordId)) {
							Ext.getCmp(queryPasswordId).destroy();
						}
					}
				}]
			}, {
				xtype : 'fieldset',
				margin : '0 0 0 0',
				flex : 1,
				id : 'modify-password-field',
				defaults : {
					xtype : 'passwordfield',
					labelWidth : 100,
					labelAlign : 'left'
				},
				items : [{
					id : 'input-old-password',
					name : 'old-password',
					label : '原始密码',
					placeHolder : '请输入原始密码',
					listeners : {
						focus : function(curView, e, eOpts){
								if(e){
									if(e.stopPropagation){
										e.stopPropagation();
									};
									if(e.stopEvent){
										e.stopEvent();
									}
								}
							addCustomerNumberKeyboard2('input-old-password',0, 'number');
							},
							keyup : function(field, e, eOpts) {
								if(field) {
									if(Ext.getCmp("input-customer-num-identity"))
										Ext.getCmp("input-customer-num-identity").setValue(field.getValue());
								}
							},
						clearicontap : function () {
							queryCustomerFieldClearicontap()
					    }
					}
				}, {
					id : 'input-new-password',
					name : 'new-password',
					label : '新密码',
					placeHolder : '请输入新密码(6位数字)',
					listeners : {
						focus : function(curView, e, eOpts){
								if(e){
									if(e.stopPropagation){
										e.stopPropagation();
									};
									if(e.stopEvent){
										e.stopEvent();
									}
								}
							addCustomerNumberKeyboard2('input-new-password',0, 'number');
							},
							keyup : function(field, e, eOpts) {
								if(field) {
									if(Ext.getCmp("input-customer-num-identity"))
										Ext.getCmp("input-customer-num-identity").setValue(field.getValue());
								}
							},
						clearicontap : function () {
							queryCustomerFieldClearicontap()
					    }
					}
					
				}, {
					id : 'input-cm-new-password',
					name : 'confirm-new-password',
					label : '确认新密码',
					placeHolder : '请输入确认新密码',
					listeners : {
						focus : function(curView, e, eOpts){
								if(e){
									if(e.stopPropagation){
										e.stopPropagation();
									};
									if(e.stopEvent){
										e.stopEvent();
									}
								}
							addCustomerNumberKeyboard2('input-cm-new-password',0, 'number');
							},
							keyup : function(field, e, eOpts) {
								if(field) {
									if(Ext.getCmp("input-customer-num-identity"))
										Ext.getCmp("input-customer-num-identity").setValue(field.getValue());
								}
							},
						clearicontap : function () {
							queryCustomerFieldClearicontap()
					    }
					}
				}]
			}]
		});
	}
	showBy(modifyPassword,Ext.getCmp('customer-query-view'));
	if(type == '1')
		Ext.getCmp('input-old-password').setHidden(true);
	else
		Ext.getCmp('input-old-password').setHidden(false);
}

/**
 *@会员信息查询
 *@Author: lijy
 *@Date: 2015-03-01
 */
Ext.define('Seller.view.customer.Query', {
    extend : 'Ext.Panel',
    alias : 'widget.querycustomer',
    parentContainer : null,
    selectCustomer : null,
    payMainUtil : null,
    MemberpayScanCalc : false,
    payType : null,
    config : {
        id : 'customer-query-view',
        centered : true,
        width : 750,
		height: 510,
		modal : true,
        cls : 'bluebg2',
        items : [{
            xtype : 'container',
            layout : 'vbox',
            items : [{
                xtype : 'container',
                layout : 'hbox',
                items : [{
                    xtype : 'container',
                    flex : 3,
                    layout : 'vbox',
                    items : [{
                        xtype : 'fieldset',
                        height : 40,
                        margin : '5 8 5 8',
                        items : [{
                            xtype : 'textfield',
                            //placeHolder : '请输入4位以上请手机号码',
                            placeHolder : '请输入手机号码或卡号精确查询',
                            id : 'queryMobile',
                            listeners : {
                            }
                        }]
                    }, {
                        xtype : 'formpanel',
                        id : 'customerQueryForm',
                        scrollable : false,
                        height : 340,
                        items : [{
                            xtype : 'fieldset',
                            defaults : {
                                labelWidth : 110,
                                height : 45,
                            },
                            items : [{
                                xtype : 'textfield',
                                name : 'cardNum',
                                label : '卡号',
                                readOnly : true
                            }, {
                                xtype : 'textfield',
                                name : 'mobile',
                                label : '手机号码',
                                readOnly : true
                            }, {
                                xtype : 'textfield',
                                name : 'balanceAmount',
                                label : '余额',
                                readOnly : true
                            }, {
                                xtype : 'numberfield',
                                name : 'discount',
                                label : '折扣(%)',
                                readOnly : true
                            }, {
                                xtype : 'textfield',
                                name : 'name',
                                label : '姓名',
                                readOnly : true
                            }, {
                                xtype : 'textfield',
                                label : '地址',
                                name : 'address',
                                readOnly : true
                            }, {
                                xtype : 'textfield',
                                label : '生日',
                                name : 'birthday',
                                readOnly : true
                            }]
                        }]
                    }, {
                        xtype : 'panel',
                        layout : 'hbox',
                        width : '100%',
                        margin : '0 0 0 10',
                        id : 'password-opt-panel',
                        hidden : true,
                        defaults : {
                            xtype : 'button',
                            cls : 'white-button',
                            margin : '5 5 5 5',
                            height : 35
                        },
                        items : [{
                            text : '新增密码',
                            id : 'password-operator-add',
                            handler : function(currView, e, eOpts) {
                            	preventEventBubble(e);
                            	validatePermission(PERMISSIONS.CUSTOMEREDIT)
                            	.then(function() {
                                    showPasswordOperatorView('1');
                                }).catch(function() {});
                            }
                        }, {
                            text : '修改密码',
                            id : 'password-operator-edit',
                            handler : function(currView, e, eOpts) {
                            	preventEventBubble(e);
                            	validatePermission(PERMISSIONS.CUSTOMEREDIT)
                            	.then(function() {
                            		showPasswordOperatorView('2');
                            	}).catch(function() {});
                            }
                        }, {
                            text : '初始化密码',
                            hidden : true,
                            handler : function() {
                                var initPwdId = "customer-init-pwd";
                                var initPwdCmp = Ext.getCmp(initPwdId);
                                if(!initPwdCmp) {
                                    initPwdCmp = Ext.Viewport.add({
                                        xtype : 'panel',
                                        id : initPwdId,
                                        width : 350,
                                        height : 250,
                                        modal : true,
                                        centered : true,
                                        hideOnMaskTap : false,
                                        items : [{
                                            xtype : 'toolbar',
                                            docked : 'top',
                                            title : '初始化密码',
                                            items : [{
                                                xtype : 'button',
                                                cls : 'close-button',
                                                handler : function() {
                                                    if(Ext.getCmp(initPwdId))
                                                        Ext.getCmp(initPwdId).destroy();
                                                }
                                            }, {xtype : 'spacer'}, {
                                                xtype : 'button',
                                                cls : 'sy-tm-button',
                                                text : '确认',
                                                handler : function() {
                                                    var selectCustomer = Ext.getCmp('customer-query-view').selectCustomer;
                                                    if(selectCustomer) {
                                                        selectCustomer.password = hex_md5('123456');
                                                        // ajax request
                                                        //nativePostRequest(webHostSynDataInterface + '/syndata/updateSellercustomerPassword', {
                                                        nativePostRequest(webHostDownInterface + '/loaddata/updateSellercustomerPassword', {
                                                            sellerCustomerId : selectCustomer.id,
                                                            password : selectCustomer.password,
                                                            sellerId : seller.id
                                                        }, function(result) {
                                                            if(result && result.state) {
                                                                showAlert('提示', '初始化密码成功!');
                                                            } else {
                                                                showAlert('提示', '初始化密码失败,请重试!');
                                                            }
                                                        }, function(errMsg) {
                                                            console.log(errMsg);
                                                            showAlert('提示', errMsg ? errMsg : '请求服务失败!');
                                                        });
                                                    }
                                                    if(Ext.getCmp(initPwdId)) {
                                                        Ext.getCmp(initPwdId).destroy();
                                                    }
                                                }
                                            }]
                                        }, {
                                            xtype : 'panel',
                                            flex : 1,
                                            height : '100%',
                                            id : 'init-password-panel',
                                            cls : 'jz-center',
                                            html : '<div style="width:100%;height:140px;line-height:140px;;text-align:center;color:red;">初始化密码为 : 123456</div>'
                                        }]
                                    });
                                }
                                initPwdCmp.show();
                            }
                        }]
                    }]
                }, {
                    xtype : 'container',
                    flex : 2,
                    layout : 'vbox',
                    items : [{
                        xtype : 'container',
                        height : 40,
                        margin : '5 8 5 8',
                        layout : 'hbox',
                        defaults : {
                            xtype : 'button',
                            iconMask : true,
                            margin : '0 3 0 0'
                        },
                        items : [{
                            cls : 'white-button',
                            height : 40,
                            id: 'queryCustomer-btn',
                            text : '查询',
                            handler : function() {
                                /*if(Ext.getCmp('self-input-customer-num'))
                                    Ext.getCmp('self-input-customer-num').destroy();
								var keywork = Ext.getCmp('queryMobile').getValue();
								if (keywork) {
									queryCustomerByMobileOrCard(keywork);
								}*/
                            }
                        }, {
                            flex : 1,
                            height : 40,
                            id: 'selectCustomer-btn',
                            text : '选择',
                            cls : 'red-button',
                            handler : function() {
                                // if(Ext.getCmp('self-input-customer-num'))
                                //    Ext.getCmp('self-input-customer-num').destroy();
                                // var keywork = Ext.getCmp('queryMobile').getValue();
                                // var selCustomer = Ext.getCmp('customer-query-view').selectCustomer;
                                // if (selCustomer) {
                                // 	if(keywork) {
                                // 		if(selCustomer.cardNum != keywork && selCustomer.mobile != keywork) {
                                // 			showAlert('提示', '输入的内容与会员信息不一致!\r\n请重新查询');
                                // 			return;
                                // 		}
                                // 	}
                                // }
                                // closeQueryPayTask(function(success) {
                                // 	if (selCustomer) {
                                // 		var parentContainer = Ext.getCmp('customer-query-view').parentContainer;
                                // 		/*if (parentContainer.getId() != 'shouyinMainView') {
                                // 		 Ext.getCmp('shouyinMainView').addCustomer(Ext.getCmp('customer-query-view').selectCustomer);
                                // 		 }*/
                                // 		if (parentContainer && parentContainer.setPreparePay)
                                // 			parentContainer.setPreparePay();
                                // 		parentContainer.addCustomer(Ext.getCmp('customer-query-view').selectCustomer);
                                // 		Ext.getCmp('customerQueryWindow').destroy();
                                // 		return;
                                // 	}
                                // 	querySellerCustomer(keywork, function(success, res) {
                                // 		if (success && res && res.cardNum) {
                                // 			fillCustomer(res);
                                // 			var parentContainer = Ext.getCmp('customer-query-view').parentContainer;
                                // 			if (parentContainer && parentContainer.setPreparePay)
                                // 				parentContainer.setPreparePay();
                                // 			parentContainer.addCustomer(res);
                                // 			/*if (parentContainer.getId() != 'shouyinMainView') {
                                // 			 Ext.getCmp('shouyinMainView').addCustomer(Ext.getCmp('customer-query-view').selectCustomer);
                                // 			 }*/
                                // 			parentContainer.show();
                                // 			Ext.getCmp('customerQueryWindow').destroy();
                                // 		} else {
                                // 			//showAlert('提示', res ? res : "查询不到会员信息!");
                                // 			showAlert('提示', "查询不到会员信息!");
                                // 		}
                                // 	});
                                // });
                            }
                        }, {
                            flex : 1,
                            height : 40,
                            id: 'cancel-selectCustomer-btn',
                            text : '取消选择',
                            cls : 'red-button',
                            handler : function() {
                                // if(Ext.getCmp('self-input-customer-num'))
                                //    Ext.getCmp('self-input-customer-num').destroy();
                                // closeQueryPayTask(function(success) {
                                // 	//if(!success) {
                                // 	var parentContainer = Ext.getCmp('customer-query-view').parentContainer;
                                // 	parentContainer.addCustomer(null);
                                // 	if(parentContainer && parentContainer.getId() != "shouyinMainView") {
                                // 		Ext.getCmp('shouyinMainView').addCustomer(null);
                                // 	}
                                // 	Ext.getCmp('customerQueryWindow').destroy();
                                // 	//}
                                // });
                            }
                        }]
                    }, {
                        xtype : 'container',
                        layout : 'vbox',
                        flex : 2,
                        margin : '0 0 0 0',
                        items : [{
                            xtype : 'formpanel',
                            id : 'customerRechargeForm',
                            scrollable : false,
                            //height : 320,
                            height : 410,
                            items : [{
                                xtype : 'fieldset',
                                instructions : '',
                                defaults : {
                                    labelWidth : 110,
                                    flex : 1
                                },
                                items : [{
                                    xtype : 'numberfield',
                                    name : 'amount',
                                    id: 'rechargeAmount',
                                    placeHolder : '请输入充值金额',
                                    label : '充值金额',
                                }, {
                                    xtype : 'numberfield',
                                    name : 'presentAmount',
                                    id: 'giftAmount',
                                    placeHolder : '请输入赠送金额',
                                    label : '赠送金额',
                                }]
                            }, {
                                margin : 0,
                                defaults : {
                                    margin : '0 0 0 0',
                                    xtype : 'ebutton',
                                    permissionName: 'CUSTOMERRECHARGE'
                                },
                                items : [{
                                    //xtype : 'button',
                                    width : '100%',
                                    margin : '5 0 0 0 ',
                                    height : 40,
                                    iconMask : true,
                                    id : 'pay-cash-recharge',
                                    text : '现金充值',
                                    cls : 'white-button',
                                    handler : function() {
                                        // doPreAmount('1');
                                    }
                                }, {
                                    //xtype : 'button',
                                    width : '100%',
                                    height : 40,
                                    margin : '5 0 0 0 ',
                                    iconMask : true,
                                    id : 'pay-unionpay-recharge',
                                    text : '银联卡充值',
                                    cls : 'white-button',
                                    handler : function() {
                                        // doPreAmount('3');
                                    }
                                }, {
                                    //xtype : 'button',
                                    width : '100%',
                                    height : 40,
                                    margin : '5 0 0 0 ',
                                    iconMask : true,
                                    id : 'pay-wxpay-recharge',
                                    text : '微信离线充值',
                                    cls : 'white-button',
                                    handler : function() {
                                        // doPreAmount('4');
                                    }
                                }, {
                                    //xtype : 'button',
                                    width : '100%',
                                    height : 40,
                                    margin : '5 0 0 0 ',
                                    iconMask : true,
                                    id : 'pay-alipay-recharge',
                                    text : '支付宝离线充值',
                                    cls : 'white-button',
                                    handler : function() {
                                        // doPreAmount('5');
                                    }
                                }, {
                                    //xtype : 'button',
                                    width : '100%',
                                    height : 40,
                                    margin : '5 0 0 0 ',
                                    iconMask : true,
                                    id : 'pay-wxpay-online-recharge',
                                    text : '微信在线充值',
                                    cls : 'white-button',
                                    handler : function() {
                                        // doPreAmount('8');
                                    }
                                }, {
                                    //xtype : 'button',
                                    width : '100%',
                                    height : 40,
                                    margin : '5 0 0 0 ',
                                    iconMask : true,
                                    id : 'pay-alipay-online-recharge',
                                    text : '支付宝在线充值',
                                    cls : 'white-button',
                                    handler : function() {
                                        // doPreAmount('9');
                                    }
                                }]
                            }]
                        }]
                    }]
                }]
            }]
        }, {
            xtype : 'toolbar',
            title : '会员信息',
            docked : 'top',
            items : [{
                xtype : 'button',
                //cls : 'close-button',
                cls : 'close-button-complete',
                width : 80,
                iconCls : 'close-icon',
                icon : 'resources/icon/public/back.png',
                text : '返回',
                id : 'query-customer-view-close'
            }, {
                xtype : 'spacer'
            }, {
                xtype : 'ebutton',
                id: 'customer-query-add-btn',
                width : 90,
                text : '添加会员',
                permissionName: "ADDCUSTOMER",
                handler : function() {
                    Ext.Viewport.add(Ext.create('Seller.view.customer.Add'));
					Ext.getCmp('customer-add-view').setParentContainer(Ext.getCmp('customer-query-view'));
                }
            }]
        }]
    },
    initialize : function(panel, eOpts) {
        setTimeout(function() {
            Ext.getCmp('queryMobile').focus();
        }, 200);
    },
    payViewBackTap : function(callback) {
    	var me = this;
    	cancelPreAmountPay(callback);
    },
    loadData : function(selectCustomerInfo) {
        payInterfaceAlert(false);
        Ext.getCmp('customer-query-view').selectCustomer = null;
        var customerQueryForm = Ext.getCmp('customerQueryForm');
        customerQueryForm.reset();
        if (selectCustomerInfo && selectCustomerInfo.mobile) {
            Ext.getCmp('queryMobile').setValue(selectCustomerInfo.mobile);
            querySellerCustomer(selectCustomerInfo.mobile, function(success, res) {
                if (success && res && res.cardNum) {
                    fillCustomer(res);
                } else {
                    //showAlert('提示', res ? res : "查询不到会员信息!");
                    showAlert('提示', "查询不到会员信息!");
                }
            });
        } else {
            Ext.getCmp('queryMobile').setValue('');
        }
        var rechargeCmp = Ext.getCmp("rechargeAmount");
        if(cashierPermissions && cashierPermissions.indexOf("40")>-1)
        	rechargeCmp && rechargeCmp.setDisabled(false);
        else {rechargeCmp && rechargeCmp.setDisabled(true); }

        // 副机自助收银
        if (isConfigSlaveSelfService()) {
            Ext.getCmp('customer-query-add-btn').setHidden(true);
            Ext.getCmp('customerRechargeForm').setHidden(true);
        }
    },
    setParentContainer : function(parentContainer) {
        this.parentContainer = parentContainer;
    },
    addCustomer : function(customerInfo) {
        if (Ext.getCmp('addCustomerView')) {
            Ext.getCmp('addCustomerView').destroy();
        }
        Ext.getCmp('queryMobile').setValue(customerInfo.mobile);
        querySellerCustomer(customerInfo.mobile, function(success, res) {
            if (success && res && res.cardNum) {
                fillCustomer(res);
            } else {
                //showAlert('提示', res ? res : "查询不到会员信息!");
                showAlert('提示', "查询不到会员信息!");
            }
        });
    },
    print : function(payTypeName, amount, presentAmount, mobile, name, address, transId, customer) {
        PrintDao.printRechargeLogic('3', {
            transId : transId,
            printTime : new Date().format("yyyy-MM-dd hh:mm:ss"),
            workId : shouYinEmployee.workId + ' ' + shouYinEmployee.workName,
            payTypeName : payTypeName,
            mobile : mobile,
            name : name,
            //nickName : nickName,
            amount : parseFloat( amount ? amount : 0).toFixed(2),
            presentAmount : parseFloat( presentAmount ? presentAmount : 0).toFixed(2),
            balanceAmount : parseFloat(customer.balanceAmount ? customer.balanceAmount : 0).toFixed(2)
        });
    },
    print2 : function(payTypeName, amount, presentAmount, mobile, name, address, transId) {
        querySellerCustomer(mobile, function(success, res) {
            if (!success)
                return;
            PrintDao.printRechargeLogic('3', {
                transId : transId,
                printTime : new Date().format("yyyy-MM-dd hh:mm:ss"),
                workId : shouYinEmployee.workId + ' ' + shouYinEmployee.workName,
                payTypeName : payTypeName,
                mobile : mobile,
                name : name,
                //nickName : nickName,
                amount : parseFloat( amount ? amount : 0).toFixed(2),
                presentAmount : parseFloat( presentAmount ? presentAmount : 0).toFixed(2),
                balanceAmount : parseFloat(res.balanceAmount ? res.balanceAmount : 0).toFixed(2)
            });
        });

    }
});
function customerNumberKeyboard(inputID,type) {
    var me = this;
    var oldNum = Ext.getCmp(inputID).getValue();
    var labelText,placeHolderText;
    var intLimitLength = inputID == 'queryMobile' ? 11 : 8;
    labelText = Ext.getCmp(inputID).getLabel();
    placeHolderText = Ext.getCmp(inputID).getPlaceHolder();

    function resetInputfieldNumber() {
        Ext.getCmp('input-customer-num-identity').inputId = inputID;
        Ext.getCmp('input-customer-num-identity').setValue(oldNum);
    }
    function getInputField() {
        return Ext.getCmp('input-customer-num-identity');
    }

    function confirmHandler() {
        if(!Ext.getCmp(inputID))
            Ext.getCmp('self-input-customer-num').destroy();
        var useInputCmp = Ext.getCmp(inputID);
        var inputNumIdentity = Ext.getCmp('input-customer-num-identity');
        if(useInputCmp && useInputCmp.getValue()) {
        	if(inputNumIdentity) inputNumIdentity.setValue(useInputCmp.getValue());
        }
        var commNum = "";
        if(inputNumIdentity) commNum = inputNumIdentity.getValue();
        if(!commNum) {
            if(Ext.getCmp('self-input-customer-num')) {
                Ext.getCmp(inputID).setValue(commNum);
                Ext.getCmp('self-input-customer-num').destroy();
            }
            return;
        }
        if(!checkPositiveNumber(commNum) && type == 1 && type == 2) {
            showAlert('提示', '您输入的金额非正确数字');
            return;
        }
        if(!isPositiveInteger(commNum) && type == 0){
            showAlert('提示', '您所输入的手机号码或卡号不正确');
            return;
        }
        if(commNum <= 0 && type == 1 && type == 2) {
            showAlert('提示', '您输入的金额有误!');
            return;
        }
        if(commNum <= 0 && type == 0) {
            showAlert('提示', '您所输入的手机号码或卡号有误!');
            return;
        }
        if(commNum <= 0 && type == 3) {
            showAlert('提示', '您输入的就餐人数有误!');
            return;
        }
        if(!isPositiveInteger(commNum) && type == 3) {
            showAlert('提示', '您输入的就餐人数不正确');
            return;
        }
        // var sellNum = parseFloat(record.get('sellNum'));
        if(type != 0)
            commNum = parseFloat(commNum).toFixed(2);
        Ext.getCmp(inputID).setValue(commNum);
        if(type == 0){
            var keywork = Ext.getCmp('input-customer-num-identity').getValue();
            if (keywork) {
                queryCustomerByMobileOrCard(keywork);
            }
        }
        if(Ext.getCmp('self-input-customer-num'))
            Ext.getCmp('self-input-customer-num').destroy();
    }
    if (Ext.getCmp('self-input-customer-num')) {
        //var inputCustomerNumView = Ext.getCmp('self-input-customer-num');
    	Ext.getCmp('self-input-customer-num').destroy();
    } //else {
        var inputCustomerNumView = Ext.Viewport.add({
            xtype : 'panel',
            layout : 'vbox',
            // centered : true,
            style : 'background: rgba(255,255,255,0.5); tbox-shadow:1px 1px 3px black;',
            modal : false,
            hidden : true,
            // hideOnTapMask : true,
            showAnimation : {
                type : 'fadeIn',
                easing : 'ease-in',
                duration: 200
            },
            // hideAnimation : 'slideOut',
            width : 300,
            bottom : window.innerHeight/2-120,
            height : 260,
            id : 'self-input-customer-num',
            inputId : '',
            items : [
                {
                    xtype : 'container',
                    // width : '100%',
                    items : [{
                        xtype : 'fieldset',
                        // margin : '15 25 0 25',
                        left :'0%',
                        items : [{
                            //xtype : 'numberfield',
                            xtype : 'textfield',
                            // labelWidth : 100,
                            label : labelText,
                            name : 'input-customer-num-name',
                            id : 'input-customer-num-identity',
                            hidden : true,
                            placeHolder : placeHolderText,
                            listeners : {
                                change : function () {
                                    Ext.getCmp(Ext.getCmp('input-customer-num-identity').inputId).setValue(Ext.getCmp('input-customer-num-identity').getValue());
                                },
                            }
                        }]
                    }]
                },
                getInputNumberView(getInputField, null,confirmHandler, intLimitLength)
            ],
            listeners : {
                show : function (currView, eOpts) {
                    var silentView = [];
                    silentView.push(Ext.getCmp('queryMobile'));
                    silentView.push(Ext.getCmp('rechargeAmount'));
                    silentView.push(Ext.getCmp('giftAmount'));
                    hideOnTapOutside(currView, silentView, 'destroy');
                }
            }
        });
    //}
    function autolocation() {
        var Sme = Ext.getCmp('self-input-customer-num');
        var Jme = $('#self-input-customer-num');
        console.warn($(window).width());
        console.warn($(window).height());
        if (Sme && !Sme.getHidden()) {
            if(type == 0 && ($(window).width() - 750) / 2 - 290 > 10){
                Jme.animate({
                    left : ($(window).width() - 750)/2-290,
                    bottom : $(window).height()/2-120
                });
            }else if(type == 0){
                Jme.animate({
                    left : 10,
                    bottom : $(window).height()/2-120
                });
            }
            else if(type != 0 && ($(window).width() - 750) / 2 - 290 > 10){
                Jme.animate({
                    left : 375 + $(window).width()/2,
                    bottom : $(window).height()/2-190
                });
            }else if(type != 0){
                Jme.animate({
                    left : $(window).width() - 300,
                    bottom : $(window).height()/2-190
                });
            }
        } else {
            if(type == 0 && ($(window).width() - 750) / 2 - 290 > 10){
                Sme.setLeft(($(window).width() - 750)/2-290);
                Sme.setBottom($(window).height()/2-120);
            }else if(type == 0){
                Sme.setLeft(10);
                Sme.setBottom($(window).height()/2-120);
            }
            else if(type != 0 && ($(window).width() - 750) / 2 - 290 > 10){
                Sme.setRight(($(window).width() - 750)/2-290);
                Sme.setBottom($(window).height()/2-190);
            }else if(type != 0){
                Sme.setRight(10);
                Sme.setBottom($(window).height()/2-190);
            }
        }
    }
    resetInputfieldNumber();
    autolocation();
    showBy(inputCustomerNumView, Ext.getCmp('customer-query-view'));
    // showBy(inputCustomerNumView, Ext.getCmp('customer-query-view'));
}

//修改会员密码键盘
function addCustomerNumberKeyboard2(inputID,type,inputType) {
	var me = this;
	var oldNum = Ext.getCmp(inputID).getValue();
	var labelText,placeHolderText;
	var intLimitLength = 50;
	labelText = Ext.getCmp(inputID).getLabel();
	placeHolderText = Ext.getCmp(inputID).getPlaceHolder();

	function resetInputfieldNumber() {
		Ext.getCmp('input-customer-num-identity').inputId = inputID;
		Ext.getCmp('input-customer-num-identity').setValue(oldNum);
	}
	function getInputField() {
		return Ext.getCmp('input-customer-num-identity');
	}

	function confirmHandler() {
		if(Ext.getCmp('self-input-customer-num'))
			Ext.getCmp('self-input-customer-num').destroy();
	}
	if (Ext.getCmp('self-input-customer-num')) {
		//var inputCustomerNumView = Ext.getCmp('self-input-customer-num');
		Ext.getCmp('self-input-customer-num').destroy();
	}

	var getInputView = null;
	var numberFieldWidth = 0;
	if(inputType == 'number'){
		getInputView = getInputNumberView;
		numberFieldWidth= 400;
	}else if(inputType == 'word'){
		getInputView = getInputWordNumberView;
		numberFieldWidth = 930;
	}
	var inputCustomerNumView = Ext.Viewport.add({
		xtype : 'panel',
		layout : 'vbox',
		// centered : true,
		style : 'background: rgba(255,255,255,0.5); tbox-shadow:1px 1px 3px black;',
		modal : false,
		hidden : true,
		// hideOnTapMask : true,
		showAnimation : {
			type : 'fadeIn',
			easing : 'ease-in',
			duration: 200
		},
		// hideAnimation : 'slideOut',
		width : numberFieldWidth,
		bottom : window.innerHeight/2-120,
		height : 260,
		id : 'self-input-customer-num',
		inputId : '',
		items : [
			{
				xtype : 'container',
				// width : '100%',
				items : [{
					xtype : 'fieldset',
					// margin : '15 25 0 25',
					left :'0%',
					items : [{
						//xtype : 'numberfield',
						xtype : 'textfield',
						// labelWidth : 100,
						label : labelText,
						name : 'input-customer-num-name',
						id : 'input-customer-num-identity',
						hidden : true,
						placeHolder : placeHolderText,
						listeners : {
							change : function () {
								Ext.getCmp(Ext.getCmp('input-customer-num-identity').inputId).setValue(Ext.getCmp('input-customer-num-identity').getValue());
							},
						}
					}]
				}]
			},
			getInputView(getInputField, null,confirmHandler, intLimitLength)
		],
		listeners : {
			show : function (currView, eOpts) {
				var silentView = [];
				silentView.push(Ext.getCmp('input-old-password'));
                silentView.push(Ext.getCmp('input-new-password'));
                silentView.push(Ext.getCmp('input-cm-new-password'));
				hideOnTapOutside(currView, silentView, 'destroy');
			}
		}
	});
	//}
	function autolocation() {
		var Sme = Ext.getCmp('self-input-customer-num');
		var Jme = $('#self-input-customer-num');
		console.warn($(window).width());
		console.warn($(window).height());
		if (Sme && !Sme.getHidden()) {
			if(type == 0 && ($(window).width() - 750) / 2 - 290 > 10){
				Jme.animate({
					left : ($(window).width() - 750)/2-290,
					bottom : $(window).height()/2-120
				});
			}else if(type == 0){
				Jme.animate({
					left : 10,
					bottom : $(window).height()/2-120
				});
			}
			else if(type == 1 && ($(window).width() - 750) / 2 - 290 > 10){
				Jme.animate({
					left : 375 + $(window).width()/2,
					bottom : $(window).height()/2-190
				});
			}else if(type == 1){
				Jme.animate({
					left : $(window).width() - 300,
					bottom : $(window).height()/2-190
				});
			}
		} else {
			if(type == 0 && ($(window).width() - 750) / 2 - 290 > 10){
				Sme.setLeft(($(window).width() - 750)/2-290);
				Sme.setBottom($(window).height()/2-120);
			}else if(type == 0){
				Sme.setLeft(10);
				Sme.setBottom($(window).height()/2-120);
			}
			else if(type == 1 && ($(window).width() - 750) / 2 - 290 > 10){
				Sme.setRight(($(window).width() - 750)/2-290);
				Sme.setBottom($(window).height()/2-190);
			}else if(type == 1){
				Sme.setRight(10);
				Sme.setBottom($(window).height()/2-190);
			}
			else if(type == 2){
				Sme.setRight($(window).width()/2 - numberFieldWidth/2);
				Sme.setBottom($(window).height()/2 - 320);
			}
			else if(type == 3){
				Sme.setRight($(window).width()/2 - numberFieldWidth/2);
				Sme.setBottom($(window).height()/2 - 105);
			}
		}
	}
	resetInputfieldNumber();
	autolocation();
	showBy(inputCustomerNumView, Ext.getCmp('customer-query-view'),1000);
}
