function calcAmountByRemark(amountData) {
	amountData.totalAmount = nvlValue(amountData.totalAmount, 0);
	amountData.remarkAmount = nvlValue(amountData.remarkAmount, 0);
	amountData.notDiscountAmount = nvlValue(amountData.notDiscountAmount, 0);
	//amountData.discount = nvlValue(amountData.discount, 100);
	amountData.discount = getDiscountValueRange(amountData.discount);
	return parseFloat((amountData.totalAmount - amountData.remarkAmount - amountData.notDiscountAmount) * (parseFloat(amountData.discount)/100)
		+ amountData.remarkAmount + amountData.notDiscountAmount);
}

/* 获取折扣框的值 */
function getDiscountViewValue() {
	var me = Ext.getCmp('allDiscountView');
	var amountData = {};
	amountData.remarkAmount = me.remarkAmount ? me.remarkAmount : 0;
	amountData.totalAmount = parseFloat(Ext.getCmp('all-discount-before').getValue());
	amountData.notDiscountAmount = parseFloat(Ext.getCmp('all-not-discount-amount').getValue());

	return amountData;
}

/* 给定默认值 */
function genDefaultValue(amountData) { // 生成默认值(只针对数字型)
	if(!amountData) return;
	for(var amountKey in amountData) {
		if(amountData.hasOwnProperty(amountKey)) {
			amountData[amountKey] = amountData[amountKey] ? amountData[amountKey] : 0;
		}
	}
}
/* 设置折扣框的值 */
function setDiscountViewValue(amountData) {
	genDefaultValue(amountData);
	// 折扣 x 金额 / 100
	amountData.sellAmount = (parseFloat(amountData.totalAmount) - parseFloat(amountData.remarkAmount) - parseFloat(amountData.notDiscountAmount)) * parseFloat(amountData.discount) / 100 + parseFloat(amountData.remarkAmount) + parseFloat(amountData.notDiscountAmount);
	var decreaseAmount = parseFloat(amountData.totalAmount - amountData.sellAmount).toFixed(2);
	Ext.getCmp('all-discount-before').setValue(parseFloat(amountData.totalAmount).toFixed(2));  // 折前应收
	Ext.getCmp('all-not-discount-amount').setValue(parseFloat(amountData.notDiscountAmount).toFixed(2));  // 不可打折金额
	Ext.getCmp('all-discount-admount').setValue(decreaseAmount);  // 减价的数量(优惠了多少)
	Ext.getCmp('all-discount-after').setValue(parseFloat(amountData.sellAmount).toFixed(2));  // 折后应收

    // 自定义更改商品金额折算成折扣时，如果折扣只保留两位数计算不精准，故保留四位数
	Ext.getCmp('all-discount').setValue(parseFloat(amountData.discount).toFixed(4));  // 折扣 隐藏
	Ext.getCmp('all-discount-visiblity').setValue(parseFloat(amountData.discount).toFixed(2));  // 折扣 显示
}

/* 显示输入密码框 */
function showInputPwdView(innerPassword, callback) {
	var passwordView = Ext.Viewport.add({
		xtype : 'panel',
		modal : true,
		hideOnMaskTap : false,
		width : 360,
		id : 'passwordView',
		height : 400,
		centered : true,
		layout : 'vbox',
		items : [{
			xtype : 'passwordpanel'
		}]
	});
	showBy(passwordView,Ext.getCmp('discount-view'),10);
	Ext.getCmp("numberPanel").setParentContainer(passwordView);
	Ext.getCmp("numberPanel").setCallBackPassword(function(password) {
		if (innerPassword == password) {
			callback && callback();
			passwordView.destroy();
		} else {
			showAlert("提示", "密码不正确");
		}
	});
}

function showInputPwdView2(innerPassword, callback) {
	var passwordView = Ext.Viewport.add({
		xtype : 'panel',
		modal : true,
		hideOnMaskTap : false,
		width : 360,
		id : 'passwordView',
		height : 400,
		centered : true,
		layout : 'vbox',
		items : [{
			xtype : 'getpassword'
		}]
	});
	passwordView.show();
	Ext.getCmp("getpassword_view").setParentContainer(passwordView);
	Ext.getCmp("getpassword_view").setCallBackPassword(function(password) {
		if (innerPassword == password) {
			callback && callback();
			passwordView.destroy();
		} else {
			showAlert("提示", "密码不正确");
		}
	});
}

/* 折扣客显示 */
function showDiscountScreen() {
	var form = Ext.getCmp('discount-form');
	var totalAmount = form.getFields('discount-after').getValue();
	if(Ext.getCmp("allDiscountView").type == 3) {// 单价(显示在计算之前)
		var commRecord = Ext.getCmp('allDiscountView').record;
		var discount = Ext.getCmp('all-discount').getValue();
		//discount = parseFloat(discount ? discount : 100);
		discount = parseFloat(getDiscountValueRange(discount));
		var commodityPrice = commRecord.get('commodityPrice');
		commodityPrice = parseFloat(commodityPrice ? commodityPrice : 0);
		var remarkPrice = commRecord.get('remarkPrice');
		remarkPrice = parseFloat(remarkPrice ? remarkPrice : 0);
		var sellPrice = parseFloat(commodityPrice * parseFloat(discount) /100) + parseFloat(remarkPrice);
		showCustomerDisplay(0x31, parseFloat(sellPrice).toFixed(2));
	} else if(Ext.getCmp("allDiscountView").type == 2) {
	} else
		showCustomerDisplay(0x32, parseFloat(totalAmount).toFixed(2));
}
/* 更新购物车数据 */
function updateCommodityInfoForDiscount(record, detailInfo) {
	calcDetailAmountForAlgo(detailInfo);
	record.set('discount', parseFloat(detailInfo.discount).toFixed(2));
	record.set('sellPrice', parseFloat(detailInfo.sellPrice).toFixed(2));
	record.set('sellAmount', parseFloat(detailInfo.sellAmount).toFixed(2));
	record.set('isPresented', detailInfo.isPresented);
	record.set("hasChangePrice", detailInfo.hasChangePrice);
	record.set("changePrice", isValidDigital(detailInfo.changePrice) ? parseFloat(detailIinfo.changePrice).toFixed(2) : null);
	record.set("chgPriceOperator", detailInfo.chgPriceOperator ? detailIinfo.chgPriceOperator : "");
	console.log('操作单据：' + record.get('commodityName') + '的折扣被修改为' + detailInfo.discount + '%,商品单价变为' + detailInfo.sellPrice + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
	Ext.getCmp('shouyinMainView').countStore();
	Ext.getCmp('discount-view').destroy();
}
/*单个商品折扣*/
function detailCommodityDiscount(discount) {
	var record = Ext.getCmp('allDiscountView').record;
	var commodityPrice = parseFloat(record.get("commodityPrice"));
	//var sellNum = parseInt(record.get("sellNum"));
	var sellNum = parseFloat(record.get("sellNum"));
	var remarkPrice = record.get("remarkPrice");
	var isWeight = record.get("isWeight");
	remarkPrice = remarkPrice ? remarkPrice : 0;
	var sellPrice = parseFloat(commodityPrice * parseFloat(discount) /100) + parseFloat(remarkPrice);
	var sellAmount = parseFloat(sellPrice) * parseFloat(sellNum);
	var detailInfo = {
		commodityPrice : commodityPrice,
		remarkPrice : remarkPrice,
		sellNum : sellNum,
		discount : parseFloat(discount).toFixed(2),
		sellPrice : parseFloat(sellPrice).toFixed(2),
		sellAmount : parseFloat(sellAmount).toFixed(2),
		isPresented : record.get('isPresented'),
		isWeight : isWeight
	};
	if(record.get('isPresented')=='1' && parseFloat(detailInfo.discount) != parseFloat(0))
		detailInfo.isPresented = '0';
	if(record.get("hasChangePrice") == '1' && parseFloat(detailInfo.discount) != parseFloat(100)) {
		detailInfo.hasChangePrice = "0";
		detailInfo.changePrice = null;
		detailInfo.chgPriceOperator = null;
	}
	if (Ext.getCmp('shouyinMainView').sellInfo) {
		if (record.get('type') == '1') {
			updateCommodityInfoForDiscount(record, detailInfo);
		} else {
			updateSellDetail(detailInfo, record.get('id'), Ext.getCmp('shouyinMainView').sellInfo.id, function(success, res) {
				if (success) {
					updateCommodityInfoForDiscount(record, detailInfo);
				} else {
					showAlert("提示", "打折失败！");
				}
			});
		}
	} else {
		updateCommodityInfoForDiscount(record, detailInfo);
	}
}
/* 更改折扣并提交 */
function submitDiscount(discount) {
	var form = Ext.getCmp('discount-form');
	var discount = Ext.getCmp('all-discount').getValue();
	discount = getDiscountValueRange(discount); //discount ? discount : 100;
    var notDiscountAmount = Ext.getCmp('all-not-discount-amount').getValue();
    notDiscountAmount = parseFloat(notDiscountAmount);
    var sellAmount = parseFloat(form.getFields('discount-after').getValue());
    if (Ext.getCmp("allDiscountView").type == 2) {
		Ext.getCmp('shoukuan_view').setDiscount(discount, notDiscountAmount);
		Ext.getCmp('discount-view').destroy();
	} else if (Ext.getCmp("allDiscountView").type == 3) {
		detailCommodityDiscount(discount);
	} else {
		var alreadyDiscountAmount = Ext.getCmp('all-discount-admount').getValue();
		alreadyDiscountAmount = nvlValue(alreadyDiscountAmount,0);
		var discountOperator = function() {
			Ext.getCmp('shouyinMainView').discount = discount;
			Ext.getCmp('shouyinMainView').alreadyDiscountAmount = parseFloat(alreadyDiscountAmount).toFixed(2);
			Ext.getCmp('shouyinMainView').countStore();
			//Ext.getCmp('discount-view').destroy();
            Ext.getCmp('discount-view').hide();
			console.log('操作单据：整单折扣变为' + discount + '%，减价' + alreadyDiscountAmount + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
		};
		if (Ext.getCmp('shouyinMainView').sellInfo) {
			Ext.getCmp('shouyinMainView').sellInfo.discount = discount;
			var discountData = {discount:discount,alreadyDiscountAmount:alreadyDiscountAmount};
			SellDao.updateSellDiscount(discount, Ext.getCmp('shouyinMainView').sellInfo.id, function(success, msg) {
				if (success) {
					/*Ext.getCmp('shouyinMainView').discount = discount;
					Ext.getCmp('shouyinMainView').countStore();
					Ext.getCmp('discount-view').destroy();*/
					discountOperator();
				} else {
					showAlert('提示', '折扣失败！');
				}
			});
		} else {
			/*Ext.getCmp('shouyinMainView').discount = discount;
			Ext.getCmp('shouyinMainView').countStore();
			Ext.getCmp('discount-view').destroy();*/
			discountOperator();
		}
	}
	DiscountBtnSelect(discount);// 快键按键的选中*
    showDiscountBtnStatusByDiscount(discount);
}
/*打折的结束点*/
function dealDiscountEnd() {
	showDiscountScreen();
	submitDiscount();
}
/* 折扣权限 */
function checkDiscountPermission() {
	return new Promise(function(resolve, reject) {
		checkPermissions("4", true)
		.then(function() {resolve();})
		.catch(function() {reject()});
	});
	/*if (!checkPermissions("4", false)) {
		showAlert('提示', '当前收银员没有此项权限！');
		return false;
	}
	return true;*/
}
function showDiscountView() {
	var discountView=Ext.getCmp('discount-view');
	var shoukuanView = Ext.getCmp('shoukuan_view');
	var shouyinView = Ext.getCmp('shouyinMainView');
	if (!discountView) {
		discountView = Ext.Viewport.add({
			xtype : 'panel',
			modal : true,
			hideOnMaskTap : false,
			width : 638,
			id : 'discount-view',
			//height : 360,
			height : 420,
			centered : true,
			layout : 'vbox',
			items : [{
				xtype : 'discount'
			}]
		});
	}
	if (shoukuanView && !shoukuanView.getHidden()) {
        showBy(discountView, shoukuanView);
	} else {
        showBy(discountView, shouyinView);
	}
}

function changeDiscount(discount) {
	var amountData = getDiscountViewValue();
	if(discount == 0)
		amountData.discount = discount;
	else
		amountData.discount = discount ? discount : 100;
	setDiscountViewValue(amountData);
}
function changeDiscount2(discout) {
	var me = Ext.getCmp('allDiscountView');
	if (!me.remarkAmount) {
		me.remarkAmount = 0;
	}
	me.remarkAmount = parseFloat(me.remarkAmount);
	console.log(me.remarkAmount);
	var totalAmount = parseFloat(Ext.getCmp('all-discount-before').getValue());
	//var sellAmounnt = (totalAmount - me.remarkAmount) * parseFloat(discout) / 100 + me.remarkAmount;
	var notDiscountAmount = parseFloat(Ext.getCmp('all-not-discount-amount').getValue());
	var sellAmounnt = (totalAmount - me.remarkAmount - notDiscountAmount) * parseFloat(discout) / 100 + me.remarkAmount + notDiscountAmount;
	sellAmounnt = parseFloat(sellAmounnt).toFixed(2);
	/*Ext.getCmp('all-discount-admount').setValue((totalAmount - sellAmounnt).toFixed(2));
	Ext.getCmp('all-discount-after').setValue(sellAmounnt.toFixed(2));
	Ext.getCmp('all-discount').setValue(discout.toFixed(2));*/
	Ext.getCmp('all-discount-admount').setValue(parseFloat(totalAmount - parseFloat(sellAmounnt)).toFixed(2));
	Ext.getCmp('all-discount-after').setValue(sellAmounnt);  // 折后应收
	Ext.getCmp('all-discount').setValue(discout.toFixed(2));

	//this.remarkAmount
}

function submitDiscount2(discount) {
	var form = Ext.getCmp('discount-form');
	var discount = parseFloat(discount);
    var notDiscountAmount = Ext.getCmp('all-not-discount-amount').getValue();
    notDiscountAmount = parseFloat(notDiscountAmount);
    var sellAmount = parseFloat(form.getFields('discount-after').getValue());
    if (Ext.getCmp("allDiscountView").type == 2) {
		Ext.getCmp('shoukuan_view').setDiscount(discount, notDiscountAmount);
		Ext.getCmp('discount-view').destroy();
	} else if (Ext.getCmp("allDiscountView").type == 3) {
		var record = Ext.getCmp('allDiscountView').record;
		var sellAmount = parseFloat(form.getFields('discount-after').getValue());
		var commodityPrice = parseFloat(record.get("commodityPrice"));
		var sellNum = parseInt(record.get("sellNum"));
		var remarkPrice = record.get("remarkPrice");
		if(!remarkPrice){
			remarkPrice=0;
		}else{
			remarkPrice = parseFloat(remarkPrice);
		}
		var sellPrice = commodityPrice * discount /100 + remarkPrice;
		if (Ext.getCmp('shouyinMainView').sellInfo) {
			if (record.get('type') == '1') {
				record.set('discount', discount.toFixed(2));
				record.set('sellPrice', sellPrice.toFixed(2));
				record.set('sellAmount', sellAmount.toFixed(2));
				Ext.getCmp('shouyinMainView').countStore();
				Ext.getCmp('discount-view').destroy();
			} else {
				var sellDetail = {
					sellNum : sellNum,
					sellPrice : sellPrice.toFixed(2),
					remarkPrice:remarkPrice.toFixed(2),
					commodityPrice : record.get('commodityPrice'),
					discount : discount.toFixed(2)
				};
				updateSellDetail(sellDetail, record.get('id'), Ext.getCmp('shouyinMainView').sellInfo.id, function(success, res) {
					if (success) {
						record.set('discount', discount.toFixed(2));
						record.set('sellPrice', sellPrice.toFixed(2));
						record.set('sellAmount', sellAmount.toFixed(2));
						Ext.getCmp('shouyinMainView').countStore();
						Ext.getCmp('discount-view').destroy();
					} else {
						showAlert("提示", "打折失败！");
					}
				});
			}
		} else {
			record.set('discount', discount.toFixed(2));
			record.set('sellPrice', sellPrice.toFixed(2));
			record.set('sellAmount', sellAmount);
			Ext.getCmp('shouyinMainView').countStore();
			Ext.getCmp('discount-view').destroy();
		}
	} else {
		if (Ext.getCmp('shouyinMainView').sellInfo) {
			Ext.getCmp('shouyinMainView').sellInfo.discount = discount;
			SellDao.updateSellDiscount(discount, Ext.getCmp('shouyinMainView').sellInfo.id, function(success, msg) {
				if (success) {
					Ext.getCmp('shouyinMainView').discount = discount;
					Ext.getCmp('shouyinMainView').countStore();
					Ext.getCmp('discount-view').destroy();
				} else {
					showAlert('提示', '折扣失败！');
				}
			});
		} else {
			Ext.getCmp('shouyinMainView').discount = discount;
			Ext.getCmp('shouyinMainView').countStore();
			Ext.getCmp('discount-view').destroy();
		}
	}
}

/**
 *@Project: 整单折扣
 *@Author: lijy
 *@Date: 2015-03-01
 */
Ext.define('Seller.view.discount.Discount', {
	extend : 'Ext.Container',
	requires : ['Seller.view.discount.GetPassword', 'Seller.view.discount.PasswordPanel'],
	alias : 'widget.discount',
	config : {
		height : '100%',
		width : '100%',
		scrollable : false,
		id : 'allDiscountView',
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			dock : 'top',
			width : '100%',
			title : '折扣(%)',
			items : [{
				xtype : 'button',
				//cls : 'close-button',
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : 'discount-close',
				// handler : function() {
				// 	Ext.getCmp('discount-view').destroy();
				// }
			}]
		}, {
			xtype: 'container',
			layout: 'hbox',
			width: '100%',
			flex: 1,
			items: [
				{
					xtype: 'container',
					layout: 'vbox',
					items: [
						{
							layout : 'hbox',
							margin : 0,
							//flex : 1,
							height : 312,
							items : [{
								xtype : 'formpanel',
								id : 'discount-form',
                                margin: '22 14 0 28',
								scrollable : false,
								//width : 310,
								width : 240,
								//flex : 1,
								items : [
									{
									xtype : 'container',
									height : '100%',
                                    style: 'margin-top:0;border:1px solid #ccc;border-radius:6px;margin:3px;',
									defaults : {
										labelWidth : 120,
										margin : '2 0 0 0'
									},
									items : [
                                        {
                                            xtype : 'container',
                                            id : 'all-discount-form-header',
                                            name : 'form-discount-header',
											height : 40,
											margin: 0,
											style: 'text-align:center;background: rgba(204, 204, 204, 0.5);',
                                            html : '<div style="height:40px;line-height: 40px;">折算明细</div>'
                                        },
                                        {
										xtype : 'textfield',
										id : 'all-discount-before',
										name : 'discount-before',
										label : '折前应收',
										readOnly : true
									}, {
										xtype : 'textfield',
										id : 'all-not-discount-amount',
										name : 'all-not-discount-amount',
										label : '不可打折金额',
										readOnly : true
									}, {
										xtype : 'textfield',
										id : 'all-discount',
										name : 'discount',
										label : '折扣(%)',
										readOnly : true,
                                        hidden: true
									}, {
                                            xtype : 'textfield',
                                            id : 'all-discount-visiblity',
                                            name : 'discount',
                                            label : '折扣(%)',
                                            readOnly : true
                                        },{
										xtype : 'textfield',
										id : 'all-discount-admount',
										name : 'discount-amount',
										label : '减价',
										readOnly : true
									}, {
										xtype : 'textfield',
										id : 'all-discount-after',
										name : 'discount-after',
										label : '折后应收',
										readOnly : true
									}]
								}]
							}/*,
								{
									height : '100%',
									width : 260,
									height : 210,
									layout : 'vbox',
									hidden : false,
									style : 'border:1px solid #ddd;',
									margin : 10,
									items : [{
										xtype : 'panel',
										width : '100%',
										height : 40,
										layout : 'vbox',
										html : '<div class="zk-header" style="width: 260px;"><div class="zk-header-title jz-center">折扣</div><div class="zk-header-title jz-center">是否要密码</div><div class="zk-header-title jz-center">备注</div></div>'
									}, {
										xtype : 'list',
										id : 'discount-list',
										store : Ext.create('Ext.data.Store', {
											id : 'discount-store',
											fields : ['id', 'discount', 'isSupportPwd', 'isSupportPwdText', 'password', 'remark'],
											data : []
										}),
										listeners : {
											itemtap : function(list, index, target, record, e, eOpts) {
												// changeDiscount(record.get("discount"));
											}
										},
										emptyText : '没有折扣',
										flex : 1,
										width : '100%',
										selectedCls : 'checkedbg',
										itemTpl : '<div class=""><div class="zk-header-title jz-center">{discount}</div><div class="zk-header-title jz-center">{isSupportPwdText}</div><div class="zk-header-title jz-center text-overflow" title="{remark}">{remark}</div></div>'
									}]
								}*/]
						}, {
							xtype : 'container',
							layout : 'hbox',
							margin: '0 0 16 0',
							height : 45,
							defaults : {
								height : 40,
								margin : '2 2 0 0'
							},
							items : [{
								xtype : 'spacer',
								width: 88
							}, {
								xtype : 'button',
								width : 110,
								cls : 'white-button',
								iconMask : true,
								id : 'recovery-One-hundred',
								text : '恢复100%',
								handler : function() {

								}
							}/*, {
								xtype : 'spacer',
								width: 136
							}, {
								xtype : 'button',
								width : 110,
								cls : 'red-button',
								iconMask : true,
								id : 'discount-confirm-btn',
								text : '确定',
								handler : function() {

								}
							}, {
								xtype : 'spacer'
							}*/]
						}
					]
				},{
					xtype: 'container',
					id: 'sk-discount-inputform',
					width: 315,
					margin: '22 0 0 6',
					layout: 'vbox',
					items: [
						{
							xtype: 'container',
							layout: 'hbox',
							width: '100%',
							defaults: {
								xtype: 'ebutton',
								height: 40,
								flex: 1,
								style: 'color:rgba(0,0,0,0.5);border-radius: 10px 10px 0 0;border:none;border-right: 1px solid rgb(200, 200, 200);background:rgba(204, 204, 204, 0.5);',
								handler: function(event){
									var tabPanelId = event.getData().id;

									$('.discount-of-btn').removeClass('tab-active');
									$('#' + event.id).addClass('tab-active');

									Ext.select('div.sk-discount-inputform-body',true).hide();
									Ext.get(tabPanelId).show();

								}
							},
							items: [
                                {
                                    text: '固定折扣',
                                    id: 'discount-of-setting-btn',
                                    cls: 'discount-of-btn tab-active',
                                    margin: '0 3 0 0',
                                    data: {
                                        id: 'sk-discount-inputform-selection'
                                    }
                                },
								{
									text: '折后金额',
									id: 'discount-of-amount-btn',
									cls: 'discount-of-btn',
									margin: '0 3 0 0',
									data: {
										id: 'sk-discount-inputform-amount'
									}
								},
								{
									text: '比率折扣',
									id: 'discount-of-rate-btn',
									cls: 'discount-of-btn',
									data: {
										id: 'sk-discount-inputform-rate'
									}
								}
							]
						},
						{
							xtype: 'container',
							layout: 'hbox',
							width: '100%',
							margin: '4 0',
							items: [
								{
                                    xtype: 'container',
                                    id: 'sk-discount-inputform-selection',
                                    cls: 'sk-discount-inputform-body',
                                    layout: 'vbox',
									width: '100%',
									items: [
                                        {
                                            //width : 260,
                                            width: '100%',
                                            height : 232,
                                            layout : 'vbox',
                                            hidden : false,
                                            style : 'margin-top:-5px;border:1px solid #ddd;',
                                            items : [{
                                                xtype : 'container',
                                                width : '100%',
                                                height : 40,
                                                layout : 'vbox',
                                                html : '<div class="zk-header" style="width: 100%;"><div class="zk-header-title jz-center">折扣</div><div class="zk-header-title jz-center">是否要密码</div><div class="zk-header-title jz-center">备注</div></div>'
                                            }, {
                                                xtype : 'dataview',
                                                id : 'discount-list',
                                                store : Ext.create('Ext.data.Store', {
                                                    id : 'discount-store',
                                                    fields : ['id', 'discount', 'isSupportPwd', 'isSupportPwdText', 'password', 'remark'],
                                                    data : []
                                                }),
                                                listeners : {
                                                    itemtap : function(list, index, target, record, e, eOpts) {
                                                        // changeDiscount(record.get("discount"));
                                                    }
                                                },
                                                emptyText : '没有折扣',
                                                flex : 1,
                                                width : '100%',
                                                selectedCls : 'checkedbg',
                                                //itemTpl : '<div class=""><div class="zk-header-title jz-center">{discount}</div><div class="zk-header-title jz-center">{isSupportPwdText}</div><div class="zk-header-title jz-center text-overflow" title="{remark}">{remark}</div></div>'
                                                itemTpl : '<div style="height:42px;line-height:42px;"><div class="jz-center" style="width:33.0%;display:inline-block;">{discount}</div><div class="jz-center" style="width:33.0%;display:inline-block;">{isSupportPwdText}</div><div class="jz-center" style="width:33.0%;display:inline-block;text-overflow:ellipsis;-o-text-overflow:ellipsis;text-overflow:hidden;" title="{remark}">{remark}</div></div>'
                                            }]
                                        },{
                                    	    xtype: 'container',
											layout: {
                                    	    	type: 'hbox',
												pack: 'center'
											},
											items: [
                                                {
                                                    xtype : 'button',
                                                    width : 110,
                                                    height : 40,
                                                    cls : 'red-button',
													margin: '24 0 0 0',
                                                    iconMask : true,
                                                    id : 'discount-confirm-btn',
                                                    text : '确定',
                                                    handler : function() {

                                                    }
                                                }
											]
										}
									]
								},
								{
									xtype: 'container',
									id: 'sk-discount-inputform-amount',
									cls: 'sk-discount-inputform-body',
                                    hidden: true,
									layout: 'vbox',
									items: [
										{
											xtype : 'textfield',
											width: '100%',
											height: 38,
											id : 'discount-of-amount-input',
											cls:'discount-input-field',
											label : '请输入折后金额：',
											labelCls : 'bg-transparent',
											labelWidth : 168,
											style: 'font-size:15px;margin: 0 0 2px -5px;',
											labelAlign : 'left',
											inputCls: 'discount-input-dom',
											listeners : {
												focus : function() {hideSystemKeyboard();}
											}
										},
										{
											xtype: 'container',
											id: 'sk-discount-numberkeyboard',
											items: [
												{
													xtype : 'container',
													id : 'number-middle-content-view',
													height : 220,
													width: 320,
													layout : 'hbox',
													defaults : {
														xtype : 'container',
														layout : 'vbox',
														flex : 1,
														defaults : {
															flex : 1,
															margin : 5,
															height : 50,
															xtype : 'button',
															cls : 'white-button',
															handler : function(cmp){
																skDiscountKeyInputValue(cmp, 'discount-of-amount-input');
															}
														}
													},
													items : [{
														items : [{
															text : '1'
														}, {
															text : '4'
														}, {
															text : '7'
														}, {
															text : '0'
														}]
													}, {
														items : [{
															text : '2'
														}, {
															text : '5'
														}, {
															text : '8'
														}, {
															text : '00'
														}]
													}, {
														items : [{
															text : '3'
														}, {
															text : '6'
														}, {
															text : '9'
														}, {
															text : '.'
														}]
													}, {
														items : [{
															cls : 'sp-delete',
															id : 'number-view-delete'
														}, {
															text : '清空'
														}, {
															flex : 2,
															text : '确认',
															cls : 'red-button',
															handler : function() {
																skDiscountConfirmHandler && skDiscountConfirmHandler('discount-of-amount-input', '0');
															}
														}]
													}]
												}
											]
										}
									]
								},
								{
									xtype: 'container',
									id: 'sk-discount-inputform-rate',
									cls: 'sk-discount-inputform-body',
									hidden: true,
									layout: 'vbox',
									items: [
										{
											xtype : 'textfield',
											width: '100%',
											height: 38,
											id : 'discount-of-rate-input',
											cls:'discount-input-field',
											label : '请输入折扣比率[0-100]：',
											labelCls : 'bg-transparent',
											labelWidth : 196,
											style: 'font-size:15px;margin: 0 0 2px -5px;',
											labelAlign : 'left',
											inputCls: 'discount-input-dom',
                                            listeners : {
                                                focus : function() {hideSystemKeyboard();}
                                            }
										},
										{
											xtype: 'container',
											id: 'sk-discount-numberkeyboard',
											items: [
												{
													xtype : 'container',
													id : 'number-middle-content-view',
													height : 220,
													width: 320,
													layout : 'hbox',
													defaults : {
														xtype : 'container',
														layout : 'vbox',
														flex : 1,
														defaults : {
															flex : 1,
															margin : 5,
															height : 50,
															xtype : 'button',
															cls : 'white-button',
															handler : function(cmp){
																skDiscountKeyInputValue(cmp, 'discount-of-rate-input');
															}
														}
													},
													items : [{
														items : [{
															text : '1'
														}, {
															text : '4'
														}, {
															text : '7'
														}, {
															text : '0'
														}]
													}, {
														items : [{
															text : '2'
														}, {
															text : '5'
														}, {
															text : '8'
														}, {
															text : '00'
														}]
													}, {
														items : [{
															text : '3'
														}, {
															text : '6'
														}, {
															text : '9'
														}, {
															text : '.'
														}]
													}, {
														items : [{
															cls : 'sp-delete',
															id : 'number-view-delete2'
														}, {
															text : '清空'
														}, {
															flex : 2,
															text : '确认',
															cls : 'red-button',
															handler : function() {
																skDiscountConfirmHandler && skDiscountConfirmHandler('discount-of-rate-input', '1');
															}
														}]
													}]
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		}]
	},
	resetDiscountData : function() {
		var discountStore = Ext.getStore('discount-store');
		discountStore.removeAll();
	},
	setData : function(type, totalAmount, sellAmount, discount, notDiscountAmount) {
		this.resetDiscountData();
		Ext.getCmp("allDiscountView").type = type;
		setDiscountViewValue({
			discount : getDiscountValueRange(discount), //discount ? discount:100,
			totalAmount : totalAmount,
			notDiscountAmount : notDiscountAmount,
			sellAmount : sellAmount,
			remarkAmount : 0
		});
		//showCustomerDisplay(0x32, parseFloat(sellAmount).toFixed(2));
		setTimeout(this.loadDiscount(), 100);
	},
	loadData : function(record) {
		this.resetDiscountData();
		Ext.getCmp("allDiscountView").type = '3';
		this.record = record;
		this.type = 3;  // 单品打折计算
		this.remarkAmount = record.get('remarkAmount') ? record.get('remarkAmount') : 0;
		this.remarkPrice = record.get('remarkPrice');
		this.sellNum = record.get('sellNum');
		setDiscountViewValue({
			totalAmount : record.get('totalAmount'),
			sellAmount : record.get('sellAmount'),
			discount : getDiscountValueRange(record.get('discount')), //record.get('discount') ? record.get('discount') : 100,
			remarkAmount : this.remarkAmount,
			notDiscountAmount : 0
		});
		setTimeout(this.loadDiscount(), 100);
	},
	loadDiscount : function() {
		//加载折扣
		SellerDao.loadDiscount(function(success, res) {
			if (!success) {
				return;
			}
			var discountStore = Ext.getStore('discount-store');
			if (res.length > 0) {
				for (var i = 0; i < res.length; i++) {
					if (res[i].isSupportPwd == "1") {
						res[i].isSupportPwdText = "是";
					} else {
						res[i].isSupportPwdText = "否";
					}
					if (res[i].discount) res[i].discount = parseDigitalDecimal(res[i].discount);
					discountStore.add(res[i]);
				}
			}
		});
	},
	initialize : function(panel, eOpts) {
		var me = this;
	}
});

function skDiscountKeyInputValue(cmp, inputField) {
	var cmpText = cmp.getText();
	var oldValue = Ext.getCmp(inputField).getValue();
	oldValue = oldValue == null ? '' : String(oldValue);
	if (oldValue && isInteger(cmpText)) {
		var v = oldValue.split('.');
		var absInt = Math.abs(parseInt(v[0])) + '';
		if (v.length == 1 && absInt.length >= 7) {
			showToast('整数位最大只支持 7 位！');
			return;
		}else if (v.length == 1 && absInt.length >= 6) { // 6位数后加上'00'会变成8位数*
			if (cmpText == '00') {
				showToast('整数位最大只支持 7 位！');
				return;
			}
		} else if (v.length > 1 && v[1].length >= 2) {
			showToast('小数位最大只支持 2 位！');
			return;
		}else if (v.length > 1 && v[1].length >= 1) { // 有一位小数后加上'00'会变成3个小数位*
			if (cmpText == '00') {
				showToast('小数位最大只支持 2 位！');
				return;
			}
		}
	}
	if(!cmpText || cmpText == 'null') {  // 退格键
		if(oldValue.length > 0) {
			oldValue = oldValue.slice(0, -1);
		}
	} else if(cmpText=='清空') {
		oldValue = '';
	} else if(cmpText == '删除') {
		oldValue = '';
	} else if(cmpText == '退格') {
		if(oldValue.length > 0) {
			oldValue = oldValue.slice(0, -1);
		}
	} else if(cmpText == '.'){
		if(oldValue.indexOf(".") != -1) {
			showToast('已经是小数了!');
			return;
		} else if(oldValue == '-') { // 只有负号而没有数字
			return;
		} else {
			oldValue += cmpText;
		}
	} else if(cmpText == '-') {
		if(oldValue.length > 0) return;
		else if(oldValue.indexOf('-') > -1) return;
		oldValue += cmpText;
	} else {
		oldValue += cmpText;
	}
	Ext.getCmp(inputField).setValue(oldValue);
	Ext.getCmp(inputField).focus();
}

function skDiscountConfirmHandler(inputField, type){
	var number = Ext.getCmp(inputField).getValue();
	if(checkPositiveNumber(number)){
		if(type == '0'){//金额折扣
            var totalAmount = Ext.getCmp('all-discount-before').getValue();  // 折前应收
            var notDiscountAmount = Ext.getCmp('all-not-discount-amount').getValue();  // 不可打折金额
            if(parseFloat(number) > totalAmount){
                showAlert('提示', '请输入小于折前应收金额的数值！');
                return;
            }
			if(parseFloat(notDiscountAmount) > 0){//有不可打折金额
                var discountAmount = totalAmount - notDiscountAmount;
                if(parseFloat(number) < notDiscountAmount){
                    showAlert('提示', '请输入大于不可打折金额的数值！');
                    return;
                }
                number = (number - notDiscountAmount)/discountAmount * 100;
			}else{//没有不可打折金额
                number = number/totalAmount * 100;
			}
		}else if(type == '1'){//比率折扣
			//输入折扣，判断小于100
			if(parseFloat(number) > 100){
				showAlert('提示', '请输入小于100的数值！');
				return;
			}
		}
		//执行打折操作
        changeDiscount(number);
        dealDiscountEnd();
	}else{
		showAlert('提示', '请输入正确的数值！');
	}
}