/**
 *@Author: Xiongzp
 *@Date: 2018/7/19
 */
Ext.define('Seller.view.print.ReprintTaskListView', {
    extend: 'Ext.Container',
    alias : 'widget.reprintTaskListView',
    currentView:null,
    config: {
        id : 'reprintTaskListView',
        width: 980,
        height: 590,
        layout: {
            type: 'vbox',
            align: 'stretch'
        },
        items: [
            {
                xtype: 'toolbar',
                title: '重印小票',
                docked: 'top',
                height: 40,
                items: [
                    {
                        xtype: 'ebutton',
                        text: '返回',
                        cls: 'close-button-complete',
                        width: 80,
                        iconCls : 'close-icon',
                        icon : 'resources/icon/public/back.png',
                        id: 'reprint-tasklist-back',
                        handler: function(){
                            Ext.getCmp('reprintTaskListViewWin').destroy();
                        }
                    }
                ]
            },{
                xtype: 'container',
                height: 44,
                style: 'border-bottom: 1px solid rgb(200, 200, 200);',
                layout: {
                    type: 'vbox',
                    align: 'stretch'
                },
                items: [
                    {
                        xtype: 'spacer',
                        flex: 1
                    },
                    {
                        xtype: 'container',
                        layout: 'hbox',
                        id : 'recharge-search-bar',
                        cls:'reprintTaskList-search-bar search-hide',
                        width: '100%',
                        height: 40,
                        style: 'margin:5px 0 0 0;',
                        items:[
                            {
                                xtype: 'container',
                                width: 130,
                                style: 'height: 40px;line-height: 34px;color: rgba(0, 0, 0, 0.5);margin-left:30px;',
                                html: '<div>充值单查询日期：</div>'
                            },{
                                xtype: 'container',
                                layout: 'hbox',
                                defaults: {
                                    height: 34,
                                    width: 76,
                                    style: 'margin-left:20px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background:rgba(248,248,248,1)',
                                    handler: function(event){
                                        var queryDate = event.getData().queryDate,
                                            transDate;
                                        if(queryDate == 'today'){
                                            transDate = new Date().format("yyyy-MM-dd");
                                        }else if(queryDate == 'yesterday'){
                                            var nowTime1 = new Date().getTime() - 60 * 60 * 24 * 1000;
                                            transDate = new Date(nowTime1).format("yyyy-MM-dd");
                                        }else if(queryDate == 'beforeyesterday'){
                                            var nowTime2 = new Date().getTime() - 60 * 60 * 24 * 1000 * 2;
                                            transDate = new Date(nowTime2).format("yyyy-MM-dd");
                                        }
                                        var me = Ext.getCmp('reprintTaskList-recharge');
                                        if(me.queryCondition == transDate){
                                            if(!$('#'+event.id).hasClass('reprintTaskList-searchbtn-active')){
                                                $('#'+event.id).addClass('reprintTaskList-searchbtn-active');
                                            }
                                        }

                                        $('.recharge-search-btn').removeClass('reprintTaskList-searchbtn-active');
                                        $('#'+event.id).addClass('reprintTaskList-searchbtn-active');

                                        me.queryCondition = transDate;
                                        me.rechargePage.setCurrPage(1);

                                        var param = {
                                            transDate : me.queryCondition,
                                            page: String(me.rechargePage.getCurrPage()),
                                            pageSize:String(me.rechargePage.getLimitCount())
                                        };
                                        showLoading("正在获取充值数据, 请稍后...");
                                        me.request(param).
                                            then(function(result){
                                                closeLoading();
                                                var datalist = JSON.parse(result.datalist);
                                                me.rechargePage.countPage(result.totalCount);
                                                Ext.getCmp('recharge-total-label').setHtml(me.rechargePage.getCurrPage() + "/" + me.rechargePage.getTotalPage());
                                                me.loadRechargeStore(datalist);
                                            },function(){
                                                //请求超时
                                                me.clearRechargeStore();
                                                showAlert("提示", "获取充值数据失败，请检查网络状态或重新获取");
                                                closeLoading();
                                            }).catch(function(error){
                                                closeLoading();
                                                console.log('充值流水获取失败',error);
                                            });
                                    }
                                },
                                items: [
                                    {
                                        xtype: 'ebutton',
                                        text: '今&nbsp;&nbsp;天',
                                        cls: 'recharge-search-btn',
                                        id:'recharge-search-today',
                                        data: {
                                            queryDate: 'today'
                                        }
                                    },
                                    {
                                        xtype: 'ebutton',
                                        text: '昨&nbsp;&nbsp;天',
                                        cls: 'recharge-search-btn',
                                        id:'recharge-search-yesterday',
                                        data: {
                                            queryDate: 'yesterday'
                                        }
                                    },
                                    {
                                        xtype: 'ebutton',
                                        text: '前&nbsp;&nbsp;天',
                                        id:'recharge-search-beforeyesterday',
                                        cls: 'recharge-search-btn',
                                        data: {
                                            queryDate: 'beforeyesterday'
                                        }
                                    }
                                ]
                            },{
                              xtype: 'spacer',
                                flex: 1
                            },
                            {
                                xtype: 'ebutton',
                                id:'recharge-reprint-btn',
                                height: 34,
                                width: 76,
                                text: '打&nbsp;&nbsp;印',
                                style: 'margin-right:32px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                handler: function(){
                                    var rechargeList = Ext.getCmp('reprintTaskList-recharge-list');
                                    if(rechargeList.getSelection().length <= 0){
                                        return;
                                    }
                                    timeoutDisable('recharge-reprint-btn');
                                    var selectRecord = rechargeList.getSelection()[0];
                                    var payType      = selectRecord.get('payType');
                                    var amount       = selectRecord.get('amount');
                                    var mobile       = selectRecord.get('mobile');
                                    var customerName = selectRecord.get('customerName');
                                    var transId      = selectRecord.get('transId');
                                    var balance      = selectRecord.get('balance');
                                    var sendAmount   = selectRecord.get('sendAmount');//赠送金额
                                    var transDate   = selectRecord.get('transDate');//赠送金额
                                    // 字段含义        : 1.transId：流水号，2.amount：充值金额，3.balance：充值后金额,4.preBalance：充值前金额
                                    Ext.getCmp('reprintTaskList-recharge').reprint(payType, amount, sendAmount, mobile, customerName,transId, balance, transDate);
                                }
                            }
                        ]
                    },
                    {
                        xtype: 'container',
                        layout: 'hbox',
                        id : 'handover-search-bar',
                        cls:'reprintTaskList-search-bar',
                        width: '100%',
                        height: 40,
                        style: 'margin:5px 0 0 0;',
                        items:[
                            {
                                xtype: 'spacer',
                                width: 15
                            },
                            {
                                xtype: 'container',
                                layout: 'hbox',
                                height: 40,
                                items:[
                                    {
                                        width: 200,
                                        height: 36,
                                        xtype : 'container',
                                        style: 'border: 1px solid rgb(200, 200, 200);border-radius: 6px;',
                                        html : '<input id="handover-id-input"  type="text" placeHolder="查询交接班号"  style="height:34px;width:100%;padding-left:10px;border:none;border-radius:5px;background: rgb(248, 248, 248);"/>'
                                    },
                                    {
                                        xtype: 'ebutton',
                                        id: 'query-handover-id',
                                        height: 34,
                                        width: 76,
                                        text:  '查&nbsp;&nbsp;询',
                                        style: 'margin-left:10px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                        handler: function(){
                                           var handoverId = $.trim($('#handover-id-input').val());
                                            var me = Ext.getCmp('reprintTaskList-handover');
                                            if(!handoverId){
                                                return;
                                            }
                                            me.queryCondition = {
                                                id: handoverId,
                                                date : null
                                            };
                                            me.handoverPage.setCurrPage(1);
                                            //加载总分页数
                                            me.getHandoverTotalPage(me.queryCondition, me.queryDeviceId).
                                                then(function (totalCount) {
                                                    me.handoverPage.countPage(totalCount);
                                                    Ext.getCmp('handover-total-label').setHtml(me.handoverPage.getCurrPage() + "/" + me.handoverPage.getTotalPage());
                                                    return me.loadHandoverPagination(me.queryCondition, me.queryDeviceId, me.handoverPage.getLimitCount(), me.handoverPage.getOffset());
                                                }).
                                                then(function (data) {
                                                    me.loadHandoverStore(data);
                                                }).
                                                catch(function (error) {
                                                    console.log('交接班数据加载出错', error);
                                                });
                                        }
                                    }
                                ]
                            },
                            {
                              xtype: 'spacer',
                              width: 40
                            },
                            {
                                xtype: 'container',
                                layout: 'hbox',
                                items: [
                                    {
                                        xtype : 'container',
                                        layout : 'hbox',
                                        defaults : {
                                            labelWidth : 90
                                        },
                                        items : [
                                            {
                                                width: 100,
                                                height: 36,
                                                xtype : 'container',
                                                style: 'border: 1px solid rgb(200, 200, 200);border-radius: 6px;',
                                                html : '<input id="handover-start-time" type="text" placeHolder="开始日期" onclick="WdatePicker({startDate:new Date().format(\'yyyy-MM-dd\'), dateFmt:\'yyyy-MM-dd\'})" value="" style="height:34px;width:100%;border:none;text-align:center;border-radius:5px;background: rgb(248, 248, 248);"/>'
                                            }]
                                    }, {
                                        xtype : 'container',
                                        layout : 'hbox',
                                        defaults : {
                                            labelWidth : 90
                                        },
                                        items : [{
                                            xtype : 'container',
                                            html : '<div style="background:transparent;height:44px;line-height:36px;overflow: hidden;text-align:center;">至</div>',
                                            labelWidth : 40,
                                            width : 40
                                        }, {
                                            width: 100,
                                            height: 36,
                                            xtype : 'container',
                                            style: 'border: 1px solid rgb(200, 200, 200);border-radius: 6px;',
                                            html : '<input id="handover-end-time" type="text" placeHolder="结束日期" onclick="WdatePicker({startDate:new Date().format(\'yyyy-MM-dd\'), dateFmt:\'yyyy-MM-dd\'})" value="" style="height:34px;width:100%;border:none;text-align:center;border-radius:5px;background: rgb(248, 248, 248);"/>'
                                        }]
                                    },{
                                        xtype : 'ebutton',
                                        text : '查询日期',
                                        id : 'query-handover-datetime',
                                        width : 86,
                                        height : 34,
                                        style: 'margin-left:10px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                        handler : function() {
                                            var startTime = $.trim($('#handover-start-time').val());
                                            var endTime = $.trim($('#handover-end-time').val());

                                            if(!startTime) {
                                                showAlert('提示', '请输入开始日期!');
                                                return;
                                            } else if(!endTime) {
                                                showAlert('提示', '请输入结束日期!');
                                                return;
                                            } else if(startTime > endTime) {
                                                showAlert('提示', '开始日期大于结束日期!');
                                                return;
                                            }

                                            $('#handover-id-input').val('');

                                            var me = Ext.getCmp('reprintTaskList-handover');
                                            me.queryCondition = {
                                                id: null,
                                                date : [startTime, endTime]
                                            };

                                            me.handoverPage.setCurrPage(1);
                                            //加载总分页数
                                            me.getHandoverTotalPage(me.queryCondition, me.queryDeviceId).
                                                then(function (totalCount) {
                                                    me.handoverPage.countPage(totalCount);
                                                    Ext.getCmp('handover-total-label').setHtml(me.handoverPage.getCurrPage() + "/" + me.handoverPage.getTotalPage());
                                                    return me.loadHandoverPagination(me.queryCondition, me.queryDeviceId, me.handoverPage.getLimitCount(), me.handoverPage.getOffset());
                                                }).
                                                then(function (data) {
                                                    me.loadHandoverStore(data);
                                                }).
                                                catch(function (error) {
                                                    console.log('交接班数据加载出错', error);
                                                });
                                        }
                                    }
                                ]
                            }, {
                                xtype: 'checkboxfield',
                                id: 'reprint-handover-custom-payment',
                                cls: 'handover-checkboxfield',
                                labelAlign: 'right',
                                label: '打印自定义支付明细',
                                labelWidth: 165,
                                width: 200,
                                checked: false,
                                style: 'margin:-3px 0 0 10px;'
                            }, {
                                xtype: 'ebutton',
                                id: 'handover-reprint-btn',
                                height: 34,
                                width: 76,
                                text: '打&nbsp;&nbsp;印',
                                style: 'margin-left:10px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                handler: function(){
                                    var handoverList = Ext.getCmp('reprintTaskList-handover-list');
                                    if(handoverList.getSelection().length <= 0){
                                        return;
                                    }
                                    timeoutDisable('handover-reprint-btn');
                                    var selectRecord  = handoverList.getSelection()[0];
                                    var handoverId    = selectRecord.get('id');
                                    var sellerId      = selectRecord.get('sellerId');
                                    var isPrintDetail = true;
                                    PrintDao.reprintHandover(handoverId, sellerId, isPrintDetail);
                                }
                            }
                        ]
                    },
                    {
                        xtype: 'container',
                        layout: 'hbox',
                        id: 'sellinfo-search-bar',
                        cls: 'reprintTaskList-search-bar search-hide',
                        width: '100%',
                        height: 40,
                        style: 'margin:5px 0 0 0;',
                        items: [
                            {
                                xtype: 'container',
                                width: 130,
                                style: 'height: 40px;line-height: 34px;color: rgba(0, 0, 0, 0.5);margin-left:30px;',
                                html: '<div>订单查询日期：</div>'
                            },{
                                xtype: 'container',
                                layout: 'hbox',
                                defaults: {
                                    height: 34,
                                    width: 76,
                                    style: 'margin-left:20px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                    handler: function(event){
                                        var queryDate = event.getData().queryDate,
                                            sellinfoDate;
                                        if(queryDate == 'today'){
                                            sellinfoDate = new Date().format("yyyy-MM-dd");
                                        }else if(queryDate == 'yesterday'){
                                            var nowTime1 = new Date().getTime() - 60 * 60 * 24 * 1000;
                                            sellinfoDate = new Date(nowTime1).format("yyyy-MM-dd");
                                        }

                                        var me = Ext.getCmp('reprintTaskList-sellinfo');
                                        if(me.queryCondition == sellinfoDate){
                                            if(!$('#'+event.id).hasClass('reprintTaskList-searchbtn-active')){
                                                $('#'+event.id).addClass('reprintTaskList-searchbtn-active');
                                            }
                                            return;
                                        }

                                        $('.sellinfo-search-btn').removeClass('reprintTaskList-searchbtn-active');
                                        $('#'+event.id).addClass('reprintTaskList-searchbtn-active');

                                        me.queryCondition = sellinfoDate;
                                        me.sellinfoPage.setCurrPage(1);
                                        me.getSellTotalCountByDate(me.queryCondition, me.queryDeviceId).
                                                then(function(result){
                                                me.sellinfoPage.countPage(result.totalCount);
                                                Ext.getCmp('sellinfo-total-label').setHtml(me.sellinfoPage.getCurrPage() + "/" + me.sellinfoPage.getTotalPage());
                                                    return me.loadSellPaginationByDate(me.queryCondition, me.queryDeviceId, me.sellinfoPage.getLimitCount(), me.sellinfoPage.getOffset());
                                                }).
                                                then(function(datas){
                                                     me.loadSellinfoStore(datas);
                                                }).
                                                catch(function(error){
                                                    console.log('销售单查询出错', error);
                                                });
                                    }
                                },
                                items: [
                                    {
                                        xtype: 'ebutton',
                                        text: '今&nbsp;&nbsp;天',
                                        cls: 'sellinfo-search-btn',
                                        id:'sellinfo-search-today',
                                        data: {
                                            queryDate: 'today'
                                        }
                                    },
                                    {
                                        xtype: 'ebutton',
                                        text: '昨&nbsp;&nbsp;天',
                                        cls: 'sellinfo-search-btn',
                                        id:'sellinfo-search-yesterday',
                                        data: {
                                            queryDate: 'yesterday'
                                        }
                                    }
                                ]
                            },{
                                xtype: 'spacer',
                                width: 50
                            },
                            {
                                xtype: 'container',
                                layout: 'hbox',
                                id: 'sellinfo-search-type-panel',
                                defaults: {
                                    height: 34,
                                    width: 86,
                                    style: 'margin-left:20px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                    handler: function(event){
                                        var me = Ext.getCmp('reprintTaskList-sellinfo');
                                        var deviceId = (event.getData().deviceId == "host") ? seller.deviceId : '';
                                        if(me.queryDeviceId == deviceId){
                                            if(!$('#'+event.id).hasClass('reprintTaskList-searchbtn-active')){
                                                $('#'+event.id).addClass('reprintTaskList-searchbtn-active');
                                            }
                                            return;
                                        }

                                        me.queryDeviceId = deviceId;
                                        $('.sellinfo-search-type-btn').removeClass('reprintTaskList-searchbtn-active');
                                        $('#'+event.id).addClass('reprintTaskList-searchbtn-active');

                                        me.sellinfoPage.setCurrPage(1);
                                        me.getSellTotalCountByDate(me.queryCondition, me.queryDeviceId).
                                        then(function(result){
                                            me.sellinfoPage.countPage(result.totalCount);
                                            Ext.getCmp('sellinfo-total-label').setHtml(me.sellinfoPage.getCurrPage() + "/" + me.sellinfoPage.getTotalPage());
                                            return me.loadSellPaginationByDate(me.queryCondition, me.queryDeviceId, me.sellinfoPage.getLimitCount(), me.sellinfoPage.getOffset());
                                        }).
                                        then(function(datas){
                                            me.loadSellinfoStore(datas);
                                        }).
                                        catch(function(error){
                                            console.log('销售单查询出错', error);
                                        });
                                    }
                                },
                                items: [
                                    {
                                        xtype: 'ebutton',
                                        text: '查询本机',
                                        cls: 'sellinfo-search-type-btn',
                                        id:'sellinfo-search-host',
                                        data: {
                                            deviceId: 'host'
                                        }
                                    },
                                    {
                                        xtype: 'ebutton',
                                        text: '查询全部',
                                        cls: 'sellinfo-search-type-btn',
                                        id:'sellinfo-search-all',
                                        data: {
                                            deviceId: ''
                                        }
                                    }
                                ]
                            },{
                                xtype: 'spacer',
                                flex: 1
                            },
                            {
                                xtype: 'ebutton',
                                id:'sellinfo-reprint-btn',
                                height: 34,
                                width: 76,
                                text: '打&nbsp;&nbsp;印',
                                style: 'margin-right:32px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                handler: function(){
                                    var sellinfoList = Ext.getCmp('reprintTaskList-sellinfo-list');
                                    if(sellinfoList.getSelection().length <= 0){
                                        return;
                                    }
                                    timeoutDisable('sellinfo-reprint-btn');
                                    var selectRecord = sellinfoList.getSelection()[0];
                                    var sellId = selectRecord.get('id');
                                    var selectCustomerInfo = null;
                                    var callBack = null;
                                    var isReprint = true;
                                    PrintDao.printById(8, sellId, selectCustomerInfo, callBack,isReprint);
                                }
                            }
                        ]
                    },
                    {
                        xtype: 'container',
                        layout: 'hbox',
                        id: 'allsellinfo-search-bar',
                        cls: 'reprintTaskList-search-bar search-hide',
                        width: '100%',
                        height: 40,
                        style: 'margin:5px 0 0 0;',
                        items:[
                            {
                                xtype: 'spacer',
                                width: 30
                            },
                            {
                                xtype: 'container',
                                layout: 'hbox',
                                height: 40,
                                items:[
                                    {
                                        width: 200,
                                        height: 36,
                                        xtype : 'container',
                                        style: 'border: 1px solid rgb(200, 200, 200);border-radius: 6px;',
                                        html : '<input id="allsellinfo-id-input"  type="text" placeHolder="请输入订单号查找"  style="height:34px;width:100%;padding-left:10px;border:none;border-radius:5px;background: rgb(248, 248, 248);"/>'
                                    },
                                    {
                                        xtype: 'ebutton',
                                        id: 'query-allsellinfo-id',
                                        height: 34,
                                        width: 76,
                                        text: '查&nbsp;&nbsp;询',
                                        style: 'margin-left:20px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                        handler: function(){
                                            var allsellinfoId = $.trim($('#allsellinfo-id-input').val());
                                            var me = Ext.getCmp('reprintTaskList-allSellinfo');
                                            me.queryCondition = allsellinfoId;
                                            me.allsellinfoPage.setCurrPage(1);
                                            //加载总分页数
                                            me.getSellTotalCount(me.queryCondition, me.queryDeviceId).
                                            then(function(totalCount){
                                                me.allsellinfoPage.countPage(totalCount);
                                                Ext.getCmp('allsellinfo-total-label').setHtml(me.allsellinfoPage.getCurrPage() + "/" + me.allsellinfoPage.getTotalPage());
                                                return me.loadSellPagination(me.queryCondition, me.queryDeviceId, me.allsellinfoPage.getLimitCount(), me.allsellinfoPage.getOffset());
                                            }).
                                            then(function(datas){
                                                me.loadSellinfoStore(datas);
                                            }).
                                            catch(function(error){
                                                console.log('销售单查询出错', error);
                                            });
                                        }
                                    }
                                ]
                            },
                            {
                                xtype: 'spacer',
                                flex: 1
                            },
                            {
                                xtype: 'ebutton',
                                id: 'allsellinfo-reprint-btn',
                                height: 34,
                                width: 76,
                                text: '打&nbsp;&nbsp;印',
                                style: 'margin-right: 32px;border: 1px solid rgb(200, 200, 200);border-radius: 20px;color: rgba(0, 0, 0, 0.5);margin:0 10 0 10;background: rgb(248, 248, 248);',
                                handler: function(){
                                    var allsellinfoList = Ext.getCmp('reprintTaskList-allsellinfo-list');
                                    if(allsellinfoList.getSelection().length <= 0){
                                        return;
                                    }
                                    timeoutDisable('allsellinfo-reprint-btn');
                                    var selectRecord  = allsellinfoList.getSelection()[0];
                                    var sellId    = selectRecord.get('id');
                                    var status    = selectRecord.get('status');
                                    var sellType    = selectRecord.get('sellType');
                                    var isReprint = true;
                                    PrintDao.printSellTicketLogic(sellId, status, sellType, null, isReprint);
                                }
                            }
                        ]
                    },
                    {
                        xtype: 'spacer',
                        flex: 1
                    }
                ]
            },
            {
                xtype: 'container',
                flex: 1,
                layout: 'vbox',
                width: '100%',
                items: [
                    {
                        xtype: 'container',
                        id : 'reprintTaskList-tabpanel',
                        cls:'reprintTaskList-tabpanel',
                        layout: 'hbox',
                        width: '100%',
                        height: 42,
                        defaults: {
                            height: 38,
                            width: 110,
                            handler: function(event){
                                var currentView = Ext.getCmp('reprintTaskListView').currentView;
                                var value = event.getData().value;
                                var tabHeader = event.getData().tabHeader;
                                if(currentView == value){
                                    var $currentBtn = $('#'+event.getId());
                                    if(!$currentBtn.hasClass('tab-active')){
                                        $currentBtn.addClass('tab-active');
                                    }
                                    return;
                                }
                                var id = event.getData().id;
                                var view = Ext.create(value);
                                $('.reprintTaskList-tabpanel-tabItem').removeClass('tab-active');
                                $('#'+event.getId()).addClass('tab-active');

                                $('.reprintTaskList-search-bar').addClass('search-hide');
                                var $tabHeader = $('#'+ tabHeader);
                                $tabHeader.removeClass('search-hide');

                                Ext.getCmp('reprintTaskListView').currentView = value;

                                Ext.getCmp('reprintTaskList-contentpanel').removeAll();
                                Ext.getCmp('reprintTaskList-contentpanel').add(view);
                                Ext.getCmp(id) && Ext.getCmp(id).loadData();

                            }
                        },
                        items:[
                            {
                                xtype: 'ebutton',
                                text: '交接班',
                                id: 'reprintTaskList-handover-btn',
                                cls: 'reprintTaskList-tabpanel-tabItem tab-active tab-button',
                                data: {
                                    value : 'Seller.view.reprintTaskList.handover',
                                    id: 'reprintTaskList-handover',
                                    tabHeader:'handover-search-bar'
                                }
                            },
                            {
                                xtype: 'ebutton',
                                text: '充值单',
                                id: 'reprintTaskList-recharge-btn',
                                cls:'reprintTaskList-tabpanel-tabItem tab-button',
                                data: {
                                    value : 'Seller.view.reprintTaskList.recharge',
                                    id : 'reprintTaskList-recharge',
                                    tabHeader:'recharge-search-bar'
                                }
                            },
                            {
                                xtype: 'ebutton',
                                text: '台单',
                                id: 'reprintTaskList-sellinfo-btn',
                                cls: 'reprintTaskList-tabpanel-tabItem tab-button',
                                data: {
                                    value : 'Seller.view.reprintTaskList.sellinfo',
                                    id : 'reprintTaskList-sellinfo',
                                    tabHeader:'sellinfo-search-bar'
                                }
                            },
                            {
                                xtype: 'ebutton',
                                text: '销售单',
                                id: 'reprintTaskList-allsellinfo-btn',
                                cls: 'reprintTaskList-tabpanel-tabItem tab-button',
                                data: {
                                    value : 'Seller.view.reprintTaskList.allSellinfo',
                                    id : 'reprintTaskList-allSellinfo',
                                    tabHeader:'allsellinfo-search-bar'
                                }
                            }
                        ]
                    },
                    {
                        xtype : 'container',
                        id : 'reprintTaskList-contentpanel',
                        width: '100%',
                        flex: 1
                    }
                ]
            }
        ]
    },
    loadData: function(){

        if(!(Application.Ftype == Application.MASTER)){
            Ext.getCmp('sellinfo-search-type-panel').hide();
        }
        // 打印自定义支付明细
        SettingDao.loadSysParamsValid({
            keyword: 'SWPS',
            callback: function(success, res) {
                if (success && res && res.length > 0) {
                    for (var ri = 0, rlen = res.length; ri < rlen; ri++) {
                        var key = res[ri]["paramName"];
                        if (key == 'isPrintCustomPayment')
                            Ext.getCmp('reprint-handover-custom-payment').setData({id: res[ri].id});
                    }
                }
                if (!(showPtSetting.isPrintCustomPayment == 'false' || showPtSetting.isPrintCustomPayment == false)) {
                    Ext.getCmp('reprint-handover-custom-payment').check();
                } else {
                    Ext.getCmp('reprint-handover-custom-payment').uncheck();
                }
            }
        })
        if (Station.type === Station.SINGLE) {
            Ext.getCmp('reprintTaskList-recharge-btn').setHidden(true);
        } else {
            Ext.getCmp('reprintTaskList-recharge-btn').setHidden(false);
        }

        //重印小票默认加载交接班信息
        Ext.getCmp('reprintTaskListView').currentView = "Seller.view.reprintTaskList.handover";
        var handoverView = Ext.create("Seller.view.reprintTaskList.handover");

        Ext.getCmp('reprintTaskList-contentpanel').removeAll();
        Ext.getCmp('reprintTaskList-contentpanel').add(handoverView);

        Ext.getCmp("reprintTaskList-handover") && Ext.getCmp("reprintTaskList-handover").loadData();
    }
});

//台单
Ext.define('Seller.view.reprintTaskList.sellinfo', {
    extend: 'Ext.Container',
    alias: 'widget.reprintSellinfo',
    id: 'reprintTaskList-sellinfo',
    sellinfoPage: new $.PageUtil({
        limitCount: 10
    }),
    queryCondition: '',
    queryDeviceId : '',
    config: {
        xtype: 'container',
        width: '100%',
        layout:'vbox',
        items: [
            {
                xtype:'container',
                layout:'vbox',
                items: [
                    {
                        xtype: 'container',
                        height: 38,
                        width:"100%",
                        html : '<div class="reprintTaskList-sellinfo-header reprintTaskList-header" style="width:100%;background:rgba(211,223,241,0.6);" >' +
                                    '<span class="ceil device-id">收银机编号</span><span class="ceil id">销售单号</span><span class="ceil place-name">台号</span><span class="ceil work-name">交班员工</span>' +
                                    '<span class="ceil total-amount">总金额</span>' +
                                    '<span class="ceil sell-amount">销售总额</span>' +
                                    '<span class="ceil sell-time">开台时间</span>' +
                                '</div>'
                    },
                    {
                        xtype: 'dataview',
                        id: 'reprintTaskList-sellinfo-list',
                        height: 386,
                        scrollable: false,
                        style: 'border-bottom: 1px solid rgb(200, 200, 200);',
                        store: Ext.create('Ext.data.Store', {
                            id: 'reprintTaskList-sellinfo-store',
                            fields: ['id', 'workName', 'totalAmount', 'sellAmount', 'discount', 'alreadyDiscountAmount', 'eraseZeroAmount', 'roundAmount', 'sellTime', 'placeName', 'deviceId'],
                            data: []
                        }),
                        selectedCls : 'reprintTaskList-select',
                        itemCls: 'reprintTaskList-item',
                        emptyText:'<div style="height: 80px;line-height: 80px;text-align: center;font-size: 18px;">未查询到相关记录!</div>',
                        itemTpl: new Ext.XTemplate('<div class="reprintTaskList-list-item reprintTaskList-sellinfo-list-item" style="min-height: 38px;line-height:38px;width:100% !important;font-size:16px !important;" >' +
                                                        '<span class="ceil device-id">{deviceId}</span><span class="ceil id">{id}</span><span class="ceil place-name">{placeName}</span><span class="ceil work-name">{workName}</span>' +
                                                        '<span class="ceil total-amount">{totalAmount}</span>' +
                                                        '<span class="ceil sell-amount">{sellAmount}</span>' +
                                                        '<span class="ceil sell-time">{sellTime}</span>' +
                                                    '</div>')
                    },
                    {
                        xtype : 'panel',
                        layout : 'hbox',
                        hidden : false,
                        id : 'sellinfo-bar',
                        style: 'margin-top:5px',
                        defaults : {
                            height : 40
                        },
                        items : [{
                            xtype : 'container',
                            layout : 'hbox',
                            width : 200,
                            margin:10,
                            defaults : {
                                width : 80,
                                xtype:'ebutton'
                            },
                            items : []
                        }, {
                            xtype : 'spacer'
                        }, {
                            margin : '0 0 0 30',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-sellinfo\').downChangeSellinfoView()">上一页</div>'
                        }, {
                            margin : '0 30',
                            style: 'line-height:32px',
                            xtype : 'label',
                            id : 'sellinfo-total-label',
                            html : '1/1'
                        }, {
                            margin : '0 30 0 0',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-sellinfo\').upChangeSellinfoView()">下一页</div>'
                        }]
                    }
                ]
            }
        ]
    },
    clearSellinfoStore: function(){
        var store = Ext.getStore('reprintTaskList-sellinfo-store');
        store.removeAll();
    },
    loadSellinfoStore: function(data){
        if(!data){
            return;
        }
        var me = this;
        me.clearSellinfoStore();

        var sellinfoList = Ext.getCmp('reprintTaskList-sellinfo-list');
        var sellinfoStore = sellinfoList.getStore();
        var datas = [];
        for(var i = 0, len = data.length; i < len; i++){
            var record = {};
            record.id                    = data[i].id;
            record.workName              = data[i].workName;
            record.totalAmount           = data[i].totalAmount ? parseFloat(data[i].totalAmount).toFixed(2) : '0.00';
            record.sellAmount            = data[i].sellAmount ? parseFloat(data[i].sellAmount).toFixed(2) : '0.00';
            record.alreadyDiscountAmount = data[i].alreadyDiscountAmount ? parseFloat(data[i].alreadyDiscountAmount).toFixed(2) : '0.00';
            record.eraseZeroAmount       = data[i].eraseZeroAmount ? parseFloat(data[i].eraseZeroAmount).toFixed(2) : '0.00';
            record.roundAmount           = data[i].roundAmount ? parseFloat(data[i].roundAmount).toFixed(2) : '0.00';
            record.discount              = data[i].discount ? data[i].discount : '100';
            record.sellTime              = data[i].sellTime;
            record.placeName              = data[i].placeName;
            record.deviceId              = data[i].deviceId;
            datas.push(record);
        }
        sellinfoStore.add(datas);
    },
    getSellTotalCountByDate: function(date, deviceId){
        return new Promise(function(resolve, reject){
            SellDao.getSellTotalCountByDate(date, deviceId, function(success, result){
                if(success && result){
                    resolve(result);
                }
            });
        });
    },
    loadSellPaginationByDate: function(date, deviceId, limit, offset){
        return new Promise(function(resolve, reject){
            SellDao.loadSellPageByDate(date, deviceId, limit, offset, function(success, datas){
                if(success && datas){
                    resolve(datas);
                }
            });
        });
    },
    downChangeSellinfoView: function(){
        var me = this;
        me.sellinfoPage.down();
        me.loadSellPaginationByDate(me.queryCondition, me.queryDeviceId, me.sellinfoPage.getLimitCount(), me.sellinfoPage.getOffset()).
            then(function(datas){
                me.loadSellinfoStore(datas);
                Ext.getCmp('sellinfo-total-label').setHtml(me.sellinfoPage.getCurrPage() + "/" + me.sellinfoPage.getTotalPage());
            }).
            catch(function(error){
                console.log('交接班分页数据查询失败',error)
            });
    },
    upChangeSellinfoView: function(){
        var me = this;
        me.sellinfoPage.up();
        me.loadSellPaginationByDate(me.queryCondition, me.queryDeviceId, me.sellinfoPage.getLimitCount(), me.sellinfoPage.getOffset()).
            then(function(datas){
                me.loadSellinfoStore(datas);
                Ext.getCmp('sellinfo-total-label').setHtml(me.sellinfoPage.getCurrPage() + "/" + me.sellinfoPage.getTotalPage());
            }).
            catch(function(error){
                console.log('交接班分页数据查询失败',error)
            });
    },
    loadData: function(){
        var me = this;

        $('.sellinfo-search-btn').removeClass('reprintTaskList-searchbtn-active');
        $('#sellinfo-search-today').addClass('reprintTaskList-searchbtn-active');

        $('.sellinfo-search-type-btn').removeClass('reprintTaskList-searchbtn-active');
        $('#sellinfo-search-host').addClass('reprintTaskList-searchbtn-active');

        me.queryCondition = new Date().format("yyyy-MM-dd");
        me.queryDeviceId = seller.deviceId;
        me.sellinfoPage.setCurrPage(1);
        me.getSellTotalCountByDate(me.queryCondition, me.queryDeviceId).
            then(function(result){
                me.sellinfoPage.countPage(result.totalCount);
                Ext.getCmp('sellinfo-total-label').setHtml(me.sellinfoPage.getCurrPage() + "/" + me.sellinfoPage.getTotalPage());
                return me.loadSellPaginationByDate(me.queryCondition, me.queryDeviceId, me.sellinfoPage.getLimitCount(), me.sellinfoPage.getOffset());
            }).
            then(function(datas){
                me.loadSellinfoStore(datas);
            }).
            catch(function(error){
                console.log('销售单查询出错', error);
            });
    }
});

//销售单
Ext.define('Seller.view.reprintTaskList.allSellinfo', {
    extend: 'Ext.Container',
    alias: 'widget.reprintallSellinfo',
    id: 'reprintTaskList-allSellinfo',
    allsellinfoPage: new $.PageUtil({
        limitCount: 10
    }),
    queryCondition: '',
    queryDeviceId : '',
    config: {
        xtype: 'container',
        width: '100%',
        layout:'vbox',
        items: [
            {
                xtype:'container',
                layout:'vbox',
                items: [
                    {
                        xtype: 'container',
                        height: 38,
                        width:"100%",
                        html : '<div class="reprintTaskList-allsellinfo-header reprintTaskList-header" style="padding-left: 10px;width:100%;background:rgba(211,223,241,0.6);" >' +
                        '<span class="ceil device-id">收银机编号</span><span class="ceil id">销售单号</span><span class="ceil work-name">交班员工</span>' +
                        '<span class="ceil total-amount">总金额</span><span class="ceil discount">整单折扣</span><span class="ceil already-discountamount">折扣金额</span>' +
                        '<span class="ceil sell-amount">销售总额</span>' +
                        '<span class="ceil sell-time">销售日期</span>' +
                        '</div>'
                    },
                    {
                        xtype: 'dataview',
                        id: 'reprintTaskList-allsellinfo-list',
                        height: 386,
                        scrollable: false,
                        style: 'border-bottom: 1px solid rgb(200, 200, 200);',
                        store: Ext.create('Ext.data.Store', {
                            id: 'reprintTaskList-allsellinfo-store',
                            fields: ['id', 'workName', 'totalAmount', 'sellAmount', 'discount', 'alreadyDiscountAmount', 'eraseZeroAmount', 'roundAmount', 'sellTime', 'status', 'sellType', 'deviceId'],
                            data: []
                        }),
                        selectedCls : 'reprintTaskList-select',
                        itemCls: 'reprintTaskList-item',
                        emptyText:'<div style="height: 80px;line-height: 80px;text-align: center;font-size: 18px;">未查询到相关记录!</div>',
                        itemTpl: new Ext.XTemplate('<div class="reprintTaskList-list-item reprintTaskList-allsellinfo-list-item" style="min-height: 38px;line-height:38px;width:100% !important;padding-left: 10px;font-size:16px !important;" >' +
                            '<span class="ceil device-id">{deviceId}</span><span class="ceil id">{id}</span><span class="ceil work-name">{workName}</span>' +
                            '<span class="ceil total-amount">{totalAmount}</span><span class="ceil discount">{discount}%</span><span class="ceil already-discountamount">{alreadyDiscountAmount}</span>' +
                            '<span class="ceil sell-amount">{sellAmount}</span>' +
                            '<span class="ceil sell-time">{sellTime}</span>' +
                            '</div>')
                    },
                    {
                        xtype : 'panel',
                        layout : 'hbox',
                        hidden : false,
                        id : 'sellinfo-bar',
                        style: 'margin-top:5px',
                        defaults : {
                            height : 40
                        },
                        items : [{
                            xtype : 'container',
                            layout : 'hbox',
                            width : 200,
                            margin:10,
                            defaults : {
                                width : 80,
                                xtype:'ebutton'
                            },
                            items : []
                        }, {
                            xtype : 'spacer'
                        }, {
                            margin : '0 0 0 30',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-allSellinfo\').downChangeSellinfoView()">上一页</div>'
                        }, {
                            margin : '0 30',
                            style: 'line-height:32px',
                            xtype : 'label',
                            id : 'allsellinfo-total-label',
                            html : '1/1'
                        }, {
                            margin : '0 30 0 0',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-allSellinfo\').upChangeSellinfoView()">下一页</div>'
                        }]
                    }
                ]
            }
        ]
    },
    clearSellinfoStore: function(){
        var store = Ext.getStore('reprintTaskList-allsellinfo-store');
        store.removeAll();
    },
    loadSellinfoStore: function(data){
        if(!data){
            return;
        }
        var me = this;
        me.clearSellinfoStore();

        var sellinfoList = Ext.getCmp('reprintTaskList-allsellinfo-list');
        var sellinfoStore = sellinfoList.getStore();
        var datas = [];
        for(var i = 0, len = data.length; i < len; i++){
            var record = {};
            record.id                    = data[i].id;
            record.workName              = data[i].workName;
            record.totalAmount           = data[i].totalAmount ? parseFloat(data[i].totalAmount).toFixed(2) : '0.00';
            record.sellAmount            = data[i].sellAmount ? parseFloat(data[i].sellAmount).toFixed(2) : '0.00';
            record.alreadyDiscountAmount = data[i].alreadyDiscountAmount ? parseFloat(data[i].alreadyDiscountAmount).toFixed(2) : '0.00';
            record.eraseZeroAmount       = data[i].eraseZeroAmount ? parseFloat(data[i].eraseZeroAmount).toFixed(2) : '0.00';
            record.roundAmount           = data[i].roundAmount ? parseFloat(data[i].roundAmount).toFixed(2) : '0.00';
            record.discount              = data[i].discount ? parseFloat(data[i].discount).toFixed(2) : '100';
            record.sellTime              = data[i].sellTime;
            record.status                = data[i].status;
            record.sellType              = data[i].sellType;
            record.deviceId              = data[i].deviceId;
            datas.push(record);
        }
        sellinfoStore.add(datas);
    },
    getSellTotalCount: function(keyword, deviceId){
        return new Promise(function(resolve, reject){
            SellDao.getSellTotalCountNotRevoke(keyword, deviceId, function(success, result){
                if(success){
                    resolve(result);
                }
            });
        });
    },
    loadSellPagination: function(keyword, deviceId, limit, offset){
        return new Promise(function(resolve, reject){
            SellDao.loadSellInfoPageNotRevoke(keyword, deviceId, limit, offset, function(success, datas){
                if(success && datas){
                    resolve(datas);
                }
            });
        });
    },
    downChangeSellinfoView: function(){
        var me = this;
        me.allsellinfoPage.down();
        me.loadSellPagination(me.queryCondition, me.queryDeviceId, me.allsellinfoPage.getLimitCount(), me.allsellinfoPage.getOffset()).
        then(function(datas){
            me.loadSellinfoStore(datas);
            Ext.getCmp('allsellinfo-total-label').setHtml(me.allsellinfoPage.getCurrPage() + "/" + me.allsellinfoPage.getTotalPage());
        }).
        catch(function(error){
            console.log('交接班分页数据查询失败',error)
        });
    },
    upChangeSellinfoView: function(){
        var me = this;
        me.allsellinfoPage.up();
        me.loadSellPagination(me.queryCondition, me.queryDeviceId, me.allsellinfoPage.getLimitCount(), me.allsellinfoPage.getOffset()).
        then(function(datas){
            me.loadSellinfoStore(datas);
            Ext.getCmp('allsellinfo-total-label').setHtml(me.allsellinfoPage.getCurrPage() + "/" + me.allsellinfoPage.getTotalPage());
        }).
        catch(function(error){
            console.log('交接班分页数据查询失败',error)
        });
    },
    loadData: function(){
        var me = this;

        $('.allsellinfo-search-btn').removeClass('reprintTaskList-searchbtn-active');
        $('#allsellinfo-search-today').addClass('reprintTaskList-searchbtn-active');

        me.queryCondition = '';
        me.queryDeviceId = Application.Ftype == Application.MASTER ? null : seller.deviceId;
        me.allsellinfoPage.setCurrPage(1);

        me.getSellTotalCount(me.queryCondition, me.queryDeviceId).
        then(function(totalCount){
            me.allsellinfoPage.countPage(totalCount);
            Ext.getCmp('allsellinfo-total-label').setHtml(me.allsellinfoPage.getCurrPage() + "/" + me.allsellinfoPage.getTotalPage());
            return me.loadSellPagination(me.queryCondition, me.queryDeviceId, me.allsellinfoPage.getLimitCount(), me.allsellinfoPage.getOffset());
        }).
        then(function(datas){
            me.loadSellinfoStore(datas);
        }).
        catch(function(error){
            console.log('销售单查询出错', error);
        });
    }
});

//充值单列表
Ext.define('Seller.view.reprintTaskList.recharge', {
    extend: 'Ext.Container',
    alias: 'widget.reprintRecharge',
    id:'reprintTaskList-recharge',
    rechargePage: new $.PageUtil({
        limitCount: 10
    }),
    queryCondition: '',
    config: {
        xtype: 'container',
        width: '100%',
        layout:'vbox',
        items:[
            {
                xtype: 'container',
                layout: 'vbox',
                items: [
                    {
                        xtype: 'container',
                        height: 38,
                        width:"100%",
                        html : '<div class="reprintTaskList-header" style="width:100%;background:rgba(211,223,241,0.6);" >' +
                                    '<span class="ceil card-number">会员卡号</span><span style="position: relative;left: -16px;" class="ceil name">会员名称</span><span class="ceil serial-number">充值流水号</span>' +
                                     '<span class="ceil paytype">支付方式</span><span class="ceil recharge-amount">充值金额</span><span class="ceil present-amount">充值前金额</span>' +
                                    '<span class="ceil total-amount">总金额</span><span class="ceil recharge-createdate">充值日期</span>' +
                                '</div>'
                    },
                    {
                        xtype: "dataview",
                        id: 'reprintTaskList-recharge-list',
                        height: 386,
                        style: 'border-bottom: 1px solid rgb(200, 200, 200);',
                        scrollable: false,
                        store: Ext.create('Ext.data.Store', {
                            id: 'reprintTaskList-recharge-store',
                            /*
                             *  字段含义        : 1.transId：流水号，2.amount：充值金额，3.balance：充值后金额,4.preBalance：充值前金额5.sendAmount：赠送金额
                             *  payType支付方式 : 1.现金，2储蓄卡，3.银联卡，4.微信支付，5.支付宝支付，6.次卡，7.积分兑换，8.微信在线，9.支付宝在线
                             * */
                            fields: ['cardNum', 'customerName','transId', 'payType', 'amount', 'preBalance', 'balance', 'transDate', 'mobile', 'sendAmount'],
                            data: []
                        }),
                        selectedCls : 'reprintTaskList-select',
                        itemCls: 'reprintTaskList-item',
                        emptyText:'<div style="height: 80px;line-height: 80px;text-align: center;font-size: 18px;">未查询到相关记录!</div>',
                        itemTpl: new Ext.XTemplate('<div class="reprintTaskList-list-item" style="min-height: 38px;line-height:38px;width:100% !important;font-size:16px !important;">' +
                                                         '<span class="ceil card-number" style="white-space: nowrap;">{cardNum}</span><span style="position: relative;left: -16px;" class="ceil name">{customerName}</span><span class="ceil serial-number">{transId}</span>' +
                                                         '<span class="ceil paytype" style="white-space: nowrap;">{payType}</span><span class="ceil recharge-amount">{amount}</span><span class="ceil present-amount">{preBalance}</span>' +
                                                         '<span class="ceil total-amount">{balance}</span><span class="ceil recharge-createdate">{transDate}</span>' +
                                                    '</div>')
                    },
                    {
                        xtype : 'panel',
                        layout : 'hbox',
                        hidden : false,
                        id : 'recharge-bar',
                        style: 'margin-top:5px',
                        defaults : {
                            height : 40
                        },
                        items : [{
                            xtype : 'container',
                            layout : 'hbox',
                            width : 200,
                            margin:10,
                            defaults : {
                                width : 80,
                                xtype:'ebutton'
                            },
                            items : []
                        }, {
                            xtype : 'spacer'
                        }, {
                            margin : '0 0 0 30',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-recharge\').downChangeRechargeView()">上一页</div>'
                        }, {
                            margin : '0 30',
                            style: 'line-height:32px',
                            xtype : 'label',
                            id : 'recharge-total-label',
                            html : '1/1'
                        }, {
                            margin : '0 30 0 0',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-recharge\').upChangeRechargeView()">下一页</div>'
                        }]
                    }
                ]
            }
        ]
    },
    reprint : function(payTypeName, amount, presentAmount, mobile, name, transId, balanceAmount, transDate) {
        PrintDao.printRechargeLogic('3', {
            isReprint: true,
            transId : transId,
            printTime : transDate,
            workId : shouYinEmployee.workId + ' ' + shouYinEmployee.workName,
            payTypeName : payTypeName,
            mobile : mobile,
            name: name,
            amount : parseFloat( amount ? amount : 0).toFixed(2),
            presentAmount : parseFloat( presentAmount ? presentAmount : 0).toFixed(2),
            balanceAmount : balanceAmount ? balanceAmount.toFixed(2) : '0.00'
        });
    },
    clearRechargeStore: function(){
        var store = Ext.getStore('reprintTaskList-recharge-store');
        store.removeAll();
    },
    loadRechargeStore: function(data){
       /*
       *  字段含义        : 1.transId：流水号，2.amount：充值金额，3.balance：充值后金额,4.preBalance：充值前金额,5.sendAmount：赠送金额
       *  payType支付方式 : 1.现金，2储蓄卡，3.银联卡，4.微信支付，5.支付宝支付，6.次卡，7.积分兑换，8.微信在线，9.支付宝在线
       *
       * */
        if(!data){
            return;
        }
        var me = this;
        me.clearRechargeStore();

        var rechargeView = Ext.getCmp('reprintTaskList-recharge-list');
        var rechargeStore = rechargeView.getStore();
        var datas = [];
        for(var i = 0, len = data.length; i < len; i++){
            var record = {};
            record.transId      = data[i].transId;
            record.customerName = data[i].customerName;
            record.cardNum      = data[i].cardNum;
            record.payType      = getChargePayTypeName(data[i].payType);
            record.amount       = data[i].amount;
            record.preBalance   = data[i].preBalance;
            record.balance      = data[i].balance;
            record.transDate    = data[i].transDate;
            record.mobile       = data[i].mobile;
            record.sendAmount   = data[i].sendAmount;
            datas.push(record);
        }
        rechargeStore.add(datas);
    },
    /*
    * 充值流水请求,分页查询
    *@param {Object} limit,offset
    * @param {Object} callback(result || error)
    * */
    request: function(param){
        var REQUEST_OK = '0000';
        return new Promise(function(resolve, reject){
            nativePostRequest(webHostDownInterface + '/wpSellerPreamountTrans/pagingQueryTrans',param,function(result){
                if(result && result.retcode == REQUEST_OK ){
                    var result1 = result;
                    resolve(result1);
                }
            });
            setTimeout(function(){
                //请求超时回调
                reject();
            }, 8000)
        });
    },
    downChangeRechargeView : function(){
        var me = this;
        if(!me.queryCondition){
            return;
        }
        me.rechargePage.down();

        var param = {
            transDate : me.queryCondition,
            page: String(me.rechargePage.getCurrPage()),
            pageSize:String(me.rechargePage.getLimitCount())
        };
        showLoading("正在获取充值数据, 请稍后...");
        me.request(param).
            then(function(result){
                closeLoading();
                var datalist = JSON.parse(result.datalist);
                me.rechargePage.countPage(result.totalCount);
                Ext.getCmp('recharge-total-label').setHtml(me.rechargePage.getCurrPage() + "/" + me.rechargePage.getTotalPage());
                me.loadRechargeStore(datalist);
            }, function(){
                showAlert("提示", "获取充值数据失败，请检查网络状态或重新获取");
                closeLoading();
            }).catch(function(error){
                closeLoading();
                console.log('充值流水获取失败',error);
            });
    },
    upChangeRechargeView : function(){
        var me = this;
        if(!me.queryCondition){
            return;
        }
        me.rechargePage.up();

        var param = {
            transDate : me.queryCondition,
            page: String(me.rechargePage.getCurrPage()),
            pageSize:String(me.rechargePage.getLimitCount())
        };
        showLoading("正在获取充值数据, 请稍后...");
        me.request(param).
            then(function(result){
                closeLoading();
                var datalist = JSON.parse(result.datalist);
                me.rechargePage.countPage(result.totalCount);
                Ext.getCmp('recharge-total-label').setHtml(me.rechargePage.getCurrPage() + "/" + me.rechargePage.getTotalPage());
                me.loadRechargeStore(datalist);
            },function(){
                showAlert("提示", "获取充值数据失败，请检查网络状态或重新获取");
                closeLoading();
            }).catch(function(error){
                closeLoading();
                console.log('充值流水获取失败',error);
            });
    },
    loadData: function(){
        var me = this;
        me.clearRechargeStore();
        $('.recharge-search-btn').removeClass('reprintTaskList-searchbtn-active');
        $('#recharge-search-today').addClass('reprintTaskList-searchbtn-active');

        me.queryCondition = new Date().format("yyyy-MM-dd");

        var param = {
            transDate : me.queryCondition,
            page: String(me.rechargePage.getCurrPage()),
            pageSize:String(me.rechargePage.getLimitCount())
        };

        showLoading("正在获取充值数据, 请稍后...");
        me.request(param).
        then(function(result){
            closeLoading();
            var datalist = JSON.parse(result.datalist);
            me.rechargePage.countPage(result.totalCount);
            Ext.getCmp('recharge-total-label').setHtml(me.rechargePage.getCurrPage() + "/" + me.rechargePage.getTotalPage());
            me.loadRechargeStore(datalist);
        }, function(){
            showAlert("提示", "获取充值数据失败，请检查网络状态或重新获取");
            closeLoading();
        }).catch(function(error){
            closeLoading();
            console.log('充值流水获取失败',error);
        });
    }
});

// 交接班列表
Ext.define('Seller.view.reprintTaskList.handover', {
    extend: 'Ext.Container',
    alias:'widget.reprintHandover',
    id: 'reprintTaskList-handover',
    queryCondition: {},
    queryDeviceId: '',
    handoverPage: new $.PageUtil({
        limitCount: 10
    }),
    config: {
        xtype: 'container',
        width: '100%',
        layout:'vbox',
        items:[
            {
                xtype: 'container',
                layout: 'vbox',
                items: [
                    {
                        xtype: 'container',
                        height: 38,
                        width:"100%",
                        html : '<div class="reprintTaskList-handover-header reprintTaskList-header" style="width:100%;background:rgba(211,223,241,0.6);" >' +
                                    '<span class="ceil device-id">收银机编号</span><span class="ceil id">交班编号</span><span class="ceil work-name">交班员工</span>' +
                                    '<span class="ceil total-amount">净商品销售额</span><span class="ceil sell-amount">实收总额</span><span class="ceil present-amount">优惠总额</span>' +
                                    '<span class="ceil petty-cash">备用金额</span>' +
                                    '<span class="ceil endtime">交班日期</span>' +
                               '</div>'
                    },
                    {
                        xtype: "dataview",
                        id: 'reprintTaskList-handover-list',
                        height: 386,
                        scrollable: false,
                        style: 'border-bottom: 1px solid rgb(200, 200, 200);',
                        store: Ext.create('Ext.data.Store', {
                            id: 'reprintTaskList-handover-store',
                            fields: ['id', 'workName','totalAmount', 'sellAmount', 'presentAmount', 'returnCashAmount', 'inputAmount', 'pettyCash', 'endTime', 'deviceId', 'sellerId'],
                            data: []
                        }),
                        selectedCls : 'reprintTaskList-select',
                        itemCls: 'reprintTaskList-item',
                        emptyText:'<div style="height: 80px;line-height: 80px;text-align: center;font-size: 18px;">未查询到相关记录!</div>',
                        itemTpl: new Ext.XTemplate('<div class="reprintTaskList-list-item reprintTaskList-handover-list-item" style="min-height: 38px;line-height:38px;width:100% !important;font-size:16px !important;">' +
                                                        '<span class="ceil device-id">{deviceId}</span><span class="ceil id">{id}</span><span class="ceil work-name">{workName}</span>' +
                                                        '<span class="ceil total-amount">{totalAmount}</span><span class="ceil sell-amount">{sellAmount}</span><span class="ceil present-amount">{presentAmount}</span>' +
                                                        '<span class="ceil petty-cash">{pettyCash}</span>' +
                                                        '<span class="ceil endtime">{endTime}</span>'  +
                                                    '</div>')
                    },
                    {
                        xtype : 'panel',
                        layout : 'hbox',
                        hidden : false,
                        id : 'handover-bar',
                        style: 'margin-top:5px',
                        defaults : {
                            height : 40
                        },
                        items : [{
                            xtype : 'container',
                            layout : 'hbox',
                            width : 200,
                            margin:10,
                            defaults : {
                                width : 80,
                                xtype:'ebutton'
                            },
                            items : []
                        }, {
                            xtype : 'spacer'
                        }, {
                            margin : '0 0 0 30',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-handover\').downChangeHandoverView()">上一页</div>'
                        }, {
                            margin : '0 30',
                            style: 'line-height:32px',
                            xtype : 'label',
                            id : 'handover-total-label',
                            html : '1/1'
                        }, {
                            margin : '0 30 0 0',
                            html : '<div style="width:80px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'reprintTaskList-handover\').upChangeHandoverView()">下一页</div>'
                        }]
                    }
                ]
            }
        ]
    },
    downChangeHandoverView : function(){
        var me = this;
        me.handoverPage.down();
        me.loadHandoverPagination(me.queryCondition, me.queryDeviceId, me.handoverPage.getLimitCount(), me.handoverPage.getOffset()).
            then(function(datas){
                me.loadHandoverStore(datas);
                Ext.getCmp('handover-total-label').setHtml(me.handoverPage.getCurrPage() + "/" + me.handoverPage.getTotalPage());
            }).
            catch(function(error){
                console.log('交接班分页数据查询失败',error);
            });
    },
    upChangeHandoverView : function(){
        var me = this;
        me.handoverPage.up();
        me.loadHandoverPagination(me.queryCondition, me.queryDeviceId, me.handoverPage.getLimitCount(), me.handoverPage.getOffset()).
            then(function(datas){
                me.loadHandoverStore(datas);
                Ext.getCmp('handover-total-label').setHtml(me.handoverPage.getCurrPage() + "/" + me.handoverPage.getTotalPage());
            }).
            catch(function(error){
                console.log('交接班分页数据查询失败',error)
            });
    },
    loadHandover : function(){
        return new Promise(function(resolve, reject){
            HandoverDao.loadHandover(function(success, datas){
                if(success){
                    resolve(datas);
                }
            });
        });
    },
    loadHandoverPagination : function(queryCondition, queryDeviceId, limit, offset){
        return new Promise(function(resovle, reject){
            HandoverDao.getHandoverPage(queryCondition, queryDeviceId, limit, offset, function(success, datas){
                if(success && datas.length >= 0){
                    resovle(datas);
                }
            });
        });
    },
    getHandoverTotalPage: function(queryCondition, queryDeviceId){
        return new Promise(function(resolve, reject){
            HandoverDao.getHandoverTotalCount(queryCondition, queryDeviceId, function(success, data){
                if(success && data){
                    resolve(data[0].result);
                }
            });
        });
    },
    loadHandoverStore: function(data){
        if(!data){
            return;
        }
        var me = this;
        me.clearHandoverStore();

        var handoverView = Ext.getCmp('reprintTaskList-handover-list');
        var handoverStore = handoverView.getStore();
        var datas = [];
        for(var i = 0, len = data.length; i < len; i++){
            var record = {};
            record.id               = data[i].id;
            record.workName         = data[i].workName;
            record.totalAmount      = data[i].totalAmount ? parseFloat(data[i].totalAmount).toFixed(2) : '0.00';
            record.sellAmount       = data[i].sellAmount ? parseFloat(data[i].sellAmount).toFixed(2) : '0.00';
            record.presentAmount    = data[i].presentAmount ? parseFloat(data[i].presentAmount).toFixed(2) : '0.00';
            record.returnCashAmount = data[i].returnCashAmount ? parseFloat(data[i].returnCashAmount).toFixed(2) : '0.00';
            record.inputAmount      = data[i].inputAmount ? parseFloat(data[i].inputAmount).toFixed(2) : '0.00';
            record.pettyCash        = data[i].pettyCash ? parseFloat(data[i].pettyCash).toFixed(2) : '0.00';
            record.endTime          = data[i].endTime;
            record.deviceId         = data[i].deviceId;
            record.sellerId         = data[i].sellerId;
            datas.push(record);
        }
        handoverStore.add(datas);
    },
    clearHandoverStore: function(){
        var store = Ext.getStore('reprintTaskList-handover-store');
        store.removeAll();
    },
    loadData: function() {
        var me = this;

        $('#handover-id-input').val('');

        me.handoverPage.setCurrPage(1);
        //初始化设置交接班默认查询当天信息
        var now = new Date().format('yyyy-MM-dd');
        $('#handover-start-time').val(now);
        $('#handover-end-time').val(now);
        me.queryCondition = {
            id: null,
            date : [now, now]
        };
        me.queryDeviceId = Application.Ftype == Application.MASTER ? null : seller.deviceId;
        //加载总分页数
        me.getHandoverTotalPage(me.queryCondition, me.queryDeviceId).
            then(function (totalCount) {
                me.handoverPage.countPage(totalCount);
                Ext.getCmp('handover-total-label').setHtml(me.handoverPage.getCurrPage() + "/" + me.handoverPage.getTotalPage());
                return me.loadHandoverPagination(me.queryCondition, me.queryDeviceId, me.handoverPage.getLimitCount(), me.handoverPage.getOffset());
            }).
            then(function (data) {
                me.loadHandoverStore(data);
            }).
            catch(function (error) {
                console.log('交接班数据加载出错', error);
            });
    }
});
