/**
 *@Author: Xiongzp
 *@CreateTime: 2019-01-08
 **/
Ext.define('Seller.view.regist.RegisterCode', {
    extend: 'Ext.Container',
    alias: 'widget.registerCode',
    config: {
        id: 'register-code-view',
        centered : true,
        modal : true,
        width : 550,
        height : 420,
        items: [
            {
                xtype: 'toolbar',
                docked : 'top',
                title: '产品注册',
                items: [
                    /*{
                        xtype : 'button',
                        cls : 'close-button',
                        handler : function() {
                            if(Ext.getCmp('register-code-view')) {
                                Ext.getCmp('register-code-view').destroy();
                            }
                        }
                    }*/
                ]
            },
            {
                xtype: 'container',
                style: 'background: #f5f5f5;padding: 20px 20px; 10px',
                layout: {
                  type: 'vbox',
                  align: 'center',
                  pack: 'center'
                },
                items: [
                    {
                        xtype: 'container',
                        margin: '0 0 20 0',
                        html: '<div style="text-indent: 2em;">' +
                                     '<p id="remainUseTime" style="color: #f00;margin-bottom: 10px;"></p>' +
                                    '<p>欢迎使用本系统，本软件采用注册码加密方式，需要在使用前进行产品注册，这样才能使用软件的全部功能，并可得到我司提供的技术支持服务。</p>' +
                             '</div>'
                    },
                    {
                        xtype: 'fieldset',
                        margin: '10px',
                        width: '100%',
                        title: '注册信息',
                        items: [
                            {
                                xtype: 'textfield',
                                id: 'machine-code-id',
                                name : 'machineCode',
                                label: '机器码',
                                labelWidth: 120,
                                readOnly: true
                            },
                            {
                                xtype: 'textfield',
                                id: 'register-code-id',
                                flex: 1,
                                name : 'registerCode',
                                label: '注册码',
                                labelWidth: 120,
                                placeHolder: '请输入注册码'
                            }
                        ]
                    },
                    {
                        xtype: 'container',
                        width: '100%',
                        layout: 'hbox',
                        items: [
                            {
                              xtype: 'spacer',
                              flex: 1
                            },
                            {
                                xtype: 'ebutton',
                                id: 'generate-register-code',
                                style: 'background: rgba(0,0,0,0.1);',
                                width : 108,
                                height : 35,
                                margin : '5 4 5 10',
                                text: '注册',
                                handler: function() {
                                    timeoutDisable('generate-register-code');
                                    var registerCodeView = Ext.getCmp('register-code-view');
                                    var machineCode = Ext.getCmp('machine-code-id').getValue();
                                    var registerCode = $.trim(Ext.getCmp('register-code-id').getValue());
                                    if (!registerCode) {
                                        showAlert('提示', '请输入注册码！');
                                        return;
                                    }
                                    try {
                                        var generateRegisterCode = window.getRegCodeNum ? getRegCodeNum(machineCode) : '';
                                        if (!generateRegisterCode) {
                                            showAlert('提示', '注册失败，请稍后重试！');
                                            return;
                                        }
                                        if (generateRegisterCode !== registerCode) {
                                            showAlert('提示', '注册码错误！');
                                            return;
                                        }
                                        showLoading('正在注册，请稍后...');
                                        registerCodeView.updateSeller({isRegister: '1'}, function(success){
                                            if (success) {
                                                Ext.getCmp('register-code-view').destroy();
                                                showAlert('提示', '注册成功！');
                                            } else {
                                                showAlert('提示', '注册失败！');
                                            }
                                            closeLoading();
                                        });
                                    } catch (e) {
                                        console.log('注册出错：',e);
                                    }
                                }
                            },
                            {
                                xtype: 'ebutton',
                                id: 'try-out-id',
                                style: 'background: rgba(0,0,0,0.1);',
                                width : 108,
                                height : 35,
                                margin : '5 4 5 10',
                                text: '试用',
                                handler: function() {
                                    timeoutDisable('try-out-id');
                                    if(Ext.getCmp('register-code-view')) {
                                        Ext.getCmp('register-code-view').destroy();
                                    }
                                }
                            },
                            {
                                xtype: 'spacer',
                                flex: 1
                            }
                        ]
                    }
                ]
            }
        ]
    },
    updateSeller: function(sqlData, callback) {
        SellerDao.updateSeller(sqlData, seller.id, function(success) {
            if (success) {
                callback && callback(true);
            }
        });
    },
    loadData: function(retVal) {
        var machineCode = window.getMachineNum ? getMachineNum() : '';
        if (machineCode) {
            Ext.getCmp('machine-code-id').setValue(machineCode);
        }
        if (retVal.isExpire) {
            Ext.getCmp('try-out-id').setHidden(true);
        }
        $('#remainUseTime').text(retVal.message ? retVal.message : '');
    }
});

function validExpDateForSingleStation() {
    new Promise(function(resolve, reject) {
        if (seller.isRegister === '0' || !seller.isRegister) {
            validateExpirationPromise()
                .then(function(retVal) {
                    resolve(retVal);
                })
                .catch(function(){
                    resolve();
                });
        }
    }).then(function(retVal) {
        showRegisterCodeView(retVal);
    });
}

function validateExpirationPromise() {
    return new Promise(function(resolve, reject) {
        ValidateExpiration.valid(function(success, retVal){
            if (success) {
                resolve(retVal);
            }
        });
    });
}

/*
* 单机版提交收银登录
* */
function showRegisterCodeView(retVal) {
    var registerCodeView = Ext.getCmp('register-code-view');
    if(registerCodeView) registerCodeView.destroy();
    Ext.Viewport.add(Ext.create('Seller.view.regist.RegisterCode'));
    Ext.getCmp('register-code-view').loadData(retVal);
}

var ValidateExpiration = (function() {
    function ValidateExpiration() {}
    ValidateExpiration.valid = function(callback) {
        if (!ValidateExpiration.validExpiration(callback)) return;
        if (!ValidateExpiration.validRemainTime(callback)) return;
        return callback && callback(true);
    };
    ValidateExpiration.validExpiration = function(callback) {
        if (seller.expirationDate < new Date().format('yyyy-MM-dd hh:mm:ss')) {
            var expirationHints = '软件30天试用期已过，请注册后再使用！';
            callback && callback(true, {message: expirationHints, isExpire: true});
            return false;
        }
        return true;
    };
    ValidateExpiration.validRemainTime = function(callback) {
        if (seller.expirationDate >= new Date().format('yyyy-MM-dd hh:mm:ss')) {
            var currentTime = new Date().getTime();
            var expirationTime = new Date(seller.expirationDate).getTime();
            var remainTime = expirationTime - currentTime;
            var expirationHints = '软件剩余使用时间：';
            expirationHints += calcRemainUseDate(remainTime/1000, '');
            callback && callback(true, {message: expirationHints});
            return false;
        }
        return true;
    };
    return ValidateExpiration;
})();

function updateDateAfterUpgrade(registerData) {
    isUpgradeToCloud = true;
    showLoading('正在更新商家数据...');
    setStationToCloud();
    setStationTitle();

    Ext.getCmp('cmp-toggle-seller').setHidden(false);
    Ext.getCmp('btnRegist2').setHidden(true);
    // 重新绑定账号
    updateSellerAfterUpgrade(registerData.loginAccount, registerData.loginPwd, function(success) {
        initFGdbMaster();
        loadSynUploadData();
    });
}

function updateSellerAfterUpgrade(userName, pwd, callback) {
    new RequestUtil(webHostDownInterface + "/login/newBindSeller", {userName:userName,pwd:hex_md5(pwd),vbookerVersion:version,activationCode:seller.activationCode}, '',
        function(result) {
            if (result.state) {
                SellerDao.getLocalUser(function (success, sellerItem) {
                    SellerDao.deleteAllSeller(function (success, res) {
                        if (success) {
                            var password = hex_md5(pwd);
                            try {
                                seller.id = result.sellerLogInfo.id;//result.sellerId;
                                seller.userName = result.sellerLogInfo.userName;
                                seller.password = password;
                                seller.ename = result.sellerLogInfo.ename;
                                seller.phone = result.sellerLogInfo.phone;
                                seller.mobile = result.sellerLogInfo.mobile;
                                seller.parentSellerId = result.sellerLogInfo.parentSellerId;
                                seller.teaPrice = result.sellerLogInfo.teaPrice;
                                seller.location = result.sellerLogInfo.location;
                                seller.softwareServiceId = result.sellerLogInfo.softwareServiceId;
                                seller.serviceProxyId = result.sellerLogInfo.serviceProxyId;
                                seller.isRegisterMeituan = result.sellerLogInfo.isRegisterMeituan;
                                seller.isWxOrder = result.sellerLogInfo.isWxOrder === "1" ? "1" : "0";
                                seller.isCombineWxOrder = result.sellerLogInfo.isCombineWxOrder === "1" ? "1" : "0";
                            } catch(err) {console.log(err);}
                            seller.expirationDate = new Date(result.sellerLogInfo.expirationDate).format("yyyy-MM-dd hh:mm:ss");  // 过期时间
                            result.sellerLogInfo.expirationDate = seller.expirationDate;
                            seller.mixDateEncrypt = getEncryptDateInfo(); // 加密
                            if(!result.sellerLogInfo.hasOwnProperty("mixDateEncrypt")) {
                                result.sellerLogInfo.mixDateEncrypt = seller.mixDateEncrypt;
                            }
                            seller.serviceProxyTel = result.sellerSerive.servicePersonTel;
                            seller.serviceProxyName = result.sellerSerive.servicePersonName;
                            seller.serviceProxyCompanyName = result.sellerSerive.serviceCompanyName;
                            if(!result.sellerLogInfo.hasOwnProperty("serviceProxyTel")) {
                                result.sellerLogInfo.serviceProxyTel = seller.serviceProxyTel;
                            }
                            if(!result.sellerLogInfo.hasOwnProperty("serviceProxyName")) {
                                result.sellerLogInfo.serviceProxyName = seller.serviceProxyName;
                            }
                            if(!result.sellerLogInfo.hasOwnProperty("serviceProxyCompanyName")) {
                                result.sellerLogInfo.serviceProxyCompanyName = seller.serviceProxyCompanyName;
                            }
                            seller.deviceId = "00"; // 主机默认是"00"
                            showServiceProxyId();
                            $("#sellerUserName")[0].innerHTML = ("商家账号:" + seller.userName);
                            if (Application.Ftype == Application.MASTER) {
                                if (seller.id) {
                                    updateMasterDeviceType();
                                }
                            }
                            LoadDataDao.updateSeller(result.sellerLogInfo, function() {
                                closeLoading();
                                callback && callback(true);
                            }, true);
                        } else {
                            callback && callback(false);
                            closeLoading();
                            showAlert('提示', "更新商家信息失败，请重新绑定再登录！");
                        }
                    });
                });
            } else {
                closeLoading();
                callback && callback(false);
                showAlert('提示', result.msg ? result.msg : '更新商家信息失败，请重新绑定再登录！', null, null, 180, null, null, 280);
            }
        }, function(err) {
            closeLoading();
            showAlert("提示", "更新商家信息失败，请重新绑定再登录!");
        }).requestUrl();
}