/**
 *@Author: Xiongzp
 *@CreateTime: 2019-01-15
 **/

var PASSWORD = 'aibao2019';

Ext.define('Seller.view.shouyin.FixDataManualView', {
    extend: 'Ext.Container',
    xtype: 'fixDataManualView',
    alias: 'widget.fixDataManualView',
    config: {
        id: 'fixDataManualView',
        height : 500,
        width : '100%',
        layout: 'vbox',
        items: [
            {
                xtype: 'toolbar',
                docked: 'top',
                title: '修复数据',
                items: [
                    {
                        xtype: 'ebutton',
                        width: 80,
                        text: '返回',
                        cls: 'close-button-complete',
                        iconCls : 'close-icon',
                        icon : 'resources/icon/public/back.png',
                        handler: function() {
                            Ext.getCmp('FixDataManualWin').destroy();
                        }
                    }
                ]
            },
            {
                xtype: 'container',
                layout: {
                    type: 'vbox',
                    pack: 'center',
                    align: 'center'
                },
                height: '100%',
                style: 'background: #fff;',
                items: [
                    {
                        xtype: 'container',
                        width: '90%',
                        margin: '0 0 60 0',
                        layout: {
                            type: 'vbox'
                        },
                        items: [
                            {
                                xtype: 'fieldset',
                                width: '100%',
                                margin: '0 0 15 0',
                                items: [
                                    {
                                        xtype: 'textareafield',
                                        id: 'sql-textarea-id',
                                        height: 150,
                                        label: 'SQL语句：',
                                        labelWidth: 100,
                                        placeHolder: '执行多条SQL语句请加分号分隔'
                                    }
                                ]
                            },
                            {
                                xtype: 'ebutton',
                                id: 'execute-sql-btn',
                                cls: 'white-button',
                                height: 40,
                                width: 160,
                                text: '执行SQL语句',
                                handler: function() {
                                    timeoutDisable('execute-sql-btn');
                                    var me = Ext.getCmp('fixDataManualView');
                                    var sqlString = $.trim(Ext.getCmp('sql-textarea-id').getValue());
                                    me.execute('Sql', sqlString);
                                }
                            }
                        ]
                    },
                    {
                        xtype: 'container',
                        width: '90%',
                        layout: {
                            type: 'vbox'
                        },
                        items: [
                            {
                                xtype: 'fieldset',
                                margin: '0 0 15 0',
                                width: '100%',
                                items: [
                                    {
                                        xtype: 'textareafield',
                                        id: 'func-textarea-id',
                                        height: 40,
                                        label: '函数：',
                                        labelWidth: 100,
                                        placeHolder: '执行多个函数请加分号分隔'
                                    }
                                ]
                            },
                            {
                                xtype: 'ebutton',
                                id: 'execute-func-btn',
                                cls: 'white-button',
                                height: 40,
                                width: 160,
                                text: '执行函数',
                                handler: function() {
                                    timeoutDisable('execute-func-btn');
                                    var me = Ext.getCmp('fixDataManualView');
                                    var funcString = $.trim(Ext.getCmp('func-textarea-id').getValue());
                                    me.execute('Function', funcString);
                                }
                            }
                        ]
                    }
                ]
            }
        ]
    },
    execute: function(type, funcStr) {
        funcStr = $.trim(funcStr);
        if (!funcStr) return showAlert('提示', '参数不能为空！');
        var funcArr = funcStr.split(';');
        var executeType = {
            "Sql": function(sql, index) {
                try {
                    fgDB.executeSql(sql, [], function(res) {
                        console.log(res.rows);
                        showAlert('提示', '第' + (index + 1 ) + '条SQL语句执行成功！');
                    }, function(err) {
                        showAlert('提示', '执行失败！');
                        console.log('手动执行SQL语句出错：', err);
                    });
                } catch(err) {
                    console.log('catch error 手动执行SQL语句出错：', err.message);
                }
            },
            "Function": function(func, index) {
                try {
                    window.eval(func);
                } catch (err) {
                    console.log('手动执行函数出错：', err.message);
                    showAlert('提示', '第' + (index + 1 ) + '个函数执行失败！');
                }
            }
        };
        var execute = function(type, funcArr) {
            $.each(funcArr, function(index, func) {
                executeType[type](func, index);
            });
        };
        execute(type, funcArr);
    }
});

function showLoginView(callback) {
    var loginView = Ext.getCmp('fixdata-login-view');
    if (!loginView) {
        loginView = Ext.Viewport.add({
            xtype: 'container',
            id: 'fixdata-login-view',
            width: 430,
            height: 230,
            layout: 'vbox',
            centered: true,
            hideOnMaskTap : false,
            modal: true,
            items: [
                {
                    xtype: 'toolbar',
                    title: '修复数据授权'
                },
                {
                    xtype: 'container',
                    style: 'background: #fff;',
                    layout: {
                        type: 'vbox',
                        align: 'center'
                    },
                    width: '100%',
                    items: [
                        {
                            xtype: 'fieldset',
                            layout: 'vbox',
                            width: '80%',
                            margin: '20 0 0 0',
                            items: [
                                {
                                    xtype: 'passwordfield',
                                    id: 'fixdata-password-id',
                                    label: '密码',
                                    labelWidth: 100,
                                    placeHolder: '请输入密码'
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            layout: 'vbox',
                            width: '80%',
                            margin: '0 0 20 0',
                            defaults: {
                                style: 'margin:10px 0 0 0;',
                                height: 40
                            },
                            items: [
                                {
                                    xtype: 'ebutton',
                                    cls: 'red-button',
                                    text: '授权',
                                    handler: function() {
                                        var password = $.trim(Ext.getCmp('fixdata-password-id').getValue());
                                        if (!password) return showAlert('提示', '请输入密码！');
                                        checkFixDataPwd(password)
                                            .then(function(success) {
                                                if (success) {
                                                    callback && callback(true);
                                                    Ext.getCmp('fixdata-login-view').destroy();
                                                } else {
                                                    callback && callback(false, '密码不正确!');
                                                }
                                            });
                                    }
                                },
                                {
                                    xtype: 'ebutton',
                                    cls: 'white-button',
                                    text: '取消',
                                    handler: function() {
                                        if (Ext.getCmp('fixdata-login-view')) {
                                            Ext.getCmp('fixdata-login-view').destroy();
                                        }
                                    }
                                }
                            ]
                        }
                    ]
                }
            ]
        });
    }
    showBy(loginView, Ext.getCmp('shouyinMainView'));
}

function showFixDataManualView() {
    var FixDataManualWin = Ext.getCmp('FixDataManualWin');
    if (!FixDataManualWin) {
        FixDataManualWin = Ext.Viewport.add({
            xtype: 'container',
            id: 'FixDataManualWin',
            width: 720,
            height: 500,
            modal: true,
            hideOnMaskTap : false,
            centered: true,
            scrollable: false,
            items: [
                {
                    xtype: 'fixDataManualView'
                }
            ]
        });
    }
    showBy(FixDataManualWin, Ext.getCmp('shouyinMainView'));
}

function checkFixDataPwd(password) {
    return new Promise(function(resolve, reject) {
        if (password === PASSWORD) {
            return resolve(true);
        } else {
            return resolve(false);
        }
    });
}

function checkFixDataPromise() {
    return new Promise(function(resolve, reject) {
        showLoginView(function(success, message) {
            if (success) {
                resolve();
            } else {
                showAlert('提示', message ? message : '密码不正确！');
            }
        });
    });
}

function validFixDataPromise() {
    return new Promise(function(resolve, reject) {
        checkFixDataPromise()
            .then(function() {
                resolve();
            })
            .catch(function(err) {
                console.log(err);
            });
    });
}