/**
 *@Author: Xiongzp
 *@CreateTime: 2018-10-25
 **/
Ext.define('Seller.view.shouyin.OptPrintSetting', {
    extend : 'Ext.Container',
    alias : 'widget.optPrintSetting',
    scrollData: {},
    listStoreData: [],
    config : {
        height : 540,
        width : '100%',
        scrollable : false,
        id: 'opt-print-setting-view',
        layout : 'vbox',
        items : [
            {
                xtype: 'toolbar',
                height: 42,
                docked: 'top',
                title: '打印设置记录表',
                items: [
                    {
                        xtype: 'ebutton',
                        text: '返回',
                        cls: 'close-button-complete',
                        width: 80,
                        iconCls : 'close-icon',
                        icon : 'resources/icon/public/back.png',
                        handler: function() {
                            Ext.getCmp('optPrintSettingWin').destroy();
                        }
                    }
                ]
            },
            {
                xtype: 'panel',
                width: '100%',
                flex: 1,
                layout: 'vbox',
                items: [
                    {
                        xtype: 'panel',
                        height: 38,
                        width:"100%",
                        html : '<div class="opt-print-setting-header" style="width:100%;background:rgba(211,223,241,0.6);" >' +
                                    '<span class="ceil print-type">打印类型</span><span class="ceil print-name">打印名称</span><span class="ceil print-value">是否打印</span>' +
                                    '<span class="ceil opt-id">操作员编号</span><span class="ceil opt-name">操作员名称</span><span class="ceil user-name">商家名称</span>' +
                                    '<span class="ceil status">状态</span>' +
                                    '<span class="ceil create-time">设置日期</span>' +
                                '</div>'
                    },
                    {
                        xtype: 'dataview',
                        id: 'opt-printsetting-list',
                        width: '100%',
                        flex: 1,
                        scrollable : true,
                        store: {
                            fields: ['id', 'printType', 'printName', 'printValue', 'optId', 'optName', 'userName', 'status', 'createTime'],
                            data: []
                        },
                        emptyText:'<div style="height: 80px;line-height: 80px;text-align: center;font-size: 18px;">未查询到相关记录!</div>',
                        itemTpl: '<div class="opt-print-setting-list-item" style="height: 36px;line-height: 36px;touch-action: none;" >' +
                                     '<span class="ceil print-type" style="text-align: left;padding-left: 23px;">{printType}</span><span class="ceil print-name" style="text-align: left;padding-left: 50px;">{printName}</span><span class="ceil print-value">{printValue}</span>' +
                                     '<span class="ceil opt-id">{optId}</span><span class="ceil opt-name">{optName}</span><span class="ceil user-name">{userName}</span>' +
                                     '<span class="ceil status">{status}</span>' +
                                     '<span class="ceil create-time">{createTime}</span>' +
                                 '</div>',
                        listeners: {
                            itemtouchmove: function(field) {
                                var scrollData = Ext.getCmp('opt-print-setting-view').scrollData;
                                var listHeight = field.getScrollableBehavior().scrollerElement.getHeight();
                                var currentTop = field.getItemAt(0).getBoundingClientRect().top;
                                var scrollDistance = Math.abs(scrollData.firstItemInitTop - currentTop);
                                var flag = (scrollData.firstItemInitTop > currentTop) ? true : false;// 向下滚动才判断
                                // 滚到底部加载数据
                                if (flag && ((scrollData.listClientHeight + scrollDistance) >= listHeight)) {
                                    var listStoreData = Ext.getCmp('opt-print-setting-view').listStoreData;
                                    if (listStoreData.length > 0) {
                                        field.getStore().add(listStoreData.splice(0, 12));
                                    }
                                    if (listStoreData.length === 0) {
                                        var loadTips = Ext.getDom('optPrintsetting-list-loadTips');
                                        if (loadTips) {
                                            loadTips.innerText = '没有更多数据了';
                                        }
                                    }
                                }

                            },
                            painted: function(element) {
                                // 确保列表渲染，再获取初始数据
                                setTimeout(function(){
                                    var listView = Ext.getCmp('opt-printsetting-list');
                                    var totalCount = listView.getStore().getAllCount();
                                    if (totalCount <= 0) return;
                                    var self = Ext.getCmp('opt-print-setting-view');
                                    self.scrollData.firstItemInitTop = listView.getItemAt(0).getBoundingClientRect().top;
                                    self.scrollData.listClientHeight = element.getHeight();

                                    if (Ext.getCmp('opt-print-setting-view').listStoreData <= 12) return;
                                    var div = document.createElement('div');
                                    div.innerHTML = '<p id="optPrintsetting-list-loadTips" style="text-align: center;border-top: 1px solid rgba(0,0,0,0.1);">下拉加载更多数据</p>';
                                    listView.getScrollableBehavior().scrollerElement.appendChild(div);
                                }, 20);
                            }
                        }
                    }
                ]
            }
        ]
    },
    loadPrintSettingData: function() {
        return new Promise(function(resolve, reject){
            SettingDao.loadOptPrintSetting(function(success, result) {
                if (success && result) {
                    resolve(result);
                } else {
                    reject();
                }
            });
        });
    },
    loadPrintSettingStore: function(data) {
        var store = Ext.getCmp('opt-printsetting-list').getStore();
        store.removeAll();
        store.add(data);
    },
    loadData: function() {
        var self = this;
        self.listStoreData = [];
        self.loadPrintSettingData().
        then(function(result) {
            self.listStoreData = result;
            self.loadPrintSettingStore(self.listStoreData.splice(0, 12));
        }).
        catch(function(err) {
            console.log('err', err);
        });
    }
});

function addOptPrintSetting(param) {
    var data = {
        id: createUUIDForId(),
        userName: seller.userName,
        sellerId: seller.id,
        deviceId: seller.deviceId,
        optId: shouYinEmployee.workId,
        optName:  shouYinEmployee.workName,
        printType: param.printType,
        printName: param.printName,
        printValue: param.printValue,
        status: param.status,
        createTime: new Date().format('yyyy-MM-dd hh:mm:ss')
    };
    SettingDao.addOptPrintSetting(data, function(success) {
        if (success) {
             // console.log('插入表记录成功：table [operatePrintSetting]');
        }
    });
}

function dealOptPrintSettingData(settingData) {
    var paramDatasMap = {
        'isShouyinCustomerPrint': ['收款', '客户单'],
        'isShouyinPrivatePrint': ['收款', '存根单'],
        'isShouyinKitchenPrint': ['收款', '厨房'],
        'isShouyinLabelPrint': ['收款', '标签'],
        'isShouyinTablePrint': ['收款', '台单'],
        'isOrderCustomerPrint': ['下单', '客户单'],
        'isOrderKitchenPrint': ['下单', '厨房'],
        'isOrderLabelPrint': ['下单', '标签'],
        'isOrderPrivatePrint': ['下单', '存根单'],
        'isOrderTablePrint': ['下单', '台单'],
        'isReturnOrderCustomerPrint': ['反结账', '客户单'],
        'isReturnOrderPrivatePrint': ['反结账', '存根单'],
        'isMtOrderCustomerPrint': ['美团订单', '客户单'],
        'isMtOrderKitchenPrint': ['美团订单', '厨房'],
        'isMtOrderLabelPrint': ['美团订单', '标签'],
        'isMtOrderPrivatePrint': ['美团订单', '存根单']
    };
    var sqlDatas = [];
    for (var key in paramDatasMap) {
        if (paramDatasMap.hasOwnProperty(key)) {
            var paramType = paramDatasMap[key][0];
            var paramName = paramDatasMap[key][1];
            var value = (settingData[key] == 'true' ||  settingData[key]== '1' )? '是' : '否';
            var sqlData = {
                id: createUUIDForId(),
                userName: seller.userName,
                deviceId: seller.deviceId,
                sellerId: seller.id,
                printType: paramType,
                printName: paramName,
                printValue: value,
                optId: shouYinEmployee.workId,
                optName: shouYinEmployee.workName,
                status: '初始',
                createTime: new Date().format('yyyy-MM-dd hh:mm:ss')
            };
            sqlDatas.push(sqlData);
        }
    }
    return sqlDatas;
}

function addOptPrintSettingByInitialData(settingData) {
    var sqlDatas = dealOptPrintSettingData(settingData);
    var delDate = new Date((+new Date() - 1000 * 3600 * 24 * 2)).format('yyyy-MM-dd');
    SettingDao.delOptPrintSettingByTime([delDate], function(success) {
        if (success) {
            // console.log('删除表记录成功：table [operatePrintSetting]');
            SettingDao.addOptPrintSetting(sqlDatas, function(success) {
                if (success) {
                    // console.log('插入表记录成功：table [operatePrintSetting]');
                }
            });
        }
    });
}

function showOptPrintSettingView() {
    var optPrintSettingWin = Ext.getCmp('optPrintSettingWin');
    if (!optPrintSettingWin) {
        Ext.Viewport.add({
            xtype: 'panel',
            id: 'optPrintSettingWin',
            width: 880,
            height: 540,
            modal: true,
            hideOnMaskTap : false,
            centered: true,
            scrollable: false,
            items: [
                {
                    xtype: 'optPrintSetting'
                }
            ]
        });
    }
    Ext.getCmp('opt-print-setting-view').loadData();
}
