/**
 * 选桌下单弹框
 */
Ext.define("Seller.view.shouyin.SelectPlaceView", {
	extend : "Ext.Container",
	alias : "widget.selectplaceview",
	xtype : "SelectPlaceView",
	config : {
		id : "select-place-view",
		xtype : "container",
		centered : true,
		modal : true,
		width : 460,
		height : 360,
		cls : "sy-bg",
		layout : "vbox",
		padding : "5",
		style: 'border-radius: 6px;',
		items : [{
			xtype : "toolbar",
			docked : "top",
			title : "下单",
			items : [{
				xtype : "button",
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : "select-place-cancel",
				handler : function() {
					/*if(Ext.getCmp("select-place-view")) {
						Ext.getCmp("select-place-view").destroy();
					}*/
				}
			}, {
				xtype : "spacer"
			}, {
				xtype : "button",
				cls : "sy-tm-button",
				width : 70,
				id : "select-place-suspend",
				text : "挂单"
			}, {
				xtype : "button",
				cls : "sy-tm-button",
				width : 70,
				id : "select-place-confirm",
				text : "确定"
			}]
		}, {
			xtype : "container",
			margin : "0 0 0 0",
			style : "background:white;",
			defaults : {
				xtype : "textfield",
				labelWidth : 120,
				labelAlign : "left"
			},
			items : [{
				xtype : 'hiddenfield',
				name : 'placeId',
				id : 'select-place-id'
			}, {
				xtype : 'selectfield',
				value : '',
				label : '服务员',
				name : 'select-waiter-name',
				id : 'select-waiter-name',
				options : []
			}, {
				xtype : 'hiddenfield',
				name : 'remarkIds',
				id : 'select-place-remarkIds'
			}, {
				label: "桌号",
				name : 'placeName',
				id : 'select-place-name',
				placeHolder : '桌号',
				required : true,
				readOnly : true,
			}, {
				label : "整单口味",
				name : 'remark',
				id : 'select-place-remark',
				placeHolder : '整单口味',
				readOnly : true,
				required : false
			}, {
				label : "茶位单价",
				name : 'teaPrice',
				id : 'select-place-teaprice',
				placeHolder : '茶位单价',
				value : 0,
				maxLength : 10,
				required : true
			}, {
				label : "客人数",
				id : 'select-place-personNum',
				maxLength : 10,
				value : '1',
				required : false
			}]
		}, {
			xtype : 'container',
			//width : 300,
			width : "100%",
			height : 220,
			cls : 'whitebg',
			hidden : true,
			padding : 10,
			defaults : {
				xtype : 'container',
				layout : 'hbox',
				height : 50,
				defaults : {
					xtype : 'button',
					handler : inputPlaceInfoValue,
					flex : 1,
					height : 40,
					margin : 7,
					cls : 'white-button'
				}
			},
			items : [{
				xtype : 'container',
				items : [{
					text : '1'
				}, {
					text : '2'
				}, {
					text : '3'
				}]
			}, {
				xtype : 'container',
				items : [{
					text : '4'
				}, {
					text : '5'
				}, {
					text : '6'
				}]
			}, {
				xtype : 'container',
				items : [{
					text : '7'
				}, {
					text : '8'
				}, {
					text : '9'
				}]
			}, {
				xtype : 'container',
				items : [{
					text : '0'
				}, {
					text : '.'
				}, {
					id : 'select-place-delete',
					iconCls : 'putup-delete'
				}]
			}]
		}, {
			xtype: 'container',
			layout : "vbox",
			id: 'select-place-show-print',
            style : "background:white;",
			// hidden: true,
			items: [{
				xtype: "container",
				width: "100%",
				layout: "hbox",
				defaults: {
					xtype: "checkboxfield",
					labelWidth: 160,
					labelAlign: "right",
					flex: 1
				},
				items: [{
					label: "客户单打印",
					id: "select-place-customer-print",
				}, {
					label: "存根单打印",
					id: "select-place-stub-print",
				}, {
					/* 打印 */
					xtype: "panel",
					style: "background:none;border:none;box-shadow:none;shadow:none;",
					top: 0,
					left: 0,
					width: "100%",
					height: 43,
					layout: "hbox",
					defaults: {
						xtype: "button",
						style: "background:none;border:none;",
						flex: 1
					},
					items: [{
						id: "select-place-cp-mask"
					}, {
						id: "select-place-sp-mask"
					}]
				}]
			}, {
				xtype: "container",
				width: "100%",
				layout: "hbox",
                style : "background:white;",
				defaults: {
					xtype: "checkboxfield",
					labelWidth: 160,
					labelAlign: "right",
					flex: 1
				},
				items: [{
					label: "厨房打印",
					id: "select-place-kitchen-print",
				}, {
					label: "标签打印",
					id: "select-place-label-print",
				}, {
					xtype: "container",
					style: "background:none;border:none;box-shadow:none;shadow:none;",
					top: 0,
					left: 0,
					width: "100%",
					height: 43,
					layout: "hbox",
					defaults: {
						xtype: "button",
						style: "background:none;border:none;",
						flex: 1
					},
					items: [{
						id: "select-place-kp-mask"
					}, {
						id: "select-place-lp-mask"
					}]
				}]
			}, {
				xtype: "container",
				width: "100%",
				layout: "hbox",
				defaults: {
					xtype: "checkboxfield",
					labelWidth: 160,
					labelAlign: "right",
					flex: 1
				},
				items: [{
					label: "台单打印",
					id: "select-place-table-print",
				}, {
					xtype: "textfield",
				}, {
					xtype: "container",
					style: "background:none;border:none;box-shadow:none;shadow:none;",
					top: 0,
					left: 0,
					width: "100%",
					height: 43,
					layout: "hbox",
					defaults: {
						xtype: "button",
						style: "background:none;border:none;",
						flex: 1
					},
					items: [{
						id: "select-place-tp-mask"
					}, {
						xtype: "textfield",
						readOnly: true,
						id: "select-place-assist-mask"
					}]
				}]
			}]
		}, {
			xtype: 'container',
			id: 'select-place-hide-print',
            style : "background:white;",
			// hidden: false,
			height: 40,
			html: '<div style="color:red;line-height: 24px;text-align: center;margin-top: 10px;">(需要修改打印配置，请到系统设置->打印设置中修改)</div>'
		},{
			xtype : "container",
			width : "100%",
			layout : "hbox",
            style : "background:white;",
			defaults : {
				xtype : "checkboxfield",
				labelWidth : 160,
				labelAlign : "right",
				flex : 1
			},
			items : [{
				xtype : "textfield"
			}, {
				label : "不再显示",
				id : "is-reshow-putup-view"
			}, {
				xtype : "button",
				top : 0,
				right : 0,
				width : "50%",
				height : 45,
				id : "select-place-view-notshow",
				style : "background:none;border:none;",
				/*listeners : {
					tap : function(currView, e, eOpts) {
						preventEventBubble(e);
						var cbCmp = Ext.getCmp("is-reshow-putup-view");
						var viewData = cbCmp && cbCmp.getData();
						if(viewData && viewData.id);
						else viewData = {id : createUUIDForId()};
						var isChecked = false;
						if(cbCmp) {
							isChecked = cbCmp.isChecked();
						}
						var paramsData = {
								id : viewData.id,
								sellerId : seller.id,
								paramType : "SYS",
								paramName : "directOrder",
								paramValue : isChecked ? "false" : "true",
								syned : "0",
							};
						SettingDao.saveSysParams(paramsData, function(success) {
							if(success) {
								cbCmp && cbCmp.setData(viewData);
								isChecked ? cbCmp.uncheck() : cbCmp.check();
								if(sysParams) {
									sysParams.replace(getMapKeyBySeperator([paramsData.paramType,paramsData.paramName]), paramsData);
								}
							} else {
								showAlert("提示", "修改失败!");
							}
						});
					}
				}*/
			}]
		}, {
			xtype : 'container',
			layout : 'hbox',
			hidden : true,
			height : 40,
			margin : '10 0 0 0',
			defaults : {
				height : 40
			},
			items : [{
				xtype : 'button',
				cls : ["sy-bg",'sy-tm-button'],
				iconMask : true,
				id : 'select-place-status-1',
				text : '挂单',
				margin : '0 0 0 5',
				flex : 1,
				handler : function() {
					// timeoutDisable('putup-status-1');
					// Ext.getCmp('putup-edit-view').submitPutUp('-1');
				}
			}, {
				width : 5,
				xtype : 'container'
			}, {
				xtype : 'button',
				cls : ["sy-bg",'sy-tm-button'],
				margin : '0 5 0 5',
				iconMask : true,
				text : '下单',
				flex : 1,
				id : 'select-place-XiaD',
				handler : function() {
					// Ext.getCmp('putup-edit-view').submitPutUp('0');
				}
			}]
		}]
	},
    initialize : function() {
        if(isAndroidSys()) {
            var selectPlaceView = Ext.getCmp("select-place-view");
            selectPlaceView.setTop(30);
            var width = selectPlaceView.getWidth();
            width = width || 450;
            selectPlaceView.setLeft((clientWidth-width)/2);
        }
    },
	submitPutup : function(status) {
		var me = this;
		showLoading("正在下单, 请稍侯...");
		if(isPutupSubmiting){
			closeLoading();
			return;
		}
		var me=this;
		isPutupSubmiting=true;
		var shouyinMain = Ext.getCmp('shouyinMainView');
		var shopSign = "";
		if(Ext.getCmp('select-place-shopSign1'))
			shopSign = Ext.getCmp('select-place-shopSign1').getValue();
		var placeId = Ext.getCmp('select-place-id').getValue();
		var placeName = Ext.getCmp("select-place-name").getValue();
		var personNum = Ext.getCmp('select-place-personNum').getValue();
		var teaPrice = Ext.getCmp('select-place-teaprice').getValue();
		var remark = Ext.getCmp('select-place-remark').getValue();
		var remarkIds = Ext.getCmp('select-place-remarkIds').getValue();
		var teaAmount = 0;
		var endOperator = function() {
			closeLoading();
		}
		if(!checkValidCondition(personNum.trim(), ConditionValue.NOTEMPTY|ConditionValue.NOTZERO|ConditionValue.CKINTEGER, '请输入正确的人数!')) {
			me.resetSubmit();
			endOperator();
			return;
		}
		if (personNum && teaPrice) {
			teaAmount = personNum * teaPrice;
		}
		if(placeId == "") {
			me.resetSubmit();
			endOperator();
			showAlert('提示', '请选择餐桌!');
			return;
		} else if(!checkValidCondition(placeId, ConditionValue.NOTEMPTY, '请选择餐桌!')) {
			endOperator();
			return;
		}
		if(placeName == "") {
			me.resetSubmit();
			endOperator();
			showAlert('提示', '请选择餐桌');
			return;
		} else if(!checkValidCondition(placeName, ConditionValue.NOTEMPTY, '请选择餐桌!')) {
			me.resetSubmit();
			endOperator();
			return;
		}
		if (teaPrice) {
			var v = teaPrice.split('.');
			if (v[0].length > 8) {
				showAlert('提示', '茶位单价整数位最大只支持 8 位！', null, null, null, function () {
                    me.currField = Ext.getCmp('select-place-teaprice');
                });
                me.resetSubmit();
                endOperator();
				return;
			} else if (v.length > 1 && v[1].length > 2) {
                showAlert('提示', '茶位单价小数位最大只支持 2 位！', null, null, null, function () {
                    me.currField = Ext.getCmp('select-place-teaprice');
                });
                me.resetSubmit();
                endOperator();
                return;
			} else if(!checkValidCondition(teaPrice.trim(), ConditionValue.NOTEMPTY|ConditionValue.CKPOSITIVE, '茶位单价请输入有效数字\n保留两位有效数字如(3.88)!')) {
                me.resetSubmit();
                endOperator();
                return;
            }
		}
		if (personNum) {
            if (personNum.length > 4) {
                showAlert('提示', '客人数最大只支持 4 位！', null, null, null, function () {
                    me.currField = Ext.getCmp('select-place-personNum');
                });
                me.resetSubmit();
                endOperator();
                return;
            }
		}
		var data = {
			syned : '0',
			status : status,
			discount : shouyinMain.discount,
			shopSign : nvlValue(shopSign, ''),
			placeId : nvlValue(placeId, ''),
			placeName : nvlValue(placeName, ''),
			personNum : nvlValue(personNum, 0),
			remark : nvlValue(remark, ''),
			remarkIds : nvlValue(remarkIds, ''),
			teaPrice : nvlValue(teaPrice, 0),
			teaAmount : nvlValue(teaAmount, 0)
		};
		if (seller.teaPrice != teaPrice) {
			updateTeaPrice(teaPrice);
		}

		data.costAmount = shouyinMain.costAmount;
		//判断是否是取单的挂单操作
		if (Ext.getCmp('shouyinMainView').sellInfo) {
			var oldPlaceId=Ext.getCmp('shouyinMainView').sellInfo.placeId;
			var details = Ext.getCmp('shouyinMainView').getChangeRecord();
			var sellId = Ext.getCmp('shouyinMainView').sellInfo.id;
			var sellInfoStatus = Ext.getCmp('shouyinMainView').sellInfo.status;  // 之前是否处于挂单状态
			var oldSellInfo = Ext.getCmp('shouyinMainView').sellInfo;
			var date = new Date();
			data.id = sellId;
			data.placeName = placeName;
			data.status = status;
			data.placeId = placeId;
			//oldSellInfo.sellInfoStatus = sellInfoStatus;
			//oldSellInfo.oldPlaceId = oldPlaceId;
			data.oldStatus = sellInfoStatus;
			var sellInfoNotDiscountAmount = nvlValue(Ext.getCmp('shouyinMainView').sellInfo.notDiscountAmount, 0);
			var sellInfoDiscountAmount = nvlValue(Ext.getCmp('shouyinMainView').sellInfo.discountAmount, 0);
			data.notDiscountAmount = parseFloat(parseFloat(sellInfoNotDiscountAmount) + calcNotDiscountAmountForDetails(details)).toFixed(2);
			data.discountAmount = parseFloat(parseFloat(sellInfoDiscountAmount) + calcDiscountAmountForDetails(details)).toFixed(2);
			var tmpDiscountAmount = parseFloat(parseFloat(data.discountAmount) * (parseFloat(data.discount)/100));
			data.alreadyDiscountAmount = parseFloat(parseFloat(data.discountAmount) - parseFloat(tmpDiscountAmount)).toFixed(2);
			commonPutupBySellInfo(details, data, function() {
				me.resetSubmit();
				endOperator();
				if (Ext.getCmp('shouyinMainView').sellInfo.placeName != placeName) {
                    PrintDao.printChangeTableLogic(Ext.getCmp('shouyinMainView').sellInfo.placeName, placeName);
				}
				if(placeId) {
					if(oldPlaceId&&oldPlaceId!=placeId){
						dealPlace(3, oldPlaceId);
					}
				}
				Ext.getCmp('shouyinMainView').resetData();
				Ext.getCmp('select-place-view').destroy();
				showCustomerDisplay(0x30, '0.00');
			});
			return;
		}
		data.totalAmount = shouyinMain.totalAmount;
		data.sellAmount = shouyinMain.sellAmount;
		data.costAmount = shouyinMain.costAmount;
		data.commodityNum = shouyinMain.commodityNum;
		if (Ext.getCmp('shouyinMainView').selectCustomerInfo) {
			data.customerId = shouyinMain.selectCustomerInfo.id;
			data.customerName = shouyinMain.selectCustomerInfo.name;
			data.customerMobile = shouyinMain.selectCustomerInfo.mobile;
			data.customerAddress = shouyinMain.selectCustomerInfo.address;
		}
		setClerkInfo(data);
		Ext.getCmp('shouyinMainView').createSellInfo(status, data, function(success, msg, codeUrl, sellId) {
			me.resetSubmit();
			endOperator();
			if (success) {
				if (status == '0') {
					PrintDao.printOrderById(sellId, '');
				}
				Ext.getCmp('shouyinMainView').resetData();
				showCustomerDisplay(0x30, '0.00');
				dealPlace(status, placeId);
				Ext.getCmp('select-place-view').destroy();
			} else {
				showAlert('提示', msg ? msg : '操作失败！');
			}
		});
	},
	resetSubmit:function(){
		setTimeout(function(){
			isPutupSubmiting=false;
		},1000)
	},
	toAllRemarkView : function() {
		var allRemarkView=Ext.getCmp('allRemarkView');
		if (!allRemarkView) {
			allRemarkView=Ext.Viewport.add(Ext.create('Ext.ux.AllRemark'));
		}
		showBy(allRemarkView,Ext.getCmp("select-place-view"));
		var remarkIds = Ext.getCmp('select-place-remarkIds').getValue();
		Ext.getCmp('allRemarkView').setParentContainer(Ext.getCmp("select-place-view"));
		Ext.getCmp('allRemarkView').setPutupRemark(remarkIds);
	},
	setPutupRemark : function(remark, remarkIds) {
		Ext.getCmp('select-place-remarkIds').setValue(remarkIds);
		Ext.getCmp('select-place-remark').setValue(remark);
	},
	fillData : function(dataInfo) {
		//Ext.getCmp('putup-shopSign1').setValue(dataInfo.shopSign);
		Ext.getCmp('select-place-id').setValue(dataInfo.placeId);
		Ext.getCmp('select-place-personNum').setValue(dataInfo.personNum);
		//Ext.getCmp('select-place-teaprice').setValue(dataInfo.teaPrice ? dataInfo.teaPrice : 0);
        var teaUnitPrice = isValidDigital(dataInfo.teaPrice) ? dataInfo.teaPrice : 0;
        if(parseInt(teaUnitPrice) == parseFloat(teaUnitPrice)) teaUnitPrice = parseInt(teaUnitPrice);
        else teaUnitPrice = parseDigitalDecimal(teaUnitPrice);
        Ext.getCmp('select-place-teaprice').setValue(teaUnitPrice);
		Ext.getCmp('select-place-remarkIds').setValue(dataInfo.remarkIds);
		Ext.getCmp("select-place-remark").setValue(dataInfo.remark);
		Ext.getCmp("select-place-name").setValue(dataInfo.placeName);
	},
	loadDataBySellInfo : function() {
		var me = this;
		var currsellInfo = Ext.getCmp('shouyinMainView').sellInfo;
		me.fillData(currsellInfo);
	},
	loadDataBySelectPlace : function() {
		var me = this;
		var selectPlace = Ext.getCmp('shouyinMainView').selectPlace;
		var placeId = selectPlace.get('id');
		var placeName = selectPlace.get('placeName');
		//var typeId = selectPlace.get('typeId');
		var selectPlaceData = selectPlace.getData();
		selectPlaceData.placeId = selectPlaceData.id;
		selectPlaceData.placeName = selectPlaceData.placeName;
		if (parseInt(Ext.getCmp('shouyinMainView').personNum)) {
            selectPlaceData.personNum = Ext.getCmp('shouyinMainView').personNum;
        }
		me.fillData(selectPlaceData);
	},
	initKtPrinter : function() {
		// 是否显示打印设置
		if (!(showPtSetting.isOrderPrintShow == 'false' || showPtSetting.isOrderPrintShow == false)) {
			Ext.getCmp('select-place-view').setHeight(460);
			Ext.getCmp('select-place-show-print').setHidden(false);
			Ext.getCmp('select-place-hide-print').setHidden(true);
		} else {
			Ext.getCmp('select-place-view').setHeight(360)
			Ext.getCmp('select-place-show-print').setHidden(true);
			Ext.getCmp('select-place-hide-print').setHidden(false);
		}

		if (!(setting.isOrderCustomerPrint == 'false' || setting.isOrderCustomerPrint == false)) {
			Ext.getCmp('select-place-customer-print').check();
		} else {
			Ext.getCmp('select-place-customer-print').uncheck();
		}

		if (!(setting.isOrderPrivatePrint == 'false' || setting.isOrderPrivatePrint == false)) {
			Ext.getCmp('select-place-stub-print').check();
		} else {
			Ext.getCmp('select-place-stub-print').uncheck();
		}

		if (!(setting.isOrderKitchenPrint == 'false' || setting.isOrderKitchenPrint == false)) {
			Ext.getCmp('select-place-kitchen-print').check();
		} else {
			Ext.getCmp('select-place-kitchen-print').uncheck();
		}

		if (!(setting.isOrderLabelPrint == 'false' || setting.isOrderLabelPrint == false)) {
			Ext.getCmp('select-place-label-print').check();
		} else {
			Ext.getCmp('select-place-label-print').uncheck();
		}

		if (!(setting.isOrderTablePrint == 'false' || setting.isOrderTablePrint == false)) {
			Ext.getCmp('select-place-table-print').check();
		} else {
			Ext.getCmp('select-place-table-print').uncheck();
		}
	},
	loadData : function() {
		var me = this;
		me.tableViewData = null;
		if (Ext.getCmp('shouyinMainView').sellInfo) {
			me.loadDataBySellInfo();
			me.tableViewData = Ext.getCmp('shouyinMainView').sellInfo;
		} else if(Ext.getCmp('shouyinMainView').selectPlace) {
			me.loadDataBySelectPlace();
			me.tableViewData = Ext.getCmp('shouyinMainView').selectPlace;
		}
		me.initKtPrinter();
		var waiterCmp = Ext.getCmp("select-waiter-name");
        var sellInfo = Ext.getCmp('shouyinMainView').sellInfo;
		var fullWaiterData = function() {
			var optionData = [{text:'',value:''}];
			for(var si=0,slen=saleEmloyees.length;si<slen;si++) {
				optionData.push({text:saleEmloyees[si].workName,value:saleEmloyees[si].id});
			}
			if(waiterCmp) {
				waiterCmp.setOptions(optionData);
				if(sellInfo && sellInfo.saleName) waiterCmp.setValue(sellInfo.saleName);
			}
		}
		if (saleEmloyees.length > 0) fullWaiterData();
		else {
            SellerEmployeeDao.loadSellerEmployee('2', function(success, res) {
                if (!success) return;
                saleEmloyees = res;
                if (res.length > 0) fullWaiterData();
            });
        }
		if(sysParams) {
			var putupData = sysParams.get(getMapKeyBySeperator(["SYS","directOrder"]));
			if(!putupData) return;
			var isShowPutupView = Ext.getCmp("is-reshow-putup-view");
			isShowPutupView.setData({id : putupData.id});
			if(putupData.paramValue === "true" || putupData.paramValue === true)
				isShowPutupView.setChecked(true);
			else isShowPutupView.setChecked(false);
		}
		// 最大超时10000
		/*showLoading("正在加载系统设置数据...", null, 10000);
		SettingDao.loadSysParamValueValid({
			paramType : "SYS",
			paramName : "directOrder",
			callback : function(success, putupParam) {
				var isShowPutupView = Ext.getCmp("is-reshow-putup-view");
				closeLoading();
				if(success && putupParam) {
					if(putupParam.paramName === "directOrder") {
						var putupValue = putupParam.paramValue;
						isShowPutupView.setData({id : putupParam.id});
						if(putupValue === "true" || putupValue === true)
							isShowPutupView.setChecked(false);
						else isShowPutupView.setChecked(true);
						return;
					}
				}
				// 未查询到数据，禁用设置
				isShowPutupView && isShowPutupView.setDisabled(true);
			}
		});*/
		/*SettingDao.loadSysParamsValid({keyword:"SYS", callback:function(success, datas) {
				var isShowPutupView = Ext.getCmp("is-reshow-putup-view");
				closeLoading();
				if(success && datas && datas.length > 0) {
					for(var di=0,dlen=datas.length;di<dlen;di++) {
						if(datas[di].paramName === "directOrder") {
							var putupValue = datas[di].paramValue;
							isShowPutupView.setData({id : datas[di].id});
							if(putupValue === "true" || putupValue === true)
								isShowPutupView.setChecked(true);
							else isShowPutupView.setChecked(false);
							return;
						}
					}
				}
				// 未查询到数据，禁用设置
				isShowPutupView && isShowPutupView.setDisabled(true);
			}
		});*/
	}
});

function inputPlaceInfoValue() {
	var me = Ext.getCmp('select-place-view');
	var value = this.getText();
	var id = this.getId();
    var currNum = me.currField.getValue() + '';
	if (!me.currField) {
		me.currField = Ext.getCmp('select-place-personNum');
	}
	if (value == '.') {
		if (me.currField == Ext.getCmp('select-place-personNum')) {
            showToast('客人数不允许输入小数！');
            return;
        }
        if (currNum.split('.').length > 1) {
            showToast('已经是小数！');
            return;
		}
        me.currField.focus();
    } else if (isInteger(value)) {
		if(me.currField == Ext.getCmp('select-place-teaprice')) {
			var v = currNum.split('.');
			var absInt = Math.abs(parseInt(v[0])) + '';
			if (absInt.length >= 8 && v.length < 2) {
				showToast('整数位最大只支持 8 位！');
				me.currField.focus();
				return
			} else if (v.length > 1 && v[1].length >= 2) {
                showToast('小数位最大只支持 2 位！');
                me.currField.focus();
                return
			}
		} else if (me.currField == Ext.getCmp('select-place-personNum')) {
            if (currNum.length >= 4) {
                showToast('整数位最大只支持 4 位！');
                me.currField.focus();
                return
            }
        }
	}
	if (me.firstFocus && value != '.') {
		me.currField.setValue('');
	}
	if ("select-place-delete" == id) {
		if (currNum && currNum.length > 1) {
            currNum = currNum.substring(0, currNum.length - 1);
		} else {
            currNum = 0;
		}
	} else {
		if(!validatorInputNumber(currNum, value));
		if (currNum == '0' && value != '.') {
            currNum = value;
		} else {
            currNum += value + '';
		}
	}
	me.currField.setValue(currNum);
	me.currField.focus();
	me.firstFocus = false;
}
/**
 * submitPutup.call({}, status);
 * 下单操作
 * @author v_cjc
 * @createTime 2018年4月17日 上午9:54:17
 * @param status
 * @returns
 */
/*submitPutup.call({
	shopSign:"",
	shopSign:Ext.getCmp('select-place-shopSign1').getValue(),
	placeId:Ext.getCmp('select-place-id').getValue(),
	placeName:Ext.getCmp("select-place-name").getValue(),
	personNum:Ext.getCmp('select-place-personNum').getValue(),
	teaPrice:Ext.getCmp('select-place-teaprice').getValue(),
	remark:Ext.getCmp('select-place-remark').getValue(),
	remarkIds:Ext.getCmp('select-place-remarkIds').getValue()
}, "1");
submitPutup(sellInfo, "-1");*/
function submitPutup(status) {
	var me = this;
	showLoading("正在下单, 请稍侯...");
	if(isPutupSubmiting){
		closeLoading();
		return;
	}
	var me=this;
	isPutupSubmiting=true;
	var shouyinMain = Ext.getCmp('shouyinMainView');
	var shopSign = "";
	if(this.shopSign)
		shopSign = this.shopSign;
	var tableViewData = null;
	if (shouyinMain.sellInfo) {
		tableViewData = shouyinMain.sellInfo;
	} else if(shouyinMain.selectPlace) {
		tableViewData = shouyinMain.selectPlace.getData();
	}
	var oldTeaPrice = tableViewData ? tableViewData.teaPrice : 0;
	oldTeaPrice = oldTeaPrice ? oldTeaPrice : "0";

	var placeId = this.placeId;
	var placeName = this.placeName;
	var personNum = this.personNum;
	var teaPrice = this.teaPrice;
	var saleId = this.saleId ? this.saleId : null;
    var saleWorkId = this.saleWorkId ? this.saleWorkId : null;
    var saleName = this.saleName ? this.saleName : null;
	var isViewData = this.isViewData;
	// 检测是否是数字
	if(!isValidDigital(teaPrice)) {
		if(isViewData===true);else teaPrice = "0";
	} else ;//teaPrice = parseFloat(teaPrice).toFixed(2);
	var remark = this.remark;
	var remarkIds = this.remarkIds;
	var teaAmount = 0;
	var terminalOperator = function() {
		closeLoading();
	}
	var endOperator = function() {
		closeLoading();
		if(Ext.getCmp('select-place-view'))
			Ext.getCmp('select-place-view').hide();
	}
	function checkViewData() {
		if(!checkValidCondition(personNum.trim(), ConditionValue.NOTEMPTY|ConditionValue.NOTZERO|ConditionValue.CKINTEGER, '请输入正确的人数!')) {
			resetSubmit();
			terminalOperator();
			return;
		}
		if(placeId == "") {
			resetSubmit();
			terminalOperator();
			showAlert('提示', '请选择餐桌!');
			return;
		} else if(!checkValidCondition(placeId, ConditionValue.NOTEMPTY, '请选择餐桌!')) {
			terminalOperator();
			return;
		}
		if(placeName == "") {
			resetSubmit();
			terminalOperator();
			showAlert('提示', '请选择餐桌');
			return;
		} else if(!checkValidCondition(placeName, ConditionValue.NOTEMPTY, '请选择餐桌!')) {
			resetSubmit();
			terminalOperator();
			return;
		}
	}
	//checkViewData();

	if (personNum && teaPrice) {
		var tmpPersonNum = 0;
		var tmpTeaPrice = 0;
		if(isValidDigital(personNum)) tmpPersonNum = parseFloat(personNum);
		if(isValidDigital(teaPrice)) tmpTeaPrice = parseFloat(teaPrice);
		teaAmount = parseFloat(tmpPersonNum) * parseFloat(tmpTeaPrice);
	}
	if (teaPrice) {
		var v = toString(teaPrice).split('.');
		if (v[0].length > 7) {
			showAlert('提示', '茶位单价整数位最大只支持 7 位！', null, null, null, function () {
                me.currField = Ext.getCmp('select-place-teaprice');
            });
            resetSubmit();
            terminalOperator();
			return;
		} else if (v.length > 1 && v[1].length > 2) {
            showAlert('提示', '茶位单价小数位最大只支持 2 位！', null, null, null, function () {
                me.currField = Ext.getCmp('select-place-teaprice');
            });
            resetSubmit();
            terminalOperator();
            return;
		} else if(!checkValidCondition(toString(teaPrice).trim(), ConditionValue.NOTEMPTY|ConditionValue.CKPOSITIVE, '茶位单价请输入有效数字\n保留两位有效数字如(3.88)!')) {
            resetSubmit();
            terminalOperator();
            return;
        }
	}
	closeLoading();
	new Promise(function(resolve, reject) {
		if(oldTeaPrice!=teaPrice) {
			checkPermissions(PERMISSIONS.TEAPRICEMODIFY, true, "对不起,您没有权限修改茶位费!")
			.then(function() {resolve();})
			.catch(function() {
				resetSubmit();
				terminalOperator();
			});
		} else resolve();
	}).then(function() {
		showLoading("正在下单, 请稍侯...");
		if (personNum) {
	        if (personNum.length > 4) {
	            showAlert('提示', '客人数最大只支持 4 位！', null, null, null, function () {
	                me.currField = Ext.getCmp('select-place-personNum');
	            });
	            resetSubmit();
	            terminalOperator();
	            return;
	        } else if(isValidDigital(personNum)) {
	        	if(parseFloat(personNum)<0 || parseFloat(personNum)>parseInt(personNum)) {
		        	showAlert('提示', '客人数只能输入正整数！', null, null, null, function () {
		                me.currField = Ext.getCmp('select-place-personNum');
		            });
		        	resetSubmit();
		            terminalOperator();
		            return;
	        	}
	        } else {
	        	showAlert('提示', '客人数只能输入数字！', null, null, null, function () {
	                me.currField = Ext.getCmp('select-place-personNum');
	            });
	        	resetSubmit();
	            terminalOperator();
	            return;
	        }
		}
		var data = {
			syned : '0',
			status : status,
			discount : shouyinMain.discount,
			shopSign : nvlValue(shopSign, ''),
			placeId : nvlValue(placeId, ''),
			placeName : nvlValue(placeName, ''),
			personNum : nvlValue(personNum, 0),
			remark : nvlValue(remark, ''),
			remarkIds : nvlValue(remarkIds, ''),
			teaPrice : nvlValue(teaPrice, 0),
			teaAmount : nvlValue(teaAmount, 0),
            saleId : saleId,
			saleWorkId : saleWorkId,
			saleName : saleName
		};
		if (seller.teaPrice != teaPrice) {
			updateTeaPrice(teaPrice);
		}

		data.costAmount = shouyinMain.costAmount;
		//判断是否是取单的挂单操作
		if (Ext.getCmp('shouyinMainView').sellInfo) {
			var oldPlaceId=Ext.getCmp('shouyinMainView').sellInfo.placeId;
			var details = Ext.getCmp('shouyinMainView').getChangeRecord();
			var sellId = Ext.getCmp('shouyinMainView').sellInfo.id;
			var sellInfoStatus = Ext.getCmp('shouyinMainView').sellInfo.status;  // 之前是否处于挂单状态
			var oldSellInfo = Ext.getCmp('shouyinMainView').sellInfo;
			var date = new Date();
			data.id = sellId;
			data.placeName = placeName;
			data.status = status;
			data.placeId = placeId;
			//oldSellInfo.sellInfoStatus = sellInfoStatus;
			//oldSellInfo.oldPlaceId = oldPlaceId;
			data.oldStatus = sellInfoStatus;
			var sellInfoNotDiscountAmount = nvlValue(Ext.getCmp('shouyinMainView').sellInfo.notDiscountAmount, 0);
			var sellInfoDiscountAmount = nvlValue(Ext.getCmp('shouyinMainView').sellInfo.discountAmount, 0);
			data.notDiscountAmount = parseFloat(parseFloat(sellInfoNotDiscountAmount) + calcNotDiscountAmountForDetails(details)).toFixed(2);
			data.discountAmount = parseFloat(parseFloat(sellInfoDiscountAmount) + calcDiscountAmountForDetails(details)).toFixed(2);
			var tmpDiscountAmount = parseFloat(parseFloat(data.discountAmount) * (parseFloat(data.discount)/100));
			data.alreadyDiscountAmount = parseFloat(parseFloat(data.discountAmount) - parseFloat(tmpDiscountAmount)).toFixed(2);
			commonPutupBySellInfo(details, data, function() {
				resetSubmit();
				endOperator();
				if (Ext.getCmp('shouyinMainView').sellInfo.placeName != placeName) {
	                PrintDao.printChangeTableLogic(Ext.getCmp('shouyinMainView').sellInfo.placeName, placeName);
				}
				if(placeId) {
					if(oldPlaceId&&oldPlaceId!=placeId){
						dealPlace(3, oldPlaceId);
					}
				}
				Ext.getCmp('shouyinMainView').resetData();
				if(sySetting.mode == SYS_TYPE.HOTEL){
					syLeftButtonClick($(".sy-left-button[index="+6+"]")[0], 6);
				}
				showCustomerDisplay(0x30, '0.00');
			});
			return;
		}
		data.totalAmount = shouyinMain.totalAmount;
		data.sellAmount = shouyinMain.sellAmount;
		data.costAmount = shouyinMain.costAmount;
		data.commodityNum = shouyinMain.commodityNum;
		if (Ext.getCmp('shouyinMainView').selectCustomerInfo) {
			data.customerId = shouyinMain.selectCustomerInfo.id;
			data.customerName = shouyinMain.selectCustomerInfo.name;
			data.customerMobile = shouyinMain.selectCustomerInfo.mobile;
			data.customerAddress = shouyinMain.selectCustomerInfo.address;
		}
		setClerkInfo(data);
		Ext.getCmp('shouyinMainView').createSellInfo(status, data, function(success, msg, codeUrl, sellId) {
			resetSubmit();
			endOperator();
			if (success) {
				var statusMsg = '开台下单';
				if (data.status == '-1') statusMsg = '开台挂单';
				console.log('餐桌:' + data.placeName + statusMsg + ',订单号：' + sellId + '---' + new Date().format('yyyy-MM-dd hh:mm:ss'));
				if (status == '0') {
					console.log('打印明细：收银员:' + shouYinEmployee.workName + ',收银台:' + seller.deviceId + ',订单:' + sellId + ',明细数量：' + data.commodityNum);
					PrintDao.printOrderById(sellId, '');
				}
				Ext.getCmp('shouyinMainView').resetData();
				if(sySetting.mode == SYS_TYPE.HOTEL){
					syLeftButtonClick($(".sy-left-button[index="+6+"]")[0], 6);
				}
				showCustomerDisplay(0x30, '0.00');
				dealPlace(status, placeId);
			} else {
				showAlert('提示', msg ? msg : '操作失败！');
			}
		});
	}).catch(function() {});

};

function resetSubmit(){
	setTimeout(function(){
		isPutupSubmiting=false;
	},1000)
};