var KTPrinterDao = {
	loadAllPrinter : function(callback) {
        var sql = "select * from kitchenprinter where sellerId='" + seller.id + "'";
        loadBySql(sql, callback);
    },
    loadPrinter : function(callback) {
        var sql = "select distinct * from kitchenprinter where sellerId='" + seller.id + "' and ifnull(status,'0')<>'9'";
        loadBySql(sql, callback);
    },
    loadKtPrinterSetting : function(callback){
        var sql = "select id,sellerId,ktPrintName,ktPrintIp,mode,printQuantity,paperWidth,model,beepEnable,autoCut,roll from kitchenprinter where sellerId='" +
                    seller.id +
                    "' and ifnull(isDeleted, '0')='0' and ifnull(status,'0')<>'9'";
         loadBySql(sql, callback);
    },
    loadPrinterNoDel : function(callback) {
    	var sql = "select distinct k.ktPrintName,k.id,k.sellerId,k.ktPrintIp,k.mode,k.interface,k.printQuantity,k.paperWidth," +
    			 "k.customWidth,k.rowledge,k.model,k.port,k.baudrate,k.beepEnable,k.autoCut,k.roll,k.status" +
    			 " from kitchenprinter k where k.sellerId='"+ seller.id +"' and ifnull(isDeleted, '0')='0' and ifnull(status,'0')<>'9' group by k.ktPrintName";
    	loadBySql(sql, callback);
    },
    loadPrinterById : function(id, callback) {
        var sql = "select  * from kitchenprinter where sellerId='" + seller.id + "' and id='" + id + "'";
        loadBySql(sql, callback);
    },
    loadPrinterByNotId : function(id, callback) {
        var sql = "SELECT  * FROM kitchenprinter where sellerId='" + seller.id + "' and id<>'" + id + "' and ifnull(isDeleted, '0')='0' and ifnull(status,'0')<>'9'";
        loadBySql(sql, callback);
    },
    loadSynPrinter : function(callback) {
        var sql = "SELECT * FROM kitchenprinter where sellerId='" + seller.id + "' and ifnull(syned, '0')='0' ";
        loadBySql(sql, callback);
    },
    updatePrinter : function(printer, id, callback) {
        update('kitchenprinter', printer, id, callback);
    },
    addPrinter : function(printer, callback) {
        insert('kitchenprinter', printer, callback);
    },
    deletePrinterById : function(id, callback) {
        var sql = "delete from kitchenprinter where sellerId='" + seller.id + "' and id='" + id + "'";
        executeSql(sql, callback);
    },
    deletePrinterAll : function(callback) {
        //var sql = "delete from kitchenprinter where sellerId='" + seller.id + "'";
    	var sql = "delete from kitchenprinter where ifnull(syned, '0')='1'";
        executeSql(sql, callback);
    },
    /* 删除所有数据 */
    deleteAreaPrintSettingAll : function(callback) {
        var sql = "delete from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        //executeSql(sql, callback);
        executeSqlParams(sql, params, callback);
    },
    /**
     * 根据打印数据删除(本机)
     * @param data [Object]
     * @param callback
     */
    deleteAreaPrintSettingByDataLocal : function(data, callback) {
        var sql = "delete from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        for(var key in data) {
            if(data.hasOwnProperty(key)) {
                sql += " AND " + key + "=?";
                params.push(data[key]);
            }
        }
        //console.log(sql);
        //executeSqlParams(sql, params, callback);
        executeSqlParamsLocal(sql, params, callback);
    },
    /**
     * 根据打印数据删除
     * @param data [Object]
     * @param callback
     */
    deleteAreaPrintSettingByData : function(data, callback) {
        var sql = "delete from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        for(var key in data) {
            if(data.hasOwnProperty(key)) {
                sql += " AND " + key + "=?";
                params.push(data[key]);
            }
        }
        console.log(sql);
        executeSqlParams(sql, params, callback);
    },
    /* 根据打印数据查询(本机) */
    loadAreaPrintSettingByDataLocal: function(data, callback) {
        var sql = "select targetId,targetName,targetTypeId,targetTypeName from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        for (var key in data) {
            if (data.hasOwnProperty(key)) {
                sql += " AND " + key + "=?";
                params.push(data[key]);
            }
        }
        //loadBySqlParam(sql, params, callback);
        loadBySqlParamLocal(sql, params, callback);
    },
    /* 根据打印数据查询 */
    loadAreaPrintSettingByData: function(data, callback) {
        var sql = "select targetId,targetName,targetTypeId,targetTypeName from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        for (var key in data) {
            if (data.hasOwnProperty(key)) {
                sql += " AND " + key + "=?";
                params.push(data[key]);
            }
        }
        loadBySqlParam(sql, params, callback);
    },
    /**
     * 根据ID删除
     * @param id [String]
     * @param callback
     */
    deleteAreaPrintSettingById : function(id, callback) {
        var sql = "delete from areaPrintSetting where id=? AND sellerId=?";
        var params = [id, seller.id];
        executeSqlParams(sql, params, callback);
    },
    /**
     * 根据多个ID删除
     * @param ids [Array]
     * @param callback
     */
    deleteAreaPrintSettingByIds : function(ids, callback) {
        var sql = "delete from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        if(ids) {
            sql += " AND (" + new Array(ids.length).fill("id=?").join(" OR ") + ")";
        }
        params = params.concat(ids);
        console.log(sql);
        executeSqlParams(sql, params, callback);
    },
    /**
     * 根据打印目标ID(此处为商品ID)删除
     * @param targetId [String]
     * @param callback
     * */
    deleteAreaPrintSettingByTargetId : function(targetId, callback) {
        var sql = "delete from areaPrintSetting where targetId=? AND sellerId=?";
        var params = [targetId, seller.id];
        console.log(sql);
        executeSqlParams(sql, params, callback);
    },
    /**
     * 根据多个打印目标ID(此处为商品ID)删除
     * @param targetIds [Array]
     * @param callback
     * */
    deleteAreaPrintSettingByTargetId : function(targetIds, callback) {
        var sql = "delete from areaPrintSetting where sellerId=?";
        var params = [seller.id];
        if(targetIds) {
            sql += " AND (" + new Array(targetIds.length).fill("targetId=?").join(" OR ") + ")";
        }
        params = params.concat(targetIds);
        console.log(sql);
        executeSqlParams(sql, params, callback);
    },
    /**
     * 批量添加或更新区域打印数据(本机使用)
     * @param areaPrintDatas [Array]
     * @param callback
     */
    addOrUpdateAreaPrintSettingLocal : function(areaPrintDatas, callback) {
        fgDB.transaction(function(tx) {
                for(var ai=0,alen=areaPrintDatas.length;ai<alen;ai++) {
                    var areaPrintData = areaPrintDatas[ai];
                    var keys = Object.keys(areaPrintData);
                    var values = Object.values(areaPrintData);
                    var sql = "REPLACE INTO areaPrintSetting (" + keys.join(",") + ") VALUES (" + new Array(values.length).fill("?").join(",") + ")";
                    tx.executeSql(sql, values);
                }
            },
            function() {
                console.log("batch success!");
                callback && callback(true);
            },
            function(err) {console.log("batch error!");callback && callback(false);});
    },
    /**
     * 批量添加或更新区域打印数据(只有主机可使用)
     * @param areaPrintDatas [Array]
     * @param callback
     */
    addOrUpdateAreaPrintSetting : function(areaPrintDatas, callback) {
        if(isConfigMaster()) {
            fgDB.transaction(function(tx) {
                for(var ai=0,alen=areaPrintDatas.length;ai<alen;ai++) {
                    var areaPrintData = areaPrintDatas[ai];
                    var keys = Object.keys(areaPrintData);
                    var values = Object.values(areaPrintData);
                    var sql = "REPLACE INTO areaPrintSetting (" + keys.join(",") + ") VALUES (" + new Array(values.length).fill("?").join(",") + ")";
                    tx.executeSql(sql, values);
                }
            },
            function() {
                console.log("batch success!");
                callback && callback(true);
            },
            function(err) {console.log("batch error!");callback && callback(false);});
        } else {
            var operatorSql = [];
            for(var ai=0,alen=areaPrintDatas.length;ai<alen;ai++) {
                var areaPrintData = areaPrintDatas[ai];
                var keys = Object.keys(areaPrintData);
                var values = Object.values(areaPrintData);
                operatorSql.push({
                    sql : "REPLACE INTO areaPrintSetting (" + keys.join(",") + ") VALUES (" + new Array(values.length).fill("?").join(",") + ")",
                    params : values
                })
            }
            operatorMultiSql(operatorSql, callback);
        }
    },
    /**
     * 加载区域打印数量
     * @param callback
     */
    loadAreaPrintCount : function(callback) {
        var sql = "SELECT COUNT(1) ttlNum FROM areaPrintSetting t WHERE t.sellerId=?";
        getBySqlParamLocal(sql, [seller.id], callback);
    },
    submitById : function(id, callback) {
        KTPrinterDao.loadPrinterById(id, function(success, printers) {
            if(success && printers && printers.length > 0) {
                for(var pi=0,plen=printers.length;pi<plen;pi++)
                    KTPrinterDao.submitToServer(printers[pi]);
                // callback && callback(true);
            }
            // else callback && callback(false);
        });
    },
    /* 加载厨打的区域打印 */
    loadAreaSettingForKitchenPrint : function(callback) {
        var sql = "SELECT A.id,A.sellerId,A.pType,A.printerId,A.pTarget,A.targetId,A.targetName,A.status,K.ktPrintName,K.ktPrintIp,K.mode,K.autoCut,K.model,K.beepEnable,K.roll,K.paperWidth,K.printQuantity FROM areaPrintSetting A LEFT JOIN kitchenprinter K ON (A.printerId=K.id) WHERE IFNULL(A.status,'1')<>'9' AND IFNULL(K.status,'1')<>'9' AND A.sellerId=? AND IFNULL(A.pTarget,'')='P' AND IFNULL(A.pType,'')='K'";
        loadBySqlParam(sql, [seller.id], callback);
    },
    /* 加载非厨打的区域打印 */
    loadAreaSettingNotKitchenPrint : function(callback) {
        var sql = "SELECT A.id,A.sellerId,A.pType,A.printerId,A.pTarget,A.targetId,A.targetName,A.status FROM areaPrintSetting A WHERE IFNULL(A.status,'1')<>'9' AND A.sellerId=? AND IFNULL(A.pTarget,'')='P' AND IFNULL(A.pType,'')<>'K'";
        loadBySqlParamLocal(sql, [seller.id], callback);
    },
    /* 加载厨打/标签的商品打印 */
    loadCommoditySettingKitchenPrint : function(callback) {
        var sql = "SELECT A.id,A.sellerId,A.pType,A.printerId,A.pTarget,A.targetId,A.targetName,A.status,K.ktPrintName,K.ktPrintIp,K.mode,K.autoCut,K.model,K.beepEnable,K.roll,K.paperWidth,K.printQuantity FROM areaPrintSetting A LEFT JOIN kitchenprinter K ON (A.printerId=K.id) WHERE IFNULL(A.status,'1')<>'9' AND IFNULL(K.status,'1')<>'9' AND A.sellerId=? AND IFNULL(A.pTarget,'')='C' AND (IFNULL(A.pType,'')='K' OR IFNULL(A.pType,'')='L')";
        loadBySqlParam(sql, [seller.id], callback);
    },
    loadAreaNotKitchenPrintSetting : function(callback) {
        /* 非厨打区域打印数据 */
        var sql = "SELECT A.id,A.sellerId,A.pType,A.printerId,A.pTarget,A.targetId,A.targetName,A.status FROM areaPrintSetting A WHERE IFNULL(A.status,'1')<>'9' AND A.sellerId=? AND (IFNULL(A.pType,'')<>'4' AND IFNULL(A.pType,'')<>'K')";
        // loadBySqlParam(sql, [seller.id], callback);
        loadBySqlParamLocal(sql, [seller.id], callback);
    },
    loadAreaKitchenPrintSetting : function(callback) {
        /* 厨打区域打印数据 */
        var sql = "SELECT A.id,A.sellerId,A.pType,A.printerId,A.pTarget,A.targetId,A.targetName,A.status,B.ktPrintIp,B.ktPrintName FROM areaPrintSetting A LEFT JOIN kitchenprinter B ON (A.printerId=B.id) WHERE IFNULL(A.status,'1')<>'9' AND A.sellerId=? AND (IFNULL(A.pType,'')='4' OR IFNULL(A.pType,'')='K')";
        loadBySqlParam(sql, [seller.id], callback);
        // loadBySqlParamLocal(sql, [seller.id], callback);
    },
    submitToServer : function(printer, callback) {
        delete printer.syned;
        var printerData = {
    		id : printer.id,
        	sellerId : printer.sellerId,
        	printerName : printer.ktPrintName,
        	printerIp : printer.ktPrintIp,
        	isDeleted : nvlValue(printer.isDeleted, '0'),
        	lastUpdateTime:printer.lastUpdateTime,
        	status:printer.status,
            mode : printer.mode,
            interface : printer.interface,   // 总分单,1.分单，2.总单，3.总分单
            printQuantity : printer.printQuantity,  // 打印份数
            paperWidth : printer.paperWidth,    // 页面宽度
            customWidth : printer.customWidth,
            rowledge : printer.rowledge,
            model : printer.model,           // 型号
            port : printer.port,
            baudrate : printer.baudrate,
            beepEnable : printer.beepEnable,   // 蜂鸣器
            autoCut : printer.autoCut,       // 自动切纸
            roll : printer.roll             // 打印后走纸(行)
        };
        console.log("KTPrinterDao 54行" +printer.id);
        //nativePostRequest(webHostSynDataInterface + '/syndata/synKitchenPrinter?time=' + new Date().getTime(), printerData, function(result) {
        nativePostRequest(webHostSynDataInterface + '/syndata/synKitchenPrinter?time=' + new Date().getTime(), printerData, function(result) {
            if(result.state) {
                KTPrinterDao.updatePrinter({
                    syned : '1'
                }, printer.id);
            } else {
                console.log("KTPrinterDao 61行" +printer.id + "返回失败");
                console.log(result.msg ? result.msg : '提交厨打失败!');
            }
        }, function(error) {
            console.log("KTPrinterDao 65行" +printer.id + "请求失败");
            console.log('请求厨打失败!');
        });
    }
};