function selectAllRemark(obj) {
	if ($(obj).hasClass("selected")) {
		$(obj).removeClass("selected");
	} else {
		$(obj).addClass("selected");
	}
}

function showAllRemarkEditor(id, sequence, price, remark) {
	if (Ext.getCmp('allRemarkEditorView')) {
		Ext.getCmp('allRemarkEditorView').show();
	} else {
		var allRemarkEditorView = Ext.Viewport.add({
			xtype : 'panel',
			modal : true,
			hideOnMaskTap : false,
			width : 380,
			id : 'allRemarkEditorView',
			height : 200,
			centered : true,
			layout : 'vbox',
			items : [{
				xtype : 'toolbar',
				dock : 'top',
				width : '100%',
				title : '编辑口味',
				items:[{
					xtype:'button',
					cls:'close-button',
					handler : function() {
						allRemarkEditorView.destroy();
					}
				}]
			}, {
				xtype : 'formpanel',
				id : 'allRemarkEditorForm',
				scrollable : false,
				width : '100%',
				flex : 1,
				items : [{
					xtype : 'fieldset',
					margin : 5,
					items : [{
						xtype : 'hiddenfield',
						name : 'id',
						id : 'addRemark-id'
					}, {
						xtype : 'hiddenfield',
						name : 'price',
						id : 'addRemark-price',
						value : 0
					}, {
						labelWidth : 80,
						xtype : 'textfield',
						name : 'remark',
						id : 'addRemark-remark',
						maxLength : 20,
						label : '名称'
					}, {
						labelWidth : 80,
						xtype : 'numberfield',
						name : 'sequence',
						id : 'addRemark-sequence',
						value : 0,
						label : '排序'
					}]
				}]
			}, {
				xtype : 'panel',
				width : '100%',
				height:35,
				margin:5,
				layout:'hbox',
				items : [{
					xtype : 'spacer'
				}, {
					xtype : 'button',
					width : 100,
					iconMask : true,
					cls:'red-button',
					text : '确定',
					handler : function() {
						var allRemarkEditorForm = Ext.getCmp('allRemarkEditorForm');
						var data = allRemarkEditorForm.getValues();
						// if (!data.sequence && data.sequence != 0) {
						// 	showAlert('提示', "请输入排序号！");
						// 	return;
						// }
						if (!data.remark) {
							showAlert('提示', "请输入备注名称！");
							return;
						}
						var isSameRemark =false;
						$(".sys_spec_text").each(function() {
							var me = $(this);
							var li = me.find("li");
							li.each(function() {
								if($(this).attr('remark') == data.remark && data.id !== $(this).attr('remarkId')) {
									isSameRemark = true;
									return false;
								}
							});
						});
						if(isSameRemark) {
							showAlert('提示', '输入备注的名称相同');
							return;
						}
						var remark = data.remark;
						var isUpdate = data.id ? true : false;
						var sqlData = {
							remark : data.remark,
							price : data.price,
							sequence : data.sequence,
							syned: "0",
							status:'1',
							lastUpdateTime:new Date().format('yyyy-MM-dd hh:mm:ss')
						};
						if (isUpdate) {
							SellerRemarkDao.updateSellerRemark(sqlData, data.id);
							sqlData.id=data.id;
							$("li[remarkId='" + data.id + "']").each(function() {
								var i = $(this);
								var p = i.find("a");
								i.attr({
									remark : data.remark,
									price : data.price,
									remarkId : data.id
								});
								var html = "<a>" + data.remark + "</a>";
								p.each(function() {
									$(this).prop("outerHTML", html);
								});
							});
						} else {
							var date = new Date();
							sqlData.id = createSysId();
							data.id = sqlData.id;
							sqlData.syned = "0";
							sqlData.sellerId = seller.id;
							sqlData.lastUpdateTime=new Date().format('yyyy-MM-dd hh:mm:ss');
							SellerRemarkDao.addSellerRemark(sqlData);
							var html = "<li remark='" + remark + "' remarkId='" + sqlData.id + "' price='" + data.price + "' onclick='selectAllRemark(this)'><a>" + remark + "</a><i></i></li>";
							$(".sys_spec_text").append(html);
						}
						allRemarkEditorView.destroy();
						SellerRemarkDao.submitSellerRemarkToServer(sqlData);
					}
				}, {
					xtype : 'spacer'
				}]
			}]
		});
		allRemarkEditorView.show();
	}
	Ext.getCmp('allRemarkEditorForm').setValues({
		id : id,
		sequence : sequence ? sequence : 0,
		price : price ? price : 0,
		remark : remark
	});
}

/**
 * 刪除
 */
function deleteAllRemark(jqueryObj) {
	var remarkId = jqueryObj.attr("remarkId");
	SellerRemarkDao.updateSellerRemark({
		syned : '0',
		isDelete : '1',
        status : '9',
		lastUpdateTime:new Date().format('yyyy-MM-dd hh:mm:ss')
	}, remarkId, function(success) {
		if (success) {
			jqueryObj.remove();
		} else {
			showAlert('提示', '删除出错！');
		}
	});
}

function setSelect(remarkIds) {
	remarkIds += ",";
	setTimeout(function() {
		$(".sys_spec_text").each(function() {
			var i = $(this);
			var p = i.find("li");
			p.each(function() {
				var remarkId = $(this).attr("remarkId");
				if (remarkIds.indexOf(remarkId + ",") != -1) {
					if (!$(this).hasClass("selected")) {
						$(this).addClass("selected");
					}
				} else {
					$(this).removeClass("selected");
				}

			});
		});
	}, 300);
}

function disSelect() {
	setTimeout(function() {
		$(".sys_spec_text").each(function() {
			var i = $(this);
			var p = i.find("li");
			p.each(function() {
				if ($(this).hasClass("selected")) {
					$(this).removeClass("selected");
				}

			});
		});
	}, 200);
}

/**
 * 购物车明细编辑
 */
Ext.define('Ext.ux.AllRemark', {
	extend : 'Ext.Container',
	xtype : ['AllRemark'],
	parentContainer : null,
	buyCarRecord : null,
	config : {
		id : 'allRemarkView',
		centered : true,
		modal : true,
		width : 600,
		height : 350,
		title : '编辑',
		listeners : {
			painted : function(element, eOpts) {
				var remarkCmp = Ext.getCmp("allRemarkButton");
				if(!remarkCmp) return;
				var isMaster = isConfigMaster();
				remarkCmp.setHidden(isMaster ? false : true);
			}
		},
		items : [{
			xtype : 'dataview',
			id : 'allRemarkContent',
			flex : 1,
			height : 308,
			cls:'whitebg',
			//scrollable : false,
			//html : ['<ul class="sys_spec_text">', '<li data-aid="3"><a href="javascript:;" title="白色">白色白色白色白色白色白色白色白色白色白色白色白色白色白色白色白色白色</a><i></i></li>', '<li data-aid="4"><a href="javascript:;" title="粉色">粉色</a><i></i></li>', '<li data-aid="8"><a href="javascript:;" title="蓝色">蓝色</a><i></i></li>', '<li data-aid="9"><a href="javascript:;" title="绿色">绿色</a><i></i></li>', '<li data-aid="10"><a href="javascript:;" title="黄色">黄色</a><i></i></li>', '<li data-aid="12"><a href="javascript:;" title="灰色">灰色</a><i></i></li>', '</ul>'].join('')
		}, {
			xtype : 'toolbar',
			title : '选择整单口味',
			id : 'AllRemarkTootar',
			docked : 'top',
			items : [{
				xtype : 'button',
				cls : 'close-button',
				handler : function() {
					Ext.getCmp('allRemarkView').destroy();
				}
			}, {
				xtype : 'spacer'
			}, {
				text : '确定',
				handler : function(currView, e, eOpts) {
					var content = "";
					var remarkIds = "";
					$(".sys_spec_text").each(function() {
						var i = $(this);
						var p = i.find("li");
						p.each(function() {
							if ($(this).hasClass("selected")) {
								var remark = $(this).attr("remark");
								var price = $(this).attr("price");
								var remarkId = $(this).attr("remarkId");
								if (content) {
									content += "," + remark;
									remarkIds += "," + remarkId;
								} else {
									content += remark;
									remarkIds = remarkId;
								}
							}
						});
					});
					/*if(currView) {
						var allRemarkView = currView.up("#allRemarkView");
						if(allRemarkView && allRemarkView.parentContainer && allRemarkView.parentContainer.id==="select-place-view") {
							allRemarkView.parentContainer.setPutupRemark(content, remarkIds);
						} else Ext.getCmp('putup-edit-view').setPutupRemark(content, remarkIds);
					} else
						Ext.getCmp('putup-edit-view').setPutupRemark(content, remarkIds);*/
					if(currView) {
						var allRemarkView = currView.up("#allRemarkView");
						if(allRemarkView && allRemarkView.parentContainer && allRemarkView.parentContainer.setPutupRemark) {
							try {
								allRemarkView.parentContainer.setPutupRemark(content, remarkIds);
							} catch(err) { console.log(err); }
						} //else Ext.getCmp('putup-edit-view').setPutupRemark(content, remarkIds);
					}
					Ext.getCmp('allRemarkView').putupRemarkIds = null;
					Ext.getCmp('allRemarkView').destroy();
				}
			}, {
				text : '编辑',
				id : 'allRemarkButton',
                hidden : Application.Ftype == Application.SLAVE ? true : false,
				handler : function() {
					if (Ext.getCmp('allRemarkTootar2').getHidden()) {
						Ext.getCmp('allRemarkTootar2').setHidden(false);
						this.setText("返回");
						disSelect();
					} else {
						Ext.getCmp('allRemarkTootar2').setHidden(true);
						this.setText("编辑");
						var remarkIds = Ext.getCmp('allRemarkView').putupRemarkIds;
						setSelect(remarkIds);
					}
				}
			}]
		}, {
			xtype : 'toolbar',
			id : 'allRemarkTootar2',
			docked : 'right',
			hidden : true,
			items : [{
				xtype : 'spacer'
			}, {
				text : '增加',
				handler : function() {
					checkPermissions("16", true)
					.then(function() {
						showAllRemarkEditor('', 0, '');
					}).catch(function() {});
				}
			}, {
				text : '刪除',
				handler : function() {
					$(".sys_spec_text").each(function() {
						var i = $(this);
						var p = i.find("li");
						p.each(function() {
							var me = this;
							if ($(this).hasClass("selected")) {
								checkPermissions("5", true)
								.then(function() {
									deleteAllRemark($(me));
								});
							}
						});
					})
					.catch(function() {});
					/*if (!checkPermissions("5", true)) {
						return;
					}
					$(".sys_spec_text").each(function() {
						var i = $(this);
						var p = i.find("li");
						p.each(function() {
							if ($(this).hasClass("selected")) {
								deleteAllRemark($(this));
							}
						});
					});*/
				}
			}, {
				text : '修改',
				handler : function() {
					checkPermissions("7", true)
					.then(function() {
						var count = 0;
						var remarkId;
						$(".sys_spec_text").each(function() {
							var i = $(this);
							var p = i.find("li");
							p.each(function() {
								if ($(this).hasClass("selected")) {
									count++;
									remarkId = $(this).attr("remarkId");
								}
							});
						});
						if (count > 1) {
							showAlert('提示', '一次只能修改一条备注！');
						} else {
							if (!remarkId) {
								return;
							}
							SellerRemarkDao.getSellerRemarkById(remarkId, function(success, res) {
								if (success) {
									showAllRemarkEditor(remarkId, res.sequence, res.price, res.remark);
								}
							});
						}
					}).catch(function() {
						
					});
					/*if (!checkPermissions("7", true)) {
						return;
					}
					var count = 0;
					var remarkId;
					$(".sys_spec_text").each(function() {
						var i = $(this);
						var p = i.find("li");
						p.each(function() {
							if ($(this).hasClass("selected")) {
								count++;
								remarkId = $(this).attr("remarkId");
							}
						});
					});
					if (count > 1) {
						showAlert('提示', '一次只能修改一条备注！');
					} else {
						if (!remarkId) {
							return;
						}
						SellerRemarkDao.getSellerRemarkById(remarkId, function(success, res) {
							if (success) {
								showAllRemarkEditor(remarkId, res.sequence, res.price, res.remark);
							}
						});
					}*/
				}
			}]
		}]
	},
	setParentContainer : function(parentContainer) {
		this.parentContainer = parentContainer;
	},
	/**
	 * 来源于下单界面整单口味
	 * @param {Object} record
	 */
	setPutupRemark : function(putupRemarkIds) {
		this.putupRemarkIds = putupRemarkIds;
		Ext.getCmp('allRemarkTootar2').setHidden(true);
		Ext.getCmp('allRemarkButton').setText("编辑");
		SellerRemarkDao.loadSellerRemark(function(success, res) {
			var remarks = [];
			if (success) {
				if (res.length > 0) {
					var k = 0;
					for (var i = 0; i < res.length; i++) {
						var item = res[i];
						if (item.price) {
							continue;
                        }
                        remarks[k++] = {
							id : item.id,
							price : (item.price && item.price != 'null') ? item.price : '0',
							priceStr : (item.price && item.price != 'null') ? ("￥" + parseFloat(item.price).toFixed(2)) : "",
							remark : item.remark
						};
					}
				}
            }
            var tpl = new Ext.XTemplate('<ul class="sys_spec_text">', '<tpl for="remarks">', '<li remark="{remark}" remarkId="{id}" price="{price}">', '<a href="javascript:;">{remark}<br/></a><i></i>', '</li>', '</tpl>');
			var content = tpl.apply({
				remarks : remarks
			});
			Ext.getCmp('allRemarkContent').setHtml(content);
			setTimeout(function() {
				$(".sys_spec_text").each(function() {
					var i = $(this);
					var p = i.find("li");
					p.click(function() {
						if ($(this).hasClass("selected")) {
							$(this).removeClass("selected");
						} else {
							$(this).addClass("selected");
						}
					});
				});
				setSelect(putupRemarkIds);
			}, 100);
		});
	},
	initialize : function(panel, eOpts) {

	}
});
